// $Id: JABngVisitor_Main.java,v 1.1.1.1 1998/07/29 12:39:07 mencnar Exp $
//
// $Source: /home/iris/grant/abng/CVS/sources/clients/Jabngvisitor/JABngVisitor_Main.java,v $
//
// $Log: JABngVisitor_Main.java,v $
// Revision 1.1.1.1  1998/07/29 12:39:07  mencnar
// initial revision
//
//
// Author: Daniel Mencnarowski (mencnar@ics.agh.edu.pl)
//
// Description: ABng visitor client implementation
//

package pl.edu.agh.ics.abngcore;

import java.awt.*;
import java.awt.event.*;
import com.sun.java.swing.*;
import com.sun.java.swing.event.*;

import java.util.Vector;

class Visitor {
  public ABng_Core_System._Badge_Holder bhref;
  public ABng_Core_System._Badge_HolderPackage.Value_Description bhvd;

  public Visitor( ABng_Core_System._Badge_Holder bhref, 
		  ABng_Core_System._Badge_HolderPackage.Value_Description bhvd) {
    this.bhref= bhref;
    this.bhvd= bhvd;
  }

  public synchronized boolean isVisitor() {
    return bhvd.visitor;
  }

  public synchronized boolean isValidVisitor() {
    return bhvd.assigned;
  }

  public synchronized int getItemId() {
    return bhvd.item_id;
  }

  public synchronized void update( ABng_Core_System._Badge_Holder bhref,
				   ABng_Core_System._Badge_HolderPackage.Value_Description bhvd) {

    this.bhref= bhref;
    this.bhvd= bhvd;
  }
  
  public String toString() { 
    String uid= bhvd.type_specific_object.user_description().uid;
    if (isValidVisitor()) 
      return uid;
    else
      return "<"+uid+">";
  }

  public synchronized Domain_Repository.UserPackage.Description descr() {
    return bhvd.type_specific_object.user_description();
  }
}

class VisitorRenderer implements ListCellRenderer {
  private JLabel mlabel;
  
  public VisitorRenderer() {
    mlabel= new JLabel();
    mlabel.setOpaque( true);
  }

  public Component getListCellRendererComponent( JList list,
						 Object value,
						 int index,
						 boolean isSelected,
						 boolean cellHasFocus) {
    Visitor vis= null;
    if (value instanceof Visitor) vis= (Visitor) value;
    mlabel.setFont( list.getFont());
    Color fg,bg;
    if (isSelected) {
      bg= list.getSelectionBackground();
      fg= list.getSelectionForeground();
    }
    else {
      bg= list.getBackground();
      fg= list.getForeground();
    }
    if (vis != null)
      if (!vis.isValidVisitor()) {
	bg= bg.darker();
	fg= fg.darker();
      }
	
    mlabel.setBackground( bg);
    mlabel.setForeground( fg);

    mlabel.setText( value.toString());
    return mlabel;
  }
};

public class JABngVisitor_Main extends JPanel 
          implements Bootstrap_listener_interface_n,
  //                     Domain_Repository._Static_Data_ObserverOperations,
                     ABng_Core_System._System_Static_Data_ObserverOperations,
                     ActionListener,
                     ListSelectionListener
{
  static JFrame frame;
  static ORB_wrapper my_orb_wrapper;

  private JList visitor_list;
  private JScrollPane visitors_panel;
  private Vector visitors= new Vector(); // of Visitor(s)

  private JLabel user_id_label;
  private JLabel forename_label, surname_label;
  private JLabel phone_label, email_label;
  private JLabel position_label;
  private JTextField user_id_field;
  private JTextField forename_field, surname_field;
  private JTextField phone_field, email_field;
  private JTextField position_field;
  private GridBagLayout gridbag;
  private JPanel user_info_panel;

  private JPanel button_panel;

  private JButton add_visitor_button;
  private JButton remove_visitor_button;

  private Visitor last_selection= null;

  ABng_Core_Management.Badge_Holder_Rep holder_manager= null;
  Domain_Repository_Management.User_Rep_Manager user_manager= null;
  private Bootstrap_listener_n bootstrap_listener= null;
  private Domain_Repository.Static_Data_Observer user_observer_object= null;
  private ABng_Core_System.System_Static_Data_Observer holder_observer_object= null;
  
  public JABngVisitor_Main() {
    //    user_observer_object= 
    //      new Domain_Repository._tie_Static_Data_Observer( this);
    //    my_orb_wrapper.connect_object( user_observer_object);
    holder_observer_object=
      new ABng_Core_System._tie_System_Static_Data_Observer( this);
    my_orb_wrapper.connect_object( holder_observer_object);

    setLayout( new BorderLayout());
    
    add(visitors_panel= new JScrollPane( visitor_list= new JList()),
	BorderLayout.WEST);
    visitor_list.setCellRenderer( new VisitorRenderer());
    visitor_list.addListSelectionListener( this);

    user_info_panel= new JPanel();
    user_info_panel.setLayout( gridbag= new GridBagLayout());
    GridBagConstraints c = new GridBagConstraints();
    c.anchor= GridBagConstraints.EAST;
    c.gridx= 0;
    c.gridy= 0;
    gridbag.setConstraints( user_id_label= new JLabel("User id") , c);
    user_info_panel.add( user_id_label);
    user_info_panel.setEnabled( false);
    c.anchor= GridBagConstraints.WEST;
    c.gridx= 1;
    gridbag.setConstraints( user_id_field= new JTextField( 8), c);
    user_id_field.setEditable(false);
    user_info_panel.add( user_id_field);

    c.anchor= GridBagConstraints.EAST;
    c.gridx= 0;
    c.gridy= 1;
    gridbag.setConstraints( forename_label= new JLabel("Forename(s)"), c);
    user_info_panel.add( forename_label);
    c.anchor= GridBagConstraints.WEST;
    c.gridx= 1;
    gridbag.setConstraints( forename_field= new JTextField( 12), c);
    user_info_panel.add( forename_field);
    c.anchor= GridBagConstraints.EAST;
    c.gridx= 2;
    gridbag.setConstraints( surname_label= new JLabel("Surname"), c);
    user_info_panel.add( surname_label);
    c.anchor= GridBagConstraints.WEST;
    c.gridx= 3;
    gridbag.setConstraints( surname_field= new JTextField( 18), c);
    user_info_panel.add( surname_field);

    c.anchor= GridBagConstraints.EAST;
    c.gridx= 0;
    c.gridy= 2;
    gridbag.setConstraints( phone_label= new JLabel("Phone"), c);
    user_info_panel.add( phone_label);
    c.anchor= GridBagConstraints.WEST;
    c.gridx= 1;
    gridbag.setConstraints( phone_field= new JTextField( 12), c);
    user_info_panel.add( phone_field);
    c.anchor= GridBagConstraints.EAST;
    c.gridx= 2;
    gridbag.setConstraints( email_label= new JLabel("E-mail"), c);
    user_info_panel.add( email_label);
    c.anchor= GridBagConstraints.WEST;
    c.gridx= 3;
    gridbag.setConstraints( email_field= new JTextField( 18), c);
    user_info_panel.add( email_field);

    c.anchor= GridBagConstraints.EAST;
    c.gridx= 0;
    c.gridy= 3;
    gridbag.setConstraints( position_label= new JLabel("Position/affiliation"), c);
    user_info_panel.add( position_label);
    c.anchor= GridBagConstraints.WEST;
    c.gridx= 1;
    gridbag.setConstraints( position_field= new JTextField( 12), c);
    user_info_panel.add( position_field);
    add( user_info_panel, BorderLayout.EAST);

    add( button_panel= new JPanel(),
	 BorderLayout.SOUTH);
    button_panel.add( remove_visitor_button= new JButton("Remove visitor"));
    remove_visitor_button.addActionListener(this);
    button_panel.add( add_visitor_button= new JButton("Add visitor"));
    add_visitor_button.addActionListener(this);

    try {
      bootstrap_listener= new Bootstrap_listener_n( this);
      holder_manager= ABng_Core_Management.Badge_Holder_RepHelper.narrow
	(Bootstrap_n.resolve( Bootstrap_n.SRV_Badge_Holder_Repository()));
      bootstrap_listener.register_callback( 
		      Bootstrap_n.SRV_Badge_Holder_Repository());
    }
    catch (Exception ex) {
      System.err.println("Error contacting Server Manager / Badge Holder Repository");
      System.err.println( ex);
      System.exit(1);      
    }
    try {
      user_manager= Domain_Repository_Management.User_Rep_ManagerHelper.narrow
	(Bootstrap_n.resolve( Bootstrap_n.SRV_User_Repository_Manager()));
      bootstrap_listener.register_callback( 
			   Bootstrap_n.SRV_User_Repository_Manager());
    }
    catch (Exception ex) {
      System.err.println("Error contacting Server Manager / User Repository");
      System.err.println( ex);
      System.exit(1);      
    }
    loadData();
  }  

  public synchronized void loadData() {
    visitor_list.setListData( new Vector());
    visitors.removeAllElements();
    
    System.err.println( "loadData");
    try {
      ABng_Core_System._Badge_HolderPackage.Pattern patt=
	RepTools.get_bhrep_pattern();
      patt.is_any= false;
      patt.visitor_pattern.is_any= false;
      patt.visitor_pattern.value= true; // only visitors

      ABng_Core_System._Badge_HolderPackage.Entity_Set es=
	new ABng_Core_System._Badge_HolderPackage.Entity_Set();
      es.s_pattern( patt);

      Domain_Repository.Query_Options qo=
	new Domain_Repository.Query_Options();
      qo.return_references= true;
      qo.return_descriptions= true;
      qo.return_value_descriptions= true;
      qo.do_attach= true;
      qo.do_detach= false;

      //      System.err.println("---complex_query");
      ABng_Core_System._Badge_HolderPackage.Query_Results qr=
	holder_manager.complex_query( es, qo, holder_observer_object);
      //      System.err.println("+++complex_query");
      //      System.err.println("len " + qr.r_value_descriptions.length);
      holder_manager.attach_add_system_static_data_observer( holder_observer_object);
      int len= qr.r_references.length;
      for (int i=0; i<len; i++) {
	Visitor vis= new Visitor( qr.r_references[i],
				  qr.r_value_descriptions[i]);
	visitors.addElement( vis);
      }
      //      for (int i=0; i<qr.r_attach_results.length; i++)
      //	System.err.println( ""+i+' '+qr.r_attach_results[i]);
      visitor_list.setListData( visitors);
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
    System.err.println("...loadData");
  }

  public synchronized void reference_resolved( String[] name,
					       org.omg.CORBA.Object server_ref,
					       int callback_identifier) {

    System.err.println("reference_resolved");
    if (Bootstrap_n.equal_names
	( name, Bootstrap_n.SRV_Badge_Holder_Repository())) {

      holder_manager= ABng_Core_Management.Badge_Holder_RepHelper.narrow
	(server_ref);
      loadData();
    }
    if (Bootstrap_n.equal_names
	( name, Bootstrap_n.SRV_User_Repository_Manager())) {

      user_manager= Domain_Repository_Management.User_Rep_ManagerHelper.narrow
	(server_ref);
      loadData();
    }
  }

  public void server_shutdown( String[] name,
			     int callback_identifier) {}
  /*  
  public void _notify( int item_id, 
        Domain_Repository.Static_Data_ObserverPackage.Static_Data_Object sdo,
	Domain_Repository.Change_Type ct) {
    notify( item_id, sdo, ct);
  }
 
  public void notify( int item_id, 
        Domain_Repository.Static_Data_ObserverPackage.Static_Data_Object sdo,
	Domain_Repository.Change_Type ct) {

    System.err.println("notify");
    loadData();
  }
  */

  public void _notify( int item_id, 
        ABng_Core_System.System_Static_Data_ObserverPackage.
		       System_Static_Data_Object ssdo,
	Domain_Repository.Change_Type ct) {
    notify( item_id, ssdo, ct);
  }

  public void notify( int item_id, 
        ABng_Core_System.System_Static_Data_ObserverPackage.
		       System_Static_Data_Object ssdo,
	Domain_Repository.Change_Type ct) {

    System.err.println("notify");
    //    loadData();
  }

  public void abort() {}

  public synchronized void actionPerformed( ActionEvent e) {
    Object source= e.getSource();
    String ac= e.getActionCommand();
    if ("Refresh".equals(ac)) {
      loadData();
      return;
    }
    else if ("Exit".equals(ac)) System.exit(0);

    if (last_selection == null) return;
    if (source == remove_visitor_button &&
	     last_selection.isValidVisitor()) {

      try {
	ABng_Core_System._Badge_HolderPackage.Description bhdesc=
	  last_selection.bhref.descr();
	if (!bhdesc.visitor ||
	    !bhdesc.assigned) return;

	bhdesc.assigned= false;
	holder_manager.update( last_selection.bhref,
			       bhdesc);
      }
      catch (Exception ex) {
	ex.printStackTrace();
      }
    }
    else if (source == add_visitor_button &&
	     !last_selection.isValidVisitor()) {
      try {
	Domain_Repository.UserPackage.Pattern upatt=
	  RepTools.get_urep_pattern();
	upatt.is_any= false;
	upatt.item_id_pattern.is_any= false;
	upatt.item_id_pattern.value= last_selection.descr().item_id;

	Domain_Repository.User[] ures=
	  user_manager.rep().find( upatt);
	if (ures.length !=1) return;
	Domain_Repository.UserPackage.Description udesc=
	  new Domain_Repository.UserPackage.Description();
	udesc.uid= user_id_field.getText();
	udesc.forename= forename_field.getText();
	udesc.surname= surname_field.getText();
	udesc.position= position_field.getText();
	udesc.email= email_field.getText();
	udesc.phone= phone_field.getText();
	user_manager.update( ures[0],
			     udesc);

	ABng_Core_System._Badge_HolderPackage.Description bhdesc=
	  last_selection.bhref.descr();
	if (!bhdesc.visitor ||
	    bhdesc.assigned) return;

	bhdesc.assigned= true;
	holder_manager.update( last_selection.bhref,
			       bhdesc);
	bhdesc= last_selection.bhref.descr();
      }
      catch (Exception ex) {
	ex.printStackTrace();
      }
    }
  }

  public synchronized void valueChanged( ListSelectionEvent e) {
    
    ListModel listData = visitor_list.getModel();

    int first= visitor_list.getMinSelectionIndex(),
        last= visitor_list.getMaxSelectionIndex();

    if (first != -1)
      setSelection( (Visitor) listData.getElementAt( first));
    else
      setSelection( null);
  }

  private void setSelection( Visitor vis) {
    last_selection= vis;
    if (vis == null) {
      add_visitor_button.setEnabled( false);
      remove_visitor_button.setEnabled( false);
      return;
    }

    if (vis.isValidVisitor()) {
      add_visitor_button.setEnabled( false);
      remove_visitor_button.setEnabled( true);
      user_id_field.setText( vis.descr().uid);
      forename_field.setText( vis.descr().forename);
      forename_field.setEnabled( false);
      surname_field.setText( vis.descr().surname);
      surname_field.setEnabled( false);
      position_field.setText( vis.descr().position);
      position_field.setEnabled( false);
      email_field.setText( vis.descr().email);
      email_field.setEnabled( false);
      phone_field.setText( vis.descr().phone);
      phone_field.setEnabled( false);
    }
    else {
      add_visitor_button.setEnabled( true);
      remove_visitor_button.setEnabled( false);
      user_id_field.setText( vis.descr().uid);
      forename_field.setText("");
      forename_field.setEnabled( true);
      surname_field.setText("");
      surname_field.setEnabled( true);
      position_field.setText("");
      position_field.setEnabled( true);
      email_field.setText("");
      email_field.setEnabled( true);
      phone_field.setText("");
      phone_field.setEnabled( true);
    }
  }

  JMenuBar createMenuBar() {
    JMenuBar mb= new JMenuBar();
    JMenu menu= new JMenu("Misc");
    mb.add( menu);
    JMenuItem mi;
    menu.add( mi= new JMenuItem("Refresh"));
    mi.setActionCommand("Refresh");
    mi.addActionListener(this);
    menu.addSeparator();
    menu.add( mi= new JMenuItem("Exit"));
    mi.setActionCommand("Exit");
    mi.addActionListener(this);

    return mb;
  }

  public static void main(String argv[]) {

    my_orb_wrapper= new ORB_wrapper();
    my_orb_wrapper.init_application( argv);
    Bootstrap_n.init();

    JABngVisitor_Main panel= new JABngVisitor_Main();
    frame = new JFrame("ABng Visitors");
    frame.setJMenuBar( panel.createMenuBar());

    frame.addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {System.exit(0);}
    });
    frame.getContentPane().setLayout( new FlowLayout());
    frame.getContentPane().add( panel);
    frame.pack();
    frame.show();
  }
  
}
