package ABngSystem;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.lang.*;

import com.sun.java.swing.*;
import com.sun.java.swing.event.*;
import com.sun.java.swing.border.*;


import ABng_Core.*;
import ABng_Core_System.*;
import ABng_Core_Management.*;

//////////////////////////////////////////
/* Class that's a part of four windows in the
   repository window. AddPanel for adding the item to 
   repository. Just a item panel for input data
   and three buttons: Add, Clear and Close */
/////////////////////////////////////////////

class AddPanel extends JPanel{

   JButton add;
   JButton clear;
   ItemPanel sensorpanel;

   Window parent;
   RepGet repository;
   String repname;
   org.omg.CORBA.Object object;

   public AddPanel(Window parent, String repname, RepGet rep){

// CHECK THE BACKGROUND COLOR
//      setBackground(Color.lightGray);
      setSize(595,370);
      setLayout(null);
      this.parent = parent;
      this.repository = rep;
      this.repname = repname;
      object = null;

      ButtonClicked bc = new ButtonClicked();
      add = new JButton("Add");
      add.setSize(125,25);
      add.setLocation(155,335);
      add.addActionListener(bc);
      add.setToolTipText("Add item");
//      add.setEnabled(false);
      add(add);
      clear = new JButton("Clear");
      clear.setSize(125,25);
      clear.setLocation(315,335);
      clear.addActionListener(bc);
      clear.setToolTipText("Clear form");
      add(clear);

      if (repname.equals(RepName.userRep)) 
         sensorpanel = new UserPanel(true, 1, parent);
      else if (repname.equals(RepName.sensorRep)) 
         sensorpanel = new SensorPanel(true, 1, parent);
      else if (repname.equals(RepName.badgeRep))
         sensorpanel = new BadgePanel(true, 1, parent);
      else if (repname.equals(RepName.holderRep))
         sensorpanel = new HolderPanel(true, 1, parent);
      else if (repname.equals(RepName.locationTypeRep))
         sensorpanel = new LocationTypePanel(true, 1, parent);
      else if (repname.equals(RepName.locationDescRep))
         sensorpanel = new LocationDescPanel(true, 1, parent);
      else if (repname.equals(RepName.abngldRep))
         sensorpanel = new AbngldPanel(true, 1, parent);
      else if (repname.equals(RepName.viewRep))
         sensorpanel = new ViewPanel(true, 1, parent);
      sensorpanel.setLocation(115,10);
      add(sensorpanel);
   }

   public org.omg.CORBA.Object getObject() { return object; }

/////////////////////////////////////////////////
/* Class that response when user click the button
   It's just recognize the source and invoking right 
   action. */
/////////////////////////////////////////////////

   protected final class ButtonClicked implements ActionListener{
      public void actionPerformed(ActionEvent e){
         if (((JButton) e.getSource()) == add){
            if (sensorpanel.check()){
               parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
// We're asking to make sure the settings are OK
               if (JOptionPane.showConfirmDialog(parent, 
                          "Are You Accept this settings", 
                          "Add Confirmation", 
                          JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION){
                  parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
                  String mesg = "Unknow error";
                  if (repname.equals(RepName.sensorRep)){
                     String sensid = ((SensorPanel) sensorpanel).getSensorNumber();
                     String netnb = ((SensorPanel) sensorpanel).getNetworkNumber();
                     String netname = ((SensorPanel) sensorpanel).getNetworkGroupName();
                     mesg = repository.add("0", sensid, netnb, netname);
                  } else if (repname.equals(RepName.userRep)){
                     String uid = ((UserPanel) sensorpanel).getUID();
                     String forename = ((UserPanel) sensorpanel).getForename();
                     String surname = ((UserPanel) sensorpanel).getSurname();
                     String position = ((UserPanel) sensorpanel).getPosition();
                     String email = ((UserPanel) sensorpanel).getEmail();
                     String phone = ((UserPanel) sensorpanel).getPhone();
                     mesg = repository.add("0", uid, forename, surname, position, email, phone);
                  } else if (repname.equals(RepName.badgeRep)){
                     try{
                        byte[] abyte = ((BadgePanel) sensorpanel).getID();
                        org.omg.CORBA.Object holder = ((BadgePanel) sensorpanel).getBadgeHolder();
                        mesg = repository.add(abyte, holder);
                     } catch (NumberFormatException ex) {
		       ex.printStackTrace();
                        mesg = "Please enter a valid number as badgeID";
                     }
                  } else if (repname.equals(RepName.holderRep)){
                     org.omg.CORBA.Object mybadge = ((HolderPanel) sensorpanel).getMyBadge();
                     org.omg.CORBA.Object currentbadge = ((HolderPanel) sensorpanel).getCurrentBadge();
                     org.omg.CORBA.Object homesensor = ((HolderPanel) sensorpanel).getHomeSensor();
                     ABng_Core.Locatable_Type_Specific_Object ltso = ((HolderPanel) sensorpanel).getLTSO();
                     ABng_Core.Locatable_Type type = ((HolderPanel) sensorpanel).getType();
		     boolean visitor = ((HolderPanel) sensorpanel).getVisitor();
		     boolean valid_visitor = ((HolderPanel) sensorpanel).getValidVisitor();
                     mesg = repository.add(mybadge, currentbadge, homesensor, ltso, visitor, valid_visitor);
                  } else if (repname.equals(RepName.locationTypeRep)){
                     String name = ((LocationTypePanel) sensorpanel).getName();
                     Domain_Repository.Property_Description[] tab = ((LocationTypePanel) sensorpanel).getDescriptions();
                     mesg = repository.add("0", name, tab);
                  } else if (repname.equals(RepName.locationDescRep)){
                     String name = ((LocationDescPanel) sensorpanel).getName();
                     Domain_Repository.Property[] tab = ((LocationDescPanel) sensorpanel).getProperties();
                     mesg = repository.add("0", name, tab);
                  } else if (repname.equals(RepName.abngldRep)){
                     Domain_Repository.Location_Description ld = ((AbngldPanel) sensorpanel).getLocationDescription();
                     Sensor[] sensors = ((AbngldPanel) sensorpanel).getSensors();
                     mesg = repository.add("0", ld, sensors);
                  } else if (repname.equals(RepName.viewRep)){
                     mesg = "Not supported yet";
                  }
                  if (mesg.compareTo("OK") != 0) {
                     parent.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
                     JOptionPane.showMessageDialog(parent, mesg, "Can't add item", JOptionPane.ERROR_MESSAGE);
                  } else {
                     sensorpanel.clear();
                     parent.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
                     JOptionPane.showMessageDialog(parent, "Operation successfully", "Add OK", JOptionPane.INFORMATION_MESSAGE);
                     if (parent.getClass().getName().equals("RepositoryDialog"))
                        ((RepositoryDialog)parent).updateList();
                     else ((RepositoryReferenceDialog)parent).updateList();
                  }
               }
            }
            else {
               parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));            

// or to tell the user he(she) shoud fill all fields
               JOptionPane.showMessageDialog(parent, "You must fill all fields first", "Can't add item", JOptionPane.ERROR_MESSAGE);
            }
            parent.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
            SwingUtilities.updateComponentTreeUI(parent);
         }
         else if (((JButton) e.getSource()) == clear){
// Just clear form - discard changes
            sensorpanel.clear();
         }
      }
   }
}
