package ABngSystem;
 
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.lang.*;
 
import com.sun.java.swing.*;
import com.sun.java.swing.event.*;
import com.sun.java.swing.border.*;
 
import ABng_Core.*;
import ABng_Core_System.*;
import ABng_Core_Management.*;
 
//////////////////////////////////////////////////
/* This class represents a graphic "part" of itch location type
   It just shows badge's fields to user.
   Few methods to manage this fields */
///////////////////////////////////////
 
class LocationTypePanel extends ItemPanel{
 
   boolean state;
   int type;
   int index;
   Window parent;
   org.omg.CORBA.Object object;

   JTextField name;
   JList proplist;
   JButton propbutton;
   JButton add;
   JButton remove;
   String[] propnames;
   Domain_Repository.Property_Description[] properties;
   Domain_Repository.Property_Description_Pattern[] proppattern;
 
   public LocationTypePanel(boolean state, int type, Window parent){
 
      JPanel pane = new JPanel();
      pane.setLayout(null);
      this.state = state;
      this.type = type;
      this.parent = parent;
      object = null;
  
      propnames = new String[0];
      properties = new Domain_Repository.Property_Description[0];

      JLabel label;
      label = new JLabel("Location_Type name:");
      label.setSize(330,15);
      label.setLocation(10,10);
      pane.add(label);
      name = new JTextField();
      name.setSize(315,20);
      name.setLocation(25,30);
      name.setEnabled(state);
      pane.add(name);
 
      label = new JLabel("Properties Desription list:");
      label.setSize(330,15);
      label.setLocation(10,60);
      pane.add(label);
      proplist = new JList(propnames);
      proplist.setLocation(0,0);
      proplist.addListSelectionListener(new ItemChanged());
      proplist.addMouseListener(new ItemClicked());
      JScrollPane scrollpane = new JScrollPane(proplist);
      scrollpane.setSize(315,150);
      scrollpane.setLocation(25,80);
      pane.add(scrollpane);

      LocationTypeClicked ltc = new LocationTypeClicked();
      propbutton = new JButton("Display selected property");
      propbutton.setSize(315,20);
      propbutton.setLocation(25,240);
      propbutton.setEnabled(false);
      propbutton.addActionListener(ltc);
      pane.add(propbutton);

      add = new JButton("Add property");
      add.setSize(150, 20);
      add.setLocation(25, 270);
      add.setEnabled(state);
      add.addActionListener(ltc);
      pane.add(add);
      remove = new JButton("Remove property");
      remove.setSize(150, 20);
      remove.setLocation(190, 270);
      remove.setEnabled(false);
      remove.addActionListener(ltc);
      pane.add(remove);
 
      if (type == 2){
         add.setText("Add Property Pattern");
         remove.setText("Remove Property Pattern");
      }

      proppattern = new Domain_Repository.Property_Description_Pattern[0];
      pane.setPreferredSize(new Dimension(360,270));
      add(pane);
      this.setViewportView(pane);
   }
 
// Get itch of the fields
   public String getName() { return name.getText(); }
   public Domain_Repository.Property_Description[] getDescriptions() { return properties; }
 
// Set itch of the fields
   public void setName(String value) { name.setText(value); }
   public void setDesriptions(Domain_Repository.Property_Description[] value) { properties = value; }
 
// Clear all fields
   public void clear(){
      name.setText("");
      properties = new Domain_Repository.Property_Description[0];
      proppattern = new Domain_Repository.Property_Description_Pattern[0];
      propnames = new String[0];
      proplist.setListData(propnames);
      proplist.repaint();
      proplist.revalidate();
      propbutton.setEnabled(false);
      remove.setEnabled(false);
   }
 
// Chack if all filds are filled
   public boolean check(){
      if (name.getText().compareTo("") == 0) return false;
      return true;
   }
 
// Just copy the content of source badge
   public void copy(ItemPanel source){
   }
 
   public void setData(org.omg.CORBA.Object source){
 
      Domain_Repository.Location_Type lt = Domain_Repository.Location_TypeHelper.narrow(source);
      object = source;
 
      name.setText(lt.name());
      propnames = new String[0];
      proplist.setListData(propnames);
      proplist.repaint();
      proplist.revalidate();
      propbutton.setEnabled(false);
      properties = lt.property_description_list();
      if (properties == null) {
         properties =  new Domain_Repository.Property_Description[0];
      }
      propnames = new String[properties.length];
      for (int i=0; i<properties.length; i++){
         propnames[i] = new String(properties[i].name);
      }
      proplist.setListData(propnames);
      proplist.repaint();
      proplist.revalidate();
      propbutton.setEnabled(false);
      remove.setEnabled(false);
      repaint();
   }
 
// Build pattern for find function
 
   public Domain_Repository.Location_TypePackage.Pattern buildPattern(){
      Domain_Repository.Property_Descriptions_Pattern pdp = RepGet.BuildPropertyDescriptionsPattern( null, proppattern);
      return RepGet.BuildLocationTypePattern("", name.getText(), pdp);
   }

/////////////////////////////////
/* Reaction for button clicked */
/////////////////////////////////
 
   protected final class LocationTypeClicked implements ActionListener{
      public void actionPerformed(ActionEvent e){
         if (((JButton) e.getSource()) == propbutton){
            parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
            PDWindow pdw = new PDWindow(parent);
            pdw.setData(properties[index]);
            pdw.getContentPane().remove(pdw.accept);
            pdw.setVisible(true);
            pdw.dispose();
         }
         else if (((JButton) e.getSource()) == add){
            if (type == 1){
               parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
               PDWindow dlg = new PDWindow(parent);
               dlg.setVisible(true);
               if (dlg.getAnswer()){
                  Domain_Repository.Property_Description pd = dlg.getPD();
                     parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
                     int count = properties.length;
                     Domain_Repository.Property_Description[] old = properties;
                     String[] oldnames = propnames;
                     properties = new Domain_Repository.Property_Description[count+1];
                     propnames = new String[count+1];
                     for (int i=0; i<count; i++){
                        properties[i] = old[i];
                        propnames[i] = oldnames[i];
                     }
                     properties[count] = pd;
                     propnames[count] = pd.name;
                     proplist.setListData(propnames);
                     proplist.repaint();
                     proplist.revalidate();
               }
               dlg.dispose();
               parent.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
            } else if (type == 2){
               parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
               PDWindow dlg = new PDWindow(parent);
               dlg.setVisible(true);
               if (dlg.getAnswer()){
                  int count = proppattern.length;
                  Domain_Repository.Property_Description_Pattern[] old = proppattern;
                  String[] oldnames = propnames;
                  proppattern = new Domain_Repository.Property_Description_Pattern[count+1];
                  propnames = new String[count+1];
                  for (int i=0; i<count; i++){
                     proppattern[i] = old[i];
                     propnames[i] = oldnames[i];
                  }
                  proppattern[count] = RepGet.BuildPropertyDescriptionPattern(dlg.getPD());
                  propnames[count] = "Property Description Pattern";
                  proplist.setListData(propnames);
                  proplist.repaint();
                  proplist.revalidate();
               }
               dlg.dispose();
               parent.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
            }
         }
         else if (((JButton) e.getSource()) == remove){
            if (type == 1) {
               parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
                  int count = properties.length;
                  for (int i=index; i<count-1; i++){
                     properties[i] = properties[i+1];
                     propnames[i] = propnames[i+1];
                  }
                  properties[count-1] = null;
                  propnames[count-1] = null;
                  Domain_Repository.Property_Description[] old = properties;
                  String[] oldnames = propnames;
                  properties = new Domain_Repository.Property_Description[count-1];
                  propnames = new String[count-1];
                  for (int i=0; i<count-1; i++){
                     properties[i] = old[i];
                     propnames[i] = oldnames[i];
                  }
                  proplist.setListData(propnames);
                  proplist.repaint();
                  proplist.revalidate();
               parent.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
            } else if (type == 2) {
               parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
               int count = proppattern.length;
               for (int i=index; i<count-1; i++){
                  proppattern[i] = proppattern[i+1];
                  propnames[i] = propnames[i+1];
               }
               proppattern[count-1] = null;
               propnames[count-1] = null;
               Domain_Repository.Property_Description_Pattern[] old = proppattern;
               String[] oldnames = propnames;
               proppattern = new Domain_Repository.Property_Description_Pattern[count-1];
               propnames = new String[count-1];
               for (int i=0; i<count-1; i++){
                  proppattern[i] = old[i];
                  propnames[i] = oldnames[i];
               }
               proplist.setListData(propnames);
               proplist.repaint();
               proplist.revalidate();
               parent.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
            }
            remove.setEnabled(false);
            propbutton.setEnabled(false);
         }
      }
   }
 
//////////////////////////////////////
/* This class response when the user
   click on an item */
//////////////////////////////////////
 
   protected final class ItemChanged implements ListSelectionListener{
      public void valueChanged(ListSelectionEvent e){
         index = proplist.getSelectedIndex();
         if (index!=-1){
            if (type != 2) propbutton.setEnabled(true);
            if (state) remove.setEnabled(true);
         }
      }
   }

   protected final class ItemClicked extends MouseAdapter{
      public void mouseClicked(MouseEvent e){
         if (e.getClickCount() == 2){
            if (e.getSource() == proplist){
               propbutton.doClick();
            }
         }
         super.mouseClicked(e);
      }
   }
}

