package ABngSystem;

import ABng_Core_System.SensorPackage.*;
import ABng_Core_System.*;
import ABng_Core_Management.*;
import Domain_Repository.*;
import Domain_Repository_Management.*;

import CosNaming.*;
import org.omg.CORBA.ORB;

import java.io.*;

public class RepGet
{
	private NamingContext ncRoot = null;
	private ORB oMyORB = null;
	private org.omg.CORBA.Object oRepository = null;
	private org.omg.CORBA.Object oRepositoryManagement = null;
	private String sVersion = "0.9.6";
	private String sAuthors = "Radek Stachowiak, Marcin Zyjewski";
	private int iRepositoryType;
	private String sRepositoryType;
	private String sRepositoryManagement = "_Manager";
	private String srepnameSensor = "Sensor_Repository";					// 1
	private String srepnameBadge = "Badge_Repository";					// 2
	private String srepnameBadgeHolder = "Badge_Holder_Repository";				// 3
	private String srepnameUser = "User_Repository";					// 104
	private String srepnameEquipment = "Equipment_Repository";				// 105
	private String srepnameMetaEquipment = "Meta_Equipment_Repository";			// 106
	private String srepnameLocationType = "Location_Type_Repository";			// 107
	private String srepnameLocationDescription = "Location_Description_Repository";		// 108
	private String srepnameABngLocationDescription = "ABng_Location_Description_Repository";// 9
	private String srepnameViews = "View_Managers";						// 201
	private	String sFirst =  "ABng_Core";
	private	String sSecond = "Domain_Repository";
	private	String sThird = "Management";
	private	String sFourth = "Public";

	private org.omg.CORBA.Object IORfile_to_object( String IORfilename )
	throws Exception {
		String IOR;
		FileInputStream fis = new FileInputStream( IORfilename );
		byte[] contents = new byte[ (int) new File( IORfilename ).length() ];
		int len = fis.read( contents );
		while( contents[ len-1 ] < ' ' ) len--;  // End of string removal.
		IOR = new String( contents, 0, len );
		return oMyORB.string_to_object( IOR );
	}

	public RepGet()
	{
		sRepositoryType = new String("__empty__");
		oMyORB = ORB.init();

		String sNS_environment = "NS_IOR_FILE";
		String sNS_filename = "/home/iris/abs/data/NS.ior";
		String sNS_result = System.getProperty( sNS_environment , sNS_filename );
		try {
			ncRoot = NamingContextHelper.narrow( IORfile_to_object( sNS_result ) );
			if( ncRoot == null ) {
				System.err.println("ERROR! I cannot connect to NameService: " + sNS_result );
			}
		}
		catch ( Exception e ) {
			System.err.println("ERROR! Exception raised during connect to NameService: " + sNS_result + "\n" + e.toString() );
		}

		System.out.println("[RG initialized][RepGet, version " + sVersion + " (c) 1998 " + sAuthors + "]" );

	}

	//
	// Public function to connect to specified repository. ON exit returns int corresponds to repository
	// or 0 in case of unknown repository (ERROR!)
	//
	public String init( String _sName )
	{
		sRepositoryType = new String( _sName );

		if ( _sName.compareTo( srepnameSensor ) == 0 )
			iRepositoryType = 1;
		else if ( _sName.compareTo( srepnameBadge ) == 0 )
			iRepositoryType = 2;
		else if ( _sName.compareTo( srepnameBadgeHolder ) == 0 )
			iRepositoryType = 3;
		else if ( _sName.compareTo( srepnameUser ) == 0 )
			iRepositoryType = 104;
		else if ( _sName.compareTo( srepnameEquipment ) == 0 )
			iRepositoryType = 105;
		else if ( _sName.compareTo( srepnameMetaEquipment ) == 0 )
			iRepositoryType = 106;
		else if ( _sName.compareTo( srepnameLocationType ) == 0 )
			iRepositoryType = 107;
		else if ( _sName.compareTo( srepnameLocationDescription ) == 0 )
			iRepositoryType = 108;
		else if ( _sName.compareTo (srepnameABngLocationDescription ) == 0 )
			iRepositoryType = 9;
		else if ( _sName.compareTo (srepnameViews ) == 0 )
			iRepositoryType = 201;
		else
		{
			iRepositoryType = 0;
			return new String("Unknown Repository Name");
		}

		return connectToRepository( );
	}

	private String connectToRepository( )
	{
		org.omg.CORBA.Object oRef = null;
		org.omg.CORBA.Object oRefMan = null;
		NameComponent[] ncTable = null;

		if( iRepositoryType == 201 )			// Views
		{
			oRepository = null;
			oRepositoryManagement = null;

			System.out.println("[RG operation][Connection to " + sRepositoryType + " PROPABLY opened.]");
			return new String( "OK" );
		}

		ncTable = new NameComponent[4]; 

		if( iRepositoryType > 100 ) 
		{
		        ncTable[0] = new NameComponent( "ABng", "ABng");
			ncTable[1] = new NameComponent( sSecond, sSecond );
			ncTable[2] = new NameComponent( sThird , sThird );
			ncTable[3] = new NameComponent( sRepositoryType  + sRepositoryManagement + "@", sRepositoryType + sRepositoryManagement + "@");
			try
			{
				oRefMan = ncRoot.resolve( ncTable ); 
			}
			catch( CosNaming.NamingContextPackage.InvalidName e )
			{
				System.err.println("ERROR! InvalidName. " + e.toString() );
				return new String("Invalid Repository Name.");
			}
			catch ( CosNaming.NamingContextPackage.CannotProceed   e)
			{
				System.err.println("ERROR! Cannot proceed. " + e.toString() );
				return new String("Cannot proced request.");
			}
			catch ( CosNaming.NamingContextPackage.NotFound e)
			{
				System.err.println("ERROR! Reference not found. " + e.toString() );
				return new String("Repository not found.");
			}
			catch ( Exception e)
			{
				System.err.println("ERROR! " + e.toString() );
				return new String("Unknown exception during resolving NS.");
			}


			ncTable[2] = new NameComponent( sFourth, sFourth );
			ncTable[3] = new NameComponent( sRepositoryType, sRepositoryType );

			try
			{
				oRef = ncRoot.resolve( ncTable ); 
			}
			catch( CosNaming.NamingContextPackage.InvalidName e )
			{
				System.err.println("ERROR! InvalidName. " + e.toString() );
				return new String("Invalid Repository Name.");
			}
			catch ( CosNaming.NamingContextPackage.CannotProceed   e)
			{
				System.err.println("ERROR! Cannot proceed. " + e.toString() );
				return new String("Cannot proced request.");
			}
			catch ( CosNaming.NamingContextPackage.NotFound e)
			{
				System.err.println("ERROR! Reference not found. " + e.toString() );
				return new String("Repository not found.");
			}
			catch ( Exception e)
			{
				System.err.println("ERROR! " + e.toString() );
				return new String("Unknown exception during resolving NS.");
			}

			oRepository = oRef;
			oRepositoryManagement = oRefMan;
		}
		else 
		{
		        ncTable[0] = new NameComponent( "ABng", "ABng");
			ncTable[1] = new NameComponent( sFirst, sFirst );
			ncTable[2] = new NameComponent( sThird, sThird );
			ncTable[3] = new NameComponent( sRepositoryType+"@", sRepositoryType+"@" );

			try
			{
				oRef = ncRoot.resolve( ncTable ); 
			}
			catch( CosNaming.NamingContextPackage.InvalidName e )
			{
				System.err.println("ERROR! InvalidName. " + e.toString() );
				return new String("Invalid Repository Name.");
			}
			catch ( CosNaming.NamingContextPackage.CannotProceed   e)
			{
				System.err.println("ERROR! Cannot proceed. " + e.toString() );
				return new String("Cannot proced request.");
			}
			catch ( CosNaming.NamingContextPackage.NotFound e)
			{
				System.err.println("ERROR! Reference not found. " + e.toString() );
				return new String("Repository not found.");
			}
			catch ( Exception e)
			{
				System.err.println("ERROR! " + e.toString() );
				return new String("Unknown exception during resolving NS.");
			}

			oRepository = oRef;
		}

		System.out.println("[RG operation][Connection to " + sRepositoryType + " opened.]");
		return new String( "OK" );
	}

	public String[] listRepositories()
	{
		String[] sArray = new String[ 8 ];

		sArray[ 0 ] = new String ( srepnameUser );
		sArray[ 1 ] = new String ( srepnameSensor );
		sArray[ 2 ] = new String ( srepnameBadge );
		sArray[ 3 ] = new String ( srepnameBadgeHolder );
		sArray[ 4 ] = new String ( srepnameLocationType );
		sArray[ 5 ] = new String ( srepnameLocationDescription );
		sArray[ 6 ] = new String ( srepnameABngLocationDescription );
		sArray[ 7 ] = new String ( srepnameViews );

		return sArray;
	}
	
	////////////////////////////////////////////////////////////////////////////// GLOBAL REPOSITORIES FUNCTIONs
	////////////////////////////////////////////////////////////////////////////////////////////////////////////

	//
	// Returns array of CORBA OBjects or in case of failure empty (length == 0) array.
	//
	public org.omg.CORBA.Object[] list()
	{
		if ( iRepositoryType == 1 ) {
		//////////////////////////////////////////////////////////////////// SENSOR REPOSITORY CODE
		Sensor_Rep rTest;
		Sensor[] sList = new Sensor[0];

		rTest = Sensor_RepHelper.narrow( oRepository );
		try
		{
			sList = rTest.sensor_list();
		}
		catch ( Exception e )
		{
			System.err.println("ERROR! " + e.toString() );
			return new org.omg.CORBA.Object[0];
		}

		return sList;

		} else if ( iRepositoryType == 104 ) {
		//////////////////////////////////////////////////////////////////// USER REPOSITORY CODE
		User_Rep_Manager rTest;
		User[] uList = new User[0];

		rTest = User_Rep_ManagerHelper.narrow( oRepositoryManagement );
		try
		{
			uList = rTest.user_list();
		}
		catch ( Exception e )
		{
			System.err.println("ERROR! " + e.toString() );
			return new org.omg.CORBA.Object[0];
		}


		return uList;

		} else if ( iRepositoryType == 9 ) {
		/////////////////////////////////////////////////////////////  ABNG_LOCATION_DESCRIPTION REPOSITORY CODE
		ABng_Location_Description_Rep rTest;
		ABng_Location_Description[] abldList = new ABng_Location_Description[0];

		rTest = ABng_Location_Description_RepHelper.narrow( oRepository );
		try
		{
			abldList = rTest.abng_location_descriptions_list();		
		}
		catch ( Exception e )
		{
			System.err.println("ERROR! " + e.toString() );
			return new org.omg.CORBA.Object[0];
		}


		return abldList;

		} else if ( iRepositoryType == 2 ) {
		//////////////////////////////////////////////////////////////////// BADGE REPOSITORY CODE
		Badge_Holder_Rep rTest;
		_Badge_Holder[] bdghList = new _Badge_Holder[0];

		rTest = Badge_Holder_RepHelper.narrow( oRepository );
		try
		{
			bdghList = rTest.badge_holder_list();
		}
		catch ( Exception e )
		{
			System.err.println("ERROR! " + e.toString() );
			return new org.omg.CORBA.Object[0];
		}


		return bdghList;

		} else if ( iRepositoryType == 3 ) {
		///////////////////////////////////////////////////////////// BADGE HOLDER REPOSITORY CODE
		Badge_Holder_Rep rTest;
		_Badge_Holder[] bdghList = new _Badge_Holder[0];

		rTest = Badge_Holder_RepHelper.narrow( oRepository );
		try
		{
			bdghList = rTest.badge_holder_list();
		}
		catch ( Exception e )
		{
			System.err.println("ERROR! " + e.toString() );
			return new org.omg.CORBA.Object[0];
		}


		return bdghList;

		} else if ( iRepositoryType == 107 ) {
		//////////////////////////////////////////////////////////////////// LOCATION TYPE REPOSITORY CODE
		Location_Type_Rep_Manager rTest;
		Location_Type[] ltList = new Location_Type[0];

		rTest = Location_Type_Rep_ManagerHelper.narrow( oRepositoryManagement );
		try
		{
			ltList = rTest.location_type_list();
		}
		catch ( Exception e )
		{
			System.err.println("ERROR! " + e.toString() );
			return new org.omg.CORBA.Object[0];
		}


		return ltList;

		} else if ( iRepositoryType == 108 ) {
		/////////////////////////////////////////////////////////////////// LOCATION DESCRIPTION REPOSITORY CODE
		Location_Description_Rep_Manager rTest;
		Location_Description[] ldList = new Location_Description[0];

		rTest = Location_Description_Rep_ManagerHelper.narrow( oRepositoryManagement );
		try
		{
			ldList = rTest.location_description_list();
		}
		catch ( Exception e )
		{
			System.err.println("ERROR! " + e.toString() );
			return new org.omg.CORBA.Object[0];
		}


		return ldList;

		} else if ( iRepositoryType == 201 ) {
		///////////////////////////////////////////////////////////////////////// VIEWS
    		BindingListHolder blHolder = new BindingListHolder();
                BindingIteratorHolder biHolder = new BindingIteratorHolder();
                int batchSize = 100; 
		int i;
		NameComponent[] ncTable = null;
		NamingContext ncTemp;

			ncTable = new NameComponent[3];

			ncTable[0] = new NameComponent( sFirst, sFirst );
			ncTable[1] = new NameComponent( sThird , sThird );
			ncTable[2] = new NameComponent( sRepositoryType, sRepositoryType );

			try
			{
				ncTemp = NamingContextHelper.narrow( ncRoot.resolve( ncTable ) ); 
			}
			catch( CosNaming.NamingContextPackage.InvalidName e )
			{
				System.err.println("ERROR! InvalidName. " + e.toString() );
				return new org.omg.CORBA.Object[0];
			}
			catch ( CosNaming.NamingContextPackage.CannotProceed   e)
			{
				System.err.println("ERROR! Cannot proceed. " + e.toString() );
				return new org.omg.CORBA.Object[0];
			}
			catch ( CosNaming.NamingContextPackage.NotFound e)
			{
				System.err.println("ERROR! Reference not found. " + e.toString() );
				return new org.omg.CORBA.Object[0];
			}
			catch ( Exception e)
			{
				System.err.println("ERROR! " + e.toString() );
				return new org.omg.CORBA.Object[0];
			}

			try
			{
                        	ncTemp.list( batchSize, blHolder, biHolder ) ;
			}
			catch ( Exception e)
			{
				System.err.println("ERROR! " + e.toString() );
				return new org.omg.CORBA.Object[0];
			}

			org.omg.CORBA.Object[] array = new org.omg.CORBA.Object[ blHolder.value.length ];
			ncTable = new NameComponent[4];
			ncTable[0] = new NameComponent( sFirst, sFirst );
			ncTable[1] = new NameComponent( sThird , sThird );
			ncTable[2] = new NameComponent( sRepositoryType, sRepositoryType );
                
                        for( i=0; i < blHolder.value.length; i++ )
                        {
				ncTable[3] = new NameComponent( blHolder.value[i].binding_name[0].id, blHolder.value[i].binding_name[0].kind );

				try
				{
					array[ i ]  = ncRoot.resolve( ncTable ); 
				}
				catch( CosNaming.NamingContextPackage.InvalidName e )
				{
					System.err.println("ERROR! InvalidName. " + e.toString() );
					return new org.omg.CORBA.Object[0];
				}
				catch ( CosNaming.NamingContextPackage.CannotProceed   e)
				{
					System.err.println("ERROR! Cannot proceed. " + e.toString() );
					return new org.omg.CORBA.Object[0];
				}
				catch ( CosNaming.NamingContextPackage.NotFound e)
				{
					System.err.println("ERROR! Reference not found. " + e.toString() );
					return new org.omg.CORBA.Object[0];
				}
				catch ( Exception e)
				{
					System.err.println("ERROR! " + e.toString() );
					return new org.omg.CORBA.Object[0];
				}
                        }

		return array;

		}

		// Return FALSE object
		return new org.omg.CORBA.Object[0];
	}

	//
	// Function returns RGContainer Objects which holds array of Objects and arrays of their description.
	// In case of error function return RGContainer with IsError() == true.
	//
	public RGContainer listRG()
	{
		RGContainer rgReturn;
		String[] sArray;
		int i;

		if ( iRepositoryType == 1 ) {
		//////////////////////////////////////////////////////////////////// SENSOR REPOSITORY CODE
		Sensor_Rep rTest;
		Sensor[] sensList;

		rTest = Sensor_RepHelper.narrow( oRepository );
		try
		{
			sensList = rTest.sensor_list();
		}
		catch ( Exception e )
		{
			System.err.println("ERROR! " + e.toString() );
			rgReturn = new RGContainer();
			rgReturn.SetErrorText("Unable to list repository /Comunication failure ???/");
			return rgReturn;
		}

		rgReturn = new RGContainer ( sensList );
		sArray = rgReturn.GetStrings();

		if ( sArray != null )
		{
			for ( i = 0 ; i < sensList.length ; i++ ) 
			{
				sArray[ i ] = DescriptSensor( sensList[ i ] );
			}
			if( i > 0 )
			{
				rgReturn.SetError( false );
				rgReturn.SetErrorText( "No error." );
			}
		}

		return rgReturn;

		} else if ( iRepositoryType == 104 ) {
		//////////////////////////////////////////////////////////////////// USER REPOSITORY CODE
		User_Rep_Manager rTest;
		User[] uList;

		rTest = User_Rep_ManagerHelper.narrow( oRepositoryManagement );
		try
		{
			uList = rTest.user_list();
		}
		catch ( Exception e )
		{
			System.err.println("ERROR! " + e.toString() );
			rgReturn = new RGContainer();
			rgReturn.SetErrorText("Unable to list repository /Comunication failure ???/");
			return rgReturn;
		}

		rgReturn = new RGContainer ( uList );
		sArray = rgReturn.GetStrings();

		if ( sArray != null )
		{
			for ( i = 0 ; i < uList.length ; i++ ) 
			{
				sArray[ i ] = DescriptUser( uList[ i ] );
			}
			if( i > 0 )
			{
				rgReturn.SetError( false );
				rgReturn.SetErrorText( "No error." );
			}
		}

		return rgReturn;
		
		} else if ( iRepositoryType == 2 ) {
		//////////////////////////////////////////////////////////////////// BADGE REPOSITORY CODE
		Badge_Rep rTest;
		Badge[] bdgList = null;

		rTest = Badge_RepHelper.narrow( oRepository );
		try
		{
			bdgList = rTest.badge_list();
		}
		catch ( Exception e )
		{
			System.err.println("ERROR! " + e.toString() );
			rgReturn = new RGContainer();
			rgReturn.SetErrorText("Unable to list repository /Comunication failure ???/");
			return rgReturn;
		}

		rgReturn = new RGContainer ( bdgList );
		sArray = rgReturn.GetStrings();

		if ( sArray != null )
		{
			for ( i = 0 ; i < bdgList.length ; i++ ) 
			{
				sArray[ i ] = DescriptBadge( bdgList[ i ] );
			}
			if( i > 0 )
			{
				rgReturn.SetError( false );
				rgReturn.SetErrorText( "No error." );
			}
		}

		return rgReturn;

		} else if ( iRepositoryType == 9 ) {
		/////////////////////////////////////////////////////////////  ABNG_LOCATION_DESCRIPTION REPOSITORY CODE
		ABng_Location_Description_Rep rTest;
		ABng_Location_Description[] abldList = null; 

		rTest = ABng_Location_Description_RepHelper.narrow( oRepository );
		try
		{
			abldList = rTest.abng_location_descriptions_list();		
		}
		catch ( Exception e )
		{
			System.err.println("ERROR! " + e.toString() );
			rgReturn = new RGContainer();
			rgReturn.SetErrorText("Unable to list repository /Comunication failure ???/");
			return rgReturn;
		}

		rgReturn = new RGContainer ( abldList );
		sArray = rgReturn.GetStrings();

		if ( sArray != null )
		{
			for ( i = 0 ; i < abldList.length ; i++ ) 
			{
				sArray[ i ] = DescriptABngLocationDescription( abldList[ i ] );
			}
			if( i > 0 )
			{
				rgReturn.SetError( false );
				rgReturn.SetErrorText( "No error." );
			}
		}

		return rgReturn;

		} else if ( iRepositoryType == 3 ) {
		//////////////////////////////////////////////////////////// BADGE HOLDER REPOSITORY CODE
		Badge_Holder_Rep rTest;
		_Badge_Holder[] bdghList = null;

		rTest = Badge_Holder_RepHelper.narrow( oRepository );
		try
		{
			bdghList = rTest.badge_holder_list();
		}
		catch ( Exception e )
		{
			System.err.println("ERROR! " + e.toString() );
			rgReturn = new RGContainer();
			rgReturn.SetErrorText("Unable to list repository /Comunication failure ???/");
			return rgReturn;
		}

		rgReturn = new RGContainer ( bdghList );
		sArray = rgReturn.GetStrings();

		if ( sArray != null )
		{
			for ( i = 0 ; i < bdghList.length ; i++ ) 
			{
				sArray[ i ] = DescriptBadgeHolder( bdghList[ i ] );
			}
			if( i > 0 )
			{
				rgReturn.SetError( false );
				rgReturn.SetErrorText( "No error." );
			}
		}

		return rgReturn;

		} else if ( iRepositoryType == 107 ) {
		//////////////////////////////////////////////////////////////////// LOCATION TYPE REPOSITORY CODE
		Location_Type_Rep_Manager rTest;
		Location_Type[] ltList;

		rTest = Location_Type_Rep_ManagerHelper.narrow( oRepositoryManagement );
		try
		{
			ltList = rTest.location_type_list();
		}
		catch ( Exception e )
		{
			System.err.println("ERROR! " + e.toString() );
			rgReturn = new RGContainer();
			rgReturn.SetErrorText("Unable to list repository /Comunication failure ???/");
			return rgReturn;
		}

		rgReturn = new RGContainer ( ltList );
		sArray = rgReturn.GetStrings();

		if ( sArray != null )
		{
			for ( i = 0 ; i < ltList.length ; i++ ) 
			{
				sArray[ i ] = DescriptLocationType( ltList[ i ] );
			}
			if( i > 0 )
			{
				rgReturn.SetError( false );
				rgReturn.SetErrorText( "No error." );
			}
		}

		return rgReturn;
		
		} else if ( iRepositoryType == 108 ) {
		/////////////////////////////////////////////////////////////////// LOCATION DESCRIPTION REPOSITORY CODE
		Location_Description_Rep_Manager rTest;
		Location_Description[] ldList;

		rTest = Location_Description_Rep_ManagerHelper.narrow( oRepositoryManagement );
		try
		{
			ldList = rTest.location_description_list();
		}
		catch ( Exception e )
		{
			System.err.println("ERROR! " + e.toString() );
			rgReturn = new RGContainer();
			rgReturn.SetErrorText("Unable to list repository /Comunication failure ???/");
			return rgReturn;
		}

		rgReturn = new RGContainer ( ldList );
		sArray = rgReturn.GetStrings();

		if ( sArray != null )
		{
			for ( i = 0 ; i < ldList.length ; i++ ) 
			{
				sArray[ i ] = DescriptLocationDescription( ldList[ i ] );
			}
			if( i > 0 )
			{
				rgReturn.SetError( false );
				rgReturn.SetErrorText( "No error." );
			}
		}

		return rgReturn;
		
		} else if ( iRepositoryType == 201 ) {
		/////////////////////////////////////////////////////////////////////////// VIEWS

    		BindingListHolder blHolder = new BindingListHolder();
                BindingIteratorHolder biHolder = new BindingIteratorHolder(); 
                final int batchSize = 100; 
		NameComponent[] ncTable = null;
		NamingContext ncTemp;
		rgReturn = new RGContainer();

			ncTable = new NameComponent[3];

			ncTable[0] = new NameComponent( sFirst, sFirst );
			ncTable[1] = new NameComponent( sThird , sThird );
			ncTable[2] = new NameComponent( sRepositoryType, sRepositoryType );

			try
			{
				ncTemp = NamingContextHelper.narrow( ncRoot.resolve( ncTable ) ); 
			}
			catch( CosNaming.NamingContextPackage.InvalidName e )
			{
				System.err.println("ERROR! InvalidName. " + e.toString() );
				rgReturn.SetErrorText("Invalid Repository Name.");
				return rgReturn;
			}
			catch ( CosNaming.NamingContextPackage.CannotProceed   e)
			{
				System.err.println("ERROR! Cannot proceed. " + e.toString() );
				rgReturn.SetErrorText("Cannot proced request.");
				return rgReturn;
			}
			catch ( CosNaming.NamingContextPackage.NotFound e)
			{
				System.err.println("ERROR! Reference not found. " + e.toString() );
				rgReturn.SetErrorText("Repository not found.");
				return rgReturn;
			}
			catch ( Exception e)
			{
				System.err.println("ERROR! " + e.toString() );
				rgReturn.SetErrorText("Unknown exception during resolving NS.");
				return rgReturn;
			}
			try
			{
                        	ncTemp.list( batchSize, blHolder, biHolder ) ;
			}
			catch ( Exception e)
			{
				System.err.println("ERROR! " + e.toString() );
				rgReturn.SetErrorText("Unknown exception during resolving NS.");
				return rgReturn;
			}

			org.omg.CORBA.Object[] array = new org.omg.CORBA.Object[ blHolder.value.length ];
			ncTable = new NameComponent[4];
			ncTable[0] = new NameComponent( sFirst, sFirst );
			ncTable[1] = new NameComponent( sThird , sThird );
			ncTable[2] = new NameComponent( sRepositoryType, sRepositoryType );
                
                        for( i=0; i < blHolder.value.length; i++ )
                        {
				ncTable[3] = new NameComponent( blHolder.value[i].binding_name[0].id, blHolder.value[i].binding_name[0].kind );

				try
				{
					array[ i ]  = ncRoot.resolve( ncTable ); 
				}
				catch( CosNaming.NamingContextPackage.InvalidName e )
				{
					System.err.println("ERROR! InvalidName. " + e.toString() );
					rgReturn.SetErrorText("Invalid Repository Name.");
					return rgReturn;
				}
				catch ( CosNaming.NamingContextPackage.CannotProceed   e)
				{
					System.err.println("ERROR! Cannot proceed. " + e.toString() );
					rgReturn.SetErrorText("Cannot proced request.");
					return rgReturn;
				}
				catch ( CosNaming.NamingContextPackage.NotFound e)
				{
					System.err.println("ERROR! Reference not found. " + e.toString() );
					rgReturn.SetErrorText("Repository not found.");
					return rgReturn;
				}
				catch ( Exception e)
				{
					System.err.println("ERROR! " + e.toString() );
					rgReturn.SetErrorText("Unknown exception during resolving NS.");
					return rgReturn;
				}
                        }

			rgReturn = new RGContainer( array );

			sArray = rgReturn.GetStrings();

			if ( sArray != null )
			{
				for ( i = 0 ; i < array.length ; i++ ) 
				{
					sArray[ i ] = DescriptView( array[ i ] );
				}
				if( i > 0 )
				{
					rgReturn.SetError( false );
					rgReturn.SetErrorText( "No error." );
				}
			}


		return rgReturn;

		}

		// Return FALSE object
		return new RGContainer();
	}

	//
	// Remove function for Repositories
	// Returns string "OK" if everything went ok, or any other with error message when failuer occurs.
	//
	public String remove( org.omg.CORBA.Object _object )
	{
		if ( iRepositoryType == 1 ) {
		//////////////////////////////////////////////////////////////////// SENSOR REPOSITORY CODE
		Sensor_Rep rTest;
		Sensor sensTemp;

		rTest = Sensor_RepHelper.narrow( oRepository );
		sensTemp = SensorHelper.narrow( _object );

		try {
			rTest.remove( sensTemp );
		}
		catch( Unknown_Object_Ref e ) {
			System.err.println("ERROR! Unknown object reference. " + e.toString() );
			return new String("Unknown object reference.");
		} 
		catch( Exception e ) {
				System.err.println("ERROR! " + e.toString() );
				return new String("Unknown exception during removal of object.");
		}

		return new String("OK");

		} else if ( iRepositoryType == 104 ) {
		///////////////////////////////////////////////////////////////////// USER REPOSITORY CODE
		User_Rep_Manager rTest;
		User uTemp;

		rTest = User_Rep_ManagerHelper.narrow( oRepositoryManagement );
		uTemp = UserHelper.narrow( _object );

		try {
			rTest.remove( uTemp );
		}
		catch( Unknown_Object_Ref e ) {
			System.err.println("ERROR! Unknown object reference. " + e.toString() );
			return new String("Unknown object reference.");
		} 
		catch( Exception e ) {
			System.err.println("ERROR! " + e.toString() );
			return new String("Unknown exception during removal of object.");
		}

		return new String("OK");

		} else if ( iRepositoryType == 9 ) {
		//////////////////////////////////////////////////////////// ABNG_LOCATION_DESCRIPTION REPOSITORY CODE
		ABng_Location_Description_Rep rTest;
		ABng_Location_Description abldTemp; 

		rTest = ABng_Location_Description_RepHelper.narrow( oRepository );
		abldTemp = ABng_Location_DescriptionHelper.narrow( _object );;		

		try {
			rTest.remove( abldTemp );
		}
		catch( Unknown_Object_Ref e ) {
			System.err.println("ERROR! Unknown object reference. " + e.toString() );
			return new String("Unknown object reference.");
		} 
		catch( Exception e ) {
				System.err.println("ERROR! " + e.toString() );
				return new String("Unknown exception during removal of object.");
		}

		return new String("OK");

		} else if ( iRepositoryType == 2 ) {
		//////////////////////////////////////////////////////////////////// BADGE REPOSITORY CODE
		Badge_Rep rTest;
		Badge bdgTemp;

		rTest = Badge_RepHelper.narrow( oRepository );
		bdgTemp = BadgeHelper.narrow( _object );

		try {
			rTest.remove( bdgTemp );
		}
		catch( Unknown_Object_Ref e ) {
			System.err.println("ERROR! Unknown object reference. " + e.toString() );
			return new String("Unknown object reference.");
		} 
		catch( Exception e ) {
				System.err.println("ERROR! " + e.toString() );
				return new String("Unknown exception during removal of object.");
		}

		return new String("OK");

		} else if ( iRepositoryType == 3 ) {
		///////////////////////////////////////////////////////////// BADGE HOLDER REPOSITORY CODE
		Badge_Holder_Rep rTest;
		_Badge_Holder bdghTemp;

		rTest = Badge_Holder_RepHelper.narrow( oRepository );
		bdghTemp = _Badge_HolderHelper.narrow( _object );

		try {
			rTest.remove( bdghTemp );
		}
		catch( Unknown_Object_Ref e ) {
			System.err.println("ERROR! Unknown object reference. " + e.toString() );
			return new String("Unknown object reference.");
		} 
		catch( Exception e ) {
				System.err.println("ERROR! " + e.toString() );
				return new String("Unknown exception during removal of object.");
		}

		return new String("OK");

		} else if ( iRepositoryType == 107 ) {
		//////////////////////////////////////////////////////////////////// LOCATION TYPE REPOSITORY CODE
		Location_Type_Rep_Manager rTest;
		Location_Type ltTemp;

		rTest = Location_Type_Rep_ManagerHelper.narrow( oRepositoryManagement );
		ltTemp = Location_TypeHelper.narrow( _object );

		try {
			rTest.remove( ltTemp );
		}
		catch( Operation_Not_Allowed e ) {
			System.err.println("ERROR! Operation not allowed. " + e.toString() );
			return new String("Operation not allowed.");
		} 
		catch( Unknown_Object_Ref e ) {
			System.err.println("ERROR! Unknown object reference. " + e.toString() );
			return new String("Unknown object reference.");
		} 
		catch( Exception e ) {
			System.err.println("ERROR! " + e.toString() );
			return new String("Unknown exception during removal of object.");
		}

		return new String("OK");

		} else if ( iRepositoryType == 108 ) {
		/////////////////////////////////////////////////////////////////// LOCATION DESCRIPTION REPOSITORY CODE
		Location_Description_Rep_Manager rTest;
		Location_Description ldTemp;

		rTest = Location_Description_Rep_ManagerHelper.narrow( oRepositoryManagement );
		ldTemp = Location_DescriptionHelper.narrow( _object );

		try {
			rTest.remove( ldTemp );
		}
		catch( Unknown_Object_Ref e ) {
			System.err.println("ERROR! Unknown object reference. " + e.toString() );
			return new String("Unknown object reference.");
		} 
		catch( Exception e ) {
			System.err.println("ERROR! " + e.toString() );
			return new String("Unknown exception during removal of object.");
		}

		return new String("OK");

		} else if ( iRepositoryType == 201 ) {
		/////////////////////////////////////////////////////////////////////////////////////// VIEWS

		return new String("Remove function is not implemented for VIEWS.");
		}

		// Return FALSE object
		System.err.println("ERROR! Propably, the RepGet interface has NOT been initialized correctly.");
		return new String("RepGet interface has NOT been initialized correctly.");
	}

	///////////////////////////////////////////////////////////////////////////// SPECIFIC REPOSITORIES CODE
	////////////////////////////////////////////////////////////////////////////////////////////////////////
		
	//////////////////////////////////////////////////////////////////// SENSOR REPOSITORY CODE

	//
	// Descript Sensor to string
	//
	static public String DescriptSensor( org.omg.CORBA.Object _object )
	{
		if( _object == null ) return new String ( "NULL Object." );
		Sensor sensor = SensorHelper.narrow( _object ) ;
		return new String( "Sensor [" + sensor.id().sensor_num + ", " + sensor.id().network_num + ", " + sensor.id().group_name + "]" );
	}

	//
	// Function to build sensor pattern from strings (clean data).
	//
	static public ABng_Core_System.SensorPackage.Pattern BuildSensorPattern( String _item_id, String _sensor_num, String _network_num, String _group_name )
	{
		boolean bTemp;
		Unsigned_Short_Pattern uspOne, uspTwo;
		Unsigned_Long_Pattern ulpOne;
		String_Pattern spOne;
		Sensor_Id_Pattern sipOne;

		boolean bGlobalAny = true;
		boolean bIdAny = true;

		if ( _item_id == null || _item_id.compareTo( "" ) == 0 ) 
		{
			_item_id = new String("1");	
			bTemp = true ;
		}
		else 
		{
			bTemp = false;
			bGlobalAny = false;
		}
		ulpOne = new Unsigned_Long_Pattern( bTemp , new Integer( _item_id ).intValue() );

		if( _sensor_num == null || _sensor_num.compareTo( "" ) == 0 ) 
		{
			_sensor_num = new String("1");
			bTemp = true;
		}
		else 
		{
			bTemp = false;
			bIdAny = false;
			bGlobalAny = false;
		}
		uspOne = new Unsigned_Short_Pattern ( bTemp , new Short ( _sensor_num ).shortValue() );

		if( _network_num == null || _network_num.compareTo( "" ) == 0 ) 
		{
			_network_num = new String("1");
			bTemp = true;
		}
		else 
		{
			bTemp = false;
			bIdAny = false;
			bGlobalAny = false;
		}
		uspTwo = new Unsigned_Short_Pattern( bTemp , new Short( _network_num ).shortValue() );

		if ( _group_name == null || _group_name.compareTo( "" ) == 0 ) bTemp = true;
		else 
		{
			bTemp = false;
			bIdAny = false;
			bGlobalAny = false;
		}
		spOne = new String_Pattern( bTemp , _group_name );

		sipOne = new Sensor_Id_Pattern( bIdAny , uspOne , uspTwo , spOne );

		System.out.println( "[RG pattern][GLOBAL: " + bGlobalAny + ", " + ulpOne.is_any + ", semiGLOBAL: " + sipOne.is_any + ", " + uspOne.is_any + ", " + uspTwo.is_any + ", " + spOne.is_any + "]" );
		return new ABng_Core_System.SensorPackage.Pattern( bGlobalAny , ulpOne , sipOne );
	}

	//
	// Add function fo Sensor Repository
	//
	public String add( String _item_id , String _sensor_num , String _network_num , String _group_name )
	{
		ABng_Core_System.SensorPackage.Description descTemp;
		Sensor_Rep rTest;

		rTest = Sensor_RepHelper.narrow( oRepository );
		descTemp = new ABng_Core_System.SensorPackage.Description( new Integer ( _item_id ).intValue() , new ABng_Core_System.Sensor_Id (new Short( _sensor_num ).shortValue() , new Short(_network_num).shortValue() , _group_name ) );
		
		try {
			rTest.add( descTemp );
		}
		catch( Domain_Repository.Duplicate_Data_Record e ) {
			System.err.println("ERROR! Duplicate data record. " + e.toString() );
			return new String("Duplicate data record.");
		} 
		catch( Exception e ) {
				System.err.println("ERROR! " + e.toString() );
				return new String("Unknown exception during adding of object.");
		}

		return new String("OK");
	}

	//
	// Update function for Sensor Repository
	//
	public String update( org.omg.CORBA.Object _object , String _item_id , String _sensor_num , String _network_num , String _group_name )
	{
		ABng_Core_System.SensorPackage.Description descTemp = null;
		Sensor_Rep rTest;
		Sensor sensTemp;
		
		rTest = Sensor_RepHelper.narrow( oRepository );
		sensTemp = SensorHelper.narrow( _object );

		descTemp = new ABng_Core_System.SensorPackage.Description( new Integer ( _item_id ).intValue() , new ABng_Core_System.Sensor_Id (new Short( _sensor_num ).shortValue() , new Short(_network_num).shortValue() , _group_name ) );

		try {
			rTest.update( sensTemp , descTemp );
		}
		catch( Domain_Repository.Duplicate_Data_Record e ) {
			System.err.println("ERROR! Duplicate data record. " + e.toString() );
			return new String("Duplicate data record.");
		} 
		catch( Unknown_Object_Ref e ) {
			System.err.println("ERROR! Unknown object reference. " + e.toString() );
			return new String("Unknown object reference.");
		} 
		catch( Exception e ) {
				System.err.println("ERROR! " + e.toString() );
				return new String("Unknown exception during adding of object.");
		}

		return new String("OK");
	}

	//
	// Find function for Sensor Repository
	//
	public RGContainer find( ABng_Core_System.SensorPackage.Pattern _pattern  )
	{
		Sensor_Rep rTest;
		Sensor[] sList = null;
		RGContainer rgReturn;

		rTest = Sensor_RepHelper.narrow( oRepository );

		try {	
			sList = rTest.find( _pattern );
		}
		catch( Domain_Repository.Search_Not_Implemented e ) {
			System.err.println("ERROR! Search not implemented. " + e.toString() );
			rgReturn = new RGContainer();
			rgReturn.SetErrorText( new String( "Search not implemented." ) );
			return rgReturn;
		} 
		catch( Exception e ) {
			System.err.println("ERROR! " + e.toString() );
			rgReturn = new RGContainer();
			rgReturn.SetErrorText( new String( "Unknown error." ) );
			return rgReturn;
		}

		rgReturn = new RGContainer( sList );

		if( sList != null )
		{
			int i;			// local variable

			for( i = 0 ; i< sList.length ; i++ )
			{
				rgReturn.GetStrings()[ i ] = DescriptSensor( sList[ i ] );
			}
			if( i > 0 )
			{
				rgReturn.SetError( false );
				rgReturn.SetErrorText( "No error." );
			}
		}

		return rgReturn;
	}

	/////////////////////////////////////////////////////////////////////////// BADGE HOLDER REPOSITORY CODE

	//
	// Convert to  badgeholder to string
	//
	static public String DescriptBadgeHolder( org.omg.CORBA.Object _object )
	{
		String info;

		if( _object == null ) return new String ( "NULL Object." );
		_Badge_Holder badgeholder = _Badge_HolderHelper.narrow( _object ) ;
		try 
		{
			info = DescriptLTSO( badgeholder.type_specific_object() );
		}
		catch( Domain_Repository.Destination_Unreachable e )
		{
			info = new String("LTSO is empty");
		}
		
		return new String( "Badge Holder [" + info + "]" );
	}

	//
	// Build badge holder pattern
	//
	static public ABng_Core_System._Badge_HolderPackage.Pattern BuildBadgeHolderPattern( String _item_id, ABng_Core_System.BadgePackage.Pattern _bdg_my, ABng_Core_System.BadgePackage.Pattern _bdg_current, ABng_Core_System.SensorPackage.Pattern _sens_home, ABng_Core.Locatable_Type_Specific_Object_Pattern _lctb_o , Domain_Repository.Boolean_Pattern _vis_o, Domain_Repository.Boolean_Pattern _valid_vis_o)
	{
		boolean bTemp;
		boolean bGlobalAny = true;
		Unsigned_Long_Pattern ulpOne;

		if ( _item_id == null || _item_id.compareTo( "" ) == 0 ) 
		{
			_item_id = new String("1");	
			bTemp = true ;
		}
		else 
		{
			bTemp = false;
			bGlobalAny = false;
		}
		ulpOne = new Unsigned_Long_Pattern( bTemp , new Integer( _item_id).intValue() );

		if( _bdg_my.is_any && _bdg_current.is_any && _sens_home.is_any && _lctb_o.is_any )
			bGlobalAny = true;
		else
			bGlobalAny = false;

		System.out.println( "[RG pattern][GLOBAL: " + bGlobalAny + ", " + ulpOne.is_any + ", " + _bdg_my.is_any + ", " + _bdg_current.is_any + ", " + _sens_home.is_any + ", " + _lctb_o.is_any + "]" );
		return new ABng_Core_System._Badge_HolderPackage.Pattern( bGlobalAny, ulpOne, _bdg_my, _bdg_current, _sens_home, _lctb_o, _vis_o, _valid_vis_o );
	}

	//
	// Descript Locatable Type Specific Object to string
	//
	static public String DescriptLTSO( ABng_Core.Locatable_Type_Specific_Object _object )
	{
	  if( _object == null ) return new String ( "NULL Object." );
	  boolean is_user_obj= false;
	  try {
	    _object.user_obj();
	    is_user_obj= true;
	  }
	  catch (Exception ex) {}
	  if (is_user_obj) 
	    return DescriptUser( _object.user_obj() );
	  else
	    return new String( "Equipment [no description method yet]" );
	}

	//
	// Build Locatable Type Specific Object Pattern
	//
	static public ABng_Core.Locatable_Type_Specific_Object_Pattern BuildLTSOPattern( ABng_Core.Locatable_Type _discriminator, Object _patternObject )
	{
		boolean bTemp = false;
		if( _patternObject == null ) 
		{
			bTemp = true;
			System.err.println("[RG error][Can't handle null pointer in BUildLTSOPattern()]");
		}

		ABng_Core.Locatable_Type_Specific_Object_PatternPackage.Ref_Pattern rpTemp;
		rpTemp = new ABng_Core.Locatable_Type_Specific_Object_PatternPackage.Ref_Pattern();

		if( _discriminator == ABng_Core.Locatable_Type.LOCATABLE_USER )
		{
			rpTemp.user_obj_pattern( (Domain_Repository.UserPackage.Pattern) _patternObject );
			if (  ((Domain_Repository.UserPackage.Pattern) _patternObject).is_any )
				bTemp = true;
		}
		else
		{
			rpTemp.equipment_obj_pattern( (Domain_Repository.EquipmentPackage.Pattern) _patternObject );
			if ( ( (Domain_Repository.EquipmentPackage.Pattern) _patternObject ).is_any )
				bTemp = true;
		}

		System.out.println( "[RG pattern][GLOBAL: " + bTemp + "]" );
		return new ABng_Core.Locatable_Type_Specific_Object_Pattern( bTemp , rpTemp ); 
	}

	//
	// Add function for Badge Holder Repository
	//
	public String add( org.omg.CORBA.Object _oMyBadge, org.omg.CORBA.Object _oCurrentBadge, org.omg.CORBA.Object _oHomeSensor, ABng_Core.Locatable_Type_Specific_Object _ltso, boolean visitor, boolean valid_visitor  )
	{
		ABng_Core_System._Badge_HolderPackage.Description descTemp;
		Badge_Holder_Rep rTest;

		rTest = Badge_Holder_RepHelper.narrow( oRepository );
		descTemp = new ABng_Core_System._Badge_HolderPackage.Description( 0 , (ABng_Core_System.Badge) _oMyBadge, (ABng_Core_System.Badge) _oCurrentBadge, (ABng_Core_System.Sensor) _oHomeSensor, _ltso, visitor, valid_visitor );

		try {
			rTest.add( descTemp );
		}
		catch( Domain_Repository.Destination_Unreachable e ) {
			System.err.println("ERROR! Destination Unreachable. " + e.toString() );
			return new String("Destination Unreachable.");
		} 
		catch( Domain_Repository.Duplicate_Data_Record e ) {
			System.err.println("ERROR! Duplicate data record. " + e.toString() );
			return new String("Duplicate data record.");
		} 
		catch( Exception e ) {
				System.err.println("ERROR! " + e.toString() );
				return new String("Unknown exception during adding of object.");
		}

		return new String("OK");
	}

	//
	// Update function for Badge Holder Repository
	//
	public String update( org.omg.CORBA.Object _object, org.omg.CORBA.Object _oMyBadge, org.omg.CORBA.Object _oCurrentBadge, org.omg.CORBA.Object _oHomeSensor, ABng_Core.Locatable_Type_Specific_Object _ltso, boolean visitor, boolean valid_visitor )
	{
		ABng_Core_System._Badge_HolderPackage.Description descTemp;
		Badge_Holder_Rep rTest;
		_Badge_Holder bdghTemp;

		rTest = Badge_Holder_RepHelper.narrow( oRepository );
		bdghTemp = _Badge_HolderHelper.narrow( _object );
		descTemp = new ABng_Core_System._Badge_HolderPackage.Description( 0 , (ABng_Core_System.Badge) _oMyBadge, (ABng_Core_System.Badge) _oCurrentBadge, (ABng_Core_System.Sensor) _oHomeSensor, _ltso, visitor, valid_visitor );

		try {
			rTest.update( bdghTemp, descTemp );
		}
		catch( Domain_Repository.Destination_Unreachable e ) {
			System.err.println("ERROR! Destination Unreachable. " + e.toString() );
			return new String("Destination Unreachable.");
		} 
		catch( Domain_Repository.Duplicate_Data_Record e ) {
			System.err.println("ERROR! Duplicate data record. " + e.toString() );
			return new String("Duplicate data record.");
		} 
		catch( Unknown_Object_Ref e ) {
			System.err.println("ERROR! Unknown object reference. " + e.toString() );
			return new String("Unknown object reference.");
		} 
		catch( Exception e ) {
				System.err.println("ERROR! " + e.toString() );
				return new String("Unknown exception during adding of object.");
		}

		return new String("OK");
	}

	//
	// Find function for Badge_Holder
	//
	public RGContainer find( ABng_Core_System._Badge_HolderPackage.Pattern _pattern )
	{
		Badge_Holder_Rep rTest;
		_Badge_Holder[] bdghList = null;
		RGContainer rgReturn = new RGContainer();

		rTest = Badge_Holder_RepHelper.narrow( oRepository );

		try
		{
			bdghList = rTest.find( _pattern );
		}
		catch( Domain_Repository.Search_Not_Implemented e ) {
			System.err.println("ERROR! Search not implemented. " + e.toString() );
			rgReturn.SetErrorText( new String( "Search not implemented." ) );
			return rgReturn;
		} 
		catch( Exception e ) {
			System.err.println("ERROR! " + e.toString() );
			rgReturn.SetErrorText( new String( "Unknown error." ) );
			return rgReturn;
		}

		rgReturn = new RGContainer( bdghList );

		if( bdghList != null )
		{
			int i;	// local variable

			for( i = 0 ; i< bdghList.length ; i++ )
			{
				rgReturn.GetStrings()[ i ] = DescriptBadgeHolder( bdghList[ i ] );
			}
			if( i > 0 )
			{
				rgReturn.SetError( false );
				rgReturn.SetErrorText( "No error." );
			}
		}

		return rgReturn;
	}

	/////////////////////////////////////////////////////////////////////////// BADGE REPOSITORY CODE

	//
	// Descript Badge to String
	//
	static public String DescriptBadge( org.omg.CORBA.Object _object )
	{
		if( _object == null ) return new String ( "NULL Object." );
		Badge badge = BadgeHelper.narrow( _object ) ;

		String sTemp = "";
		int i;

		for( i = 0 ; i < badge.id().length ; i++ )
		{
			sTemp = sTemp + Integer.toString( badge.id()[i] , 16 ) + " ";
		}

		return new String( "Badge [" + sTemp + "]" );
	}

	//
	// Build Badge Pattern
	//
	static public ABng_Core_System.BadgePackage.Pattern BuildBadgePattern( String _item_id, byte[] _bArray  )
	{
		Unsigned_Long_Pattern ulpOne;
		Octets_Pattern ocOne;
		boolean bTemp;
		boolean bGlobalAny = true;

		if ( _item_id == null || _item_id.compareTo( "" ) == 0 ) 
		{
			_item_id = new String("1");	
			bTemp = true ;
		}
		else 
		{
			bTemp = false;
			bGlobalAny = false;
		}
		ulpOne = new Unsigned_Long_Pattern( bTemp , new Integer( _item_id).intValue() );

		if( _bArray == null || _bArray.length == 0) 
		{
			bTemp = true;
		}
		else 
		{
			bTemp = false;
			bGlobalAny = false;
		}
		ocOne = new Octets_Pattern ( bTemp , _bArray );

		System.out.println( "[RG pattern][GLOBAL: " + bGlobalAny + ", " + ulpOne.is_any + ", " + ocOne.is_any + "]" );
		return new ABng_Core_System.BadgePackage.Pattern( bGlobalAny , ulpOne , ocOne );
	}

	//
	// Add function for Badge Repository
	//
	public String add( byte[] _bType , org.omg.CORBA.Object _oHolder )
	{
		ABng_Core_System.BadgePackage.Description descTemp;
		Badge_Rep rTest;

		rTest = Badge_RepHelper.narrow( oRepository );
		descTemp = new ABng_Core_System.BadgePackage.Description( 0 , _bType , (ABng_Core_System._Badge_Holder) _oHolder);

		try {
			rTest.add( descTemp );
		}
		catch( Domain_Repository.Destination_Unreachable e ) {
			System.err.println("ERROR! Destination Unreachable. " + e.toString() );
			return new String("Destination Unreachable.");
		} 
		catch( Domain_Repository.Duplicate_Data_Record e ) {
			System.err.println("ERROR! Duplicate data record. " + e.toString() );
			return new String("Duplicate data record.");
		} 
		catch( Exception e ) {
				System.err.println("ERROR! " + e.toString() );
				return new String("Unknown exception during adding of object.");
		}

		return new String("OK");
	}

	//
	// Update function for Badge Repository
	//
	public String update( org.omg.CORBA.Object _object , byte[] _bType , org.omg.CORBA.Object _oHolder )
	{
		ABng_Core_System.BadgePackage.Description descTemp;
		Badge_Rep rTest;
		Badge bdgTemp;

		rTest = Badge_RepHelper.narrow( oRepository );
		bdgTemp = BadgeHelper.narrow( _object );
		descTemp = new ABng_Core_System.BadgePackage.Description( 0 , _bType , (ABng_Core_System._Badge_Holder) _oHolder);

		try {
			rTest.update( bdgTemp , descTemp );
		}
		catch( Domain_Repository.Destination_Unreachable e ) {
			System.err.println("ERROR! Destination Unreachable. " + e.toString() );
			return new String("Destination Unreachable.");
		} 
		catch( Domain_Repository.Duplicate_Data_Record e ) {
			System.err.println("ERROR! Duplicate data record. " + e.toString() );
			return new String("Duplicate data record.");
		} 
		catch( Unknown_Object_Ref e ) {
			System.err.println("ERROR! Unknown object reference. " + e.toString() );
			return new String("Unknown object reference.");
		} 
		catch( Exception e ) {
				System.err.println("ERROR! " + e.toString() );
				return new String("Unknown exception during adding of object.");
		}

		return new String("OK");
	}

	//
	// Find function for Badge Repository
	//
	public RGContainer find( ABng_Core_System.BadgePackage.Pattern _pattern  )
	{
		Badge_Rep rTest;
		Badge[] bdgList = null;
		RGContainer rgReturn;

		rTest = Badge_RepHelper.narrow( oRepository );

		try {	
			bdgList = rTest.find( _pattern );
		}
		catch( Domain_Repository.Search_Not_Implemented e ) {
			System.err.println("ERROR! Search not implemented. " + e.toString() );
			rgReturn = new RGContainer();
			rgReturn.SetErrorText( new String( "Search not implemented." ) );
			return rgReturn;
		} 
		catch( Exception e ) {
			System.err.println("ERROR! " + e.toString() );
			rgReturn = new RGContainer();
			rgReturn.SetErrorText( new String( "Unknown error." ) );
			return rgReturn;
		}

		rgReturn = new RGContainer( bdgList );

		if( bdgList != null )
		{
			int i;				// local variable

			for( i = 0 ; i< bdgList.length ; i++ )
			{
				rgReturn.GetStrings()[ i ] = DescriptBadge( bdgList[ i ] );
			}
			if( i > 0 )
			{
				rgReturn.SetError( false );
				rgReturn.SetErrorText( "No error." );
			}
		}

		return rgReturn;
	}

	//////////////////////////////////////////////////////////////////////////////////// USER REPOSITORY

	//
	// Descript User to string
	//
	static public String DescriptUser( org.omg.CORBA.Object _object )
	{
		if( _object == null ) return new String ( "NULL Object." );
		User user = UserHelper.narrow( _object ) ;
		return new String( "User [" + user.surname() + ", " + user.forename() + "]" );
	}

	//
	// Build User pattern
	//
	static public Domain_Repository.UserPackage.Pattern BuildUserPattern( String _item_id, String _uid, String _forename, String _surname, String _position, String _email, String _phone)
	{
		boolean bTemp;
		boolean bGlobalAny = true;
		String_Pattern spOne,spTwo,spThree,spFour,spFive,spSix,spSeven;	
		Unsigned_Long_Pattern ulpOne;

		if ( _item_id == null || _item_id.compareTo( "" ) == 0 ) 
		{
			_item_id = new String("1");	
			bTemp = true ;
		}
		else 
		{
			bTemp = false;
			bGlobalAny = false;
		}
		ulpOne = new Unsigned_Long_Pattern( bTemp , new Integer( _item_id).intValue() );

		if( _uid == null || _uid.compareTo( "" ) == 0 )
			bTemp = true;
		else 
		{
			bTemp = false;
			bGlobalAny = false;
		}
		spOne = new String_Pattern( bTemp, _uid );

		if( _forename == null || _forename.compareTo( "" ) == 0 )
			bTemp = true;
		else 
		{
			bTemp = false;
			bGlobalAny = false;
		}
		spTwo = new String_Pattern( bTemp, _forename );

		if( _surname == null || _surname.compareTo( "" ) == 0 )
			bTemp = true;
		else 
		{
			bTemp = false;
			bGlobalAny = false;
		}
		spThree = new String_Pattern( bTemp, _surname );

		if( _position == null || _position.compareTo( "" ) == 0 )
			bTemp = true;
		else 
		{
			bTemp = false;
			bGlobalAny = false;
		}
		spFour = new String_Pattern( bTemp, _position );

		if( _email == null || _email.compareTo( "" ) == 0 )
			bTemp = true;
		else 
		{
			bTemp = false;
			bGlobalAny = false;
		}
		spFive = new String_Pattern( bTemp, _email );

		if( _phone == null || _phone.compareTo( "" ) == 0 )
			bTemp = true;
		else 
		{
			bTemp = false;
			bGlobalAny = false;
		}
		spSix = new String_Pattern( bTemp, _phone );

		System.out.println( "[RG pattern][GLOBAL: " + bGlobalAny + ", " + ulpOne.is_any + ", " + spOne.is_any + ", " + spTwo.is_any + ", " + spThree.is_any + ", " + spFour.is_any + ", " + spFive.is_any + ", " + spSix.is_any + "]" );
		return new Domain_Repository.UserPackage.Pattern( bGlobalAny , ulpOne, spOne, spTwo, spThree, spFour, spFive, spSix );
	} 

	//
	// Add function for User Repository
	//
	public String add( String _item_id , String _uid , String _forename , String _surname, String _position, String _email, String _phone )
	{
		Domain_Repository.UserPackage.Description descTemp;
		User_Rep_Manager rTest;

		rTest = User_Rep_ManagerHelper.narrow( oRepositoryManagement );
		descTemp = new Domain_Repository.UserPackage.Description( new Integer ( _item_id ).intValue() , _uid, _forename, _surname, _position, _email, _phone ) ;
		
		try {
			rTest.add( descTemp );
		}
		catch( Domain_Repository.Duplicate_Data_Record e ) {
			System.err.println("ERROR! Duplicate data record. " + e.toString() );
			return new String("Duplicate data record.");
		} 
		catch( Exception e ) {
				System.err.println("ERROR! " + e.toString() );
				return new String("Unknown exception during adding of object.");
		}

		return new String("OK");
	}

	//
	// Update function for User Repository
	//
	public String update( org.omg.CORBA.Object _object , String _item_id , String _uid , String _forename , String _surname, String _position, String _email, String _phone )
	{
		Domain_Repository.UserPackage.Description descTemp;
		User_Rep_Manager rTest;
		User userTemp;

		rTest = User_Rep_ManagerHelper.narrow( oRepositoryManagement );
		userTemp = UserHelper.narrow( _object );
		descTemp = new Domain_Repository.UserPackage.Description( new Integer ( _item_id ).intValue() , _uid, _forename, _surname, _position, _email, _phone );
		
		try {
			rTest.update( userTemp , descTemp );
		}
		catch( Domain_Repository.Duplicate_Data_Record e ) {
			System.err.println("ERROR! Duplicate data record. " + e.toString() );
			return new String("Duplicate data record.");
		} 
		catch( Unknown_Object_Ref e ) {
			System.err.println("ERROR! Unknown object reference. " + e.toString() );
			return new String("Unknown object reference.");
		} 
		catch( Exception e ) {
				System.err.println("ERROR! " + e.toString() );
				return new String("Unknown exception during adding of object.");
		}

		return new String("OK");
	}

	//
	// Find function for User Repository
	//
	public RGContainer find( Domain_Repository.UserPackage.Pattern _pattern  )
	{
		User_Rep rTest;
		User[] uList = null;
		RGContainer rgReturn;

		rTest = User_RepHelper.narrow( oRepository );

		try {	
			uList = rTest.find( _pattern );
		}
		catch( Domain_Repository.Search_Not_Implemented e ) {
			System.err.println("ERROR! Search not implemented. " + e.toString() );
			rgReturn = new RGContainer();
			rgReturn.SetErrorText( new String( "Search not implemented." ) );
			return rgReturn;
		} 
		catch( Exception e ) {
			System.err.println("ERROR! " + e.toString() );
			rgReturn = new RGContainer();
			rgReturn.SetErrorText( new String( "Unknown error." ) );
			return rgReturn;
		}

		rgReturn = new RGContainer( uList );

		if( uList != null )
		{
			int i;				// local variable

			for( i = 0 ; i< uList.length ; i++ )
			{
				rgReturn.GetStrings()[ i ] = DescriptUser( uList[ i ] );
			}
			if( i > 0 )
			{
				rgReturn.SetError( false );
				rgReturn.SetErrorText( "No error." );
			}
		}

		return rgReturn;
	}

	/////////////////////////////////////////////////////////////////////////////////// LOCATION TYPE REPOSITORY

	//
	// Descript Location Type to string
	//
	static public String DescriptLocationType( org.omg.CORBA.Object _object )
	{
		if( _object == null ) return new String ( "NULL Object." );
		Location_Type location = Location_TypeHelper.narrow( _object ) ;
		return new String( "Location type [" + location.item_id() + ", " + location.name() + "]" );
	}

	//
	// Build Location Type pattern
	//
	static public Domain_Repository.Location_TypePackage.Pattern BuildLocationTypePattern( String _item_id, String _name, Domain_Repository.Property_Descriptions_Pattern _pattern )
	{
		boolean bTemp;
		boolean bGlobalAny = true;
		String_Pattern spOne;	
		Unsigned_Long_Pattern ulpOne;

		if ( _item_id == null || _item_id.compareTo( "" ) == 0 ) 
		{
			_item_id = new String("1");	
			bTemp = true ;
		}
		{
			bTemp = false;
			bGlobalAny = false;
		}
		ulpOne = new Unsigned_Long_Pattern( bTemp , new Integer( _item_id).intValue() );

		if( _name == null || _name.compareTo( "" ) == 0 )
			bTemp = true;
		else 
		{
			bTemp = false;
			bGlobalAny = false;
		}
		spOne = new String_Pattern( bTemp, _name );

		if( _pattern.is_any == false )
			bGlobalAny = false;

		System.out.println( "[RG pattern][GLOBAL: " + bGlobalAny + ", " + ulpOne.is_any + ", " + spOne.is_any + ", " + _pattern.is_any + "]" );
		return new Domain_Repository.Location_TypePackage.Pattern( bGlobalAny , ulpOne, spOne, _pattern );
	} 

	static public Domain_Repository.Property_Descriptions_Pattern BuildPropertyDescriptionsPattern( Domain_Repository.Sequence_Pattern_Constraints _order, Domain_Repository.Property_Description_Pattern[] _pattern)
	{
		boolean bGlobalAny = true;
		Domain_Repository.Sequence_Pattern_Constraints order;

		if( _order == null ) order = Domain_Repository.Sequence_Pattern_Constraints.UNRESTRICTED;

		for( int i = 0 ; i < _pattern.length ; i ++ )
			if( _pattern[ i ].is_any == false )
				bGlobalAny = false;

		System.out.println( "[RG pattern][GLOBAL: " + bGlobalAny + " - not implemented for array]" );
		return new Domain_Repository.Property_Descriptions_Pattern( bGlobalAny, _order , _pattern );	
	}

	static public Domain_Repository.Property_Description_Pattern BuildPropertyDescriptionPattern( Domain_Repository.Property_Description _pdesc )
	{
		if( _pdesc != null )
			return BuildPropertyDescriptionPattern( _pdesc.name , BuildTypeCodePattern( _pdesc.type ) );
		else
			return BuildPropertyDescriptionPattern( null , BuildTypeCodePattern( null ) );
	}

	static public Domain_Repository.Property_Description_Pattern BuildPropertyDescriptionPattern( String _name, Domain_Repository.TypeCode_Pattern _typecode )
	{
		boolean bTemp;
		boolean bGlobalAny = true;
		String_Pattern spOne;	

		if( _name == null || _name.compareTo( "" ) == 0 )
			bTemp = true;
		else 
		{
			bTemp = false;
			bGlobalAny = false;
		}
		spOne = new String_Pattern( bTemp, _name );

		if( _typecode.is_any == false )
			bGlobalAny = false;

		System.out.println( "[RG pattern][GLOBAL: " + bGlobalAny + ", " + spOne.is_any + ", " + _typecode.is_any + "]" );
		return new Domain_Repository.Property_Description_Pattern( bGlobalAny , spOne, _typecode );
	} 

	static public Domain_Repository.TypeCode_Pattern BuildTypeCodePattern( org.omg.CORBA.TypeCode _typecode )
	{
		boolean bTemp;

		if( _typecode != null ) bTemp = false;
		else bTemp = true;

		System.out.println( "[RG pattern][GLOBAL: " + bTemp + " - false means null typecode]" );
		return new Domain_Repository.TypeCode_Pattern( bTemp, _typecode );
	}

	//
	// Add function for Location Type Repository
	//
	public String add( String _item_id , String _name, Domain_Repository.Property_Description[] _pd )
	{
		Domain_Repository.Location_TypePackage.Description descTemp;
		Location_Type_Rep_Manager rTest;

		rTest = Location_Type_Rep_ManagerHelper.narrow( oRepositoryManagement );
		descTemp = new Domain_Repository.Location_TypePackage.Description( new Integer ( _item_id ).intValue() , _name, _pd);

		try {
			rTest.add( descTemp );
		}
		catch( Domain_Repository.Invalid_Description e ) {
			System.err.println("ERROR! Invalid Description. " + e.toString() );
			return new String("Invalid data.");
		} 
		catch( Domain_Repository.Duplicate_Data_Record e ) {
			System.err.println("ERROR! Duplicate data record. " + e.toString() );
			return new String("Duplicate data record.");
		} 
		catch( Exception e ) {
				System.err.println("ERROR! " + e.toString() );
				return new String("Unknown exception during adding of object.");
		}

		return new String("OK");
	}

	//
	// Update function for Location Type Repository
	//
	public String update( org.omg.CORBA.Object _object , String _item_id , String _name , Domain_Repository.Property_Description[] _pd )
	{
		Domain_Repository.Location_TypePackage.Description descTemp;
		Location_Type_Rep_Manager rTest;
		Location_Type ltTemp;

		rTest = Location_Type_Rep_ManagerHelper.narrow( oRepositoryManagement );
		ltTemp = Location_TypeHelper.narrow( _object );
		descTemp = new Domain_Repository.Location_TypePackage.Description( new Integer ( _item_id ).intValue() , _name, _pd);
		
		try {
			rTest.update( ltTemp , descTemp );
		}
		catch( Domain_Repository.Invalid_Description e ) {
			System.err.println("ERROR! Invalid Description. " + e.toString() );
			return new String("Invalid data.");
		} 
		catch( Domain_Repository.Duplicate_Data_Record e ) {
			System.err.println("ERROR! Duplicate data record. " + e.toString() );
			return new String("Duplicate data record.");
		} 
		catch( Unknown_Object_Ref e ) {
			System.err.println("ERROR! Unknown object reference. " + e.toString() );
			return new String("Unknown object reference.");
		} 
		catch( Exception e ) {
				System.err.println("ERROR! " + e.toString() );
				return new String("Unknown exception during adding of object.");
		}

		return new String("OK");
	}

	//
	// Find function for Location Type Repository
	//
	public RGContainer find( Domain_Repository.Location_TypePackage.Pattern _pattern  )
	{
		Location_Type_Rep rTest;
		Location_Type[] ltList = null;
		RGContainer rgReturn;

		rTest = Location_Type_RepHelper.narrow( oRepository );

		try {	
			ltList = rTest.find( _pattern );
		}
		catch( Domain_Repository.Search_Not_Implemented e ) {
			System.err.println("ERROR! Search not implemented. " + e.toString() );
			rgReturn = new RGContainer();
			rgReturn.SetErrorText( new String( "Search not implemented." ) );
			return rgReturn;
		} 
		catch( Exception e ) {
			System.err.println("ERROR! " + e.toString() );
			rgReturn = new RGContainer();
			rgReturn.SetErrorText( new String( "Unknown error." ) );
			return rgReturn;
		}

		rgReturn = new RGContainer( ltList );

		if( ltList != null )
		{
			int i;				// local variable

			for( i = 0 ; i< ltList.length ; i++ )
			{
				rgReturn.GetStrings()[ i ] = DescriptLocationType( ltList[ i ] );
			}
			if( i > 0 )
			{
				rgReturn.SetError( false );
				rgReturn.SetErrorText( "No error." );
			}
		}

		return rgReturn;
	}

	/////////////////////////////////////////////////////////////////////////////// LOCATION DESCRIPTION REPOSITORY

	//
	// Descript Location Description to string
	//
	static public String DescriptLocationDescription( org.omg.CORBA.Object _object )
	{
		if( _object == null ) return new String ( "NULL Object." );
		Location_Description location = Location_DescriptionHelper.narrow( _object ) ;
		return new String( "Location description [" + location.item_id() + ", " + location.type_name() + "]" );
	}
	
	//
	// Build Location Description pattern
	//
	static public Domain_Repository.Location_DescriptionPackage.Pattern BuildLocationDescriptionPattern( String _item_id, String _name, Domain_Repository.Properties_Pattern _properties )
	{
		boolean bGlobalAny = true;
		boolean bTemp;
		String_Pattern spOne;	
		Unsigned_Long_Pattern ulpOne;

		if ( _item_id == null || _item_id.compareTo( "" ) == 0 ) 
		{
			_item_id = new String("1");	
			bTemp = true ;
		}
		else
		{
			bTemp = false;
			bGlobalAny = false;
		}
		ulpOne = new Unsigned_Long_Pattern( bTemp , new Integer( _item_id).intValue() );

		if( _name == null || _name.compareTo( "" ) == 0 )
			bTemp = true;
		else 
		{
			bTemp = false;
			bGlobalAny = false;
		}
		spOne = new String_Pattern( bTemp, _name );

		if( _properties.is_any == false )
			bGlobalAny = false;

		System.out.println( "[RG pattern][GLOBAL: " + bGlobalAny + ", " + ulpOne.is_any + ", " + spOne.is_any + ", " + _properties.is_any + "]" );
		return new Domain_Repository.Location_DescriptionPackage.Pattern( bGlobalAny , ulpOne, spOne, _properties );
	} 

	static public Domain_Repository.Properties_Pattern BuildPropertiesPattern( Domain_Repository.Sequence_Pattern_Constraints _order, Domain_Repository.Property_Pattern[] _pattern)
	{
		boolean bGlobalAny = true;
		Domain_Repository.Sequence_Pattern_Constraints order;

		if( _order == null ) order = Domain_Repository.Sequence_Pattern_Constraints.UNRESTRICTED;

		for( int i = 0 ; i < _pattern.length ; i ++ )
			if( _pattern[ i ].is_any == false )
				bGlobalAny = false;

		System.out.println( "[RG pattern][GLOBAL: " + bGlobalAny + " - not implemented for array]" );
		return new Domain_Repository.Properties_Pattern( bGlobalAny, _order , _pattern );	
	}

	static public Domain_Repository.Property_Pattern BuildPropertyPattern( Domain_Repository.Property _prop )
	{
		if( _prop != null )
			return BuildPropertyPattern( _prop.name , BuildAnyPattern( _prop.value ) );
		else
			return BuildPropertyPattern( null , BuildAnyPattern( null ) );
	}

	static public Domain_Repository.Property_Pattern BuildPropertyPattern( String _name, Domain_Repository.Any_Pattern _any )
	{
		boolean bGlobalAny = true;
		boolean bTemp;
		String_Pattern spOne;	

		if( _name == null || _name.compareTo( "" ) == 0 )
			bTemp = true;
		else 
		{
			bTemp = false;
			bGlobalAny = false;
		}
		spOne = new String_Pattern( bTemp, _name );

		if( _any.is_any == false )
			bGlobalAny = false;

		System.out.println( "[RG pattern][GLOBAL: " + bGlobalAny + ", " + spOne.is_any + ", " + _any.is_any + "]" );
		return new Domain_Repository.Property_Pattern( bGlobalAny , spOne, _any );
	} 

	static public Domain_Repository.Any_Pattern BuildAnyPattern( org.omg.CORBA.Any _any )
	{
		boolean bTemp;

		if( _any != null ) bTemp = false;
		else bTemp = true;

		System.out.println( "[RG pattern][GLOBAL: " + bTemp + " - false means null any]" );
		return new Domain_Repository.Any_Pattern( bTemp, _any );
	}

	//
	// Add function for Location Description Repository
	//
	public String add( String _item_id , String _name, Domain_Repository.Property[] _properties)
	{
		Domain_Repository.Location_DescriptionPackage.Description descTemp;
		Location_Description_Rep_Manager rTest;

		rTest = Location_Description_Rep_ManagerHelper.narrow( oRepositoryManagement );

		descTemp = new Domain_Repository.Location_DescriptionPackage.Description( new Integer ( _item_id ).intValue() , _name, _properties);

		try {
			rTest.add( descTemp );
		}
		catch( Domain_Repository.Invalid_Description e ) {
			System.err.println("ERROR! Invalid Description. " + e.toString() );
			return new String("Invalid data.");
		} 
		catch( Domain_Repository.Duplicate_Data_Record e ) {
			System.err.println("ERROR! Duplicate data record. " + e.toString() );
			return new String("Duplicate data record.");
		} 
		catch( Exception e ) {
				System.err.println("ERROR! " + e.toString() );
				return new String("Unknown exception during adding of object.");
		}

		return new String("OK");
	}

	//
	// Update function for Location Description Repository
	//
	public String update( org.omg.CORBA.Object _object , String _item_id , String _name , Domain_Repository.Property[] _properties)
	{
		Domain_Repository.Location_DescriptionPackage.Description descTemp;
		Location_Description_Rep_Manager rTest;
		Location_Description ldTemp;

		rTest = Location_Description_Rep_ManagerHelper.narrow( oRepositoryManagement );
		ldTemp = Location_DescriptionHelper.narrow( _object );

		descTemp = new Domain_Repository.Location_DescriptionPackage.Description( new Integer ( _item_id ).intValue() , _name, _properties );
		
		try {
			rTest.update( ldTemp , descTemp );
		}
		catch( Domain_Repository.Invalid_Description e ) {
			System.err.println("ERROR! Invalid Description. " + e.toString() );
			return new String("Invalid data.");
		} 
		catch( Domain_Repository.Duplicate_Data_Record e ) {
			System.err.println("ERROR! Duplicate data record. " + e.toString() );
			return new String("Duplicate data record.");
		} 
		catch( Unknown_Object_Ref e ) {
			System.err.println("ERROR! Unknown object reference. " + e.toString() );
			return new String("Unknown object reference.");
		} 
		catch( Exception e ) {
				System.err.println("ERROR! " + e.toString() );
				return new String("Unknown exception during adding of object.");
		}

		return new String("OK");
	}

	//
	// Find function for Location Description Repository
	//
	public RGContainer find( Domain_Repository.Location_DescriptionPackage.Pattern _pattern  )
	{
		Location_Description_Rep rTest;
		Location_Description[] ldList = null;
		RGContainer rgReturn;

		rTest = Location_Description_RepHelper.narrow( oRepository );

		try {	
			ldList = rTest.find( _pattern );
		}
		catch( Domain_Repository.Search_Not_Implemented e ) {
			System.err.println("ERROR! Search not implemented. " + e.toString() );
			rgReturn = new RGContainer();
			rgReturn.SetErrorText( new String( "Search not implemented." ) );
			return rgReturn;
		} 
		catch( Exception e ) {
			System.err.println("ERROR! " + e.toString() );
			rgReturn = new RGContainer();
			rgReturn.SetErrorText( new String( "Unknown error." ) );
			return rgReturn;
		}

		rgReturn = new RGContainer( ldList );

		if( ldList != null )
		{
			int i;				// local variable

			for( i = 0 ; i< ldList.length ; i++ )
			{
				rgReturn.GetStrings()[ i ] = DescriptLocationDescription( ldList[ i ] );
			}
			if( i > 0 )
			{
				rgReturn.SetError( false );
				rgReturn.SetErrorText( "No error." );
			}
		}

		return rgReturn;
	}

	////////////////////////////////////////////////////////////////////////// ABNG LOCATION DESCRIPTION REPOSITORY

	//
	// Descript ABng Location Description to string
	//
	static public String DescriptABngLocationDescription( org.omg.CORBA.Object _object )
	{
		if( _object == null ) return new String ( "NULL Object." );
		ABng_Location_Description location = ABng_Location_DescriptionHelper.narrow( _object ) ;
		return new String( "ABng Location Description [" + location.item_id() + "]" );
	}

	//
	// Build Sensor list pattern 
	//
	static public ABng_Core_System.SensorPackage.Sensors_Pattern BuildSensorsPattern( Domain_Repository.Sequence_Pattern_Constraints _order , ABng_Core_System.SensorPackage.Pattern[] _pattern )
	{
		boolean bGlobalAny = true;
		Domain_Repository.Sequence_Pattern_Constraints order;

		if( _order == null ) order = Domain_Repository.Sequence_Pattern_Constraints.UNRESTRICTED;

		for( int i = 0 ; i < _pattern.length ; i ++ )
			if( _pattern[ i ].is_any == false )
				bGlobalAny = false;

		System.out.println( "[RG pattern][GLOBAL: " + bGlobalAny + " - not implemented for array]" );
		return new ABng_Core_System.SensorPackage.Sensors_Pattern( bGlobalAny , _order , _pattern );
	}

	//
	// Build ABng Location Description Pattern 
	//
	static public ABng_Core_System.ABng_Location_DescriptionPackage.Pattern BuildABngLocationDescriptionPattern( String _item_id, Domain_Repository.Location_DescriptionPackage.Pattern _loc_descr, ABng_Core_System.SensorPackage.Sensors_Pattern _sensors )
	{
		boolean bGlobalAny = true;
		boolean bTemp = false;
		Unsigned_Long_Pattern ulpOne;

		if ( _item_id == null || _item_id.compareTo( "" ) == 0 ) 
		{
			_item_id = new String("1");	
			bTemp = true ;
		}
		else
		{
			bTemp = false;
			bGlobalAny = false;
		}
		ulpOne = new Unsigned_Long_Pattern( bTemp , new Integer( _item_id).intValue() );

		if( _loc_descr.is_any == false || _sensors.is_any == false )
			bGlobalAny = false;

		System.out.println( "[RG pattern][GLOBAL: " + bGlobalAny + ", " + ulpOne.is_any + ", " + _loc_descr.is_any + ", " + _sensors.is_any + "]" );
		return new ABng_Core_System.ABng_Location_DescriptionPackage.Pattern( bGlobalAny, ulpOne, _loc_descr, _sensors ); 
	}

	//
	// Add function for ABng Location Description Repository
	//
	public String add( String _item_id, org.omg.CORBA.Object _locDescr, org.omg.CORBA.Object[] _sensors  )
	{
		ABng_Core_System.ABng_Location_DescriptionPackage.Description descTemp;
		ABng_Location_Description_Rep rTest;

		rTest = ABng_Location_Description_RepHelper.narrow( oRepository );
		descTemp = new ABng_Core_System.ABng_Location_DescriptionPackage.Description( new Integer( _item_id ).intValue() , (Domain_Repository.Location_Description) _locDescr, (Sensor[]) _sensors );

		try {
			rTest.add( descTemp );
		}
		catch( Domain_Repository.Invalid_Description e ) {
			System.err.println("ERROR! Invalid_Description. " + e.toString() );
			return new String("Destination Unreachable.");
		} 
		catch( Domain_Repository.Duplicate_Data_Record e ) {
			System.err.println("ERROR! Duplicate data record. " + e.toString() );
			return new String("Duplicate data record.");
		} 
		catch( Exception e ) {
				System.err.println("ERROR! " + e.toString() );
				return new String("Unknown exception during adding of object.");
		}

		return new String("OK");
	}

	//
	// Update function for ABng Location Description Holder Repository
	//
	public String update( org.omg.CORBA.Object _object, org.omg.CORBA.Object _locDescr, org.omg.CORBA.Object[] _sensors )
	{
		ABng_Core_System.ABng_Location_DescriptionPackage.Description descTemp;
		ABng_Location_Description_Rep rTest;
		ABng_Location_Description abldTemp;

		rTest = ABng_Location_Description_RepHelper.narrow( oRepository );
		descTemp = new ABng_Core_System.ABng_Location_DescriptionPackage.Description( 0, (Domain_Repository.Location_Description) _locDescr, (Sensor[]) _sensors );
		abldTemp = ABng_Location_DescriptionHelper.narrow( _object );

		try {
			rTest.update( abldTemp, descTemp );
		}
		catch( Domain_Repository.Invalid_Description e ) {
			System.err.println("ERROR! Invalid_Description. " + e.toString() );
			return new String("Destination Unreachable.");
		} 
		catch( Domain_Repository.Duplicate_Data_Record e ) {
			System.err.println("ERROR! Duplicate data record. " + e.toString() );
			return new String("Duplicate data record.");
		} 
		catch( Unknown_Object_Ref e ) {
			System.err.println("ERROR! Unknown object reference. " + e.toString() );
			return new String("Unknown object reference.");
		} 
		catch( Exception e ) {
				System.err.println("ERROR! " + e.toString() );
				return new String("Unknown exception during adding of object.");
		}

		return new String("OK");
	}

	//
	// Find function for ABng Location Description
	//
	public RGContainer find( ABng_Core_System.ABng_Location_DescriptionPackage.Pattern _pattern )
	{
		ABng_Location_Description_Rep rTest;
		ABng_Location_Description[] abldList = null;
		RGContainer rgReturn = new RGContainer();

		rTest = ABng_Location_Description_RepHelper.narrow( oRepository );

		try
		{
			abldList = rTest.find( _pattern );
		}
		catch( Domain_Repository.Search_Not_Implemented e ) {
			System.err.println("ERROR! Search not implemented. " + e.toString() );
			rgReturn.SetErrorText( new String( "Search not implemented." ) );
			return rgReturn;
		} 
		catch( Domain_Repository.Destination_Unreachable e ) {
			System.err.println("ERROR! Destination Unreachable. " + e.toString() );
			rgReturn.SetErrorText( new String( "Destination Unreachable." ) );
			return rgReturn;
		} 
		catch( Exception e ) {
			System.err.println("ERROR! " + e.toString() );
			rgReturn.SetErrorText( new String( "Unknown error." ) );
			return rgReturn;
		}

		rgReturn = new RGContainer( abldList );

		if( abldList != null )
		{
			int i;	// local variable

			for( i = 0 ; i< abldList.length ; i++ )
			{
				rgReturn.GetStrings()[ i ] = DescriptABngLocationDescription ( abldList[ i ] );
			}
			if( i > 0 )
			{
				rgReturn.SetError( false );
				rgReturn.SetErrorText( "No error." );
			}
		}

		return rgReturn;
	}

	public RGContainer ABLDlist( org.omg.CORBA.Object _object )
	{
		ABng_Location_Description abldTemp;
		RGContainer rgReturn = new RGContainer();
		Sensor[] sList = null;

		abldTemp = ABng_Location_DescriptionHelper.narrow( _object );

		try
		{
			sList = abldTemp.sensor_list();
		} 
		catch( Domain_Repository.Destination_Unreachable e ) {
			System.err.println("ERROR! Destination Unreachable. " + e.toString() );
			rgReturn.SetErrorText( new String( "Destination Unreachable." ) );
			return rgReturn;
		} 
		catch( Exception e ) {
			System.err.println("ERROR! " + e.toString() );
			rgReturn.SetErrorText( new String( "Unknown error." ) );
			return rgReturn;
		}

		rgReturn = new RGContainer( sList );

		if( sList != null )
		{
			int i;	// local variable

			for( i = 0 ; i< sList.length ; i++ )
			{
				rgReturn.GetStrings()[ i ] = DescriptSensor ( sList[ i ] );
			}
			if( i > 0 )
			{
				rgReturn.SetError( false );
				rgReturn.SetErrorText( "No error." );
			}
		}

		return rgReturn;
	}

	public String ABLDadd( org.omg.CORBA.Object _object , org.omg.CORBA.Object _toadd )
	{
		Sensor sTemp;
		ABng_Location_Description abldTemp;


		abldTemp = ABng_Location_DescriptionHelper.narrow( _object );
		sTemp = SensorHelper.narrow( _toadd );

		try {
			abldTemp.add( sTemp );
		}
		catch( Domain_Repository.Duplicate_Data_Record e ) {
			System.err.println("ERROR! Duplicate data record. " + e.toString() );
			return new String("Duplicate data record.");
		} 
		catch( Unknown_Object_Ref e ) {
			System.err.println("ERROR! Unknown object reference. " + e.toString() );
			return new String("Unknown object reference.");
		} 
		catch( Exception e ) {
				System.err.println("ERROR! " + e.toString() );
				return new String("Unknown exception during adding of object.");
		}

		return new String("OK");
	}

	public String ABLDremove( org.omg.CORBA.Object _object , org.omg.CORBA.Object _toadd )
	{
		Sensor sTemp;
		ABng_Location_Description abldTemp;


		abldTemp = ABng_Location_DescriptionHelper.narrow( _object );
		sTemp = SensorHelper.narrow( _toadd );

		try {
			abldTemp.remove( sTemp );
		}
		catch( Unknown_Object_Ref e ) {
			System.err.println("ERROR! Unknown object reference. " + e.toString() );
			return new String("Unknown object reference.");
		} 
		catch( Exception e ) {
				System.err.println("ERROR! " + e.toString() );
				return new String("Unknown exception during adding of object.");
		}

		return new String("OK");
	}

	//////////////////////////////////////////////////////////////////////////////////////////////// VIEWS 

	//
	// Descript View to string
	//
	static public String DescriptView( org.omg.CORBA.Object _object )
	{
		String info;
		ABng_Core.View member_view;

		if( _object == null ) return new String ( "NULL Object." );
		View_Manager view = View_ManagerHelper.narrow( _object ) ;

		try 
		{
			member_view = view.my_view();
		}
		catch( Exception e )
		{
			info = new String("EXCEPTION: view member is NULL!");
			System.err.println( e.toString() );
			System.out.println("[RG information][View member of View Managar is EMPTY ???]");
			return new String( "View [" + info + "]" );
		}
			info = new String( view.my_view().view_name() + ", " + view.my_view().type() );

		return new String( "View [" + info + "]" );
	}

	//
	// list locatables (bh) for VIew 
	//
	public RGContainer listLocatables( org.omg.CORBA.Object _view )
	{
		View_Manager vm = View_ManagerHelper.narrow( _view );
		RGContainer rg;

		try
		{
			rg = new RGContainer( vm.my_view().locatable_list() );
		}
		catch ( Exception e )
		{
			rg = new RGContainer();
			rg.SetErrorText("View member is EMPTY.");
		}
		int index = rg.GetObjects().length;

		if( index > 0 )
		{
			int i;	// local variable

			for( i = 0 ; i< index ; i++ )
			{
				rg.GetStrings()[ i ] = DescriptBadgeHolder ( vm.deref_locatable( (ABng_Core.Locatable) rg.GetObjects()[ i ] ) );
			}
			rg.SetError( false );
			rg.SetErrorText( "No error." );
		}

		return rg;
	}

	//
	// list locataion (abld) for VIew 
	//
	public RGContainer listLocations( org.omg.CORBA.Object _view )
	{
		View_Manager vm = View_ManagerHelper.narrow( _view );
		RGContainer rg;

		try
		{
			rg = new RGContainer( vm.my_view().location_list() );
		}
		catch ( Exception e )
		{
			rg = new RGContainer();
			rg.SetErrorText("View member is EMPTY.");
		}
		int index = rg.GetObjects().length;

		if( index > 0 )
		{
			int i;	// local variable

			for( i = 0 ; i< index ; i++ )
			{
				rg.GetStrings()[ i ] = DescriptABngLocationDescription ( vm.deref_location( (ABng_Core.Location) rg.GetObjects()[ i ] ) );
			}
			rg.SetError( false );
			rg.SetErrorText( "No error." );
		}

		return rg;
	}

	//
	// add locatable
	//
	public String addLocatable( org.omg.CORBA.Object _view, org.omg.CORBA.Object _bh )
	{
		View_Manager vm = View_ManagerHelper.narrow( _view );
		_Badge_Holder bh = _Badge_HolderHelper.narrow( _bh );

		try 
		{
			vm.add_locatable( bh );
		}
		/*
		catch(  Invalid_Badge_Holder e ) {
			System.err.println("ERROR! Invalid Badge Holder. " + e.toString() );
			return new String("Invalid Badge Holder.");
		} 
		*/
		catch( Domain_Repository.Destination_Unreachable e ) {
			System.err.println("ERROR! Destination Unreachable. " + e.toString() );
			return new String("Destination Unreachable.");
		} 
		catch( Domain_Repository.Duplicate_Data_Record e ) {
			System.err.println("ERROR! Duplicate data record. " + e.toString() );
			return new String("Duplicate data record.");
		} 
		catch( Exception e ) {
				System.err.println("ERROR! " + e.toString() );
				return new String("Unknown exception during adding of object.");
		}

		return new String("OK");
	}

	//
	// remove locatable
	//
	public String removeLocatable( org.omg.CORBA.Object _view, org.omg.CORBA.Object _locatable )
	{
		View_Manager vm = View_ManagerHelper.narrow( _view );
		ABng_Core.Locatable locatable = ABng_Core.LocatableHelper.narrow( _locatable );

		try
		{
			vm.remove_locatable( locatable );
		}
		catch( Unknown_Object_Ref e ) {
			System.err.println("ERROR! Unknown object reference. " + e.toString() );
			return new String("Unknown object reference.");
		} 
		catch( Exception e ) {
				System.err.println("ERROR! " + e.toString() );
				return new String("Unknown exception during adding of object.");
		}

		return new String("OK");
	}
	
	//
	// Add location
	//
	public String addLocation( org.omg.CORBA.Object _view, org.omg.CORBA.Object _abld )
	{
		View_Manager vm = View_ManagerHelper.narrow( _view );
		ABng_Location_Description abld = ABng_Location_DescriptionHelper.narrow( _abld );

		try 
		{
			vm.add_location( abld );
		}
		catch(  ABng_Core_Management.View_ManagerPackage.Invalid_Location_Type e ) {
			System.err.println("ERROR! Invalid Location TYpe. " + e.toString() );
			return new String("Invalid Location Type.");
		} 
		catch( Domain_Repository.Destination_Unreachable e ) {
			System.err.println("ERROR! Destination Unreachable. " + e.toString() );
			return new String("Destination Unreachable.");
		} 
		catch( Domain_Repository.Duplicate_Data_Record e ) {
			System.err.println("ERROR! Duplicate data record. " + e.toString() );
			return new String("Duplicate data record.");
		} 
		catch( Exception e ) {
				System.err.println("ERROR! " + e.toString() );
				return new String("Unknown exception during adding of object.");
		}

		return new String("OK");
	}

	public String removeLocation( org.omg.CORBA.Object _view, org.omg.CORBA.Object _location )
	{
		View_Manager vm = View_ManagerHelper.narrow( _view );
		ABng_Core.Location location = ABng_Core.LocationHelper.narrow( _location );

		try
		{
			vm.remove_location( location );
		}
		catch( Unknown_Object_Ref e ) {
			System.err.println("ERROR! Unknown object reference. " + e.toString() );
			return new String("Unknown object reference.");
		} 
		catch( Exception e ) {
				System.err.println("ERROR! " + e.toString() );
				return new String("Unknown exception during adding of object.");
		}

		return new String("OK");
	}
	
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////// END OF REPGET !!!
}
