package ABngSystem;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

import com.sun.java.swing.*;
import com.sun.java.swing.event.*;
import com.sun.java.swing.border.*;

import ABng_Core.*;
import ABng_Core_System.*;
import ABng_Core_Management.*;
 
/////////////////////////////////////////
/* This class shows a window when user wants to
   update the selected item. It's just item form
   and Accept and Cancel button */
/////////////////////////////////////////

class UpdateDialog extends JDialog{

   JButton accept;
   JButton cancel;
   JDialog wnd;
   boolean answer;
   public ItemPanel localitem;
   org.omg.CORBA.Object object;
   String repname;
   RepGet repository;

   public UpdateDialog(Window parent, String repname, RepGet rep, org.omg.CORBA.Object object){
      super((JFrame) parent, repname+" - Upadate Item", true);
      setFont(new Font("Dialog", Font.PLAIN, 14));
      setSize(383,382);
      setResizable(false);
      addWindowListener(new WindowAdapter() {
	      public void windowClosing(WindowEvent e) {setVisible(false); }
      	});

      JPanel pane = new JPanel();
      pane.setLayout(null);
      wnd = this;
      answer = false;
      this.object = object;
      this.repname = repname;
      this.repository = rep;

      if (repname.equals(RepName.userRep))
         localitem = new UserPanel(true, 1, parent);
      else if (repname.equals(RepName.sensorRep))
         localitem = new SensorPanel(true, 1, parent);
      else if (repname.equals(RepName.badgeRep))
         localitem = new BadgePanel(true, 1, parent);
      else if (repname.equals(RepName.holderRep))
         localitem = new HolderPanel(true, 1, parent);
      else if (repname.equals(RepName.locationTypeRep))
         localitem = new LocationTypePanel(false, 1, parent);
      else if (repname.equals(RepName.locationDescRep))
         localitem = new LocationDescPanel(false, 1, parent);
      else if (repname.equals(RepName.abngldRep))
         localitem = new AbngldPanel(false, 1, parent);
      else if (repname.equals(RepName.viewRep))
         localitem = new ViewPanel(false, 1, parent);
      localitem.setLocation(5,5);
      localitem.setData(object);
      pane.add(localitem);

      ButtonClicked bc = new ButtonClicked();
      accept = new JButton("Accept");
      accept.setSize(125,25);
      accept.setLocation(45,325);
      accept.addActionListener(bc);
      accept.setToolTipText("Accept changes");
      pane.add(accept);
      cancel = new JButton("Cancel");
      cancel.setSize(125,25);
      cancel.setLocation(205,325);
      cancel.addActionListener(bc);
      cancel.setToolTipText("Discard changes");
      pane.add(cancel);

      setContentPane(pane);
      setVisible(true);
   }

   public boolean getAnswer(){ return answer; }
   public ItemPanel getPanel() { return localitem; }


///////////////////////////////////////////
/* What to do when the user click button */
///////////////////////////////////////////

   protected final class ButtonClicked implements ActionListener{
      public void actionPerformed(ActionEvent e){
         if (((JButton) e.getSource()) == accept){
            wnd.setCursor(new Cursor(Cursor.WAIT_CURSOR));
            if (JOptionPane.showConfirmDialog(wnd, "Are You Accept this settings", "Update Confirmation",
                     JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION){
               wnd.setCursor(new Cursor(Cursor.WAIT_CURSOR));
               String mesg = null;
               if (repname.equals(RepName.sensorRep)){
                  String sensid = ((SensorPanel) localitem).getSensorNumber();
                  String netnb = ((SensorPanel) localitem).getNetworkNumber();
                  String netname = ((SensorPanel) localitem).getNetworkGroupName();
                  mesg = repository.update(object, "0", sensid, netnb, netname);
               } else if (repname.equals(RepName.badgeRep)){
                  try{
                     byte[] abyte = ((BadgePanel) localitem).getID();
                     org.omg.CORBA.Object holder = ((BadgePanel) localitem).getBadgeHolder();
                     mesg = repository.update(object, abyte, holder);
                  } catch (Exception ex) {
                     mesg = "Please enter a valid number as badgeID";
                  }
               } else if (repname.equals(RepName.holderRep)){
                  org.omg.CORBA.Object mybadge = ((HolderPanel) localitem).getMyBadge();
                  org.omg.CORBA.Object currentbadge = ((HolderPanel) localitem).getCurrentBadge();
                  org.omg.CORBA.Object homesensor = ((HolderPanel) localitem).getHomeSensor();
                  ABng_Core.Locatable_Type_Specific_Object ltso = ((HolderPanel) localitem).getLTSO();
                  ABng_Core.Locatable_Type type = ((HolderPanel) localitem).getType();
		  boolean visitor= ((HolderPanel) localitem).getVisitor();
		  boolean valid_visitor= ((HolderPanel) localitem).getValidVisitor();
                  mesg = repository.update(object, mybadge, currentbadge, homesensor, ltso, visitor, valid_visitor);
               } else if (repname.equals(RepName.userRep)){
                  String uid = ((UserPanel) localitem).getUID();
                  String forename = ((UserPanel) localitem).getForename();
                  String surname = ((UserPanel) localitem).getSurname();
                  String position = ((UserPanel) localitem).getPosition();
                  String email = ((UserPanel) localitem).getEmail();
                  String phone = ((UserPanel) localitem).getPhone();
                  mesg = repository.update(object, "0", uid, forename, surname, position, email, phone);
               } else if (repname.equals(RepName.locationTypeRep)){
                  String name = ((LocationTypePanel) localitem).getName();
                  Domain_Repository.Property_Description[] tab = ((LocationTypePanel) localitem).getDescriptions();
                  mesg = repository.update(object, "0", name, tab);
               } else if (repname.equals(RepName.locationDescRep)){
                  String name = ((LocationDescPanel) localitem).getName();
                  Domain_Repository.Property[] tab = ((LocationDescPanel) localitem).getProperties();
                  mesg = repository.update(object, "0", name, tab);
               } else if (repname.equals(RepName.abngldRep)){
                  Domain_Repository.Location_Description ld = ((AbngldPanel) localitem).getLocationDescription();
                  Sensor[] sensors = ((AbngldPanel) localitem).getSensors();
                  mesg = repository.update(object, ld, sensors);
               } else if (repname.equals(RepName.viewRep)){
               }
               if (mesg.compareTo("OK") != 0){
                  JOptionPane.showMessageDialog(wnd, mesg, "Can't update item", JOptionPane.ERROR_MESSAGE);
                  localitem.setData(object);
               } else {
                  JOptionPane.showMessageDialog(wnd, "Operation successfully", "Update OK", JOptionPane.INFORMATION_MESSAGE);
                  answer = true;
                  wnd.setVisible(false);
               }
            }
            wnd.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
         }
         else if (((JButton) e.getSource()) == cancel){
            answer = false;
            wnd.setVisible(false);
         }
      }
   }
}

