#include <iostream.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <signal.h>

#include "whlib.hh" // musi byc includowane przed ixami bo inaczej jest
                    // blad wynikajacy definicji Error gdzies w ixach 

#include "screen_lock.hh"
#include "abng_lock_setup.hh"
#include "X_screen_lock.hh"
#include "X_abng.hh"


int running = 1;
screen_lock *sl; // musi byc dostepna w funkcji obslugi
Domain_Repository::Repository_Item_Id home_location_id;
int licznik = 0; // tymczasowy licznik

void notify(whereis_result *result)
{
  //  cerr << "notify, licznik " << licznik << endl;
  //cerr << "ID "<< result->getLocID() << endl;
  if (result->getLocID() != home_location_id)
  {
    //cerr << "bedziem lokowac" << endl;
    sl->lock();
  }
  else
  {
    //cerr << "bedziem odlokowywac" << endl;
    sl->unlock();
  }
  // tymczasowe do testow
  //if ((++licznik)%2)
  //  sl->unlock();
  //else
  //  sl->lock();
}   
 
void sig_handler(int signr)
{
  running=0; // wymusza wyjscie
  //cerr << "program shuting down" << endl;
}


int main(int argc, char *argv[])
{
  X_abng *xabng;
  whereis_result *result;

  if ( !(xabng = new X_abng(argc, argv)) )
    exit(1);

  //cerr << xabng->lock_args() << endl;
  //cerr << xabng->quiet_mode() << endl;

  if ( !(sl=new X_screen_lock(xabng->lock_args())) )
  {
    delete xabng;
    exit(2);
  }

  whereis_tools *wtools = new whereis_tools(argc, argv);

  signal(SIGHUP, sig_handler);
  signal(SIGINT, sig_handler);
  signal(SIGTERM, sig_handler);

  if ( wtools->connect(xabng->viewname()) )
  {
    // usunac flage VERBOSE !!! 
    result = wtools->traceUser(xabng->username(), notify, 0); // WH_FU_VERBOSE);

    home_location_id=result->getLocID();
 
    while (running && result)
      sleep (1);

    if (result)
      delete result;

    wtools->disconnect();
  }
  
  delete wtools;
    
  sl->unlock();
  delete sl;
  delete xabng;
}


