package jabba;

import com.sun.java.swing.ImageIcon;

import java.net.URL;
import java.net.MalformedURLException;
import java.io.File;
import java.io.InputStream;
import java.io.FileInputStream;
import java.io.IOException;

class ResourceManager {
  private static String imagesPath = System.getProperty( "JABBA_HOME","./" )+"/images/";
  private static String imagesExtension = ".gif";

  public static ImageIcon loadIcon( String resId ) {
    return loadIcon( resId,"" );
  }

  public static ImageIcon loadIcon( String resId, String desc ) {
      //    System.err.println( "loading: "+imagesPath+resId+imagesExtension );
    return new ImageIcon( imagesPath+resId+imagesExtension, desc );
  }

  public static ImageIcon loadIconFromResources( String resId ) {
    return loadIconFromResources( resId,"" );
  }

  public static ImageIcon loadIconFromResources( String resId,String desc ) {
    Object obj=new ResourceManager();
    URL url = obj.getClass().getResource(resId);
    //    System.err.println( "Resource URL: "+url );
    if( url!=null) {
	return new ImageIcon(url);
    }
    else return null;
  }

  public static boolean initialize( String filename ) {
    return initialize( filename,false );
  }

    // nieuzyteczna
  public static boolean initialize( String name, boolean isUrl ) {
    InputStream instream;

    // stream initialization
    try {
      if( isUrl ) {
	URL url = new URL(name); 
	instream = url.openStream();
      }
      else {
	File configFile = new File(name);
	instream = new FileInputStream(configFile);
      }
    }
    catch( MalformedURLException ex ) {
      return false;
    }
    catch (IOException ex) {
      return false;
    }
    catch (NullPointerException ex) {
      return false;
    }

    // contents interpretation
    
    return true;

  }
}
