package jabba;

import com.sun.java.swing.JTable;
import com.sun.java.swing.JPanel;
import com.sun.java.swing.JScrollPane;
import com.sun.java.swing.table.TableColumn;
import com.sun.java.swing.table.TableColumnModel;

import java.awt.Component;
import java.awt.BorderLayout;
import java.awt.Dimension;

import java.awt.event.MouseEvent;
import java.awt.event.MouseAdapter;

class ViewerEquipmentTab extends JPanel implements ViewerTab {
  JTable table;
  ViewerEquipmentTableDataModel dataModel;
  String name;

  Jabba jabba;
  Viewer viewer;

  ViewerEquipmentTab( Jabba jabba, Viewer viewer ) {
    this( jabba,viewer,"Equipment" );
  }

  ViewerEquipmentTab( Jabba jabba, Viewer viewer, String name ) {
    super( false );
    this.jabba = jabba;
    this.viewer = viewer;
    this.name = name;
    jabba.console.addWriter( this,"Viewer equipment tab" );

    setLayout( new BorderLayout() );
  }

  public void regenerate() {
    jabba.console.messageFrom( this, "regenerate() called." );

    // usuwamy stara tabele
    removeAll();

    // tworzymy model danych
    dataModel = new ViewerEquipmentTableDataModel(jabba);

    jabba.receiver.registerDataModel( dataModel,Receiver.EQUIPMENT_MESSAGES );

    // tworzymy tabele
    TableSorter ts = new TableSorter(dataModel);
    table = new JTable(ts,null,ts.getSelectionModel());
    table.getColumnModel().getColumn( dataModel.COLUMN_QUALITY ).setCellRenderer(new QualityRenderer());
    table.setFont( Viewer.defaultFont );
    ts.addMouseListenerToHeaderInTable(table);
    table.setPreferredScrollableViewportSize( new Dimension(500,100) );
    
    ViewerTabHelper.initColumnSizes( table,dataModel );
//     table.addMouseListener( new MouseAdapter() {
//       public void mouseClicked( MouseEvent ev ) {
// 	if( ev.getClickCount()==2 ) addNewPersonTab();
//       }
//     } );

    this.add( JTable.createScrollPaneForTable(table),BorderLayout.CENTER );
  }    

//   public void addNewPersonTab() {
//     jabba.console.messageFrom( this, "addNewPersonTab() called." );

//     String tabName = (String)(table.getValueAt( table.getSelectedRow(),
//       table.convertColumnIndexToView(ViewerMainTableDataModel.COLUMN_NAME) ));

//     int person_index = ((Integer)table.getValueAt( table.getSelectedRow(),
//       ViewerMainTableDataModel.ATTRIBUTE_INDEX )).intValue();

//     DismissableViewerTab vt=viewer.createPersonTab( tabName,person_index );
//     vt.setParentTab( this );
//     viewer.addTab( vt );
//     viewer.selectTab( vt );
//   }

  public void update() {
    jabba.console.messageFrom( this, "update() called." );

    if( dataModel==null ) regenerate();
    else jabba.receiver.updateDataModel( dataModel,Receiver.EQUIPMENT_MESSAGES );
  }
    

  public JabbaDataModel getJabbaDataModel() {
    return dataModel;
  }

  public JPanel getPanel() {
    return this;
  }

  public String getName() {
    return name;
  }

}
