#include <limits.h>
#include "abng_guarded.hh"

class Incarnation_Number {
private:
  unsigned long lo;
  unsigned long hi;

public:
  Incarnation_Number() : lo(0), hi(0) {}
  Incarnation_Number( const Incarnation_Number &ic) :
    lo( ic.lo), hi( ic.hi) {}
   
  Incarnation_Number &operator = ( const Incarnation_Number &ic) {
    lo= ic.lo; hi= ic.hi;
    return *this;
  }

  Incarnation_Number &operator ++() {
    if (lo == ULONG_MAX) {
      lo= 0L;
      hi++;
    }
    else lo++;
    return *this;
  }
  
  int operator < ( const Incarnation_Number &ic) {
    return (hi<ic.hi) ? 1 : (hi>ic.hi ? 0 : (lo<ic.lo));
  }
  
  int operator <= ( const Incarnation_Number &ic) {
    return (hi<ic.hi) ? 1 : (hi>ic.hi ? 0 : (lo<=ic.lo));
  }
};


template <class T>
class DO_ptr {
  Incarnation_Number IC;
  ABng_Guarded ic_guard;
public:
  CORBA::String_var ior;
  T my_object;
      
  DO_ptr(T _my_object = 0);
  
  DO_ptr(const DO_ptr&);
  
  int operator == (const DO_ptr&) const;
  
  DO_ptr& operator = (const DO_ptr&);

  ~DO_ptr();

  Incarnation_Number get_ic() {
    auto_lock local_lock( ic_guard);
    return IC;
  }
  void update_ic( Incarnation_Number ic) {
    auto_lock local_lock( ic_guard);
    IC= ic;
  }
};


template <class T>
unsigned hash_proxy(const DO_ptr<T>& observer_p);

