// -*- Mode: C++; -*-
// $Id: basic_client.h,v 1.2 1998/07/29 13:14:45 mencnar Exp $
//
// $Source: /home/iris/grant/abng/CVS/sources/common/basic_client.h,v $
//
// $Log: basic_client.h,v $
// Revision 1.2  1998/07/29 13:14:45  mencnar
// time synchronisation,
// persistent observers,
// notify calls moved to another thread ( fixed deadlock)
// internal server names changed
//
// Revision 1.1  1998/06/16 12:56:16  mencnar
// Initial revision
//
//
// File:          rep_client.h
// Author:        Malgorzata Steinder (gosia@ics.agh.edu.pl)
// Date Created:  16.03.98
//
// General Description:
//  Declaration of the Rep_Client class which is a skeleton for ABng 
//  repository utilities.


typedef ABng_Server_Manager::Name  (*resolve_fun)(); 

template<class Repository_Types>
class Basic_Client {

public:

  typedef Repository_Types::Item Item;
  typedef Repository_Types::Item_ptr Item_ptr;
  typedef Repository_Types::Items Items;
  typedef Repository_Types::Initial_Data Initial_Data;
  typedef Repository_Types::Item::Description Description;
  typedef Repository_Types::Item::Pattern Pattern;
  typedef Repository_Types::Item::Value_Description Value_Description;
  typedef Repository_Types::Item::Value_Descriptions Value_Descriptions;
  typedef Repository_Types::Repository Repository;
  typedef Repository_Types::Repository_ptr Repository_ptr;


  Basic_Client(resolve_fun _srv_rep) :
    srv_rep(_srv_rep) {}

  virtual ~Basic_Client() {}

  virtual void init(int argc, char **argv);
  virtual void init_rep_ptr();
  
  virtual Item_ptr init_item_ptr(char* data1);
  virtual Repository_ptr rep_ptr() { return my_rep; }
  virtual Pattern init_pattern();

  virtual Pattern
    init_pattern_id(Domain_Repository::Repository_Item_Id id);
  
  virtual CORBA::ORB_ptr get_orb() {return orb_ptr;}
  virtual CORBA::BOA_ptr get_boa() {return boa_ptr;}
 
protected:

  CORBA::ORB_ptr orb_ptr;
  CORBA::BOA_ptr boa_ptr;

  Repository_ptr my_rep;

  resolve_fun srv_rep;

};

