// $Id: basic_server.h,v 1.2 1998/07/29 13:14:48 mencnar Exp $
//
// $Source: /home/iris/grant/abng/CVS/sources/common/basic_server.h,v $
//
// $Log: basic_server.h,v $
// Revision 1.2  1998/07/29 13:14:48  mencnar
// time synchronisation,
// persistent observers,
// notify calls moved to another thread ( fixed deadlock)
// internal server names changed
//
// Revision 1.1  1998/06/16 12:56:16  mencnar
// Initial revision
//
//
// File:          basic_server.h
// Author:        Jakub Szymaszek (jasz@ics.agh.edu.pl)
// Date Created:  02.02.98
//
// General Description:
//  Declaration of the Basic_Server class implementing operations
//  commonly performed in CORBA servers.

#ifndef __BASIC_SERVER_H__
#define __BASIC_SERVER_H__ 1

#ifdef ORBIX
#include <CORBA.h>
#elif defined OMNIORB
#include <omniORB2/CORBA.h>
#endif



class Basic_Server {

public: 

  Basic_Server()
    :
#ifdef ORBIX 
    my_timeout(CORBA::BOA::INFINITE_TIMEOUT),
#endif
    thread_pool(1)
    {}
  virtual ~Basic_Server() {}
 
  virtual void init_corba(int &argc, char ** &argv);

#ifdef ORBIX
  virtual void set_orbix_conf(
    unsigned long max_retries_p = (CORBA::ULong) 2, // Orbix default is 10
    unsigned long connection_timeout_p = (CORBA::ULong) 30,
    unsigned long default_tx_timeout_p = CORBA::BOA::INFINITE_TIMEOUT,
    unsigned long object_table_size_p = CORBA::_OBJECT_TABLE_SIZE_DEFAULT,
    int diagnostics_p = 0,
    int propagate_tie_detele_p = 0,
    int abort_slow_connection_p = 0);
#endif

  virtual CORBA::ORB_ptr get_orb() {return orb_ptr;}
  virtual CORBA::BOA_ptr get_boa() {return boa_ptr;}
  virtual void set_thread_pool( int nof_threads) { thread_pool= nof_threads; }
  virtual void run();

protected:
    CORBA::ORB_ptr orb_ptr;
    CORBA::BOA_ptr boa_ptr;
    int thread_pool;
#ifdef ORBIX
  long my_timeout;
#endif

public:
  static void static_impl_is_ready( void *args);
};

#endif /* __BASIC_SERVER_H__ */

