//
// $Id: bootstrap_base.hh,v 1.2 1998/07/29 13:14:50 mencnar Exp $
//
// $Log: bootstrap_base.hh,v $
// Revision 1.2  1998/07/29 13:14:50  mencnar
// time synchronisation,
// persistent observers,
// notify calls moved to another thread ( fixed deadlock)
// internal server names changed
//
// Revision 1.1  1998/06/16 12:56:04  mencnar
// Initial revision
//
// Revision 1.1  1998/02/20 15:30:47  mencnar
// Initial revision
//
//
//-----------------------------------------------------------------------------
// 
// Author:      Daniel Mencnarowski  (mencnar@ics.agh.edu.pl)
//
// Description: Header file
//              A base class for "bootstrap" interface
//

#ifndef __bootstrap_base_hh__
#define __bootstrap_base_hh__

#include "Naming.hh"
#include "abng_server_manager.hh"

#define NS_IOR_FILE "NS_IOR_FILE"
#define ABNG_CONTEXT_NAME "ABNG_CONTEXT_NAME"
#define ABNG_DEFAULT_CONTEXT_NAME "abng_core"

class Bootstrap_base {
public:
  static CORBA::ORB_ptr orb;
  CosNaming::NamingContext_var root_ns;
  CORBA::String_var abng_root_ns;

  Bootstrap_base( CORBA::ORB_ptr);

  void incremental_bind( const ABng_Server_Manager::Name &name,
			 CORBA::Object_var object);

  void unbind( const ABng_Server_Manager::Name &name);

  CORBA::Object_var resolve( const ABng_Server_Manager::Name &name);
};

#endif // __bootstrap_base_hh__

//
