// $Id: observed_i.h,v 1.2 1998/07/29 13:14:53 mencnar Exp $
//
// $Source: /home/iris/grant/abng/CVS/sources/common/observed_i.h,v $
//
// $Log: observed_i.h,v $
// Revision 1.2  1998/07/29 13:14:53  mencnar
// time synchronisation,
// persistent observers,
// notify calls moved to another thread ( fixed deadlock)
// internal server names changed
//
// Revision 1.1  1998/06/16 12:56:16  mencnar
// Initial revision
//
//
// File:          observed.h
// Author:        Jakub Szymaszek (jasz@ics.agh.edu.pl)
// Date Created:  02.02.98
//
// General Description:
//  Definition of the template Observed_I class which implements
//  operations common for those observed ABng Repositories that notify
//  their observers when a new item is added.

#ifndef __OBSERVED_I_H__
#define __OBSERVED_I_H__

//#include "abng_core_management.hh"
#include "abng_guarded.hh"
#include "basic_observed_i.h"

template <class Observer_Types>
class Observed_I : public Basic_Observed_I<Observer_Types>  {

  virtual void gc_worker();
public:

  Observed_I(
#ifdef FilePersistency
     const char *repository_name
#endif
  );

  virtual ~Observed_I();

  virtual Basic_Observed_I<Observer_Types>::Observers* add_observer_list (
    ENV_DECL1(env)) 
    throw (CORBA::SystemException);

  virtual void attach_add_observer (
    Observer_ptr obs
    ENV_DECL(env))
    throw (CORBA::SystemException);

  virtual void detach_add_observer (
    Observer_ptr obs
    ENV_DECL(env)) 
    throw (CORBA::SystemException, 
	   Domain_Repository::Unknown_Observer);

  virtual void private_attach_add_observer (
    Observer_ptr obs
    ENV_DECL(env))
    throw (CORBA::SystemException);

  virtual void private_detach_add_observer (
    Observer_ptr obs
    ENV_DECL(env));

  virtual void save_observers_to_stream( ostream &ostr);
  virtual void load_observers_from_stream( istream &istr);
protected:

  virtual void remove_proxy(Observer_ptr obs);

  // list of add observers
  Observer_List my_add_observer_list;

};
#endif /* __OBSERVED_I_H__ */






