// -*- Mode: C++; -*-
//
// $Id: Bootstrap_base.java,v 1.1.1.1 1998/07/03 13:04:43 mencnar Exp $
//
// $Log: Bootstrap_base.java,v $
// Revision 1.1.1.1  1998/07/03 13:04:43  mencnar
//
// Revision 1.1  1998/06/18 09:19:22  mencnar
// Initial revision
//
//

package pl.edu.agh.ics.abngcore;

import java.io.InputStream;

class Bootstrap_base {
  org.omg.CosNaming.NamingContext root_ns;
  private static String NS_ENV = "NS_IOR_FILE";
  
  public Bootstrap_base( java.net.URL url) {
    try {
      java.net.URLConnection urlconn= url.openConnection();
      long len= urlconn.getContentLength();
      System.err.println("long len= urlconn.getContentLength();");
      InputStream is = urlconn.getInputStream();
      System.err.println("InputStream is = urlconn.getInputStream();");
      byte[] pom = new byte[(int)len];
      is.skip(0);
      long r= is.read( pom);
      System.err.println(" len "+len+" r "+r);
      if (r==-1) throw new Exception("");
      for (; pom[(int)(len-1)]<' '; len--)
	;  // get rid of EOL sequence
      String IOR= new String( pom, 0, (int)len);
      System.err.println(IOR);
      root_ns= org.omg.CosNaming.NamingContextHelper.narrow( 
			org.omg.CORBA.ORB.init().string_to_object( IOR));
      if (root_ns == null) {
	System.err.println("Cannot resolve NameService reference (root_ns == null)");
	System.exit( 1);
      }
    }
    catch( Exception e ) {
      System.err.println( "Invalid Naming Service URL name or its contents." );
      System.err.println( e.toString()+" - exiting." );
      System.exit( 1 );
    }
  }

  public Bootstrap_base() {
    try {
      String ns_file= System.getProperty( NS_ENV);
      if ( ns_file == null) {
	System.err.println( NS_ENV+" not defined as a property; cannot contact name service");
	System.exit(1);
      }
      root_ns= org.omg.CosNaming.NamingContextHelper.narrow( 
                     file_to_object( ns_file));
      if (root_ns == null) {
	System.err.println("Cannot resolve NameService reference (root_ns == null)");
	System.exit( 1);
      }
    }
    catch ( Exception ex) {
      ex.printStackTrace();
      System.err.println("Cannot resolve NameService reference "+ex);
      System.exit( 1);
    }
  }

  void incremental_bind( String[] name,
			 org.omg.CORBA.Object object) {
    int len= name.length;

    for ( int i=1; i<len; i++) {
      org.omg.CosNaming.NameComponent[] tmpName=
	new org.omg.CosNaming.NameComponent[ i];

      for ( int j=0; j<i; j++) 
	tmpName[ j]= new org.omg.CosNaming.NameComponent( name[ j],
							  name[ j]);
      try {
	root_ns.bind_new_context( tmpName);
      }
      catch ( org.omg.CosNaming.NamingContextPackage.AlreadyBound ex1) {}
      catch ( Exception ex) {
	System.err.println("Caught exception while creating name context "+ex);
        System.exit( 1);
      }						
    }
    org.omg.CosNaming.NameComponent[] tmpName=
	new org.omg.CosNaming.NameComponent[ len];
    for ( int i=0; i<len; i++)
      tmpName[ i]= new org.omg.CosNaming.NameComponent( name[ i],
                                                        name[ i]);
    try {
      root_ns.unbind( tmpName);
    }
    catch ( Exception ex) {}
    try {
      root_ns.bind( tmpName, object);
    }
    catch ( Exception ex) {
      System.err.println("Caught exception during (NS)bind "+ex);
      System.exit( 1);
    }
  }

  void unbind( String[] name) {
  }

  org.omg.CORBA.Object resolve( String[] name)  
	    throws org.omg.CosNaming.NamingContextPackage.NotFound,
		   org.omg.CosNaming.NamingContextPackage.CannotProceed,
		   org.omg.CosNaming.NamingContextPackage.InvalidName {

    org.omg.CosNaming.NameComponent []tmpName=
      new org.omg.CosNaming.NameComponent[ name.length];

    for ( int i=0; i<name.length; i++)
      tmpName[ i]= new org.omg.CosNaming.NameComponent( name[ i],
							name[ i]);

    return root_ns.resolve( tmpName);
  }


  private static org.omg.CORBA.Object file_to_object( String file_name) 
		throws Exception {
    String IOR= null;
    java.io.FileInputStream fis= new java.io.FileInputStream( file_name);
    byte t[]= new byte[ (int) (new java.io.File( file_name).length())];
    int len= fis.read( t);
    fis.close();
    for (; t[len-1]<' '; len--)
      ;  // get rid of EOL sequence
    IOR= new String( t, 0, len);
    System.err.println("<"+IOR+">");
    return org.omg.CORBA.ORB.init().string_to_object( IOR);
  }
}
