//
// $Id: DB_Header.java,v 1.2 1998/07/29 13:25:05 mencnar Exp $
//
// $Source: /home/iris/grant/abng/CVS/sources/common_java/all/DB_Header.java,v $
//
// $Log: DB_Header.java,v $
// Revision 1.2  1998/07/29 13:25:05  mencnar
// minor bug fixes in Visibroker 3.2 port
//
// Revision 1.1.1.1  1998/07/03 13:04:43  mencnar
//
// Revision 1.2  1998/06/18 09:19:22  mencnar
// *** empty log message ***
//
// Revision 1.1  1998/01/28 08:24:47  mencnar
// Initial revision
//
//
package pl.edu.agh.ics.abngcore;

import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.net.InetAddress;
import java.io.IOException;
import java.io.BufferedReader;

public class DB_Header {
  private String rep_name= null;
  private String ver_name= null;
  private String record_description= null;
  
  public DB_Header() {}
  
  public DB_Header(
	String rep_name,
	String ver_name,
	String record_description) {
    this.rep_name= rep_name;
    this.ver_name= ver_name;
    this.record_description= record_description;
  }
  
  public void save( PrintWriter os) {
    java.util.Date today= new java.util.Date();
    String hostname= "(unknown)";
    
    try {
      hostname= InetAddress.getLocalHost().toString();
    }
    catch ( Exception ex) {}
    
    os.print(
"# Active Badge next generation (ABng)\n# Release: 1.0\n#\n# " 
+ rep_name + 
" database ( Java version)\n# Last update: " 
+ today.toString() + 
"\n#\n# Generated by a process with pid "+hostname+" on " 
+ hostname + 
"\n#\n# Format description (version " 
+ ver_name + 
")\n# 	<file>::=               <next_item_id>\n#  				<number_of_items>\n#				<data_records>\n#\n#       <data_records>::=       |\n#                               <data_record> <data_records>\n#\n");
     os.print( record_description);
  }


  public void load( BufferedReader is) 
	    throws IOException {   
    String line;
    
    do {
      is.mark( 10);
      line= is.readLine();
//      System.err.println( line);
      if ( line == null) break;
      if ( line.length() == 0) continue;
      if ( line.charAt( 0) == '#') continue;
      break;
    } while ( true );
    is.reset();
  }

  private static void writePortableStream( PrintWriter os, org.omg.CORBA.portable.OutputStream pos) {
    org.omg.CORBA.portable.InputStream pis= pos.create_input_stream();
    
    int cread;
    os.print( "<");
    try {
      while ( pis.available()>0) {
	cread= pis.read();
	if (cread<0) cread+= 256;
	if ( cread < 16) os.print( "0"+Integer.toHexString( cread));
        else os.print( Integer.toHexString( cread));
	//	System.err.println( (char) cread + " "+cread);
	//	System.err.println( "Available "+pis.available());
      }
    } catch ( Exception e) {}
    os.print( ">");
  }

  private static org.omg.CORBA.portable.InputStream readPortableStream( BufferedReader is) 
	    throws IOException {
    int cread= is.read();
    char []buf= new char[2];
    org.omg.CORBA.portable.OutputStream pos= org.omg.CORBA.ORB.init().create_output_stream();
    
    while ( cread <= ' ' && cread != -1) 
      cread= is.read();
    
    if ( cread != '<') throw new IOException();
    int cread2;
    
    cread= is.read(); cread2= is.read();
    while ( cread2 != -1 && cread != '>') {
      buf[0]= (char) cread;
      buf[1]= (char) cread2;
      String tmp= new String( buf);
      int val= Integer.parseInt( tmp, 16);
      pos.write( val);
      cread= is.read();
      if ( cread == '>') break;
      cread2= is.read();
    }
    pos.flush();
    return pos.create_input_stream();
  }
  
  public static void writeTypeCode( PrintWriter os, org.omg.CORBA.TypeCode tc) {
    org.omg.CORBA.portable.OutputStream pos= org.omg.CORBA.ORB.init().create_output_stream();
    pos.write_TypeCode( tc);
    writePortableStream( os, pos);      
  }
  
  public static org.omg.CORBA.TypeCode readTypeCode( BufferedReader is) 
	    throws IOException {
    org.omg.CORBA.portable.InputStream pis= readPortableStream( is);
    return pis.read_TypeCode();
  }
  
  public static void writeAny( PrintWriter os, org.omg.CORBA.Any any) {
    //    try {
    //      PrintWriter pw= new PrintWriter( System.err);
    //      AnyPrinter.print( any, pw);
    //      pw.flush();
    //    }
    //    catch ( Exception ex) {}

    org.omg.CORBA.portable.OutputStream pos= org.omg.CORBA.ORB.init().create_output_stream();
    pos.write_any( any);
    try {
      pos.flush();
    }
    catch ( Exception ex) {}
    writePortableStream( os, pos);
  }
  
  public static org.omg.CORBA.Any readAny( BufferedReader is) 
	    throws IOException {
    org.omg.CORBA.portable.InputStream pis= readPortableStream( is);
    
    try {
      return pis.read_any();   
    }
    catch ( Exception ex) {
      ex.printStackTrace();
      return null;
    }
  }
  
  public static int readInt( BufferedReader is) 
	    throws IOException {
    char []buf= new char[ 20];
    int cread= is.read();
    int i= 0;

        
    while ( cread <= ' ' && cread != -1) 
      cread= is.read();
    
//    System.err.println( " #"+(char) cread);  
    if ( cread <'0' || cread >'9') throw new IOException();
    do {
      buf[i++]= (char) cread;
      is.mark( 10);
      cread= is.read();
    } while ( cread>='0' && cread<='9');
    is.reset();
    return Integer.parseInt( new String( buf, 0, i));
  }
  
  private static boolean isIdentChar( char c) {
    return ( c >= 'a' && c <= 'z' || c >= 'A' && c <= 'Z' || c >= '0' && c <= '9');
  }
  
  public static String readIdent( BufferedReader is) 
		throws IOException {
    char []buf= new char[ 255];
    int cread= is.read();
    int i= 0;

        
    while ( cread <= ' ' && cread != -1) 
      cread= is.read();
    
    if ( ! isIdentChar( (char) cread)) throw new IOException();
    do {
      buf[i++]= (char) cread;
      is.mark( 10);
      cread= is.read();
    } while ( isIdentChar( (char) cread) || cread == '_');
    is.reset();
    return new String( buf, 0, i);
  }
};


