#ifndef __LT_REP_SERVER_H__
#define __LT_REP_SERVER_H__ 1

#include "rep_server.h"
#include "abng_location_descr_rep_i.h"
#include "sensor_observer.h"
#include "location_descr_observer.h"

class ABng_LD_Rep_Server : public Rep_Server {

public:

  ABng_LD_Rep_Server(
#ifdef ObjectStore
    const char *db_name_p = "dbName",
    int cold_start_p = 0,
#elif FilePersistency
    const char *file_name_p = "ABng_Location_Description_Rep.db",
#endif
#ifdef ORBIX
    long timeout_p = -1,
#endif
    const char *current_directory_p = ".",
    long interval_p = 60) : Rep_Server(
#ifdef ObjectStore
    db_name_p,
#elif FilePersistency
    file_name_p,
#endif
    current_directory_p) {}

  virtual ~ABng_LD_Rep_Server() {}

  virtual void create_objects();
  virtual void delete_objects();

protected:
  ABng_Loc_Descr_Rep_I *my_rep_i;
  Sensor_Observer_I *my_sensor_observer;
  Location_Descr_Observer_I * my_location_descr_observer;
};

#endif __LT_REP_SERVER_H__





