// $Id$
//
// $Source$
//
// $Log$
//
// File description:
//  Main file for domain java repositories (location description, equipment)
//

package pl.edu.agh.ics.abngcore;


public class Domain_Java_Main {
  public static String ld_Repository_DB = "Location_Description.db";
  public static String eq_Repository_DB = "Equipment.db";

  public static ORB_wrapper my_orb_wrapper;

  private static void usage() {
    System.out.println("Usage: domain_java_rep [options]\nThe following options can be used:\n-s \t\t Used when server is launched for the the first time (cold start)\n-d directory \t Specify the database directory");
    System.exit( 1);
  }
  
  public static void main( String argv[]) {
    my_orb_wrapper= new ORB_wrapper();
    LDescr_Main.my_orb_wrapper= my_orb_wrapper;
    Equip_Main.my_orb_wrapper= my_orb_wrapper;

    my_orb_wrapper.init_application( argv);

    Bootstrap_n.init();
    boolean coldstart= false;
    String db_directory= null;

    for (int i=0; i<argv.length; i++) {
      if ( argv[ i].equals("-s")) coldstart= true;
      else if ( argv[ i].equals("-d")) {
	if ( i+1 == argv.length) usage();
	if ( db_directory == null) db_directory= argv[ i+1];
	else db_directory= argv[ i+1]+"/"+db_directory;
      }
      else usage();		    
    }
    if ( db_directory != null) {
      ld_Repository_DB= db_directory+"/"+ld_Repository_DB;
      eq_Repository_DB= db_directory+"/"+eq_Repository_DB;
    }

    if (coldstart) System.err.println("Cold start");

    // Location description repository
    //
    LDescr_Rep ldescr_rep= null;
    try {
      ldescr_rep= new LDescr_Rep( ld_Repository_DB, 
				  coldstart);
      my_orb_wrapper.connect_object( ldescr_rep.get_repository_object());
      my_orb_wrapper.connect_object( ldescr_rep.get_manager_object());
      new Process_Status( "location_description_repository", null);
    }
    catch ( Exception ex) {
	System.err.println( "Caught exception while instantiating server object " +ex);
	ex.printStackTrace();
	System.exit( 1);
    }    
    
    // Equipment repository
    //
    Equip_Rep equip_rep= null;
    try {
      equip_rep= new Equip_Rep( eq_Repository_DB, 
				coldstart);
      my_orb_wrapper.connect_object( equip_rep.get_repository_object());
      my_orb_wrapper.connect_object( equip_rep.get_manager_object());
      new Process_Status( "equipment_repository", null);
    }
    catch ( Exception ex) {
	System.err.println(
            "Caught exception while instantiating server object " +ex);
	ex.printStackTrace();
	System.exit( 1);
    }

    System.err.println("Calling impl_is_ready");
    my_orb_wrapper.impl_is_ready();        
  }
}
