// -*- Mode: C++; -*-
//
// $Id: Equip.java,v 1.2 1998/07/29 13:34:40 mencnar Exp $
//
// $Source: /home/iris/grant/abng/CVS/sources/servers/equipment_rep/EquipmentRep/Equip.java,v $
//
// $Log: Equip.java,v $
// Revision 1.2  1998/07/29 13:34:40  mencnar
// complex_query implementation,
// delayed database commit to improve performance during
//  resolution of Meta Equipment rep.
//
// Revision 1.1  1998/06/18 08:33:19  mencnar
// Initial revision
//
// Revision 1.1  1998/01/28 08:24:20  mencnar
// Initial revision
//
//
package pl.edu.agh.ics.abngcore;

import java.io.OutputStream;
import java.io.InputStream;
import java.io.PrintWriter;
import java.io.IOException;
import java.io.BufferedReader;
import java.io.PrintWriter;
import java.util.Vector;

// Visible only inside the package
//

class Equip implements Domain_Repository._EquipmentOperations {
  private org.omg.CORBA.ORB orb= org.omg.CORBA.ORB.init();

  private int meta_equipment_item_id;
  private Domain_Repository.Equipment corba_object= null;
  private Equip_Rep container;
  
  private Domain_Repository.EquipmentPackage.Description description= null;
  
//-----------visible in the package----------------
//
  Equip(Domain_Repository.EquipmentPackage.Description data_record,
	Equip_Rep _container
  ) throws Domain_Repository.Invalid_Description,
           Domain_Repository.Destination_Unreachable {
	    
    container= _container;
    description= data_record;
   
    meta_equipment_item_id= check_record(description);
    corba_object= new Domain_Repository._tie_Equipment( this);

    Equip_Main.my_orb_wrapper.connect_object(corba_object);

  }

  Equip (BufferedReader bufr, Equip_Rep _container) throws IOException {
        
    System.err.print("Equip ");

    description= new Domain_Repository.EquipmentPackage.Description();
    description.item_id= DB_Header.readInt( bufr);
    System.err.println("description.item_id "+description.item_id);
    meta_equipment_item_id= DB_Header.readInt( bufr);
    System.err.println("meta_equipment_item_id "+meta_equipment_item_id);
    int string_length = DB_Header.readInt( bufr);
    System.err.println(string_length);
    if(string_length != 0)
       description.name= DB_Header.readIdent( bufr);
    else  description.name= "";
    System.err.println(description.name);
    string_length = DB_Header.readInt( bufr);
    // System.err.println(string_length);
    if(string_length != 0)
       description.last_command= DB_Header.readIdent( bufr);
    else  description.last_command= "";
    // System.err.println(description.last_command);

    int nof_props= DB_Header.readInt( bufr);
    System.err.println( nof_props+" properties");
    description.property_list= new Domain_Repository.Property[ nof_props];
    // System.err.println("nof_props "+nof_props);
    for ( int i=0; i<nof_props; i++) {
      description.property_list[i]= new Domain_Repository.Property();
      string_length = DB_Header.readInt( bufr);
      if(string_length != 0)
         description.property_list[i].name= DB_Header.readIdent( bufr);
      else description.property_list[i].name= "";
      System.err.println(description.property_list[i].name);
      description.property_list[i].value= DB_Header.readAny( bufr);
    }
    container= _container;
    corba_object= new Domain_Repository._tie_Equipment( this);
    Equip_Main.my_orb_wrapper.connect_object( corba_object);
  }
  
  Domain_Repository.Equipment get_corba_object() {
    return corba_object;
  }
  
  int get_meta_equipment_item_id() {
    return meta_equipment_item_id;
  }
  
  void set_item_id( int new_item_id) {
    description.item_id= new_item_id;
  }

  synchronized void set_descr( 
	Domain_Repository.EquipmentPackage.Description new_descr) {
    int item_id = description.item_id;

    description= new_descr;

    description.item_id = item_id;
  }

  synchronized void 
   set_meta_data(Domain_Repository.Meta_Equipment meta_data) {
     description.meta_data = meta_data;
  }

  synchronized void save( PrintWriter os) {
    os.println( description.item_id+" "+meta_equipment_item_id+" "+description.name.length()+" "+description.name+" "+description.last_command.length()+" "+description.last_command+" "+description.property_list.length);
    for ( int i=0; i<description.property_list.length; i++) {
      os.print(" "+description.property_list[i].name.length()+" "
               +description.property_list[i].name+" ");
      DB_Header.writeAny(os, description.property_list[i].value);
      os.println("");
    }
  }

  //------------------------match_property--
  //
  private static boolean match_property( 
      Domain_Repository.Property_Pattern pattern,
      Domain_Repository.Property property) {
    
    if ( ! pattern.is_any) {
      if ( !pattern.name_pattern.is_any)
	if ( !pattern.name_pattern.value.equals( property.name)) return false;
      if ( !pattern.value_pattern.is_any)
	if ( !pattern.value_pattern.value.equal( property.value)) return false;
    }
    return true;
  }
  
  //-------------------------match_equip---
  synchronized void match_equip( 
	Vector vec /* of Equip */, 
	Domain_Repository.EquipmentPackage.Pattern pattern
  ) throws Domain_Repository.Destination_Unreachable {
    
  if (!pattern.is_any) {
    if (!pattern.item_id_pattern.is_any)
      if (pattern.item_id_pattern.value != description.item_id) return;
    if (!pattern.name_pattern.is_any)
      if (!pattern.name_pattern.value.equals( description.name)) return;
    if (!pattern.last_command_pattern.is_any)
      if (!pattern.last_command_pattern.value.equals(description.last_command))
        return;
    if ( !pattern.property_list_pattern.is_any) {
      int descr_size= description.property_list.length;
      int pattern_size= pattern.property_list_pattern.value.length;
      int items_matched= 0; /* items matched */
      int items_hit= 0; /* items matched in their respective positions */

      if ( pattern.property_list_pattern.constraints.value() ==
	   Domain_Repository.Sequence_Pattern_Constraints._RESTRICTED_NUMBER ||
	   pattern.property_list_pattern.constraints.value() ==
	   Domain_Repository.Sequence_Pattern_Constraints._RESTRICTED_ORDERING_AND_NUMBER) {
	  System.err.println("RESTRICTED_NUMBER");
	  if (pattern.property_list_pattern.value.length 
              != description.property_list.length
          ) return;
      }
      System.err.println("Check sequence");

      switch ( pattern.property_list_pattern.constraints.value()) {
	case Domain_Repository.Sequence_Pattern_Constraints._UNRESTRICTED:
          for(int i = 0; i < pattern_size; i ++) {
            int j;
            for(j = 0; j < descr_size; j ++)
              if(match_property(pattern.property_list_pattern.value[i],
                                  description.property_list[j])
              ) break;
            if(j == descr_size) return;
          }
	case Domain_Repository.Sequence_Pattern_Constraints._RESTRICTED_NUMBER:
	  int matched_array[] = new int[pattern_size];
	  for ( int i=0; i<pattern_size; i++) matched_array[ i]= -1;
	  for ( int d_i= 0; d_i<descr_size; d_i++) {
	    boolean item_used= false;
	    for ( int p_i= 0; p_i<pattern_size; p_i++) {
	      if (!match_property(pattern.property_list_pattern.value[ p_i],
				    description.property_list[ d_i])
              ) continue;

	      if (!item_used) {
		if ( matched_array[ p_i] == -1) {
		  matched_array[ p_i]= d_i;
		  item_used= true;
		}
	      }
	    }
	  }
	  for ( int i=0; i < pattern_size; i++)
	    if ( matched_array[ i] >= 0) items_matched++;
	  System.err.println("items_matched "+items_matched);
	  System.err.println("pattern_size "+pattern_size);
	  System.err.println("descr_size "+descr_size);
	  if ( items_matched != pattern_size) return;
	  break;
	case Domain_Repository.Sequence_Pattern_Constraints._RESTRICTED_ORDERING:
	case Domain_Repository.Sequence_Pattern_Constraints._RESTRICTED_ORDERING_AND_NUMBER:
	  int tmp_items_hit;
	  for (int d_i= 0; d_i<descr_size; d_i++) {
	    int min_size= 
              (d_i+pattern_size > descr_size) ? descr_size-d_i : pattern_size;
            tmp_items_hit= 0;
            for (int p_i= 0; p_i<min_size; p_i++) {
              if (!match_property(pattern.property_list_pattern.value[p_i],
                                 description.property_list[ d_i])
              ) break;
	      tmp_items_hit++;
	    }
	    if ( tmp_items_hit > items_hit) items_hit= tmp_items_hit;
	  }
	  System.err.println("items_hit "+items_hit);
	  System.err.println("pattern_size "+pattern_size);
          System.err.println("descr_size "+descr_size);
          if ( items_hit != pattern_size) return;
          break;
      } /* switch */
    }
    if(!pattern.meta_data_pattern.is_any) {
      if(!pattern.meta_data_pattern.item_id_pattern.is_any)
         if(pattern.meta_data_pattern.item_id_pattern.value !=
            meta_equipment_item_id
         ) return;

      if(!pattern.meta_data_pattern.type_pattern.is_any ||
         !pattern.meta_data_pattern.vendor_pattern.is_any ||
         !pattern.meta_data_pattern.model_pattern.is_any ||
         !pattern.meta_data_pattern.my_dimensions_pattern.is_any ||
         !pattern.meta_data_pattern.my_control_info_pattern.is_any ||
         !pattern.meta_data_pattern.my_icon_pattern.is_any
      ) {
        Domain_Repository.Meta_EquipmentPackage.Description[] vdescrs;
        try {
           vdescrs = container.meta_equipment_rep.find_values(
                               pattern.meta_data_pattern
                     );
        } catch(Exception ex) {
	   System.err.println( ex);
           ex.printStackTrace();
           throw new Domain_Repository.Destination_Unreachable();
        }

        int i;
        for(i = 0; i < vdescrs.length; i ++)
          if(vdescrs[i].item_id == meta_equipment_item_id) break;
        if(i == vdescrs.length) return;
      }
    }
  }
  vec.addElement( this);
}
  
  //--------------------change_type---
  // returns "true" if changes made due to new type description
  //
  synchronized boolean change_type( 
      Domain_Repository.Meta_EquipmentPackage.Description typedescr
  ) {
    System.err.println("change_type");

    Domain_Repository.EquipmentPackage.Description newdescr= 
       new Domain_Repository.EquipmentPackage.Description();
    
    newdescr.item_id = description.item_id;
    newdescr.name = description.name;
    newdescr.last_command = description.last_command;
    newdescr.meta_data = description.meta_data;

    newdescr.property_list = new Domain_Repository.Property[
      typedescr.specific_property_description_list.length];
      
    int old_values_used= 0;
        
    for ( int i=0; i<newdescr.property_list.length; i++) {
      Domain_Repository.Property newprop= null;

      for ( int j=0; j<description.property_list.length; j++) {
	if ( description.property_list[ j].name.equals( 
	     typedescr.specific_property_description_list[ i].name) &&
	     description.property_list[ j].value.type().equal( 
	     typedescr.specific_property_description_list[ i].type)) {
	  newprop= description.property_list[ j];
	  if ( i==j) old_values_used++;
	}
      }
      if ( newprop == null) {
	org.omg.CORBA.Any newvalue= orb.create_any();
	newvalue.insert_short( (short) 0);
	
	System.err.println("Creating property "+
                      typedescr.specific_property_description_list[ i].name);
        newprop = new Domain_Repository.Property( 
		typedescr.specific_property_description_list[ i].name, 
                newvalue);
      }
      newdescr.property_list[ i]= newprop;
    }
    
    description= newdescr;

    boolean ret = ( old_values_used != newdescr.property_list.length);
    return ret;
  }
  
  //----------------------check_record---
  // returns an item_id of the corresponding Meta Equipment object,
  // save it, for future updates
  //
  int check_record(Domain_Repository.EquipmentPackage.Description newdescr)
       throws Domain_Repository.Invalid_Description,
              Domain_Repository.Destination_Unreachable {
    

    Domain_Repository.Meta_EquipmentPackage.Description descr;
    try {
      descr = newdescr.meta_data.descr();
    } catch(Exception ex) {
      System.err.println("check_record caught exception "+ex);
      ex.printStackTrace();
      throw new Domain_Repository.Destination_Unreachable();
    }

    for(int i = 0; i < descr.specific_property_description_list.length; i ++) {

      if(!descr.specific_property_description_list[i].name.equals(
            newdescr.property_list[i].name
         )
      )  {
         System.err.println("Names are not equal");
         System.err.println(descr.specific_property_description_list[i].name);
         System.err.println(newdescr.property_list[i].name);
         throw new Domain_Repository.Invalid_Description();
      }

      if(!descr.specific_property_description_list[i].type.equal(
          newdescr.property_list[i].value.type()
        )
      )  {
         if(descr.specific_property_description_list[i].type.kind() !=
            newdescr.property_list[i].value.type().kind()
	 ) {
            System.err.println("Types are not equal");
            System.err.println(descr.specific_property_description_list[i].type);
            System.err.println(newdescr.property_list[i].value.type());
            throw new Domain_Repository.Invalid_Description();
         }
      }
    }

    return descr.item_id;
  }
  
  

// ----pubic methods-----
//
  public synchronized Domain_Repository.EquipmentPackage.Description descr() 
    throws Domain_Repository.Destination_Unreachable {
    
    if(description.meta_data == null) 
       throw new Domain_Repository.Destination_Unreachable();

    return description;
  }

  public synchronized Domain_Repository.EquipmentPackage.Value_Description 
    value_descr() throws Domain_Repository.Destination_Unreachable {

    Domain_Repository.Meta_EquipmentPackage.Description meta_data_descr;

    if(description.meta_data == null) {
        System.err.println("nil reference");
        throw new Domain_Repository.Destination_Unreachable();
    }

    try {
       meta_data_descr = description.meta_data.value_descr();
    } catch(Exception ex) {
       System.err.println(ex);
       ex.printStackTrace();
       throw new Domain_Repository.Destination_Unreachable();
    }

    Domain_Repository.EquipmentPackage.Value_Description vdescr =
       new Domain_Repository.EquipmentPackage.Value_Description(
              description.item_id,
              meta_data_descr,
              description.name,
              description.last_command,
              description.property_list
           );
    return vdescr;
  }

  public int item_id() /* immutable property */ {
    return description.item_id;
  }

  public Domain_Repository.Meta_Equipment meta_data () 
     throws Domain_Repository.Destination_Unreachable {
    
    if(description.meta_data == null) 
       throw new Domain_Repository.Destination_Unreachable();

    return description.meta_data;
  }
 
  public synchronized String name() {
    System.err.println("name "+description.name);
    return description.name;
  }

  public synchronized String last_command() {
    System.err.println("last_command "+description.last_command);
    return description.last_command;
  }
  
  public synchronized Domain_Repository.Property[] property_list() {
    return description.property_list;
  }
  
  public synchronized Domain_Repository.Static_Data_Observer[] 
    static_data_observer_list() {
    return container.static_data_observer_list( description.item_id );
  }
  
  public synchronized void attach_static_data_observer( 
	Domain_Repository.Static_Data_Observer obs) {
	
    int []par= new int[ 1];
    par[0]= description.item_id;
    try {
      container.attach_static_data_observer( obs, par);
    }
    catch ( Domain_Repository.Unknown_Repository_Item_Ids ex) {}
  } 
  
  public synchronized void detach_static_data_observer( 
	Domain_Repository.Static_Data_Observer obs) 
	    throws Domain_Repository.Unknown_Observer {
	
    int []par= new int[ 1];
    par[0]= description.item_id;
    try {
      container.detach_static_data_observer( obs, par);
    }
    catch ( Domain_Repository.Unknown_Repository_Item_Ids ex) {}
    catch ( Domain_Repository.Unmatched_Observer_Item_Ids ex) {}
  }

  public void invoke_command(String[] commands) {
    System.err.println("invoke_command");
    for(int i = 0; i < commands.length; i ++)
      System.out.println(commands[i]);
  }

  
  public boolean equals( Object o) {
    if ( o == null) return false;
    if ( ! ( o instanceof Equip)) return false;
    
    if(meta_equipment_item_id != ((Equip) o).get_meta_equipment_item_id())
         return false;
    if(description.name == ((Equip) o).name()) return true;
    return false;
  }
}

