//
// $Id: Equip_Rep.java,v 1.2 1998/07/29 13:34:41 mencnar Exp $
//
// $Source: /home/iris/grant/abng/CVS/sources/servers/equipment_rep/EquipmentRep/Equip_Rep.java,v $
//
// $Log: Equip_Rep.java,v $
// Revision 1.2  1998/07/29 13:34:41  mencnar
// complex_query implementation,
// delayed database commit to improve performance during
//  resolution of Meta Equipment rep.
//
// Revision 1.1  1998/06/18 08:33:19  mencnar
// Initial revision
//
// Revision 1.1  1998/01/28 08:23:25  mencnar
// Initial revision
//
//

package pl.edu.agh.ics.abngcore;

import java.util.Hashtable;
import java.util.Enumeration;
import java.util.Vector;
import java.io.IOException;
import java.io.BufferedReader;
import java.io.InputStreamReader;

class MEquip_ptr {
  private static org.omg.CORBA.ORB orb= org.omg.CORBA.ORB.init();
  
  public Domain_Repository.Meta_Equipment value;
  
  public MEquip_ptr( Domain_Repository.Meta_Equipment value) {
    this.value= value;
  }
  
  public int hashCode() {
    int ret= orb.object_to_string( value).hashCode();
//    System.err.println("hashCode "+ret);
    return ret;
  }
  
  public boolean equals( Object o) {
    if ( o == null) return false;
    if ( ! ( o instanceof MEquip_ptr)) return false;
    String s1= null;
    String s2= null;
    
    boolean ret= (s1= orb.object_to_string( value)).equals(
	     s2= orb.object_to_string( (( MEquip_ptr) o).value));
//    System.err.println( "equals "+ret);
    return ret;
  }
};

//==================================Equip_Rep===
public class Equip_Rep implements
    Domain_Repository_Management._Equipment_Rep_ManagerOperations,
    Domain_Repository._Equipment_RepOperations,
    Domain_Repository._Static_Data_ObserverOperations,
    Bootstrap_listener_interface_n {

  private String Repository_DB_Name;
  private Domain_Repository_Management._tie_Equipment_Rep_Manager 
    manager_object= null;
  private Domain_Repository._tie_Equipment_Rep repository_object= null;
  private Domain_Repository._tie_Static_Data_Observer observer_object= null;
  private Hashtable equip_list= new Hashtable();   
      // key: Equip, value: Equip
  private Hashtable equip_deref= new Hashtable();  
      // key: Integer(item_id), value: Equip
  private Hashtable item_ids_to_observers_list= new Hashtable(); 
      // key: Integer(item_id), value: Hashtable (Observer)
  private Hashtable observers_to_item_ids_list= new Hashtable();
      // key: Observer, value: Hashtable (Integer)
  private Hashtable add_static_data_observer_list= new Hashtable();
      // key: Observer, value: Observer
  private Hashtable mequip_list= new Hashtable();
      // key: MEquip, value: Integer ( item id)
						    	    
  public Domain_Repository.Meta_Equipment_Rep meta_equipment_rep= null;
  private Bootstrap_listener_n bootstrap_listener;
 
  private int item_id= 1;
  
  private synchronized int alloc_item_id() {
    return item_id++;
  }

//-----------------visible in this package-------------
//
  Domain_Repository_Management.Equipment_Rep_Manager get_manager_object() {
    return manager_object;
  }
  
  Domain_Repository.Equipment_Rep get_repository_object() {
    return repository_object;
  }
  
  Domain_Repository.Static_Data_Observer get_observer_object() {
    return observer_object;
  }
  
  synchronized Domain_Repository.Static_Data_Observer[] 
     static_data_observer_list( int item_id) {

    Hashtable observers_list= 
       ( Hashtable) item_ids_to_observers_list.get( new Integer( item_id));
    if ( observers_list == null) 
       return new Domain_Repository.Static_Data_Observer[ 0];
    
    Domain_Repository.Static_Data_Observer []ret=
       new Domain_Repository.Static_Data_Observer[ observers_list.size()];

    Enumeration e= observers_list.elements();
   
    for (int i= 0; e.hasMoreElements(); i++) {
      ret[ i]= (( SDO_ptr) e.nextElement()).value;
    }
    return ret;
  }
  
  //------------------------Equip_Rep---
  public Equip_Rep(String Repository_DB_Name, boolean coldstart) 
    throws Exception {

    this.Repository_DB_Name= Repository_DB_Name;
    manager_object= 
      new Domain_Repository_Management._tie_Equipment_Rep_Manager(this);
    repository_object= new Domain_Repository._tie_Equipment_Rep(this);
    observer_object= new Domain_Repository._tie_Static_Data_Observer(this);

    bootstrap_listener= new Bootstrap_listener_n( this);
    
    try {
      restore( coldstart);
    }
    catch ( Exception ex) {
      System.err.println( "Reading database failed "+ex.toString());
      throw ex;
    }
    Bootstrap_n.register_server_in_NS(Bootstrap_n.SRV_Equipment_Repository(),
				      repository_object);
    Bootstrap_n.register_server_in_NS(
       Bootstrap_n.SRV_Equipment_Repository_Manager(),
       manager_object
    );
    bootstrap_listener.register_callback(
         Bootstrap_n.SRV_Meta_Equipment_Repository()
    );
  }

  //------------------reference_resolved---
  public void reference_resolved(
	String[] name,
	org.omg.CORBA.Object server_ref,
	int callback_identifier
  ) {
    if (Bootstrap_n.equal_names(Bootstrap_n.SRV_Meta_Equipment_Repository(), 
                                name)
    ) {
      try {
	System.err.println( server_ref);
        meta_equipment_rep= 
           Domain_Repository.Meta_Equipment_RepHelper.narrow( server_ref);
	System.err.println( meta_equipment_rep);
	check_equipments();
      }
      catch ( Exception ex) {
	System.err.println( ex);
	ex.printStackTrace();
	meta_equipment_rep= null;
      }
    }
  }

  public void server_shutdown( String[] name,
			       int callback_identifier) {
  }
  
  //-------------------------update_type---
  // returns true if changes were real
  //
  private boolean update_type(
	Equip item, 
	Domain_Repository.Meta_EquipmentPackage.Description newtype) {
	
    if ( !item.change_type(newtype)) return false; // no changes 
    
    Domain_Repository.Static_Data_ObserverPackage.Static_Data_Object 
      static_data_object=
	new Domain_Repository.Static_Data_ObserverPackage.Static_Data_Object();
    static_data_object.equipment_obj( item.get_corba_object() );
    
    try {
       Hashtable observers_list= inform_observers( 
                               item.item_id(), 
			       static_data_object,
			       Domain_Repository.Change_Type.OBJECT_UPDATED);
						
    }
    catch ( Throwable a) {
      System.err.println( a);
//      a.printStackTrace();
    }
    
    System.err.println("Internal update succedded");
    return true;

    // the callee should save the state of the repository as soon as possible
  }
  
  //-------------------check_equipments---
  private void check_equipments() 
		throws Domain_Repository.Search_Not_Implemented {

       System.err.println("check_equipments");

    if(meta_equipment_rep == null)
       System.err.println("check_equipments -- nil");
    try { // just in case
     meta_equipment_rep.detach_add_static_data_observer(get_observer_object());
    }
    catch ( Exception ex) {}

    try {
    meta_equipment_rep.attach_add_static_data_observer(get_observer_object());
    } catch(Exception ex) {
      ex.printStackTrace();
    }

    Domain_Repository.Meta_EquipmentPackage.Pattern pattern=
      RepTools.get_merep_pattern();

    try {
      Domain_Repository.Meta_Equipment []ret=
	meta_equipment_rep.find(pattern);

      int ids[]= new int[ 1];
      for ( int i=0; i<ret.length; i++) {
	ret[ i].attach_static_data_observer( get_observer_object());
	mequip_list.put( 
          new MEquip_ptr( ret[ i]), new Integer( ret[ i].item_id())
        );
      }
    } catch ( Exception ex) {
      System.err.println(ex);
      ex.printStackTrace();
    }

    pattern.is_any= false;
    pattern.item_id_pattern.is_any= false;

    boolean dirty_flag= false;

    Enumeration e= equip_list.elements();
    for (int i=0; e.hasMoreElements(); i++) {
      Equip item= ( Equip) ( e.nextElement());
      
      pattern.item_id_pattern.value= item.get_meta_equipment_item_id();
      try {
	Domain_Repository.Meta_Equipment[] find_ret=
	    meta_equipment_rep.find( pattern);
	System.err.println("Searching for type (id = "+item.get_meta_equipment_item_id()+" ) resulted in "+find_ret.length+" hit(s)");
	if (find_ret.length == 1) {
          item.set_meta_data(find_ret[0]);
	  if (update_type(item, find_ret[0].value_descr())) dirty_flag= true;
	} else {
	  try {
	    System.err.println("Could not find type description in Location Type database, removing");
	    remove( item.get_corba_object());
	  }
	  catch ( Exception ex) {
	    System.err.println("Caught exception "+ex.toString());
	  }
	}
      }
      catch ( Exception ex) {
	ex.printStackTrace();
	if (dirty_flag) save();
        return;
      }
    }
    if (dirty_flag) save();
  }
  
  //--------------------meta_equipment_change---
  private void meta_equipment_change(
	int meta_equipment_item_id,
	Domain_Repository.Meta_EquipmentPackage.Description meta_descr) {
	
    for (Enumeration e= equip_list.elements(); 
	    e.hasMoreElements(); ) {
      Equip item= ( Equip) (e.nextElement());
      
      if ( item.get_meta_equipment_item_id() != meta_equipment_item_id) 
           continue;
      
      if ( meta_descr == null /* meta removed */) {
	try {
	  remove( item.get_corba_object());
	}
	catch ( Exception ex) {
	}
      } else if (update_type( item, meta_descr)) save();
    }
  }
  
  public void notify(
	int item_id, 
	Domain_Repository.Static_Data_ObserverPackage.Static_Data_Object obj,
	Domain_Repository.Change_Type change) {

    _notify( item_id, obj, change);
  }

  //-----------------------------notify---
  public void _notify(
	int item_id, 
	Domain_Repository.Static_Data_ObserverPackage.Static_Data_Object obj,
	Domain_Repository.Change_Type change) {
    
    Domain_Repository.Meta_Equipment meta_equip= null;
    System.err.println("notify");
    try {
      meta_equip= obj.meta_equipment_obj();
    }
    catch ( Exception ex) {
      return;
    }
    
    switch ( change.value()) {
      case Domain_Repository.Change_Type._OBJECT_ADDED:
	try {
	  meta_equip.attach_static_data_observer( get_observer_object());
	  mequip_list.put(new MEquip_ptr( meta_equip), 
                          new Integer( meta_equip.item_id())
          );
	}
	catch ( Exception ex) {}
	break;
      case Domain_Repository.Change_Type._OBJECT_UPDATED:
	try {
	  MEquip_ptr mequip_ptr= new MEquip_ptr( meta_equip);
	  Integer val= ( Integer) ( mequip_list.get( mequip_ptr));
	  System.err.println("Found "+ ( val == null));
	  System.err.println("Update location type: id "+ val.intValue());
	  meta_equipment_change(val.intValue(), meta_equip.descr());
	}
	catch ( Exception ex) {
	  ex.printStackTrace();
	}	
	break;
      case Domain_Repository.Change_Type._OBJECT_REMOVED:
	try {
	  Integer val= (Integer)(mequip_list.get(new MEquip_ptr( meta_equip)));
	  meta_equipment_change(val.intValue(), null /* removed */);
	  mequip_list.remove( new MEquip_ptr( meta_equip));
	}
	catch ( Exception ex) {}	
	break;
      default:
	System.err.println("Unknown change type "+change.value());
    }
  }
  
  //-----------------------abort---
  public void abort() {
  }
	

// Equipment_Rep_Manager methods and attributes
//		
//-----------------------------------rep---    
  public Domain_Repository.Equipment_Rep rep() {
    return repository_object;
  }


  //-------------------equipment_list---  
  public synchronized Domain_Repository.Equipment[] equipment_list() {
    Enumeration e= equip_list.elements();
    
    Domain_Repository.Equipment []ret= 
      new Domain_Repository.Equipment[ equip_list.size()];
    
    for (   int i=0; 
	    e.hasMoreElements();
	    i++) {
      ret[ i]= (( Equip) e.nextElement()).get_corba_object();
    }
    return ret;
  }

  //--------------detach_dead_observers--  
  private void detach_dead_observers( Vector dead_observers) {

    int size= dead_observers.size();
    for ( int i=0; i<size; i++ ) {
      Domain_Repository.Static_Data_Observer observer=
	(Domain_Repository.Static_Data_Observer) dead_observers.elementAt( i); 
      try {
	detach_static_data_observer( observer, get_item_ids_list( observer));
      } catch ( Exception ex) {}
      try {
	detach_add_static_data_observer( observer);
      } catch ( Exception ex) {}
    }    
  }
  
  //--------------------------add------
  public synchronized Domain_Repository.Equipment add(
	Domain_Repository.EquipmentPackage.Description data_record)
	    throws Domain_Repository.Duplicate_Data_Record,
		   Domain_Repository.Invalid_Description,
                   Domain_Repository.Destination_Unreachable {
	    
    System.err.println( "Equip_Rep::add");
    Equip new_equip  = new Equip( data_record, this);

    Enumeration e_1 = equip_list.elements();
    for (int i=0; e_1.hasMoreElements(); i++) {
       Equip e_temp = ( Equip) e_1.nextElement();
       if(e_temp.get_meta_equipment_item_id() 
           == new_equip.get_meta_equipment_item_id()
          && e_temp.name().equals(data_record.name)
	  ) {
          throw new Domain_Repository.Duplicate_Data_Record();
       }
    }

    if ( equip_list.containsKey(new_equip)) {
	Equip_Main.my_orb_wrapper.disconnect_object( new_equip.get_corba_object());
	throw new Domain_Repository.Duplicate_Data_Record();
    }
	
    new_equip.set_item_id( alloc_item_id());
    
    equip_list.put( new_equip, new_equip);
    equip_deref.put( new Integer( new_equip.item_id()), new_equip);
    item_ids_to_observers_list.put( new Integer( new_equip.item_id()), 
                                    new Hashtable()
    );
    // inform interested observers
    //
    
    Domain_Repository.Static_Data_ObserverPackage.Static_Data_Object 
      static_data_object=
	new Domain_Repository.Static_Data_ObserverPackage.Static_Data_Object();
    static_data_object.equipment_obj( new_equip.get_corba_object());
    
    Vector dead_observers= new Vector();
    for (Enumeration e= add_static_data_observer_list.elements();
	    e.hasMoreElements(); ) {
	    
      Domain_Repository.Static_Data_Observer observer= 
	(( SDO_ptr) e.nextElement()).value;
	
      try {
	System.err.println("Calling notify");
	Equip_Main.my_orb_wrapper.call_static_notify(
			  observer,
			  new_equip.item_id(), static_data_object, 
                          Domain_Repository.Change_Type.OBJECT_ADDED);
	System.err.println("Notify succeeded");
      }
      catch ( Exception ex) {
	System.err.println("Notify failed");
	dead_observers.addElement( observer);
      }
    }
    detach_dead_observers( dead_observers);
    
    // store update state of the repository
    save();
    return new_equip.get_corba_object();
  }

  //-----------------------deref_object------
  private Equip deref_object( Domain_Repository.Equipment object_to )
	throws Domain_Repository.Unknown_Object_Ref {
	
   if ( object_to == null) throw new Domain_Repository.Unknown_Object_Ref();
    
    int new_item_id= 0;
    try {
      new_item_id= object_to.item_id();
    }
    catch ( Exception ex) {
      System.err.println("deref_object "+ex);
      throw new Domain_Repository.Unknown_Object_Ref();
    }
    Equip new_equip= ( Equip) equip_deref.get( new Integer( new_item_id));
    if ( new_equip == null) throw new Domain_Repository.Unknown_Object_Ref();
    return new_equip;
  }

  private int[] get_item_ids_list(Domain_Repository.Static_Data_Observer obs) {
    Hashtable item_ids_list= ( Hashtable) observers_to_item_ids_list.get( 
					    new SDO_ptr( obs));
    if ( item_ids_list == null) return new int[0];
    
    int ret[]= new int[ item_ids_list.size()];
    Enumeration e= item_ids_list.elements();
      
    for (   int i=0;
	    e.hasMoreElements();
	    i++ ) {
	    
      ret[ i]= (( Integer) e.nextElement()).intValue();
    }
    return ret;
  }
  
  //--------------------inform_observers------  
  private Hashtable inform_observers(    
    int new_item_id,
    Domain_Repository.Static_Data_ObserverPackage.Static_Data_Object 
      static_data_object,
    Domain_Repository.Change_Type change_type) {
	
    Hashtable observers_list= 
      ( Hashtable) item_ids_to_observers_list.get( new Integer( new_item_id));
    if ( observers_list == null) return null;

    // inform interested observers
    //
    
    Vector dead_observers= new Vector();
       
    for (   Enumeration e= observers_list.elements();
	    e.hasMoreElements(); ) {
	    
      Domain_Repository.Static_Data_Observer observer= 
	(( SDO_ptr) e.nextElement()).value;
	
      try {
	System.err.println("Calling notify for "+observer);
	Equip_Main.my_orb_wrapper.call_static_notify( 
			     observer,
			     new_item_id, static_data_object, change_type);
      }
      catch ( Exception ex) {
	dead_observers.addElement( observer);
      }
    }
    detach_dead_observers( dead_observers);
    
    return observers_list;
  }
  
  //-----------------------remove--------  
  public synchronized void remove(
	Domain_Repository.Equipment object_to_remove)
	    throws Domain_Repository.Unknown_Object_Ref {
   
    System.err.println("Removing object "+object_to_remove.item_id());
    Equip new_equip= deref_object( object_to_remove);
    int new_item_id= new_equip.item_id();
    
    equip_deref.remove( new Integer( new_item_id));
    equip_list.remove( new_equip);
    
    Domain_Repository.Static_Data_ObserverPackage.Static_Data_Object 
      static_data_object=
	new Domain_Repository.Static_Data_ObserverPackage.Static_Data_Object();
    static_data_object.equipment_obj( new_equip.get_corba_object() );
    
    Hashtable observers_list= 
      inform_observers( new_item_id, static_data_object,
			Domain_Repository.Change_Type.OBJECT_REMOVED);
    
    // clean up after this Equip
    //
    if ( observers_list != null) 
      for (   Enumeration e= observers_list.elements();
	      e.hasMoreElements(); ) {
	    
        Domain_Repository.Static_Data_Observer observer= 
	  (( SDO_ptr) e.nextElement()).value;

	Hashtable ids_list= 
          (Hashtable) observers_to_item_ids_list.get( new SDO_ptr( observer));
	if ( ids_list == null) continue;
      
	ids_list.remove( new Integer( new_item_id));
      }
    
    // store updated state of the repository
    //
    save();
  }
  
  
  //--------------------update------
  public synchronized void update(
	Domain_Repository.Equipment object_to_update,
	Domain_Repository.EquipmentPackage.Description data_record)
	    throws Domain_Repository.Unknown_Object_Ref,
		   Domain_Repository.Duplicate_Data_Record,
		   Domain_Repository.Invalid_Description,
                   Domain_Repository.Destination_Unreachable {
    System.err.println("update called");

    Equip new_equip= deref_object(object_to_update);
    int new_item_id= new_equip.item_id();

    int meta_data_item_id;
    try {
       meta_data_item_id = data_record.meta_data.item_id();
    } catch (Exception ex) {
      ex.printStackTrace();
      throw new Domain_Repository.Destination_Unreachable();
    }

    if(new_equip.get_meta_equipment_item_id() !=  meta_data_item_id) {
      System.err.println("Cannot change meta equipment item id");
      throw new Domain_Repository.Invalid_Description();
    }
    
    new_equip.check_record( data_record);
    equip_list.remove( new_equip);

    Enumeration e= equip_list.elements();
    for (int i=0; e.hasMoreElements(); i++) {
       Equip e_temp = ( Equip) e.nextElement();
       if(e_temp.get_meta_equipment_item_id() == meta_data_item_id
          && e_temp.name().equals(data_record.name)
	  ) {
          equip_list.put(new_equip, new_equip);
          throw new Domain_Repository.Duplicate_Data_Record();
       }
    }
    
    // no Duplicate_Data_Record here
    new_equip.set_descr( data_record);
    equip_list.put(new_equip, new_equip);
        
    Domain_Repository.Static_Data_ObserverPackage.Static_Data_Object 
     static_data_object=
	new Domain_Repository.Static_Data_ObserverPackage.Static_Data_Object();
    static_data_object.equipment_obj( new_equip.get_corba_object() );
    
    try {
    Hashtable observers_list= 
       inform_observers( new_item_id, static_data_object,
			 Domain_Repository.Change_Type.OBJECT_UPDATED);
						
    } catch ( Throwable a) {
      System.err.println( a);
//      a.printStackTrace();
    }
    
    // store updated state of the repository
    //
    save();
    System.err.println("Update succeeded");
  }
  
// Equipment_Rep methods and attributes
//		    

  //--------------------------------find-----
  public synchronized Domain_Repository.Equipment[] find(
	Domain_Repository.EquipmentPackage.Pattern data_record_pattern)
	    throws Domain_Repository.Search_Not_Implemented,
                   Domain_Repository.Destination_Unreachable {
	    
    Vector collected= new Vector(); // of Equip
    Enumeration e= equip_list.elements();
    
    for (   int i=0; 
	    e.hasMoreElements();
	    i++) {
      (( Equip) e.nextElement()).match_equip( collected, data_record_pattern);
    }
    int size= collected.size();
    Domain_Repository.Equipment []ret= new Domain_Repository.Equipment[size];
    
    for (   int i=0;
	    i<size;
	    i++) {
      ret[ i]= (( Equip) ( collected.elementAt( i))).get_corba_object();
    }
    return ret;
  }

  //-------------------------find_values---  
  public Domain_Repository.EquipmentPackage.Value_Description[] find_values(
	Domain_Repository.EquipmentPackage.Pattern data_record_pattern)
	    throws Domain_Repository.Search_Not_Implemented,
                   Domain_Repository.Destination_Unreachable {
	    
    Vector collected= new Vector(); // of Equip
    Enumeration e= equip_list.elements();
    
    for (   int i=0; 
	    e.hasMoreElements();
	    i++) {
      (( Equip) e.nextElement()).match_equip( collected, data_record_pattern);
    }
    int size= collected.size();
    Domain_Repository.EquipmentPackage.Value_Description []ret= 
	new Domain_Repository.EquipmentPackage.Value_Description[size];

    for (   int i=0;
	    i<size;
	    i++) {
      ret[ i]= (( Equip) ( collected.elementAt( i))).value_descr();
    }
    return ret;
  }

 public synchronized Domain_Repository.EquipmentPackage.Query_Results 
   complex_query( Domain_Repository.EquipmentPackage.Entity_Set es, 
		  Domain_Repository.Query_Options qo, 
		  Domain_Repository.Static_Data_Observer obs) 
  throws Domain_Repository.Destination_Unreachable,
         Domain_Repository.Search_Not_Implemented
  {

   Domain_Repository.EquipmentPackage.Query_Results ret=
     new Domain_Repository.EquipmentPackage.Query_Results();
   ret.r_references= 
     new Domain_Repository.Equipment[0];
   ret.r_descriptions= 
     new Domain_Repository.EquipmentPackage.Description[0];
   ret.r_value_descriptions=
     new Domain_Repository.EquipmentPackage.Value_Description[0];
   ret.r_attach_results= new boolean[0];
   ret.r_detach_results= new boolean[0];
   ret.r_valid_descriptions= new boolean[0];
   ret.r_valid_value_descriptions= new boolean[0];

   Equip []item_set= null;

   switch (es.discriminator().value()) {
   case Domain_Repository.Entity_Set_Criteria._ESC_Pattern:
     {
       Domain_Repository.Equipment[] fres=
	 find( es.s_pattern());
       item_set= new Equip[fres.length];
       try {
	 for (int i=0; i<fres.length; i++)
	   item_set[i]= deref_object( fres[i]);
       }
       catch (Domain_Repository.Unknown_Object_Ref ex7) {}
     }
     break;
   case Domain_Repository.Entity_Set_Criteria._ESC_Ids:
     {
       int ids[]= es.s_ids();
       item_set= new Equip[ids.length];
       for (int i=0; i<ids.length; i++)
	 item_set[i]= (Equip) equip_deref.get( new Integer( ids[i])); 
     }
     break;
   case Domain_Repository.Entity_Set_Criteria._ESC_Refs:
     {
       Domain_Repository.Equipment[] fres=
	 es.s_refs();
       item_set= new Equip[fres.length];
       try {
	 for (int i=0; i<fres.length; i++)
	   item_set[i]= deref_object( fres[i]);
       }
       catch (Domain_Repository.Unknown_Object_Ref ex7) {}
     }
     break;
   default:
     return ret;
   }
   
   if (qo.return_references) 
     ret.r_references= 
       new Domain_Repository.Equipment[item_set.length];

   if (qo.return_descriptions) {
     ret.r_descriptions= 
       new Domain_Repository.EquipmentPackage.Description[item_set.length];
     ret.r_valid_descriptions= new boolean[item_set.length];
   }
   if (qo.return_value_descriptions) {
     ret.r_value_descriptions=
       new Domain_Repository.EquipmentPackage.Value_Description[item_set.length];
     ret.r_valid_value_descriptions= new boolean[item_set.length];
   }
   if (qo.do_attach)
     ret.r_attach_results= new boolean[item_set.length];
   if (qo.do_detach)
     ret.r_detach_results= new boolean[item_set.length];
  
   for (int i=0; i<item_set.length; i++) {
     if (qo.return_references)
       ret.r_references[i]= 
	 (item_set[i] != null) ? item_set[i].get_corba_object() : null;
     if (qo.return_descriptions) {
       ret.r_valid_descriptions[i]= false;
       if (item_set[i] != null){
	 ret.r_descriptions[i]= item_set[i].descr();
	 ret.r_valid_descriptions[i]= true;
       }
       else {
	 ret.r_descriptions[i]=
	   new Domain_Repository.EquipmentPackage.Description();
	 ret.r_descriptions[i].meta_data= null;
	 ret.r_descriptions[i].name= null;
	 ret.r_descriptions[i].last_command= null;
	 ret.r_descriptions[i].property_list=
	   new Domain_Repository.Property[0];
       }
     }
     if (qo.return_value_descriptions) {
       ret.r_valid_value_descriptions[i]= false;
       if (item_set[i] != null) {
	 ret.r_value_descriptions[i]= item_set[i].value_descr();
	 ret.r_valid_value_descriptions[i]= true;
       }
       else {
	 ret.r_value_descriptions[i]=
	   new Domain_Repository.EquipmentPackage.Value_Description();
	 ret.r_value_descriptions[i].meta_data= 
	   new Domain_Repository.Meta_EquipmentPackage.Description();
	 // xx
	 ret.r_value_descriptions[i].name= null;
	 ret.r_value_descriptions[i].last_command= null;
	 ret.r_value_descriptions[i].property_list=
	   new Domain_Repository.Property[0];
       }
     }
     if (qo.do_attach) {
       ret.r_attach_results[i]= false;
       if (item_set[i] != null) {
	 item_set[i].attach_static_data_observer(obs);
	   ret.r_attach_results[i]= true;
       }
     }
     if (qo.do_detach) {
       ret.r_detach_results[i]= false;
       try {
	 if (item_set[i] != null) {
	   item_set[i].detach_static_data_observer(obs);
	   ret.r_detach_results[i]= true;
	 }
       }
       catch (Domain_Repository.Unknown_Observer ex3) {}
     }
   }
   return ret;
 }
  
// Static_Data_Observed_R methods and attributes
//

  //--------------------------static_data_observer_list----
  //
  public synchronized 
    Domain_Repository.Static_Data_Observed_RPackage.Observer_Entry[] 
      static_data_observer_list(
  ) {
    Enumeration e= observers_to_item_ids_list.keys();
    
    Domain_Repository.Static_Data_Observed_RPackage.Observer_Entry []ret= 
      new Domain_Repository.Static_Data_Observed_RPackage.Observer_Entry[
             observers_to_item_ids_list.size()
          ];
    
    for (   int i=0; 
	    e.hasMoreElements();
	    i++) {
      ret[ i]= 
        new Domain_Repository.Static_Data_Observed_RPackage.Observer_Entry();
      ret[ i].obs= (( SDO_ptr) e.nextElement()).value;
      System.err.println( i + " observer "+ret[i].obs);
      Hashtable interest= 
        (Hashtable) observers_to_item_ids_list.get( new SDO_ptr( ret[ i].obs));
      System.err.println( i + " interest "+ interest);
      ret[ i].interest= new int[ interest.size() ];
      
      Enumeration e2= interest.elements();
      for ( int j=0;
	    e2.hasMoreElements();
	    j++) {
	ret[i].interest[j]= ( (Integer) e2.nextElement()).intValue();
      }
    }
    return ret;
  }
  
  //--------------------add_static_data_observer_list---
  public Domain_Repository.Static_Data_Observer[] 
   add_static_data_observer_list() {
    Enumeration e= add_static_data_observer_list.elements();
    
    Domain_Repository.Static_Data_Observer []ret= 
      new Domain_Repository.Static_Data_Observer[ add_static_data_observer_list.size()];
    
    for (   int i=0; 
	    e.hasMoreElements();
	    i++) {
      ret[ i]= (( SDO_ptr) e.nextElement()).value;
    }
    return ret;
 }
 
 //-------------------check_unknown_item_ids-----
 private void check_unknown_item_ids(
	int [] observed_id_list)
	    throws Domain_Repository.Unknown_Repository_Item_Ids {
	    
    Vector unknown_item_ids= new Vector(); // of Integer
    for ( int i=0; i<observed_id_list.length; i++) {
      if (!item_ids_to_observers_list.containsKey(
               new Integer( observed_id_list[i]))
      ) unknown_item_ids.addElement( new Integer( observed_id_list[i]));
    }
    if ( unknown_item_ids.size() != 0) {
      int ret[]= new int[ unknown_item_ids.size()];
      
      for (int i=0; i<ret.length; i++)
	ret[ i]= (( Integer) unknown_item_ids.elementAt( i)).intValue();
      throw new Domain_Repository.Unknown_Repository_Item_Ids( ret);
    }
 }

 //--------------------attach_static_data_observer-----
 public synchronized void attach_static_data_observer(
	Domain_Repository.Static_Data_Observer obs,
	int [] observed_id_list
 ) throws Domain_Repository.Unknown_Repository_Item_Ids {
    System.err.println("attach_static_data_observer");
    
    if ( obs == null) return;
    check_unknown_item_ids( observed_id_list);
    
    Hashtable item_ids_list= 
       (Hashtable) observers_to_item_ids_list.get( new SDO_ptr( obs));
    
    if ( item_ids_list == null) {
      item_ids_list= new Hashtable();
      observers_to_item_ids_list.put( new SDO_ptr( obs), item_ids_list);
    }
    for ( int i=0; i<observed_id_list.length; i++) {
      Hashtable observers_list= 
        (Hashtable) item_ids_to_observers_list.get( 
                        new Integer( observed_id_list[ i])
        );
      if ( observers_list != null) {
	if ( ! observers_list.contains( new SDO_ptr( obs)))
	  observers_list.put( new SDO_ptr( obs), new SDO_ptr( obs));
      }
    }
  }

  //---------------------detach_static_data_observer-----
  public synchronized void detach_static_data_observer(
	Domain_Repository.Static_Data_Observer obs,
	int [] observed_id_list)
	    throws Domain_Repository.Unknown_Repository_Item_Ids,
		   Domain_Repository.Unknown_Observer,
		   Domain_Repository.Unmatched_Observer_Item_Ids {
		   
    System.err.println("detach_static_data_observer");
    
    if ( obs == null) throw new Domain_Repository.Unknown_Observer();
    check_unknown_item_ids( observed_id_list);
     
    Vector unmatched_item_ids= new Vector();
    for ( int i=0; i<observed_id_list.length; i++) {
      Hashtable observers_list= 
         ( Hashtable) item_ids_to_observers_list.get( 
				  new Integer( observed_id_list[i])
         );
      if ( observers_list == null) continue;
       
      if ( ! observers_list.containsKey( new SDO_ptr( obs)))
	unmatched_item_ids.addElement( new Integer( observed_id_list[ i]));
    }
    if ( unmatched_item_ids.size() != 0) {
      int err_ids[]= new int[ unmatched_item_ids.size()];
      for ( int i=0; i<err_ids.length; i++)
	err_ids[i]= (( Integer) unmatched_item_ids.elementAt( i)).intValue();
      throw new Domain_Repository.Unmatched_Observer_Item_Ids( err_ids);
    }
    
    // preconditions checked
    
    Hashtable all_item_ids= 
        (Hashtable) observers_to_item_ids_list.get( new SDO_ptr( obs));
    if ( all_item_ids != null) {
      for ( int i=0; i<observed_id_list.length; i++) 
	all_item_ids.remove( new Integer( observed_id_list[i]));
      
      if ( all_item_ids.size() == 0) {
	observers_to_item_ids_list.remove( new SDO_ptr( obs));
      }
    }
    for ( int i=0; i<observed_id_list.length; i++) {
      Hashtable observers_list= 
          (Hashtable) item_ids_to_observers_list.get( 
				       new Integer( observed_id_list[i])
          );
      if ( observers_list == null) continue;
       
      observers_list.remove( new SDO_ptr( obs));
    }
  }

  //-----------------------attach_add_static_data_observer---
  public synchronized void attach_add_static_data_observer (
	Domain_Repository.Static_Data_Observer obs) {
    System.err.println("attach_add_static_data_observer "+obs);
    
    if ( obs == null) return;
    
    if ( ! add_static_data_observer_list.containsKey( new SDO_ptr( obs)))
       add_static_data_observer_list.put(new SDO_ptr( obs), new SDO_ptr( obs));
  }

  //---------------------detach_add_static_data_observer---  
  public void detach_add_static_data_observer (
	Domain_Repository.Static_Data_Observer obs)
	    throws Domain_Repository.Unknown_Observer {
    System.err.println("detach_static_data_observer "+obs);
    System.err.println("observers in list "
                       +add_static_data_observer_list.size());
    if ( add_static_data_observer_list.remove( new SDO_ptr( obs)) == null)
	throw new Domain_Repository.Unknown_Observer();
  }
 
  //---------------------save--- 
  private synchronized void save() {
    java.io.FileOutputStream fos= null;
    try {
      fos= new java.io.FileOutputStream( Repository_DB_Name+".temporary");
      java.io.PrintWriter pwri= new java.io.PrintWriter( fos);
   
      DB_Header db_header= new DB_Header( 
        "Equipment ", "1.0", 
        "#       data_record::=	<item_id> <meta_equipment_item_id> <name> <last_command> <number_of_properties> <properties>\n#\n#       <name>::= <string>\n#\n#       properties::=   |\n#                      <property> <properties>\n#\n#       property::=    <property_name> <property_value>\n#\n#       property_name::= <string>\n#\n#       property_value:= \"<\"<hexdigits> \">\"\n#\n"
      );
    
      db_header.save( pwri);
    
      pwri.println( item_id);
      pwri.println( equip_list.size());
    
      for (	Enumeration e= equip_list.elements();
  		e.hasMoreElements(); ) {
        ((Equip) e.nextElement()).save( pwri);
      }
      pwri.flush();
      pwri.close();
      fos.close();
      
      java.io.File destdb= new java.io.File( Repository_DB_Name+".temporary");
      destdb.renameTo( new java.io.File( Repository_DB_Name));
    }
    catch ( Exception ex) {
      if ( fos != null) {
	try {
	  fos.flush();
	  fos.close();
	}
	catch ( Exception ex2) {}
      }
      System.err.println("Caught exception while saving repository database "
                         +ex);
      ex.printStackTrace();
      System.exit( 1);
    }
  }
  
  //----------------------------restore---
  private synchronized void restore( boolean coldstart) 
	    throws IOException {
    java.io.FileInputStream fis;
    try {
      fis= new java.io.FileInputStream( Repository_DB_Name);
      if ( coldstart) {
	System.err.println("Repository database "+Repository_DB_Name+
          " exist, please remove it and run the repository server once again");
	System.exit( 1);
      }
    }
    catch ( IOException ex) {
      if (!coldstart) throw ex;
      save();
      fis= new java.io.FileInputStream( Repository_DB_Name);
    }

    BufferedReader bufr= new BufferedReader( new InputStreamReader( fis));
 
    DB_Header db_header= new DB_Header();
    db_header.load( bufr);
    //    System.err.println("DB_Header read");
    item_id= DB_Header.readInt( bufr);
    int nof_items= DB_Header.readInt( bufr);
    //    System.err.println("Next item id : "+item_id);
    System.err.println("Nof items "+nof_items);
    
    for ( int i=0; i<nof_items; i++) {
      Equip new_equip= new Equip( bufr, this);
    
      equip_list.put( new_equip, new_equip);
      equip_deref.put( new Integer( new_equip.item_id()), new_equip);
      item_ids_to_observers_list.put(new Integer( new_equip.item_id()), 
                                                  new Hashtable()
      );
    }
  }
};


