//
// $Id: LDescr.java,v 1.3 1998/07/03 12:50:10 mencnar Exp $
//
// $Source: /home/iris/grant/abng/CVS/sources/servers/location_description_rep/LDescr/LDescr.java,v $
//
// $Log: LDescr.java,v $
// Revision 1.3  1998/07/03 12:50:10  mencnar
// moved common files to "common_java" directory
//
// Revision 1.2  1998/06/18 09:19:22  mencnar
// *** empty log message ***
//
// Revision 1.1  1998/01/28 08:24:20  mencnar
// Initial revision
//
//
package pl.edu.agh.ics.abngcore;

import java.io.OutputStream;
import java.io.InputStream;
import java.io.PrintWriter;
import java.io.IOException;
import java.io.BufferedReader;
import java.io.PrintWriter;
import java.util.Vector;

import AnyPrinter;

// Visible only inside the package
//

class LDescr implements
		    Domain_Repository._Location_DescriptionOperations {

  private int location_type_item_id;
  private Domain_Repository.Location_Description corba_object= null;
  private LDescr_Rep container;
  
  private Domain_Repository.Location_DescriptionPackage.Description description= null;
  
//-----------visible in the package----------------
//
  LDescr ( 
	Domain_Repository.Location_DescriptionPackage.Description data_record,
	LDescr_Rep _container) 
		throws Domain_Repository.Invalid_Description {
	
    description= data_record;
    container= _container;
    location_type_item_id= check_record( description);
    corba_object= new Domain_Repository._tie_Location_Description( this);
    LDescr_Main.my_orb_wrapper.connect_object( corba_object);
  }

  LDescr (
	BufferedReader bufr,
	LDescr_Rep _container) 
		throws IOException {
	    
    description= new Domain_Repository.Location_DescriptionPackage.Description();
    description.item_id= DB_Header.readInt( bufr);
    description.type_name= DB_Header.readIdent( bufr);
    location_type_item_id= DB_Header.readInt( bufr);

    int nof_props= DB_Header.readInt( bufr);
    description.property_list= new Domain_Repository.Property[ nof_props];
    System.err.println( "Description for item_id "+description.item_id+
			" type_name "+description.type_name);
    for ( int i=0; i<nof_props; i++) {
      description.property_list[i]= new Domain_Repository.Property();
      description.property_list[i].name= DB_Header.readIdent( bufr);
      description.property_list[i].value= DB_Header.readAny( bufr);
      try {
	java.io.PrintWriter pw= new java.io.PrintWriter( System.err);
	AnyPrinter.print( description.property_list[i].value,
			  pw);
	pw.flush();
      }
      catch (Exception ex) {
	System.err.println( ex);
      }
    }
    container= _container;
    corba_object= new Domain_Repository._tie_Location_Description( this);
    LDescr_Main.my_orb_wrapper.connect_object( corba_object);
  }
  
  Domain_Repository.Location_Description get_corba_object() {
    return corba_object;
  }
  
  int get_location_type_item_id() {
    return location_type_item_id;
  }
  
  void set_item_id( int new_item_id) {
    description.item_id= new_item_id;
  }

  synchronized void set_descr( 
	Domain_Repository.Location_DescriptionPackage.Description new_descr) {
    description.type_name= new_descr.type_name;
    description.property_list= new_descr.property_list;
  }

  synchronized void save( PrintWriter os) {
    os.println( description.item_id+" "+description.type_name+" "+location_type_item_id+" "+description.property_list.length);
    for ( int i=0; i<description.property_list.length; i++) {
      os.print("   "+description.property_list[i].name+" ");
      DB_Header.writeAny( os, description.property_list[i].value);
      os.println("");
    }
  }

  //--------------------------------------------------------------------------match_ldescr_list--
  //
  private static boolean match_ldescr_list( Domain_Repository.Property_Pattern pattern,
					    Domain_Repository.Property property) {
    
    if ( ! pattern.is_any) {
      if ( !pattern.name_pattern.is_any) {
	if ( !pattern.name_pattern.value.equals( property.name)) return false;
      }
      //      System.err.println( pattern.name_pattern.value+" "+property.name);
      if ( !pattern.value_pattern.is_any)
	if ( !pattern.value_pattern.value.equal( property.value)) return false;
    }
    System.err.println("match_ldescr_list true");
    return true;
  }
  
  //------------------------------------------------------------------------------match_ldescr---
  synchronized void match_ldescr( 
	Vector vec /* of LDescr */, 
	Domain_Repository.Location_DescriptionPackage.Pattern pattern) {
    
//    System.err.println("match_ldescr");
    if ( !pattern.is_any) {
      if ( !pattern.item_id_pattern.is_any)
	if ( pattern.item_id_pattern.value != description.item_id) return;
      if ( !pattern.type_name_pattern.is_any) {
//	 System.err.println("pattern.type_name      #"+pattern.type_name_pattern);
//	 System.err.println("description.type_name  #"+description.type_name);
	if ( !pattern.type_name_pattern.value.equals( description.type_name)) return;
      }
      if ( !pattern.property_list_pattern.is_any) {
	int descr_size= description.property_list.length;
	int pattern_size= pattern.property_list_pattern.value.length;
	int items_matched= 0; /* items matched */
	int items_hit= 0; /* items matched in their respective positions */

	if ( pattern.property_list_pattern.constraints.value() ==
	     Domain_Repository.Sequence_Pattern_Constraints._RESTRICTED_NUMBER ||
	     pattern.property_list_pattern.constraints.value() ==
	     Domain_Repository.Sequence_Pattern_Constraints._RESTRICTED_ORDERING_AND_NUMBER) {
	  System.err.println("RESTRICTED_NUMBER");
	  if ( pattern.property_list_pattern.value.length != description.property_list.length) return;
	}

	//	System.err.println("Check sequence");


	switch ( pattern.property_list_pattern.constraints.value()) {
	case Domain_Repository.Sequence_Pattern_Constraints._UNRESTRICTED:
	case Domain_Repository.Sequence_Pattern_Constraints._RESTRICTED_NUMBER:
	  int matched_array[] = new int[pattern_size];
	  for ( int i=0; i<pattern_size; i++)
	    matched_array[ i]= -1;
	  for ( int d_i= 0; d_i<descr_size; d_i++) {

	    boolean item_used= false;
	    for ( int p_i= 0; p_i<pattern_size; p_i++) {
	      if ( ! match_ldescr_list( pattern.property_list_pattern.value[ p_i],
					description.property_list[ d_i])) continue;
	      
	      if ( ! item_used) {
		if ( matched_array[ p_i] == -1) {
		  matched_array[ p_i]= d_i;
		  item_used= true;
		}
	      }
	    }
	  }
	  for ( int i=0; i<pattern_size; i++)
	    if ( matched_array[ i] >= 0) items_matched++;
	  //	  System.err.println("items_matched "+items_matched);
	  //	  System.err.println("pattern_size "+pattern_size);
	  //	  System.err.println("descr_size "+descr_size);
	  if ( items_matched != pattern_size) return;
	  break;
	case Domain_Repository.Sequence_Pattern_Constraints._RESTRICTED_ORDERING:
	case Domain_Repository.Sequence_Pattern_Constraints._RESTRICTED_ORDERING_AND_NUMBER:
	  int tmp_items_hit;
	  for ( int d_i= 0; d_i<descr_size; d_i++) {
	    int min_size= (d_i+pattern_size > descr_size) ? descr_size-d_i : pattern_size;
	    tmp_items_hit= 0;
	    for ( int p_i= 0; p_i<min_size; p_i++) {
	      if ( ! match_ldescr_list( pattern.property_list_pattern.value[ p_i],
					description.property_list[ d_i])) break;
	      tmp_items_hit++;
	    }
	    if ( tmp_items_hit > items_hit) items_hit= tmp_items_hit;
	  }
	  System.err.println("items_hit "+items_hit);
	  System.err.println("pattern_size "+pattern_size);
	  System.err.println("descr_size "+descr_size);
	  if ( items_hit != pattern_size) return;
	  break;
	}
      }
    }
    vec.addElement( this);
  }
  
  //-------------------------------------------------------------------------------change_type---
  // returns "true" if changes made due to new type description
  //
  synchronized boolean change_type( Domain_Repository.Location_TypePackage.Description typedescr) {
    System.err.println("change_type");
    //    return false;
    Domain_Repository.Location_DescriptionPackage.Description newdescr= 
      ( Domain_Repository.Location_DescriptionPackage.Description) description.clone();
    newdescr.property_list= 
      new Domain_Repository.Property[ typedescr.property_description_list.length];
      
    int old_values_used= 0;
    
    for ( int i=0; i<newdescr.property_list.length; i++) {
      Domain_Repository.Property newprop= null;
      
      for ( int j=0; j<description.property_list.length; j++) 
	if ( description.property_list[ j].name.equals( 
		 typedescr.property_description_list[ i].name)) {
	  if (description.property_list[ j].value.type().kind().value()==
	      typedescr.property_description_list[ i].type.kind().value()) {
	    // only TypeCode kind is checked here
	    // the TypeCode "equal" method is broken, so it cannot be used
	    // 
	     
	    newprop= description.property_list[ j];
	    if ( i==j) old_values_used++;
	  }
	}
      
      if ( newprop == null) {
	org.omg.CORBA.Any newvalue= org.omg.CORBA.ORB.init().create_any();
	newvalue.type( org.omg.CORBA.ORB.init().get_primitive_tc( org.omg.CORBA.TCKind.tk_null));
	
	System.err.println("Creating property "+typedescr.property_description_list[ i].name);
        newprop= 
	    new Domain_Repository.Property( 
		typedescr.property_description_list[ i].name,
		newvalue);
      }
      newdescr.property_list[ i]= newprop;
    }
    
    description= newdescr;
    return ( old_values_used != newdescr.property_list.length);
  }
  
  //-------------------------------------------------------------------------------check_record---
  // returns an item_id of the corresponding Location Type object,
  // save it, for future updates
  //
  int check_record( Domain_Repository.Location_DescriptionPackage.Description newdescr)
		throws Domain_Repository.Invalid_Description {
    
//    System.err.println( "Creating pattern "+container);
    
    if ( container.location_type_rep == null) {
      System.err.println("Location Type repository not contacted");
      throw new Domain_Repository.Invalid_Description();
    }
    
    try {
      if ( newdescr.property_list.length != description.property_list.length)
        throw new Domain_Repository.Invalid_Description();   
	
//      System.err.println( "Creating pattern");
      Domain_Repository.Location_TypePackage.Pattern pattern=
	new Domain_Repository.Location_TypePackage.Pattern();

      pattern.is_any= false;
      pattern.item_id_pattern= new Domain_Repository.Unsigned_Long_Pattern();
      pattern.item_id_pattern.is_any= true;
      pattern.name_pattern= new Domain_Repository.String_Pattern();
      pattern.name_pattern.is_any= false;
      pattern.name_pattern.value= newdescr.type_name;
      pattern.property_description_list_pattern= new Domain_Repository.Property_Descriptions_Pattern();
      pattern.property_description_list_pattern.is_any= false;
      pattern.property_description_list_pattern.constraints= 
	Domain_Repository.Sequence_Pattern_Constraints.RESTRICTED_ORDERING_AND_NUMBER;

      pattern.property_description_list_pattern.value=
	new Domain_Repository.Property_Description_Pattern[ newdescr.property_list.length];

      //	      System.err.println("Pattern created");
      for ( int i=0; i< description.property_list.length; i++) {
	//	System.err.println("#"+i);
	//	AnyPrinter.print( newdescr.property_list[i].value,
	//			  new java.io.PrintWriter( System.err));

	pattern.property_description_list_pattern.value[ i]= 
	    new Domain_Repository.Property_Description_Pattern(
		false /* is_any */,
		new Domain_Repository.String_Pattern( false, newdescr.property_list[i].name),
		new Domain_Repository.TypeCode_Pattern( 
		    false, newdescr.property_list[i].value.type())
		);
      }
//      System.err.println("Call");
      Domain_Repository.Location_TypePackage.Description ret[]=
	container.location_type_rep.find_values( pattern);
	
      System.err.println( "Found "+ret.length+" records matching");
      if ( ret.length == 1) return ret[0].item_id;
    }
    catch ( Exception ex) {
      System.err.println("check_record caught exception "+ex);
      ex.printStackTrace();
    }
    throw new Domain_Repository.Invalid_Description();   
  }
  
  

// ----pubic methods-----
//
  public synchronized Domain_Repository.Location_DescriptionPackage.Description descr() {
    return description;
  }

  public synchronized Domain_Repository.Location_DescriptionPackage.Description value_descr() {
    return description;
  }

  public int item_id() /* immutable property */ {
    return description.item_id;
  }
 
  public synchronized String type_name() {
    System.err.println("type_name "+description.type_name);
    return description.type_name;
  }
  
  public synchronized Domain_Repository.Property[] property_list() {
    return description.property_list;
  }
  
  public synchronized Domain_Repository.Static_Data_Observer[] static_data_observer_list() {
    return container.static_data_observer_list( description.item_id );
  }
  
  public synchronized void attach_static_data_observer( 
	Domain_Repository.Static_Data_Observer obs) {

    System.err.println("attach_static_data_observer");
    int []par= new int[ 1];
    par[0]= description.item_id;
    try {
      container.attach_static_data_observer( obs, par);
    }
    catch ( Domain_Repository.Unknown_Repository_Item_Ids ex) {}
  } 
  
  public synchronized void detach_static_data_observer( 
	Domain_Repository.Static_Data_Observer obs) 
	    throws Domain_Repository.Unknown_Observer {
	
    int []par= new int[ 1];
    par[0]= description.item_id;
    try {
      container.detach_static_data_observer( obs, par);
    }
    catch ( Domain_Repository.Unknown_Repository_Item_Ids ex) {}
    catch ( Domain_Repository.Unmatched_Observer_Item_Ids ex) {}
  }
}

