//
// $Id: LDescr_Rep.java,v 1.3 1998/07/29 13:37:50 mencnar Exp $
//
// $Source: /home/iris/grant/abng/CVS/sources/servers/location_description_rep/LDescr/LDescr_Rep.java,v $
//
// $Log: LDescr_Rep.java,v $
// Revision 1.3  1998/07/29 13:37:50  mencnar
// complex_query implementation,
// delayed database commit to improve performance
//  during Location Type rep. resolution
//
// Revision 1.2  1998/07/03 12:50:11  mencnar
// moved common files to "common_java" directory
//
//
// Revision 1.1  1998/01/28 08:23:25  mencnar
// Initial revision
//
//

package pl.edu.agh.ics.abngcore;

import java.util.Hashtable;
import java.util.Enumeration;
import java.util.Vector;
import java.io.IOException;
import java.io.BufferedReader;
import java.io.InputStreamReader;

import AnyPrinter;


class LType_ptr {
  private static org.omg.CORBA.ORB orb= org.omg.CORBA.ORB.init();
  
  public Domain_Repository.Location_Type value;
  
  public LType_ptr( Domain_Repository.Location_Type value) {
    this.value= value;
  }
  
  public int hashCode() {
    int ret= orb.object_to_string( value).hashCode();
//    System.err.println("hashCode "+ret);
    return ret;
  }
  
  public boolean equals( Object o) {
    if ( o == null) return false;
    if ( ! ( o instanceof LType_ptr)) return false;
    String s1= null;
    String s2= null;
    
    boolean ret= (s1= orb.object_to_string( value)).equals(
	     s2= orb.object_to_string( (( LType_ptr) o).value));
//    System.err.println( "equals "+ret);
    return ret;
  }
};

//===================================================================================LDescr_Rep===
public class LDescr_Rep extends Thread implements
			    Domain_Repository_Management._Location_Description_Rep_ManagerOperations,
			    Domain_Repository._Location_Description_RepOperations,
			    Domain_Repository._Static_Data_ObserverOperations,
			    Bootstrap_listener_interface_n
                        {

  private static org.omg.CORBA.ORB orb= org.omg.CORBA.ORB.init();
  private Object save_synch= new Object();
  private boolean dirty_synch= false;
  private boolean dirty_obs_synch= false;
  private boolean is_restoring= false;		       

  private String Repository_DB_Name;

  private Domain_Repository_Management._tie_Location_Description_Rep_Manager manager_object= null;
  private Domain_Repository._tie_Location_Description_Rep repository_object= null;
  private Domain_Repository._tie_Static_Data_Observer observer_object= null;

  private Hashtable ldescr_list= new Hashtable();   
  // key: LDescr, value: LDescr
  private Hashtable ldescr_deref= new Hashtable();  
  // key: Integer(item_id), value: LDescr
  private Hashtable item_ids_to_observers_list= new Hashtable(); 
  // key: Integer(item_id), value: Hashtable (Observer)
  private Hashtable observers_to_item_ids_list= new Hashtable();
  // key: Observer, value: Hashtable (Integer)
  private Hashtable add_static_data_observer_list= new Hashtable();
  // key: Observer, value: Observer
						    
  private Hashtable ltype_list= new Hashtable();
  // key: LType, value: Integer ( item id)
						    
						    
  public Domain_Repository.Location_Type_Rep location_type_rep= null;
  private Bootstrap_listener_n bootstrap_listener;
 
  
  private int item_id= 1;
  
  private synchronized int alloc_item_id() {
    return item_id++;
  }

//-----------------visible in this package-------------
//
  Domain_Repository_Management.Location_Description_Rep_Manager get_manager_object() {
    return manager_object;
  }
  
  Domain_Repository.Location_Description_Rep get_repository_object() {
    return repository_object;
  }
  
  Domain_Repository.Static_Data_Observer get_observer_object() {
    return observer_object;
  }
  
  synchronized Domain_Repository.Static_Data_Observer[] static_data_observer_list( int item_id) {
    Hashtable observers_list= ( Hashtable) item_ids_to_observers_list.get( new Integer( item_id));
    if ( observers_list == null) return new Domain_Repository.Static_Data_Observer[ 0];
    
    Domain_Repository.Static_Data_Observer []ret=
      new Domain_Repository.Static_Data_Observer[ observers_list.size()];

    Enumeration e= observers_list.elements();
   
    for (   int i= 0;
	    e.hasMoreElements(); 
	    i++) {
	    
      ret[ i]= (( SDO_ptr) e.nextElement()).value;
    }
    return ret;
  }
  
  //--------------------------------------------------------------------------------LDescr_Rep---
  public LDescr_Rep( String Repository_DB_Name,
		     boolean coldstart) 
	    throws Exception {
    this.Repository_DB_Name= Repository_DB_Name;
    
    manager_object= new Domain_Repository_Management._tie_Location_Description_Rep_Manager( this);
    repository_object= new Domain_Repository._tie_Location_Description_Rep( this);
    observer_object= new Domain_Repository._tie_Static_Data_Observer( this);

    bootstrap_listener= new Bootstrap_listener_n( this);
    
    try {
      restore( coldstart);
    }
    catch ( Exception ex) {
      ex.printStackTrace();
      System.err.println( "Reading database failed "+ex.toString());
      throw ex;
    }
    Bootstrap_n.register_server_in_NS( Bootstrap_n.SRV_Location_Description_Repository(),
				       repository_object);
    Bootstrap_n.register_server_in_NS( Bootstrap_n.SRV_Location_Description_Repository_Manager(),
				       manager_object);
    bootstrap_listener.register_callback( Bootstrap_n.SRV_Location_Type_Repository());
  }

  //-------------------------------------------------------------------------reference_resolved---
  public void reference_resolved(
	String[] name,
	org.omg.CORBA.Object server_ref,
	int callback_identifier) {
	
    if ( Bootstrap_n.equal_names( Bootstrap_n.SRV_Location_Type_Repository(), name)) {
      try {
	System.err.println( server_ref);
        location_type_rep= Domain_Repository.Location_Type_RepHelper.narrow( server_ref);
	System.err.println( location_type_rep);
	
	check_location_descriptions();
      }
      catch ( Exception ex) {
	System.err.println( ex);
	ex.printStackTrace();
	location_type_rep= null;
      }
    }
  }

  public void server_shutdown( String[] name,
			       int callback_identifier) {
  }
  
  //--------------------------------------------------------------------------------update_type---
  private boolean update_type(
	LDescr item, 
	Domain_Repository.Location_TypePackage.Description newtype) {
	
    if ( ! item.change_type( newtype)) return false; // no changes 
    
    Domain_Repository.Static_Data_ObserverPackage.Static_Data_Object static_data_object=
	new Domain_Repository.Static_Data_ObserverPackage.Static_Data_Object();
    static_data_object.location_descr_obj( item.get_corba_object() );
    
    try {
    Hashtable observers_list= inform_observers( item.item_id(), 
						static_data_object,
						Domain_Repository.Change_Type.OBJECT_UPDATED);
						
    }
    catch ( Throwable a) {
      System.err.println( a);
//      a.printStackTrace();
    }
    
    System.err.println("Internal update succedded");
    return true;
  }
  
  //----------------------------------------------------------------check_location_descriptions---
  private void check_location_descriptions() 
		throws Domain_Repository.Search_Not_Implemented {

    try { // just in case
      location_type_rep.detach_add_static_data_observer( get_observer_object());
    }
    catch ( Exception ex) {}

    location_type_rep.attach_add_static_data_observer( get_observer_object());

    Domain_Repository.Location_TypePackage.Pattern pattern=
	new Domain_Repository.Location_TypePackage.Pattern();

    pattern.is_any= true;
    pattern.item_id_pattern= new Domain_Repository.Unsigned_Long_Pattern();
    pattern.name_pattern= new Domain_Repository.String_Pattern();
    pattern.name_pattern.value= "";
    pattern.property_description_list_pattern= new Domain_Repository.Property_Descriptions_Pattern();
    pattern.property_description_list_pattern.constraints= 
      Domain_Repository.Sequence_Pattern_Constraints.UNRESTRICTED;
    pattern.property_description_list_pattern.value=
	new Domain_Repository.Property_Description_Pattern[ 0];

    Domain_Repository.Location_Type []ret=
	location_type_rep.find( pattern);

    int ids[]= new int[ 1];
    for ( int i=0; i<ret.length; i++) {
      try {
	ret[ i].attach_static_data_observer( get_observer_object());
	ltype_list.put( new LType_ptr( ret[ i]), new Integer( ret[ i].item_id()));
      }
      catch ( Exception ex) {
      }
    }

    pattern.is_any= false;
    pattern.item_id_pattern.is_any= false;
    pattern.name_pattern.is_any= true;
    pattern.property_description_list_pattern.is_any= true;

    boolean dirty_flag= false;

    Enumeration e= ldescr_list.elements();
    for (   int i=0;
	    e.hasMoreElements();
	    i++) {
      LDescr item= ( LDescr) ( e.nextElement());
      
      pattern.item_id_pattern.value= item.get_location_type_item_id();
      try {
	Domain_Repository.Location_TypePackage.Description []find_ret=
	    location_type_rep.find_values( pattern);
	System.err.println("Searching for type ( id = "+item.get_location_type_item_id()+" ) resulted in "+find_ret.length+" hit(s)");
	if ( find_ret.length == 1) {
	  System.err.println( find_ret[0].name);
	  if (update_type( item, find_ret[ 0])) dirty_flag= true;
	} else {
	  try {
	    System.err.println("Could not find type description in Location Type database, removing");
	    remove( item.get_corba_object());
	  }
	  catch ( Exception ex) {
	    System.err.println("Caught exception "+ex.toString());
	  }
	}
      }
      catch ( Exception ex) {
	if (dirty_flag) save();
	return;
      }
    }
    if (dirty_flag) save();
  }
  
  //-----------------------------------------------------------------------location_type_change---
  private void location_type_change(
	int location_type_item_id,
	Domain_Repository.Location_TypePackage.Description type_descr) {
	
    for (   Enumeration e= ldescr_list.elements(); 
	    e.hasMoreElements(); ) {
      LDescr item= ( LDescr) (e.nextElement());
      
      if ( item.get_location_type_item_id() != location_type_item_id) continue;
      
      if ( type_descr == null /* type removed */) {
	try {
	  remove( item.get_corba_object());
	}
	catch ( Exception ex) {
	}
      } else if (update_type( item, type_descr)) save();
    }
  }
  
  public void notify(
	int item_id, 
	Domain_Repository.Static_Data_ObserverPackage.Static_Data_Object obj,
	Domain_Repository.Change_Type change) {

    _notify( item_id, obj, change);
  }

  //------------------------------------------------------------------------------------notify---
  public void _notify(
	int item_id, 
	Domain_Repository.Static_Data_ObserverPackage.Static_Data_Object obj,
	Domain_Repository.Change_Type change) {
    
    Domain_Repository.Location_Type loc_type= null;
    System.err.println("notify");
    try {
      loc_type= obj.location_type_obj();
    }
    catch ( Exception ex) {
      return;
    }
    
    switch ( change.value()) {
      case Domain_Repository.Change_Type._OBJECT_ADDED:
	try {
	  loc_type.attach_static_data_observer( get_observer_object());
	  ltype_list.put( new LType_ptr( loc_type), new Integer( loc_type.item_id()));
	}
	catch ( Exception ex) {}
	break;
      case Domain_Repository.Change_Type._OBJECT_UPDATED:
	try {
	  LType_ptr ltype_ptr= new LType_ptr( loc_type);
	  Integer val= ( Integer) ( ltype_list.get( ltype_ptr));
	  System.err.println("Found "+ ( val == null));
	  System.err.println("Update location type: id "+ val.intValue());
	  location_type_change( val.intValue(), loc_type.descr() /* updated, not removed */);
	}
	catch ( Exception ex) {
	  ex.printStackTrace();
	}	
	break;
      case Domain_Repository.Change_Type._OBJECT_REMOVED:
	try {
	  Integer val= ( Integer) ( ltype_list.get( new LType_ptr( loc_type)));
	  location_type_change( val.intValue(), null /* removed */);
	  ltype_list.remove( new LType_ptr( loc_type));
	}
	catch ( Exception ex) {}	
	break;
      default:
	System.err.println("Unknown change type "+change.value());
    }
  }
  
  //-------------------------------------------------------------------------------------abort---
  public void abort() {
  }
	

// Location_Description_Rep_Manager methods and attributes
//		
  //---------------------------------------------------------------------------------------rep---    
  public Domain_Repository.Location_Description_Rep rep() {
    return repository_object;
  }

  //-----------------------------------------------------------------location_description_list---  
  public synchronized Domain_Repository.Location_Description[] location_description_list() {
    Enumeration e= ldescr_list.elements();
    
    Domain_Repository.Location_Description []ret= 
      new Domain_Repository.Location_Description[ ldescr_list.size()];
    
    for (   int i=0; 
	    e.hasMoreElements();
	    i++) {
      ret[ i]= (( LDescr) e.nextElement()).get_corba_object();
    }
    return ret;
  }

  //--------------------------------------------------------------------detach_dead_observers--  
  private void detach_dead_observers( Vector dead_observers /* of Static_Data_Observer */) {

    int size= dead_observers.size();
    for ( int i=0; i<size; i++ ) {
      Domain_Repository.Static_Data_Observer observer=
	  ( Domain_Repository.Static_Data_Observer) dead_observers.elementAt( i);	
      try {
	detach_static_data_observer( observer, get_item_ids_list( observer));
      }
      catch ( Exception ex) {}
      try {
	detach_add_static_data_observer( observer);
      }
      catch ( Exception ex) {}
    }    
  }
  
  //----------------------------------------------------------------------------------add------
  public synchronized Domain_Repository.Location_Description add(
	Domain_Repository.Location_DescriptionPackage.Description data_record)
	    throws Domain_Repository.Duplicate_Data_Record,
		   Domain_Repository.Invalid_Description {
	    
    System.err.println( "LDescr_Rep::add");
    LDescr new_ldescr= new LDescr( data_record, this);
    if ( ldescr_list.containsKey( new_ldescr)) {
	LDescr_Main.my_orb_wrapper.disconnect_object( 
				  new_ldescr.get_corba_object());
	throw new Domain_Repository.Duplicate_Data_Record();
    }
	
    new_ldescr.set_item_id( alloc_item_id());
    
    ldescr_list.put( new_ldescr, new_ldescr);
    ldescr_deref.put( new Integer( new_ldescr.item_id()), new_ldescr);
    item_ids_to_observers_list.put( new Integer( new_ldescr.item_id()), new Hashtable());
    
    // inform interested observers
    //
    
    Domain_Repository.Static_Data_ObserverPackage.Static_Data_Object static_data_object=
	new Domain_Repository.Static_Data_ObserverPackage.Static_Data_Object();
    static_data_object.location_descr_obj( new_ldescr.get_corba_object() );
    
    Vector dead_observers= new Vector();
       
    for (   Enumeration e= add_static_data_observer_list.elements();
	    e.hasMoreElements(); ) {
	    
      Domain_Repository.Static_Data_Observer observer= 
	(( SDO_ptr) e.nextElement()).value;
	
      try {
	System.err.println("Calling notify");
	LDescr_Main.my_orb_wrapper.call_static_notify(
	     observer,
	     new_ldescr.item_id(), 
	     static_data_object, 
	     Domain_Repository.Change_Type.OBJECT_ADDED);

	System.err.println("Notify succeeded");
      }
      catch ( Exception ex) {
	System.err.println("Notify failed");
	dead_observers.addElement( observer);
      }
    }
    detach_dead_observers( dead_observers);
    
    // store update state of the repository
    save();
    
    return new_ldescr.get_corba_object();
  }

  //---------------------------------------------------------------------------deref_object------
  private LDescr deref_object( Domain_Repository.Location_Description object_to )
	throws Domain_Repository.Unknown_Object_Ref {
	
   if ( object_to == null) throw new Domain_Repository.Unknown_Object_Ref();
    
    int new_item_id= 0;
    try {
      new_item_id= object_to.item_id();
    }
    catch ( Exception ex) {
      System.err.println("deref_object "+ex);
      throw new Domain_Repository.Unknown_Object_Ref();
    }
    LDescr new_ldescr= ( LDescr) ldescr_deref.get( new Integer( new_item_id));
    if ( new_ldescr == null) throw new Domain_Repository.Unknown_Object_Ref();
    return new_ldescr;
  }

  private int[] get_item_ids_list( Domain_Repository.Static_Data_Observer obs) {
    Hashtable item_ids_list= ( Hashtable) observers_to_item_ids_list.get( 
					    new SDO_ptr( obs));
    if ( item_ids_list == null) return new int[0];
    
    int ret[]= new int[ item_ids_list.size()];
    Enumeration e= item_ids_list.elements();
      
    for (   int i=0;
	    e.hasMoreElements();
	    i++ ) {
	    
      ret[ i]= (( Integer) e.nextElement()).intValue();
    }
    return ret;
  }
  
  //----------------------------------------------------------------------inform_observers------  
  private Hashtable inform_observers(    
	int new_item_id,
	Domain_Repository.Static_Data_ObserverPackage.Static_Data_Object static_data_object,
	Domain_Repository.Change_Type change_type) {
	
    Hashtable observers_list= ( Hashtable) item_ids_to_observers_list.get( new Integer( new_item_id));
    if ( observers_list == null) return null;

    // inform interested observers
    //
    
    Vector dead_observers= new Vector();
       
    for (   Enumeration e= observers_list.elements();
	    e.hasMoreElements(); ) {
	    
      Domain_Repository.Static_Data_Observer observer= 
	(( SDO_ptr) e.nextElement()).value;
	
      try {
	System.err.println("Calling notify for "+observer);
	LDescr_Main.my_orb_wrapper.call_static_notify(
	    observer, new_item_id, static_data_object, change_type);
      }
      catch ( Exception ex) {
	dead_observers.addElement( observer);
      }
    }
    detach_dead_observers( dead_observers);
    
    return observers_list;
  }
  
  //---------------------------------------------------------------------------remove--------  
  public synchronized void remove(
	Domain_Repository.Location_Description object_to_remove)
	    throws Domain_Repository.Unknown_Object_Ref {
   
    System.err.println("Removing object "+object_to_remove.item_id());
    LDescr new_ldescr= deref_object( object_to_remove);
    int new_item_id= new_ldescr.item_id();
    
    ldescr_deref.remove( new Integer( new_item_id));
    ldescr_list.remove( new_ldescr);
    
    Domain_Repository.Static_Data_ObserverPackage.Static_Data_Object static_data_object=
	new Domain_Repository.Static_Data_ObserverPackage.Static_Data_Object();
    static_data_object.location_descr_obj( new_ldescr.get_corba_object() );
    
    Hashtable observers_list= inform_observers( new_item_id,
					       static_data_object,
					       Domain_Repository.Change_Type.OBJECT_REMOVED);
    
    // clean up after this LDescr
    //
    if ( observers_list != null) 
      for (   Enumeration e= observers_list.elements();
	      e.hasMoreElements(); ) {
	    
        Domain_Repository.Static_Data_Observer observer= 
	  (( SDO_ptr) e.nextElement()).value;

	Hashtable ids_list= ( Hashtable) observers_to_item_ids_list.get( new SDO_ptr( observer));
	if ( ids_list == null) continue;
      
	ids_list.remove( new Integer( new_item_id));
      }
    
    // store updated state of the repository
    //
    save();
  }
  
  
  //---------------------------------------------------------------------------update------
  public synchronized void update(
	Domain_Repository.Location_Description object_to_update,
	Domain_Repository.Location_DescriptionPackage.Description data_record)
	    throws Domain_Repository.Unknown_Object_Ref,
		   Domain_Repository.Duplicate_Data_Record,
		   Domain_Repository.Invalid_Description {
    System.err.println("update called");

    LDescr new_ldescr= deref_object( object_to_update);
    int new_item_id= new_ldescr.item_id();
    
    new_ldescr.check_record( data_record);
    
    // no Duplicate_Data_Record here
    new_ldescr.set_descr( data_record);

        
    Domain_Repository.Static_Data_ObserverPackage.Static_Data_Object static_data_object=
	new Domain_Repository.Static_Data_ObserverPackage.Static_Data_Object();
    static_data_object.location_descr_obj( new_ldescr.get_corba_object() );
    
    try {
    Hashtable observers_list= inform_observers( new_item_id, 
						static_data_object,
						Domain_Repository.Change_Type.OBJECT_UPDATED);
						
    }
    catch ( Throwable a) {
      System.err.println( a);
//      a.printStackTrace();
    }
    
    // store updated state of the repository
    //
    save();
    System.err.println("Update succeeded");
  }
  
// Location_Description_Rep methods and attributes
//		    

  //------------------------------------------------------------------------------------find-----
  public synchronized Domain_Repository.Location_Description[] find(
	Domain_Repository.Location_DescriptionPackage.Pattern data_record_pattern)
	    throws Domain_Repository.Search_Not_Implemented {
	    
    System.err.println("find-------------");
    Vector collected= new Vector(); // of LDescr
    Enumeration e= ldescr_list.elements();
    
    for (   int i=0; 
	    e.hasMoreElements();
	    i++) {
      (( LDescr) e.nextElement()).match_ldescr( collected, data_record_pattern);
    }
    int size= collected.size();
    Domain_Repository.Location_Description []ret= new Domain_Repository.Location_Description[size];
    
    for (   int i=0;
	    i<size;
	    i++) {
      ret[ i]= (( LDescr) ( collected.elementAt( i))).get_corba_object();
    }
    return ret;
  }

  //-------------------------------------------------------------------------------find_values---  
  public Domain_Repository.Location_DescriptionPackage.Description[] find_values(
	Domain_Repository.Location_DescriptionPackage.Pattern data_record_pattern)
	    throws Domain_Repository.Search_Not_Implemented {
	    
    Vector collected= new Vector(); // of LDescr
    Enumeration e= ldescr_list.elements();
    
    for (   int i=0; 
	    e.hasMoreElements();
	    i++) {
      (( LDescr) e.nextElement()).match_ldescr( collected, data_record_pattern);
    }
    int size= collected.size();
    Domain_Repository.Location_DescriptionPackage.Description []ret= 
	new Domain_Repository.Location_DescriptionPackage.Description[size];

    for (   int i=0;
	    i<size;
	    i++) {
      ret[ i]= (( LDescr) ( collected.elementAt( i))).descr();

      /*      
      System.err.println( "item_id "+ret[i].item_id+
			  "type_name "+ret[i].type_name);
      for (int j=0;
	   j<ret[i].property_list.length;
	   j++) {
	try {
	  java.io.PrintWriter pw= new java.io.PrintWriter( System.err);
	  AnyPrinter.print( ret[i].property_list[j].value,
			    pw);
	  pw.flush();
	}
	catch (Exception ex) {
	  System.err.println( ex);
	}
      }
      */
    }
    return ret;
  }

 public synchronized Domain_Repository.Location_DescriptionPackage.Query_Results 
   complex_query( Domain_Repository.Location_DescriptionPackage.Entity_Set es, 
		  Domain_Repository.Query_Options qo, 
		  Domain_Repository.Static_Data_Observer obs) {

   Domain_Repository.Location_DescriptionPackage.Query_Results ret=
     new Domain_Repository.Location_DescriptionPackage.Query_Results();
   ret.r_references= 
     new Domain_Repository.Location_Description[0];
   ret.r_descriptions= 
     new Domain_Repository.Location_DescriptionPackage.Description[0];
   ret.r_value_descriptions=
     new Domain_Repository.Location_DescriptionPackage.Description[0];
   ret.r_attach_results= new boolean[0];
   ret.r_detach_results= new boolean[0];
   ret.r_valid_descriptions= new boolean[0];
   ret.r_valid_value_descriptions= new boolean[0];

   LDescr []item_set= null;

   switch (es.discriminator().value()) {
   case Domain_Repository.Entity_Set_Criteria._ESC_Pattern:
     {
       try {
	 Domain_Repository.Location_Description[] fres=
	   find( es.s_pattern());
	 item_set= new LDescr[fres.length];
	 try {
	   for (int i=0; i<fres.length; i++)
	     item_set[i]= deref_object( fres[i]);
	 }
	 catch (Domain_Repository.Unknown_Object_Ref ex7) {}
       }
       catch ( Domain_Repository.Search_Not_Implemented ex0) {
	 item_set= new LDescr[0];
       }
     }
     break;
   case Domain_Repository.Entity_Set_Criteria._ESC_Ids:
     {
       int ids[]= es.s_ids();
       item_set= new LDescr[ids.length];
       for (int i=0; i<ids.length; i++)
	 item_set[i]= (LDescr) ldescr_deref.get( new Integer( ids[i])); 
     }
     break;
   case Domain_Repository.Entity_Set_Criteria._ESC_Refs:
     {
       Domain_Repository.Location_Description[] fres=
	 es.s_refs();
       item_set= new LDescr[fres.length];
       try {
	 for (int i=0; i<fres.length; i++)
	   item_set[i]= deref_object( fres[i]);
       }
       catch (Domain_Repository.Unknown_Object_Ref ex7) {}
     }
     break;
   default:
     return ret;
   }
   
   if (qo.return_references) 
     ret.r_references= 
       new Domain_Repository.Location_Description[item_set.length];

   if (qo.return_descriptions) {
     ret.r_descriptions= 
       new Domain_Repository.Location_DescriptionPackage.Description[item_set.length];
     ret.r_valid_descriptions= new boolean[item_set.length];
   }
   if (qo.return_value_descriptions) {
     ret.r_valid_value_descriptions= new boolean[item_set.length];
     ret.r_value_descriptions=
       new Domain_Repository.Location_DescriptionPackage.Description[item_set.length];
   }
   if (qo.do_attach)
     ret.r_attach_results= new boolean[item_set.length];
   if (qo.do_detach)
     ret.r_detach_results= new boolean[item_set.length];
  
   for (int i=0; i<item_set.length; i++) {
     if (qo.return_references)
       ret.r_references[i]= 
	 (item_set[i] != null) ? item_set[i].get_corba_object() : null;
     if (qo.return_descriptions) {
       ret.r_valid_descriptions[i]= false;
       if (item_set[i] != null) {
	 ret.r_descriptions[i]= item_set[i].descr();
	 ret.r_valid_descriptions[i]= true;
       }
       else {
	 ret.r_descriptions[i]=
	   new Domain_Repository.Location_DescriptionPackage.Description();
	 ret.r_descriptions[i].type_name= "";
	 ret.r_descriptions[i].property_list= 
	   new Domain_Repository.Property[0];
       }
     }
     if (qo.do_attach) {
       ret.r_attach_results[i]= false;
       if (item_set[i] != null) {
	 item_set[i].attach_static_data_observer(obs);
	   ret.r_attach_results[i]= true;
       }
     }
     if (qo.do_detach) {
       ret.r_detach_results[i]= false;
       try {
	 if (item_set[i] != null) {
	   item_set[i].detach_static_data_observer(obs);
	   ret.r_detach_results[i]= true;
	 }
       }
       catch (Domain_Repository.Unknown_Observer ex3) {}
     }
   }
   ret.r_value_descriptions= ret.r_descriptions;
   return ret;
 }
// Static_Data_Observed_R methods and attributes
//

  //-----------------------------------------------------------------static_data_observer_list----
  //
  public synchronized Domain_Repository.Static_Data_Observed_RPackage.Observer_Entry[] static_data_observer_list() {
    Enumeration e= observers_to_item_ids_list.keys();
    
    Domain_Repository.Static_Data_Observed_RPackage.Observer_Entry []ret= 
      new Domain_Repository.Static_Data_Observed_RPackage.Observer_Entry[ observers_to_item_ids_list.size()];
    
    for (   int i=0; 
	    e.hasMoreElements();
	    i++) {
      ret[ i]= new Domain_Repository.Static_Data_Observed_RPackage.Observer_Entry();
      ret[ i].obs= (( SDO_ptr) e.nextElement()).value;
      System.err.println( i + " observer "+ret[i].obs);
      Hashtable interest= ( Hashtable) observers_to_item_ids_list.get( new SDO_ptr( ret[ i].obs));
      System.err.println( i + " interest "+ interest);
      ret[ i].interest= new int[ interest.size() ];
      
      Enumeration e2= interest.elements();
      for ( int j=0;
	    e2.hasMoreElements();
	    j++) {
	ret[i].interest[j]= ( (Integer) e2.nextElement()).intValue();
      }
    }
    return ret;
  }
  
  //-------------------------------------------------------------add_static_data_observer_list---
  public Domain_Repository.Static_Data_Observer[] add_static_data_observer_list() {
    Enumeration e= add_static_data_observer_list.elements();
    
    Domain_Repository.Static_Data_Observer []ret= 
      new Domain_Repository.Static_Data_Observer[ add_static_data_observer_list.size()];
    
    for (   int i=0; 
	    e.hasMoreElements();
	    i++) {
      ret[ i]= (( SDO_ptr) e.nextElement()).value;
    }
    return ret;
 }
 
 //------------------------------------------------------------------check_unknown_item_ids-----
 private void check_unknown_item_ids(
	int [] observed_id_list)
	    throws Domain_Repository.Unknown_Repository_Item_Ids {
	    
    Vector unknown_item_ids= new Vector(); // of Integer
    for ( int i=0; i<observed_id_list.length; i++) {
      if (! item_ids_to_observers_list.containsKey( new Integer( observed_id_list[i])))
	unknown_item_ids.addElement( new Integer( observed_id_list[i]));
    }
    if ( unknown_item_ids.size() != 0) {
      int ret[]= new int[ unknown_item_ids.size()];
      
      for (int i=0; i<ret.length; i++)
	ret[ i]= (( Integer) unknown_item_ids.elementAt( i)).intValue();
      throw new Domain_Repository.Unknown_Repository_Item_Ids( ret);
    }
 }

 //--------------------------------------------------------------attach_static_data_observer-----
 public synchronized void attach_static_data_observer(
	Domain_Repository.Static_Data_Observer obs,
	int [] observed_id_list) 
	    throws Domain_Repository.Unknown_Repository_Item_Ids {
    
    if ( obs == null) return;
    check_unknown_item_ids( observed_id_list);
    
    Hashtable item_ids_list= ( Hashtable) observers_to_item_ids_list.get( new SDO_ptr( obs));
    
    if ( item_ids_list == null) {
      item_ids_list= new Hashtable();
      observers_to_item_ids_list.put( new SDO_ptr( obs), item_ids_list);
    }
    for ( int i=0; i<observed_id_list.length; i++) {
      item_ids_list.put( new Integer(observed_id_list[i]),
			 new Integer(observed_id_list[i]));
      Hashtable observers_list= 
		( Hashtable) item_ids_to_observers_list.get( new Integer( observed_id_list[ i]));
      if ( observers_list != null) {
	if ( ! observers_list.contains( new SDO_ptr( obs)))
	  observers_list.put( new SDO_ptr( obs), new SDO_ptr( obs));
      }
    }
    if (!is_restoring) save_obs();
  }

  //-------------------------------------------------------------detach_static_data_observer-----
  public synchronized void detach_static_data_observer(
	Domain_Repository.Static_Data_Observer obs,
	int [] observed_id_list)
	    throws Domain_Repository.Unknown_Repository_Item_Ids,
		   Domain_Repository.Unknown_Observer,
		   Domain_Repository.Unmatched_Observer_Item_Ids {
		   
    System.err.println("detach_static_data_observer");
    
    if ( obs == null) throw new Domain_Repository.Unknown_Observer();
    check_unknown_item_ids( observed_id_list);
     
    Vector unmatched_item_ids= new Vector();
    for ( int i=0; i<observed_id_list.length; i++) {
      Hashtable observers_list= ( Hashtable) item_ids_to_observers_list.get( 
						    new Integer( observed_id_list[i]));
      if ( observers_list == null) continue;
       
      if ( ! observers_list.containsKey( new SDO_ptr( obs)))
	unmatched_item_ids.addElement( new Integer( observed_id_list[ i]));
    }
    if ( unmatched_item_ids.size() != 0) {
      int err_ids[]= new int[ unmatched_item_ids.size()];
      for ( int i=0; i<err_ids.length; i++)
	err_ids[i]= (( Integer) unmatched_item_ids.elementAt( i)).intValue();
      throw new Domain_Repository.Unmatched_Observer_Item_Ids( err_ids);
    }
    
    // preconditions checked
    
    Hashtable all_item_ids= ( Hashtable) observers_to_item_ids_list.get( new SDO_ptr( obs));
    if ( all_item_ids != null) {
      for ( int i=0; i<observed_id_list.length; i++) 
	all_item_ids.remove( new Integer( observed_id_list[i]));
      
      if ( all_item_ids.size() == 0) {
	observers_to_item_ids_list.remove( new SDO_ptr( obs));
      }
    }
    for ( int i=0; i<observed_id_list.length; i++) {
      Hashtable observers_list= ( Hashtable) item_ids_to_observers_list.get( 
						    new Integer( observed_id_list[i]));
      if ( observers_list == null) continue;
       
      observers_list.remove( new SDO_ptr( obs));
    }
    if (!is_restoring) save_obs();
  }

  //-----------------------------------------------------------attach_add_static_data_observer---
  public synchronized void attach_add_static_data_observer (
	Domain_Repository.Static_Data_Observer obs) {
    System.err.println("attach_add_static_data_observer "+obs);
    
    if ( obs == null) return;
    
    if ( ! add_static_data_observer_list.containsKey( new SDO_ptr( obs)))
	add_static_data_observer_list.put( new SDO_ptr( obs), new SDO_ptr( obs));
    if (!is_restoring) save_obs();
  }

  //-----------------------------------------------------------detach_add_static_data_observer---  
  public void detach_add_static_data_observer (
	Domain_Repository.Static_Data_Observer obs)
	    throws Domain_Repository.Unknown_Observer {
    System.err.println("detach_static_data_observer "+obs);
    System.err.println("observers in list "+add_static_data_observer_list.size());
    if ( add_static_data_observer_list.remove( new SDO_ptr( obs)) == null)
	throw new Domain_Repository.Unknown_Observer();
    if (!is_restoring) save_obs();
  }
 
  //-------------------------------------------------------------------------------------save--- 

  private synchronized void save() {
    dirty_synch= true;
    notify();
  }

  private synchronized void save_obs() {
    dirty_obs_synch= true;
    notify();
  }

  public synchronized void run() {
    long timer= 500;
    while (true) {
      long prev= System.currentTimeMillis();
      long diff;
      if (dirty_synch || dirty_obs_synch) {
	try {
	  wait(timer);
	}
	catch (InterruptedException ex) {}
	diff= System.currentTimeMillis()-prev;
      }
      else {
	try {
	  wait();
	}
	catch (InterruptedException ex) {}
	diff= 0;
      }
      //      System.err.println("dirty_synch "+dirty_synch+"  "+timer);
      if (dirty_synch) {
	timer-= diff;
	if (timer<0) {
	  timer= 500;
	  System.err.println("real_save");
	  real_save();
	  System.err.println("database saved");
	  dirty_synch= false;
	}
      }
      if (dirty_obs_synch) {
	timer-= diff;
	if (timer<0) {
	  timer= 500;
	  System.err.println("real_save_obs");
	  real_save_obs();
	  System.err.println("database of observers saved");
	  dirty_obs_synch= false;
	}	
      }
    }
  }
  
  private synchronized void real_save_obs() {
    java.io.FileOutputStream fos= null;
    try {
      fos= new java.io.FileOutputStream( Repository_DB_Name+".otemporary");
      java.io.PrintWriter pwri= new java.io.PrintWriter( fos);

      pwri.println( observers_to_item_ids_list.size());    
      
      for ( Enumeration e= observers_to_item_ids_list.keys(); 
	    e.hasMoreElements();
	    ) {
	SDO_ptr sdo= (SDO_ptr) e.nextElement();
	pwri.print( orb.object_to_string( sdo.value));
        Hashtable item_ids_list= 
	  (Hashtable) observers_to_item_ids_list.get( new SDO_ptr(sdo.value));
	pwri.print(" ");
	if (item_ids_list == null) {
	  System.err.println("null Hashtable");
	  pwri.println( 0);
	  continue;
	}
	pwri.print( item_ids_list.size()+" ");
	for ( Enumeration e2= item_ids_list.keys(); 
	      e2.hasMoreElements();
	       ) {
	  pwri.print( ((Integer) e2.nextElement()).intValue()+" ");
	}
	pwri.println("");
      }	
      
      pwri.flush();
      pwri.close();
      fos.close();
      
      java.io.File destdb= new java.io.File( Repository_DB_Name+".otemporary");
      destdb.renameTo( new java.io.File( Repository_DB_Name+".observers"));
    }
    catch ( Exception ex) {
      if ( fos != null) {
	try {
	  fos.flush();
	  fos.close();
	}
	catch ( Exception ex2) {}
      }
      System.err.println("Caught exception while saving repository database "+ex);
      ex.printStackTrace();
      System.exit( 1);
    }
  }
			
  private synchronized void real_save() {
    java.io.FileOutputStream fos= null;
    try {
      fos= new java.io.FileOutputStream( Repository_DB_Name+".temporary");
      java.io.PrintWriter pwri= new java.io.PrintWriter( fos);
   
      DB_Header db_header= new DB_Header( "Location Description", "1.0", 
      "#    data_record::=	<item_id> <type_name> <item_id_of_type_name> <number_of_properties> <properties>\n#\n#      properties::=   |\n#                      <property> <properties>\n#\n#       property::=      <property_name> \"<\" <hexdigits> \">\"\n#\n#     hexdigits::=    |\n#                     <hexdigit> <hexdigits>\n#\n");
    
      db_header.save( pwri);
    
      pwri.println( item_id);
      pwri.println( ldescr_list.size());
    
      for (	Enumeration e= ldescr_list.elements();
  		e.hasMoreElements(); ) {
        ((LDescr) e.nextElement()).save( pwri);
      }
      pwri.flush();
      pwri.close();
      fos.close();
      
      java.io.File destdb= new java.io.File( Repository_DB_Name+".temporary");
      destdb.renameTo( new java.io.File( Repository_DB_Name));
    }
    catch ( Exception ex) {
      if ( fos != null) {
	try {
	  fos.flush();
	  fos.close();
	}
	catch ( Exception ex2) {}
      }
      System.err.println("Caught exception while saving repository database "+ex);
      ex.printStackTrace();
      System.exit( 1);
    }
  }
  
  //-----------------------------------------------------------------------------------restore---
  private synchronized void restore( boolean coldstart) 
	    throws IOException {
    is_restoring= true;
    java.io.FileInputStream fis;
    {
      try {
        fis= new java.io.FileInputStream( Repository_DB_Name);
        if ( coldstart) {
	  System.err.println("Repository database "+Repository_DB_Name+" exist, please remove it and run the repository server once again");
  	  System.exit( 1);
        }
      }
      catch ( IOException ex) {
        if (!coldstart) throw ex;
        real_save();
        fis= new java.io.FileInputStream( Repository_DB_Name);
      }
      BufferedReader bufr= new BufferedReader( new InputStreamReader( fis));
 
      DB_Header db_header= new DB_Header();
      db_header.load( bufr);
      //    System.err.println("DB_Header read");
      item_id= DB_Header.readInt( bufr);
      int nof_items= DB_Header.readInt( bufr);
      //    System.err.println("Next item id : "+item_id);
      System.err.println("Nof items "+nof_items);
    
      for ( int i=0; i<nof_items; i++) {
        LDescr new_ldescr= new LDescr( bufr, this);
    
        ldescr_list.put( new_ldescr, new_ldescr);
        ldescr_deref.put( new Integer( new_ldescr.item_id()), new_ldescr);
        item_ids_to_observers_list.put( new Integer( new_ldescr.item_id()), new Hashtable());
      }
    }
    fis= null;
    try {
      fis= new java.io.FileInputStream( Repository_DB_Name+".observers");
      if (fis!=null) {
	BufferedReader bufr= new BufferedReader( new InputStreamReader( fis));
	
	DB_Header db_header= new DB_Header();
	item_id= DB_Header.readInt( bufr);
	int nof_items= DB_Header.readInt( bufr);
	//    System.err.println("Next item id : "+item_id);
	System.err.println("Nof items "+nof_items);
	
	for ( int i=0; i<nof_items; i++) {
       
	}
      }
    }
    catch ( IOException ex) {
    }
    is_restoring= false;
  }
};


