//
//  File:         meta_equipment_rep_server.h
//  Author:       Andrzej Uszok (uszok@ics.agh.edu.pl)
//  Date Created: 20.04.98
//
// General Description:
//   Header file of the Meta_Equipment_Rep_Server class
//

#ifndef __META_EQUIPMENT_REP_SERVER_H__
#define __META_EQUIPMENT_REP_SERVER_H__ 1

#include "rep_server.h"
#include "meta_equipment_rep_i.h"

class Meta_Equipment_Rep_Server : public Rep_Server {

public:

  Meta_Equipment_Rep_Server(
#ifdef ObjectStore
    const char *db_name_p = "dbName",
    int cold_start_p = 0,
#elif FilePersistency
    const char *file_name_p = "Meta_Equipment_Rep.db",
#endif
#ifdef ORBIX
    long timeout_p = -1,
#endif
    const char *current_directory_p = ".",
    long interval_p = 60) : Rep_Server(
#ifdef ObjectStore
    db_name_p,
#elif FilePersistency
    file_name_p,
#endif
    current_directory_p) {}

  virtual ~Meta_Equipment_Rep_Server() {}

  virtual void create_objects();
  virtual void delete_objects();

protected:
  Meta_Equipment_Rep_I *my_rep_i;
};

#endif __META_EQUIPMENT_REP_SERVER_H__





