// $Id: sched_reply.cc,v 1.3 1998/06/18 10:21:56 mencnar Exp $
//
// $Source: /home/iris/grant/abng/CVS/sources/servers/scheduler/sched_reply.cc,v $
//
// $Log: sched_reply.cc,v $
// Revision 1.3  1998/06/18 10:21:56  mencnar
// moved to CVS
//
// Revision 1.2  1997/11/03 09:33:32  mencnar
// Fixes in IDLs
//
// Revision 1.1  1997/10/23 09:16:46  mencnar
// Initial revision
//
//


// Temporary log:
// Fixed potential memory leak ( extracting barrier ids)
//

#include "sched_main.hh"

Sched_Barrier_Id Sched_Reply_Badge::min_barrier_id() {
  return Sched_Barrier_Id( barrier_id.badge_id);
}


//-------------------------------------------------Sched_Reply_Badge_unknown
//

Sched_Reply_Badge_unknown::Sched_Reply_Badge_unknown( 
		  		     const ABng_Core_System::Octets &_data,
				     const char *group_name) :
  Sched_Reply_Badge( RK_badge_unknown, 
		     get_time_object(),
		     extract_barrier_id( _data, group_name),
		     extract_sequence_number( _data)),
  data( _data) {

  if (data.length()>=2) reply_code= data[1];
}

void Sched_Reply_Badge_unknown::send_reply( Sched_Request &req, int repeat_num) {
  ABng_Core_System::Octets oct;

  int len= data.length() - 2 /* sensor_id */
                         - 1 /* reply_code */
                         - 1 /* packet length */
                         - 1 /* badge_id length */
                         - barrier_id.badge_id.length();
  len= (len<0) ? 0 : len;
  oct.length(len);
  int i= 1 /* station_id*/ + 1 /* reply code*/ +1 /* packet length*/
        +1 /* badge_id length*/ + barrier_id.badge_id.length();
  for (int j=0; j<len; j++)
    oct[j]= data[i+j];
           
  req.complex_request.reply_to->
    badge_command_reply( (ABng_Core_System::Sensor_Id) barrier_id,
                         barrier_id.badge_id, oct,
                         time_stamp, req.complex_request.req_id, repeat_num);
}

Sched_Barrier_Id Sched_Reply_Badge_unknown::extract_barrier_id( 
                                const ABng_Poller::AB_Poller::Octets &data,
				const char *group_name) {
  if (data.length() >=5) {
    Badge_Id b_id;
    int len= (int) data[3];
    len= (4+len>=data.length()) ? 0 : len;

    b_id.length( len);
    for (int i=0; i<len; i++)
      b_id[i]= data[4+i];
    return Sched_Barrier_Id( b_id, (Network_Id) data[data.length()-1], 
			           (Station_Id) data[0],
			           group_name );
  } 
  Sched_Barrier_Id bid;
  return bid;
}

Seq_Number Sched_Reply_Badge_unknown::extract_sequence_number(
                                 const ABng_Core_System::Octets &data) {
  Seq_Number seq= 0;
  if (data.length()<3) return seq;
  return data[data.length()-3];
}

ABng_Core::Time Sched_Reply_Badge_unknown::get_time_object() {
  ABng_Core::Time tm;
  return tm;
}

void Sched_Reply_challenge::send_reply( Sched_Request &req, int repeat_num) {
  
  req.complex_request.reply_to->
    challenge_reply( (ABng_Core_System::Sensor_Id) barrier_id,
		     barrier_id.badge_id, random,
		     time_stamp, req.complex_request.req_id, repeat_num);
}

void Sched_Reply_sound::send_reply( Sched_Request &req, int repeat_num) {
 
  req.complex_request.reply_to->
    sound_reply( (ABng_Core_System::Sensor_Id) barrier_id, 
		 barrier_id.badge_id, sound,
		 time_stamp, req.complex_request.req_id, repeat_num);
}

void Sched_Reply_set_state::send_reply( Sched_Request &req, int repeat_num) {
  req.complex_request.reply_to->
    set_state_reply( (ABng_Core_System::Sensor_Id) barrier_id,
		     barrier_id.badge_id,
		     status,
		     sound,
		     time_stamp,
		     req.complex_request.req_id, repeat_num);
}

void Sched_Reply_get_state::send_reply( Sched_Request &req, int repeat_num) {
  req.complex_request.reply_to->
    get_state_reply( (ABng_Core_System::Sensor_Id) barrier_id,
		     barrier_id.badge_id,
		     major_version,
		     minor_version,
		     status,
		     time_stamp,
		     req.complex_request.req_id, repeat_num);
}

void Sched_Reply_set_home::send_reply( Sched_Request &req, int repeat_num) {
  req.complex_request.reply_to->
    set_home_reply( (ABng_Core_System::Sensor_Id) barrier_id,
		    barrier_id.badge_id,
		    address,
		    time_stamp,
		    req.complex_request.req_id, repeat_num);
}

void Sched_Reply_get_home::send_reply( Sched_Request &req, int repeat_num) {
  req.complex_request.reply_to->
    get_home_reply( (ABng_Core_System::Sensor_Id) barrier_id,
		    barrier_id.badge_id,
		    address,
		    time_stamp,
		    req.complex_request.req_id, repeat_num);
}

Sched_Barrier_Id Sched_Reply_get_station_state::min_barrier_id() {
  return Sched_Barrier_Id( barrier_id.network_id,
			   barrier_id.station_id,
			   barrier_id.group_name);
}


//-------------------------------------------------Sched_Reply_Sensor_unknown
//

Sched_Reply_Sensor_unknown::Sched_Reply_Sensor_unknown( 
		  		     const ABng_Core_System::Octets &_data,
				     const char *group_name) :
  Sched_Reply( RK_badge_unknown, 
	       Sched_Reply_Badge_unknown::get_time_object(),
	       extract_barrier_id( _data, group_name)),
  data( _data) {

  if (data.length()>=2) reply_code= data[1];
}

void Sched_Reply_Sensor_unknown::send_reply( Sched_Request &req, int repeat_num) {
  ABng_Core_System::Octets oct;

  int len= data.length() - 2 /* sensor_id */
                         - 1 /* reply_code */
                         - 1 /* packet length */;
  len= (len<0) ? 0 : len;
  oct.length(len);
  int i= 1 /* station_id*/ + 1 /* reply code*/ +1 /* packet length*/;
  for (int j=0; j<len; j++)
    oct[j]= data[i+j];
           
  req.complex_request.reply_to->
    sensor_command_reply( (ABng_Core_System::Sensor_Id) barrier_id,
                         oct,
                         time_stamp, req.complex_request.req_id, repeat_num);
}

Sched_Barrier_Id Sched_Reply_Sensor_unknown::extract_barrier_id( 
                                const ABng_Core_System::Octets &data,
				const char *group_name) {
  if (data.length() >=2) {
    return Sched_Barrier_Id( data[data.length()-1], data[0], 
			     group_name);
  } 
  Sched_Barrier_Id bid;
  return bid;
}

Sched_Barrier_Id Sched_Reply_Sensor_unknown::min_barrier_id() {
  return Sched_Barrier_Id( barrier_id.network_id, barrier_id.station_id, 
			   (const char *) barrier_id.group_name);
}



void Sched_Reply_get_station_state::send_reply( Sched_Request &req, int repeat_num) {
  req.complex_request.reply_to->
    get_station_state_reply( (ABng_Core_System::Sensor_Id) barrier_id,
			     major_version,
			     minor_version,
			     status1,
			     status2,
			     time_stamp,
			     req.complex_request.req_id, repeat_num);
}








