//
//  File:         sensor_rep_server.h
//  Author:       Andrzej Uszok (uszok@ics.agh.edu.pl)
//  Date Created: 05.02.98
//
// General Description:
//   Header file of the Sensor_Rep_Server class
//

#ifndef sensor_rep_server_i_h
#define sensor_rep_server_i_h 1

#include "rep_server.h"
#include "sensor_rep_i.h"

class Sensor_Rep_Server : public Rep_Server {

public:
   Sensor_Rep_Server(
#ifdef ObjectStore
    	const char *db_name_p = "dbName",
#elif FilePersistency
    	const char *file_name_p = "Sensor_Rep.db",
#endif
    	const char *current_directory_p = "."
   ) : Rep_Server (
#ifdef ObjectStore
    		db_name_p,
#elif FilePersistency
   		 file_name_p,
#endif
    		current_directory_p
       ) {}

  virtual 
    ~Sensor_Rep_Server() {}

  virtual void 
    create_objects();

  virtual void 
    delete_objects();

protected:
   Sensor_Rep_I *my_rep_i;
};

#endif /* sensor_rep_server_i_h */





