// $Id: dyn_dispatcher.hh,v 1.1 1998/07/29 14:57:12 mencnar Exp $
//
// $Source: /home/iris/grant/abng/CVS/sources/servers/sighting_processors/dyn_dispatcher.hh,v $
//
// $Log: dyn_dispatcher.hh,v $
// Revision 1.1  1998/07/29 14:57:12  mencnar
// performance tuning,
// receive sightings calls moved to dyn_dispatcher.* for future optimisation
//
//
// Author: Daniel Mencnarowski (mencnar@ics.agh.edu.pl)
//

#ifndef __DYN_DISPATCHER_HH__
#define __DYN_DISPATCHER_HH__

#include <iostream.h>
#include "abng_core_management.hh"
#include "bootstrap_n.hh"
#include "basic_rep_i.h"
#include "observed_i.h"
#include "view_rep_types.h"

class DynDispatcher : public Basic_Observed_I<DDO_Types> {
private:
  ABng_S_Guarded buffer_guard;
  omni_condition buffer_released;
  omni_condition buffer_data;
  omni_condition buffer_sleep;
  int active_buffer;
  struct timeval start_time;

  typedef RWTValHashDictionary< Observer_ptr,
    ABng_Core::Sighting_Descriptions *> Burst_Buffer_Type;

  typedef RWTValHashDictionaryIterator<Observer_ptr,
    ABng_Core::Sighting_Descriptions *> Burst_Buffer_Iterator;

  Burst_Buffer_Type* burst_buffer[2];
  unsigned long burst_delay;

  void add_sighting( Basic_Observed_I<DDO_Types>::Observer_ptr obs,
		     ABng_Core::Sighting_Description &sd);

  static void static_dyn_worker( void *args);
  void dyn_worker();
  int get_buffer_to_send();

public:
  DynDispatcher (
#ifdef FilePersistency
    const char *repository_name_p,
#endif
    unsigned long _burst_delay
  );

  void set_burst_delay( unsigned long new_delay);

  int dynamic_notify_observer( Observer_ptr obs,
				ABng_Core::Sighting_Description &sd);
  void dynamic_notify_observers( Basic_Observed_I<DDO_Types>::Observer_List &obs,
				 ABng_Core::Sighting_Description &sd);
};


#endif // __DYN_DISPATCHER_HH__

//
