// $Id: view_server.h,v 1.1.1.1 1998/06/18 13:37:37 mencnar Exp $
//
// $Source: /home/iris/grant/abng/CVS/sources/servers/sighting_processors/view_server.h,v $
//
// $Log: view_server.h,v $
// Revision 1.1.1.1  1998/06/18 13:37:37  mencnar
//
// Revision 1.1  1998/03/06 13:49:00  jasz
// Initial revision
//
//
// File:          view_server_i.h
// Author:        Jakub Szymaszek (jasz@ics.agh.edu.pl)
// Date Created:  26.01.98
//
// General Description:
//   Declaration of the View_Server class. An object of this class
//   handles maintains a single instance of the View_I class.

#ifndef __VIEW_REP_SERVER_H__
#define __VIEW_REP_SERVER_H__ 1
#include <rw/rwdate.h>
#include <rw/rwtime.h>
#include "rep_server.h"
#include "view_i.h"

class View_Server : public Rep_Server {

  static char cwd_buffer[255];
public:

  View_Server(
#ifdef ObjectStore
    const char *db_name, 
#elif FilePersistency
    const char *view_db_name,
    const char *location_rep_db_name,
    const char *locatable_rep_db_name,
#endif
    const char *current_directory_p = getcwd(cwd_buffer, sizeof(cwd_buffer)));

  virtual ~View_Server();

  virtual void init(int argc, char **argv);
  virtual void final();
  virtual void create_objects() {};
  virtual void delete_objects() {};
protected:

  void print_info();

  View_I *my_view;
#ifdef FilePersistency
  char *my_location_rep_db_name;
  char *my_locatable_rep_db_name;
#endif

};

#endif __VIEW_SERVER_H__












