//
//  File:         badge_holder_rep_client.h
//  Author:       Andrzej Uszok (uszok@ics.agh.edu.pl)
//  Date Created: 16.05.98
//
// General Description:
//   Header file for the implementation class of a client of 
//	the Badge_Holder Repositoryinterface
//

#ifndef __BADGE_HOLDER_REP_CLIENT_H__
#define __BADGE_HOLDER_REP_CLIENT_H__ 1

#include <stream.h>

#include "abng_core_management.hh"
#include "abng_core_types.h"
#include "domain_rep_management.hh"
#include "domain_rep_types_mgr.h"
#include "bootstrap_n.hh"
#include "rep_client.h"

class Badge_Holder_Rep_Client : public Rep_Client<Badge_Holder_Types> 
{
public:

   // ctor
   Badge_Holder_Rep_Client() : Rep_Client<Badge_Holder_Types> (
	Bootstrap::SRV_Badge_Holder_Repository,
	Bootstrap::SRV_Badge_Holder_Repository
   ) 
{ 
	badge_rep = new Basic_Client<Badge_Types>(Bootstrap::SRV_Badge_Repository);
	sensor_rep = new Basic_Client<Sensor_Types>(Bootstrap::SRV_Sensor_Repository);
	user_rep = new Basic_Client<User_Types_Mgr>(Bootstrap::SRV_User_Repository);
	equipment_rep = new Basic_Client<Equipment_Types_Mgr>(Bootstrap::SRV_Equipment_Repository);
}

   virtual 
    ~Badge_Holder_Rep_Client () {}

   virtual ABng_Core_System::Badge_Holder::Description
    init_data (
	char* data
    );

protected:
   Basic_Client<Badge_Types>* badge_rep;
   Basic_Client<Sensor_Types>* sensor_rep;
   Basic_Client<User_Types_Mgr>* user_rep;
   Basic_Client<Equipment_Types_Mgr>* equipment_rep;
};

#endif __BADGE_HOLDER_REP_CLIENT_H__





