#ifndef __badge_rep_client_hh__
#define __badge_rep_client_hh__

#include <stream.h>
#include "abng_server_manager.hh"
#include "rep_client.h"
#include "badge_rep_i.hh"

ostream& 
 operator << (ostream&, Domain_Repository::Location_Type::Value_Description&);

class Badge_Rep_Types {
public:
  typedef ABng_Core_System::Badge Item;
  typedef ABng_Core_System::Badge_ptr Item_ptr;
  typedef ABng_Core_Management::Badge_Rep::Badges Items;
  typedef ABng_Core_System::Badge::Description Initial_Data;
  typedef ABng_Core_Management::Badge_Rep Repository;
  typedef ABng_Core_Management::Badge_Rep Repository_Manager;
  typedef ABng_Core_Management::Badge_Rep_ptr Repository_ptr;
  typedef ABng_Core_Management::Badge_Rep_ptr Repository_Manager_ptr;
};

class Badge_Rep_Client : public Rep_Client<Badge_Rep_Types> {

public:

  Badge_Rep_Client() : Rep_Client<Badge_Rep_Types>(
	Bootstrap::SRV_Badge_Repository,
	Bootstrap::SRV_Badge_Repository) {
  }

  virtual ~Badge_Rep_Client() {}
  
  virtual void init_rep_ptr();

  virtual Initial_Data init_data(char* data);
  virtual ABng_Core_System::Badge::Pattern init_pattern_id(
         Domain_Repository::Repository_Item_Id id
  );

  ABng_Core_System::Badge_Holder_ptr init_badge_holder_ptr( istream &istr);

protected:
  ABng_Core_Management::Badge_Holder_Rep_ptr badge_holder_rep_ptr;
};

#endif __badge_rep_client_hh__






