// $Log: badge_rep_observer_i.cc,v $
// Revision 1.1  1998/06/18 14:11:10  mencnar
// Initial revision
//
// Revision 1.1  1998/01/05 15:39:33  mencnar
// Initial revision
//
//

//
//  File:         sensor_rep_observer_i.cc
//  Author:       Andrzej Uszok (uszok@ics.agh.edu.pl)
//  Date Created: 16.12.97
//
// General Description:
//   Implementation file for the Sensor_Rep_Observer_I class
//

#include "badge_rep_observer_i.hh"

   Badge_Rep_Observer_I::Badge_Rep_Observer_I (
   )
{
	// init my_corba_object
	my_corba_object = (ABng_Core_System::System_Static_Data_Observer_ptr)NULL;
}

   Badge_Rep_Observer_I::~Badge_Rep_Observer_I ()
{
  //	CORBA::release(my_corba_object);
}

 void 
   Badge_Rep_Observer_I::notify (
	Domain_Repository::Repository_Item_Id item_id,
	const ABng_Core_System::System_Static_Data_Observer::System_Static_Data_Object& sd, 
	Domain_Repository::Change_Type change,
	CORBA::Environment &IT_env
   )
		throw (CORBA::SystemException)
{
	int id_p;
	Badge_ptr badge_p;

	switch(change) {
		case Domain_Repository::OBJECT_ADDED:
			cerr << "Badge_Rep_Observer: new badge added" << endl;	
			badge_p= sd.badge_obj();

			// attempt to get the id of this badge
			try {
				id_p = badge_p->item_id();
			} catch (CORBA::SystemException& se){
				cerr << "Badge_Rep monitor error: ";
				cerr << "exception when trying to get the id of the new badge! ";
				cerr << endl << &se << endl;
			}
			cerr << "Badge_Rep_Observer: new badge id " << id_p << endl;

			// attempt to register observer in this badge
			try {
				badge_p->attach_system_static_data_observer(my_corba_object);
			} catch (CORBA::SystemException& se){
				cerr << "Badge_Rep monitor error: ";
				cerr << "exception when trying to register observer for the new badge! ";
				cerr << endl << &se << endl;
			}
			cerr << "Badge_Rep monitor: observer for new Badge registered" << endl;
			break;

		case Domain_Repository::OBJECT_REMOVED:
			cerr << "Badge_Rep_Observer: badge removed" << endl;	
			break;

		case Domain_Repository::OBJECT_UPDATED:
			cerr << "Badge_Rep_Observer: badge updated" << endl;	
			badge_p= sd.badge_obj();

			// attempt to get the id of this badge
			try {
				id_p = badge_p->item_id();
			} catch (CORBA::SystemException& se){
				cerr << "Badge_Rep monitor error: ";
				cerr << "exception when trying to get the id of the updated badge! ";
				cerr << endl << &se << endl;
			}
			cerr << "Badge_Rep_Observer: updated Badge id " << id_p << endl;
			break;

		default:
			cerr << "Badge_Rep_Observer error: unknow change type !!!" << endl;	
	}
}

 void 
   Badge_Rep_Observer_I::abort (
	CORBA::Environment &IT_env
   ) 
		throw (CORBA::SystemException)
{
	cerr << "Badge_Rep_Observer: abort called!!!" << endl << endl;	
	cerr << "Badge_Rep_Observer: exiting!!" << endl;

	exit(0);	

}

