// $Id: sched_test.cc,v 1.3 1998/06/18 14:14:00 mencnar Exp $
//
// $Source: /home/iris/grant/abng/CVS/sources/utils/commander_util/sched_test.cc,v $
//
// $Log: sched_test.cc,v $
// Revision 1.3  1998/06/18 14:14:00  mencnar
// moved to CVS
//
// Revision 1.2  1998/03/23 14:38:57  mencnar
// Complete rewrite.
// Now supports scheduler,sensor,badge,location,locatable and view commands
//
// Revision 1.1  1997/10/23 09:42:20  mencnar
// Initial revision
//
//

#include <rw/tvdlist.h>
#include <rw/cstring.h>
#include <rw/rwtime.h>
#include <rw/rwdate.h>
#include <iostream.h>
#include <strstream.h>
#include <ctype.h>
#include <stdio.h>
#include "abng_core_management.hh"
#include "sched_debug.hh"
#include <omnithread.h>
#include "bootstrap_n.hh"
#include "compatibility.hh"

class CallerImpl : public BOA_IMPL_BASE(ABng_Core,Caller) {

  static void show_location( ABng_Core::Location_ptr my_location) {
    cout << "\tlocation ";
    if (CORBA::is_nil( my_location)) cout << "nil" << endl;
    else {
      try {
	cout << "(item_id) " << my_location->item_id() << endl;
      }
      catch (CORBA::Exception &ex) {
	cout << "-- destination unreachable" << endl;
      }
    }
  }
  
  static void show_locatable( ABng_Core::Locatable_ptr my_locatable) {
    cout << "\tlocatable ";
    if (CORBA::is_nil( my_locatable)) cout << "nil" << endl;
    else {
      try {
	cout << "(item_id) " << my_locatable->item_id() << endl;
      }
      catch (CORBA::Exception &ex) {
	cout << "-- destination unreachable" << endl;
      }
    }
  }

public:
  virtual void challenge_reply( ABng_Core::Location_ptr my_location,
				ABng_Core::Locatable_ptr my_locatable,
				const ABng_Core::Octets &random,
				const ABng_Core::Time &ts,
				CORBA::Long request_id,
				CORBA::Long repeat_num
				ENV_DECL( env)) {
    cout << "challenge_reply req_id " << request_id
         << " repeat_num " << repeat_num << endl;
    show_location( my_location);
    show_locatable( my_locatable);
    cout << "\trandom " << random << endl
         << "\ttime " << ts << endl;
  }

  virtual void sound_reply( ABng_Core::Location_ptr my_location,
			    ABng_Core::Locatable_ptr my_locatable,
			    const ABng_Core::Octets &sound,
			    const ABng_Core::Time &ts,
			    CORBA::Long request_id,
			    CORBA::Long repeat_num
			    ENV_DECL( env)) {
    cout << "sound_reply req_id " << request_id
         << " repeat_num " << repeat_num << endl;
    show_location( my_location);
    show_locatable( my_locatable);
    cout << "\tsound " << sound << endl
         << "\ttime " << ts << endl;
  }

  virtual void set_state_reply( ABng_Core::Location_ptr my_location,
				ABng_Core::Locatable_ptr my_locatable,
				CORBA::Octet status,
				const ABng_Core::Octets &sound,
				const ABng_Core::Time &ts,
				CORBA::Long request_id,
				CORBA::Long repeat_num
				ENV_DECL( env)) {
    cout << "set_state_reply req_id " << request_id
         << " repeat_num " << repeat_num << endl;
    show_location( my_location);
    show_locatable( my_locatable);
    cout << "\tstatus (dec) " << dec << (int) status << endl
         << "\tsound " << sound << endl
         << "\ttime " << ts << endl;
  }

  virtual void get_state_reply( ABng_Core::Location_ptr my_location,
				ABng_Core::Locatable_ptr my_locatable,
				CORBA::Octet major_version,
				CORBA::Octet minor_version,
				CORBA::Octet status,
				const ABng_Core::Time &ts,
				CORBA::Long request_id,
				CORBA::Long repeat_num
				ENV_DECL( env)) {
    cout << "get_state_reply req_id " << request_id
         << " repeat_num " << repeat_num << endl;
    show_location( my_location);
    show_locatable( my_locatable);
    cout << "\tmajor_version " << dec << (int) major_version << endl
         << "\tminor_version " << (int) minor_version << endl
	 << "\tstatus " << (int) status << endl
         << "\ttime " << ts << endl;
  }

  virtual void set_home_reply( ABng_Core::Location_ptr my_location,
			       ABng_Core::Locatable_ptr my_locatable,
			       const ABng_Core::Octets &address,
			       const ABng_Core::Time &ts,
			       CORBA::Long request_id,
			       CORBA::Long repeat_num
			       ENV_DECL( env)) {
    cout << "set_home_reply req_id " << request_id
	 << " repeat_num " << repeat_num << endl;
    show_location( my_location);
    show_locatable( my_locatable);
    cout << "\taddress " << address << endl
         << "\ttime " << time << endl;
  }

  virtual void get_home_reply( ABng_Core::Location_ptr my_location,
			       ABng_Core::Locatable_ptr my_locatable,
			       const ABng_Core::Octets &address,
			       const ABng_Core::Time &ts,
			       CORBA::Long request_id,
			       CORBA::Long repeat_num
			       ENV_DECL( env)) {
    cout << "get_home_reply req_id " << request_id
	 << " repeat_num " << repeat_num << endl;
    show_location( my_location);
    show_locatable( my_locatable);
    cout << "\taddress " << address << endl
         << "\ttime " << time << endl;
  }
  
  virtual void get_station_state_reply( ABng_Core::Location_ptr my_location,
					CORBA::Octet major_version,
					CORBA::Octet minor_version,
					CORBA::Octet status1,
					CORBA::Octet status2,
					const ABng_Core::Time &ts,
					CORBA::Long request_id,
					CORBA::Long repeat_num
					ENV_DECL( env)) {
    cout << "get_station_state_reply req_id " << request_id 
	 << " repeat_num " << repeat_num << endl;
    show_location( my_location);
    cout << "\tmajor_version " << (dec) << (int) major_version << endl
         << "\tminor_version " << (int) minor_version << endl
         << "\tstatus1 " << (int) status1 << endl
	 << "\tstatus2 " << (int) status2 << endl
	 << "\ttime " << (int) time << endl;
  }

  virtual void location_command_reply( ABng_Core::Location_ptr my_location,
				       const ABng_Core::Octets &reply_body,
				       const ABng_Core::Time &ts,
				       CORBA::Long request_id,
				       CORBA::Long repeat_num
				       ENV_DECL( env)) {
    cout << "location_command_reply req_id " << request_id
         << " repeat_num " << repeat_num << endl;
    show_location( my_location);
    cout << "\treply_body " << reply_body << endl
         << "\ttime " << time << endl;
  }

  virtual void locatable_command_reply( ABng_Core::Location_ptr my_location,
					ABng_Core::Locatable_ptr my_locatable,
					const ABng_Core::Octets &reply_body,
					const ABng_Core::Time &ts,
					CORBA::Long request_id,
					CORBA::Long repeat_num
					ENV_DECL( env)) {
    cout << "locatable_command_reply req_id " << request_id
         << " repeat_num " << repeat_num << endl;
    show_location( my_location);
    show_locatable( my_locatable);
    cout << "\treply_body " << reply_body << endl
         << "\ttime " << time << endl;
  }
			
  virtual void null_message( ABng_Core::Location_ptr my_location,
			     const ABng_Core::Time &ts,
			     CORBA::Long request_id,
			     CORBA::Long repeat_num
			     ENV_DECL( env)) {
  }

  virtual void request_processed( ABng_Core::Location_ptr my_location,
				  ABng_Core::Locatable_ptr my_locatable,
				  const ABng_Core::Time &ts,
				  CORBA::Long request_id,
				  CORBA::Long repeat_num
				  ENV_DECL( env)) {
    cout << "request_processed req_id " << request_id
	 << " repeat_num " << repeat_num << endl
	 << "\ttime " << ts << endl;
  }

  virtual void error_occured( ABng_Core::Location_ptr my_location,
			      ABng_Core::Locatable_ptr my_locatable,
			      ABng_Core::Command_Error_Code error_code,
			      CORBA::Long request_id,
			      CORBA::Long repeat_num,
			      CORBA::Long retry_num
			      ENV_DECL( env)) {
    cout << "error_occured req_id " << request_id
         << " repeat_num " << repeat_num << endl;
    show_location( my_location);
    show_locatable( my_locatable);
    cout << "\terror_code "
	 << (error_code==ABng_Core::SIGHTING_TIMEOUT ?
	     "SIGHTING_TIMEOUT" :
	     (error_code==ABng_Core::REPLY_TIMEOUT ?
	      "REPLY_TIMEOUT" : "(unknown error code)")) << endl
	 << "\tretry_num " << retry_num << endl;
  }

  virtual void request_completed( CORBA::Long request_id
				  ENV_DECL( env)) {
    cout << "request_completed req_id " << request_id << endl;
  }
};

class Scheduler_CallerImpl : 
  public BOA_IMPL_BASE(ABng_Core_System,Scheduler_Caller) {
public:

  virtual void challenge_reply (const ABng_Core_System::Sensor_Id& sensor, 
				const ABng_Core_System::Badge_Id& badge, 
				const ABng_Core_System::Octets& random, 
				const ABng_Core_System::Time& ts,
				CORBA::Long request_id,
				CORBA::Long repeat_num
				ENV_DECL( env)) {
    cout << "challenge_reply req_id " << request_id 
         << " repeat_num " << repeat_num << endl
         << "\tsensor " << sensor << endl
         << "\tbadge " << badge << endl
         << "\trandom " << random << endl
         << "\ttime " << ts << endl;
  }

  virtual void sound_reply (const ABng_Core_System::Sensor_Id& sensor, 
			    const ABng_Core_System::Badge_Id& badge, 
			    const ABng_Core_System::Octets& sound, 
			    const ABng_Core_System::Time& ts, 
			    CORBA::Long request_id, 
			    CORBA::Long repeat_num
			    ENV_DECL( env)) {
    cout << "sound_reply req_id " << request_id 
         << " repeat_num " << repeat_num << endl
         << "\tsensor " << sensor << endl
         << "\tbadge " << badge << endl
         << "\tsound " << sound << endl
         << "\ttime " << ts << endl;
  }

  virtual void set_state_reply (const ABng_Core_System::Sensor_Id& sensor, 
				const ABng_Core_System::Badge_Id& badge, 
				CORBA::Octet status, 
				const ABng_Core_System::Octets& sound, 
				const ABng_Core_System::Time& ts, 
				CORBA::Long request_id, 
				CORBA::Long repeat_num
				ENV_DECL( env)) {
    cout << "set_state_reply req_id " << request_id 
         << " repeat_num " << repeat_num << endl
         << "\tsensor " << sensor << endl
         << "\tbadge " << badge << endl
         << "\tsound " << sound << endl
         << "\tstatus " << hex << (int) status << endl
         << "\ttime " << ts << endl;
  }

  virtual void get_state_reply (const ABng_Core_System::Sensor_Id& sensor, 
				const ABng_Core_System::Badge_Id& badge, 
				CORBA::Octet major_version, 
				CORBA::Octet minor_version, 
				CORBA::Octet status, 
				const ABng_Core_System::Time& ts, 
				CORBA::Long request_id, 
				CORBA::Long repeat_num
				ENV_DECL( env)) {
    cout << "get_state_reply req_id " << request_id 
         << " repeat_num " << repeat_num << endl
         << "\tsensor " << sensor << endl
         << "\tbadge " << badge << endl
         << "\tmajor_version " << dec << (int) major_version << endl
         << "\tminor_version " << dec << (int) minor_version << endl
         << "\tstatus " << hex << (int) status << endl
         << "\ttime " << ts << endl;
  }

  virtual void set_home_reply (const ABng_Core_System::Sensor_Id& sensor, 
			       const ABng_Core_System::Badge_Id& badge, 
			       const ABng_Core_System::Octets& address, 
 			       const ABng_Core_System::Time& ts, 
			       CORBA::Long request_id, 
			       CORBA::Long repeat_num
			       ENV_DECL( env)) {
    cout << "set_home_reply req_id " << request_id 
         << " repeat_num " << repeat_num << endl
         << "\tsensor " << sensor << endl
         << "\tbadge " << badge << endl
         << "\taddress " << address << endl
         << "\ttime " << ts << endl;
  }

  virtual void get_home_reply (const ABng_Core_System::Sensor_Id& sensor, 
			       const ABng_Core_System::Badge_Id& badge, 
			       const ABng_Core_System::Octets& address, 
			       const ABng_Core_System::Time& ts, 
			       CORBA::Long request_id, 
			       CORBA::Long repeat_num
			       ENV_DECL( env)) {
    cout << "get_home_reply req_id " << request_id 
         << " repeat_num " << repeat_num << endl
         << "\tsensor " << sensor << endl
         << "\tbadge " << badge << endl
         << "\taddress " << address << endl
         << "\ttime " << ts << endl;
  }
  
  virtual void get_station_state_reply (const ABng_Core_System::Sensor_Id& sensor,
					CORBA::Octet major_version, 
					CORBA::Octet minor_version, 
					CORBA::Octet status1, 
					CORBA::Octet status2, 
					const ABng_Core_System::Time& ts, 
					CORBA::Long request_id, 
					CORBA::Long repeat_num
					ENV_DECL( env)) {
    cout << "get_station_state req_id " << request_id 
         << " repeat_num " << repeat_num << endl
         << "\tsensor " << sensor << endl
         << "\tmajor_version " << dec << (int) major_version << endl
         << "\tminor_version " << dec << (int) minor_version << endl
         << "\tstatus1 " << hex << (int) status1 << endl
         << "\tstatus2 " << hex << (int) status2 << endl
         << "\ttime " << ts << endl;
  }

  virtual void sensor_command_reply( const ABng_Core_System::Sensor_Id& sensor,
				     const ABng_Core_System::Octets &reply_body,
				     const ABng_Core_System::Time &ts,
				     CORBA::Long request_id,
				     CORBA::Long repeat_num
				     ENV_DECL( env)) {
    cout << "sensor_command_reply req_id " << request_id 
         << " repeat_num " << repeat_num << endl
         << "\tsensor " << sensor << endl
         << "\treply_body " << reply_body << endl
         << "\ttime " << ts << endl;
  }

  virtual void badge_command_reply( const ABng_Core_System::Sensor_Id& sensor,
				    const ABng_Core_System::Badge_Id& badge,
				    const ABng_Core_System::Octets &reply_body,
				    const ABng_Core_System::Time &ts,
				    CORBA::Long request_id,
				    CORBA::Long repeat_num
				    ENV_DECL( env)) {
    cout << "badge_command_reply req_id " << request_id 
         << " repeat_num " << repeat_num << endl
         << "\tsensor " << sensor << endl
         << "\tbadge " << badge << endl
         << "\treply_body " << reply_body << endl
         << "\ttime " << ts << endl;
  }


  
  virtual void null_message (const ABng_Core_System::Sensor_Id& sensor, 
			     const ABng_Core_System::Time& ts, 
			     CORBA::Long request_id,
			     CORBA::Long repeat_num
			     ENV_DECL( env)) {
    cout << "null_message req_id " << request_id 
         << " repeat_num " << repeat_num << endl
         << "\tsensor " << sensor << endl
         << "\tsensor " << sensor << endl
         << "\ttime " << ts << endl;
  }

  virtual void request_processed (const ABng_Core_System::Sensor_Id& sensor,
				  const ABng_Core_System::Badge_Id& badge,
				  const ABng_Core_System::Time& ts, 
				  CORBA::Long request_id,
				  CORBA::Long repeat_num
				  ENV_DECL( env)) {
    cout << "request_processed req_id " << request_id 
         << " repeat_num " << repeat_num << endl
         << "\tsensor " << sensor << endl
         << "\tsensor " << sensor << endl
         << "\tbadge " << badge << endl
         << "\ttime " << ts << endl;
  }

  virtual void error_occured (const ABng_Core_System::Sensor_Id& sensor,
			      const ABng_Core_System::Badge_Id& badge,
			      ABng_Core::Command_Error_Code error_code,
			      CORBA::Long request_id,
			      CORBA::Long repeat_num,
			      CORBA::Long retry_num
			      ENV_DECL( env)) {
    cout << "error occured req_id " << request_id
         << " repeat_num " << repeat_num << " retry_num " << retry_num << endl
	 << "\terror_code "
	 << (error_code==ABng_Core::SIGHTING_TIMEOUT ?
	     "SIGHTING_TIMEOUT" :
	     (error_code==ABng_Core::REPLY_TIMEOUT ?
	      "REPLY_TIMEOUT" : 
	      (error_code==ABng_Core::POLLER_UNREACHABLE) ? 
	      "POLLER_UNREACHABLE" : "(unknown error code)")) << endl
         << "\tbadge_id " << badge << endl
         << "\tsensor_id " << sensor << endl;
  }

  virtual void request_completed( CORBA::Long request_id
				  ENV_DECL( IT_env)) {
    cout << "request completed req_id " << request_id << endl;
  }
};


static void register_impl( void *arg) {
  CORBA::BOA_ptr boa_ptr= (CORBA::BOA_ptr) arg;
  try {
#ifdef ORBIX
    boa_ptr->processEvents( CORBA::ORB::INFINITE_TIMEOUT);
#else
    boa_ptr->impl_is_ready();
#endif
  }
  catch ( CORBA::SystemException &ex) {
    cout << "Caught system exception " << ex
	 << " -- impl_is_ready" << endl;
    return;
  }
}

enum command_type { SCHEDULER_COMMAND, SENSOR_COMMAND, BADGE_COMMAND,
                    LOCATION_COMMAND, LOCATABLE_COMMAND, VIEW_COMMAND };


class Commander {
  istream &istr;
  int quit_flag;
  ABng_Core::Command_Context ctx;
  command_type ct;

  Scheduler_CallerImpl my_caller;
  CallerImpl core_caller;

  RWTime offset_time; // time of the 1st Jan 1970 00:00:00 UTC
  ABng_Core_System::Badge_Ids badge_ids;
  ABng_Core_System::Badges badge_refs;
  ABng_Core::Locatables locatable_refs;
  ABng_Core::Locatable_var locatable_ref;
  ABng_Core_System::Badge_var badge_ref;

  ABng_Core_System::Sensor_Ids sensor_ids;
  ABng_Core_System::Sensors sensor_refs;
  ABng_Core::Locations location_refs;
  ABng_Core::Location_var location_ref;
  ABng_Core_System::Sensor_var sensor_ref;

  Domain_Repository::Repository_Item_Id item_id;
  ABng_Core_Management::Badge_Rep_var badge_rep_ref;
  ABng_Core_Management::Sensor_Rep_var sensor_rep_ref;
  ABng_Core_System::Scheduler_var scheduler_ref;
  ABng_Core::View_var view_ref;
  RWCString view_name;

  int get_badge_rep_ref();
  int get_sensor_rep_ref();
  int get_scheduler_ref();
  int get_view_ref();

  int read_string( RWCString &string, const char *default_string);
  int read_int( int &int_value, int default_value);
  int read_hex_int( int &int_value, int default_value);

  int read_command_type();
  int read_badge();
  int read_badge_seq();
  int read_sensor();
  int read_sensor_seq();
  int read_period( Domain_Repository::Time &time);
  int read_time( Domain_Repository::Time &time);
  int read_data( ABng_Core_System::Octets &data);

  void show_requests( ABng_Core::Request_Queue::Requests *reqs);
  void show_requests( 
        ABng_Core_System::Scheduler_Request_Queue::Scheduler_Requests *reqs);
  void list_all_requests();
  void list_user_requests( const char *user_name);
  void remove_request( CORBA::Long request_id);

public:
  Commander( istream &_istr);
  int process_command();
  int more_commands() { return !quit_flag; }
};

Commander::Commander( istream &_istr) : 
  istr( _istr), 
  quit_flag( 0),
  ct( SCHEDULER_COMMAND),
  offset_time( RWDate( 1, 1, 1970), 0, 0,0, RWZone::utc()) {

  ctx.at.seconds= ctx.at.microseconds= 0;
  ctx.waiting_for_sighting_timeout.seconds= 15;
  ctx.waiting_for_sighting_timeout.microseconds= 0;
  ctx.waiting_for_reply_timeout.seconds= 16;
  ctx.waiting_for_reply_timeout.microseconds= 0;
  ctx.interval.seconds= ctx.interval.microseconds= 0;
  ctx.repeat= 1;
  ctx.retries= 5;
  ctx.interest= ABng_Core::Error_And_Reply;    

  CONNECT_IMPL( ABng_Core::Caller_var, &core_caller);
  CONNECT_IMPL( ABng_Core_System::Scheduler_Caller_var, &my_caller);
}

int Commander::get_badge_rep_ref() {
  if ( CORBA::is_nil( badge_ref.operator->())) {
    try {
      badge_rep_ref= ABng_Core_Management::Badge_Rep::_narrow( 
		    Bootstrap::resolve( Bootstrap::SRV_Badge_Repository()));
      if ( CORBA::is_nil( badge_rep_ref.operator->())) {
	cerr << "Cannot find badge repository" << endl;
	return 0;
      }
    }
    catch ( CORBA::Exception &ex) {
      cerr << "Cannot find badge repository " << ex << endl;
      return 0;
    }
  }
  else return 1;
}

int Commander::get_sensor_rep_ref() {
  if ( CORBA::is_nil( sensor_ref.operator->())) {
    try {
      sensor_rep_ref= ABng_Core_Management::Sensor_Rep::_narrow( 
		    Bootstrap::resolve( Bootstrap::SRV_Sensor_Repository()));
      if ( CORBA::is_nil( sensor_rep_ref.operator->())) {
	cerr << "Cannot find sensor repository" << endl;
	return 0;
      }
    }
    catch ( CORBA::Exception &ex) {
      cerr << "Cannot find sensor repository " << ex << endl;
      return 0;
    }
  }
  else return 1;
}

int Commander::get_scheduler_ref() {
  if ( CORBA::is_nil( scheduler_ref.operator->())) {
    try {
      scheduler_ref= ABng_Core_System::Scheduler::_narrow( 
		    Bootstrap::resolve( Bootstrap::SRV_Scheduler()));
      if ( CORBA::is_nil( scheduler_ref.operator->())) {
	cerr << "Cannot find scheduler" << endl;
	return 0;
      }
    }
    catch ( CORBA::Exception &ex) {
      cerr << "Cannot find scheduler " << ex << endl;
      return 0;
    }
  }
  else return 1;
}

int Commander::get_view_ref() {
  if ( CORBA::is_nil( (ABng_Core::View_ptr) view_ref)) {
    cerr << "View object is unresolved" << endl;
    return 0;
  }
  return 1;
}

int Commander::read_command_type() {
  RWCString ct_string;

  cout << "[Scheduler] [Badge] [Sensor] [Location] [Locatable] [View] ";
  istr >> ct_string;

  if ( ct_string == "Scheduler") ct= SCHEDULER_COMMAND;
  else if ( ct_string == "Badge") ct= BADGE_COMMAND;
  else if ( ct_string == "Sensor") ct= SENSOR_COMMAND;
  else if ( ct_string == "Locatable") ct= LOCATABLE_COMMAND;
  else if ( ct_string == "Location") ct= LOCATION_COMMAND;
  else if ( ct_string == "View") ct= VIEW_COMMAND;
  else {
    cout << "Unknown command type "+ct_string << endl;
    return 0;
  }
  if ( ct == LOCATABLE_COMMAND ||
       ct == LOCATION_COMMAND ||
       ct == VIEW_COMMAND) {
    cout << "Enter view name ";
    istr >> ct_string;
    view_name= ct_string;
    try {
      view_ref= ABng_Core::View::_narrow( 
         Bootstrap::resolve( Bootstrap::CTX_ABng_Core_Public_Views()+
			     (const char *)ct_string));

      if ( CORBA::is_nil( (ABng_Core::View_ptr) view_ref)) {
	cerr << "Cannot find view object" << endl;
	return 0;
      }
    }
    catch ( CORBA::Exception &ex) {
      cerr << "Cannot find view object " << ex << endl;
      return 0;
    }
  }
  return 1;
}

int Commander::read_string( RWCString &string, const char *default_value) {

 
  cout << "[* = " << default_value << "] ";
  istr >> string;
  if ( string == "*") string= default_value;

  if (!istr) return 0;
  cerr << string << endl;
  return 1;
}

int Commander::read_int( int &value, int default_value) {
  RWCString linebuf;

  cout << "[* = " << default_value << "] ";    
  istr >> linebuf;
  if ( linebuf == "*") value= default_value;
  else 
    if ( sscanf( linebuf, "%d", &value) !=1) return 0;
  
  if (!istr) return 0;
  return 1;  
}

int Commander::read_hex_int( int &value, int default_value) {
  RWCString linebuf;

  cout << "[* = " << default_value << "] ";    
  istr >> linebuf;
  if ( linebuf == "*") value= default_value;
  else 
    if ( sscanf( linebuf, "%x", &value) !=1) return 0;

  if (!istr) return 0;
  return 1;  
}

int Commander::read_badge_seq() {
  ostrstream buf;
  RWCString tmp;
  ABng_Core_System::Badge_Id bid;

  cout << "Enter sequence of badge ids" << endl;
  buf << "<";
  do {
    cout << "More badges (y/n) ";
    read_string( tmp, "Y");
    if ( tmp != "y" && tmp != "Y") break;
    cout << "Enter badge id ";
    istr >> bid;
    buf << bid;
  } while (1);
  buf << ">";
  istrstream ibuf( buf.str());
  if ( ! ( ibuf >> badge_ids)) {
    cout << "Error reading sequence of badge ids" << endl;
    return 0;
  }
  return 1;
}

int Commander::read_badge() {
  RWCString tmp;
  ABng_Core_System::Badge::Pattern pattern;
  ABng_Core::Locatable::Pattern locatable_pattern;

  switch ( ct) {
  case BADGE_COMMAND:
    if (!get_badge_rep_ref()) return 0;
    try {
      cout << "Enter item id of a badge in badge repository ";
      istr >> item_id;
      pattern.is_any= 0;
      pattern.item_id_pattern.is_any= 0;
      pattern.item_id_pattern.value= item_id;
      pattern.id_pattern.is_any= 1;
      ABng_Core_System::Badges_var find_ret=
	badge_rep_ref->find( pattern);
      if ( find_ret->length() != 1) {
	cerr << "Could not determine requested badge" << endl;
	return 0;
      }
      badge_ref= ABng_Core_System::Badge::_duplicate( find_ret[ 0]);
    }
    catch ( CORBA::Exception &ex) {
      cerr << "Error contacting badge repository " << ex << endl;
      return 0;
    }
    break;
  case SENSOR_COMMAND:
    if (!get_badge_rep_ref()) return 0;
    badge_refs.length( 0);
    cout << "Enter sequence of badge item ids" << endl;
    do {
      cout << "More badges (y/n) ";
      read_string( tmp, "Y");
      if ( tmp != "y" && tmp != "Y") break;
      cout << "Enter badge item id ";
      int tmp_int;
      if (!( istr >> tmp_int)) return 0;
      pattern.is_any= 0;
      pattern.item_id_pattern.is_any= 0;
      pattern.item_id_pattern.value= tmp_int;
      pattern.id_pattern.is_any= 1;
      try {
	ABng_Core_System::Badges_var find_ret=
	  badge_rep_ref->find( pattern);
	if ( find_ret->length() != 1) {
	  cerr << "Could not determine requested badge" << endl;
	  return 0;
	}
	badge_refs.length( badge_refs.length()+1);
	badge_refs[ badge_refs.length()-1]= ABng_Core_System::Badge::_duplicate( find_ret[ 0]);
      }
      catch (CORBA::Exception &ex) {
	cout << "Error contacting badge repository " << ex << endl;
	return 0;
      }
    } while (1);
    break;
  case LOCATABLE_COMMAND:
    if (!get_view_ref()) return 0;
    try {
      cout << "Enter item id of a locatable ";
      istr >> item_id;
      locatable_pattern.is_any= 0;
      locatable_pattern.item_id_pattern.is_any= 0;
      locatable_pattern.item_id_pattern.value= item_id;
      locatable_pattern.home_location_pattern.is_any= 1;
      locatable_pattern.type_specific_object_pattern.is_any= 1;

      ABng_Core::Locatables_var find_ret=
	view_ref->find_locatable( locatable_pattern);
      if ( find_ret->length() != 1) {
	cerr << "Could not determine requested locatable object" << endl;
	return 0;
      }
      locatable_ref= ABng_Core::Locatable::_duplicate( find_ret[ 0]);
    }
    catch ( CORBA::Exception &ex) {
      cerr << "Error contacting view " << ex << endl;
      return 0;
    }
    break;    
  case LOCATION_COMMAND:
  case VIEW_COMMAND:
    if (!get_view_ref()) return 0;
    locatable_refs.length( 0);
    cout << "Enter sequence of locatable item ids" << endl;
    do {
      cout << "More locatables (y/n) ";
      read_string( tmp, "Y");
      if ( tmp != "y" && tmp != "Y") break;
      cout << "Enter locatable item id ";
      int tmp_int;
      if (!( istr >> tmp_int)) return 0;
      locatable_pattern.is_any= 0;
      locatable_pattern.item_id_pattern.is_any= 0;
      locatable_pattern.item_id_pattern.value= tmp_int;
      locatable_pattern.home_location_pattern.is_any= 1;
      locatable_pattern.type_specific_object_pattern.is_any= 1;
      try {
	ABng_Core::Locatables_var find_ret=
	  view_ref->find_locatable( locatable_pattern);
	if ( find_ret->length() != 1) {
	  cerr << "Could not determine requested locatable" << endl;
	  continue;
	}
	locatable_refs.length( locatable_refs.length()+1);
	locatable_refs[ locatable_refs.length()-1]= 
	  ABng_Core::Locatable::_duplicate( find_ret[ 0]);
      }
      catch (CORBA::Exception &ex) {
	cout << "Error contacting view " << ex << endl;
	return 0;
      }
    } while (1);
    break;    
  case SCHEDULER_COMMAND:
    if (!read_badge_seq()) return 0;
    break;
  }
  return 1;
}

int Commander::read_sensor_seq() {
  ostrstream buf;
  RWCString tmp;
  char linebuf[ 100];

  cout << "Enter sequence of sensor ids" << endl;
  buf << "<";
  do {
    cout << "More sensors (y/n) ";
    read_string( tmp, "Y");
    if ( tmp != "y" && tmp != "Y") break;
    cout << "Sensor_Number ";
    int tmp_sn, tmp_nn;
    istr >> tmp_sn;
    buf << tmp_sn << " ";
    cout << "Network_Number ";
    istr >> tmp_nn;
    buf << tmp_nn << " ";
    cout << "Network_Name (no whitespaces please)";
    istr >> tmp;
    buf << tmp << " ";
  } while (1);
  buf << ">";
  //  cout << buf.str() << endl;
  istrstream ibuf( buf.str());
  if ( ! ( ibuf >> sensor_ids)) {
    cout << "Error reading sequence of sensor ids" << endl;
    return 0;
  }
}

int Commander::read_sensor() {
  RWCString tmp;
  ABng_Core_System::Sensor::Pattern pattern;
  ABng_Core::Location::Pattern location_pattern;

  switch ( ct) {
  case SENSOR_COMMAND:
    if (!get_sensor_rep_ref()) return 0;
    try {
      ABng_Core_System::Sensor::Pattern pattern;

      cout << "Enter item id of a sensor in sensor repository";
      istr >> item_id;
      pattern.is_any= 0;
      pattern.item_id_pattern.is_any= 0;
      pattern.item_id_pattern.value= item_id;
      pattern.id_pattern.is_any= 1;
      ABng_Core_System::Sensors_var find_ret=
	sensor_rep_ref->find( pattern);
      if ( find_ret->length() != 1) {
	cerr << "Could not determine requested sensor" << endl;
	return 0;
      }
      sensor_ref= ABng_Core_System::Sensor::_duplicate( find_ret[ 0]);
    }
    catch ( CORBA::Exception &ex) {
      cerr << "Error contacting sensor repository " << ex << endl;
      return 0;
    }
    break;
  case BADGE_COMMAND:
    if (!get_sensor_rep_ref()) return 0;
    sensor_refs.length( 0);
    cout << "Enter sequence of sensor item ids" << endl;
    do {
      cout << "More sensors (y/n) ";
      read_string( tmp, "Y");
      if ( tmp != "y" && tmp != "Y") break;
      cout << "Enter sensor item id ";
      int tmp_int;
      if (!( istr >> tmp_int)) return 0;
      pattern.is_any= 0;
      pattern.item_id_pattern.is_any= 0;
      pattern.item_id_pattern.value= item_id;
      pattern.id_pattern.is_any= 1;
      try {
	ABng_Core_System::Sensors_var find_ret=
	  sensor_rep_ref->find( pattern);
	if ( find_ret->length() != 1) {
	  cerr << "Could not determine requested sensor" << endl;
	  return 0;
	}
	sensor_refs.length( sensor_refs.length()+1);
	sensor_refs[ sensor_refs.length()-1]= ABng_Core_System::Sensor::_duplicate( find_ret[ 0]);
      }
      catch (CORBA::Exception &ex) {
	cout << "Error contacting sensor repository " << ex << endl;
      }
    } while (1);
    break;
  case LOCATABLE_COMMAND:
  case VIEW_COMMAND:
    if (!get_view_ref()) return 0;
    location_refs.length( 0);
    cout << "Enter sequence of location item ids" << endl;
    do {
      cout << "More locations (y/n) ";
      read_string( tmp, "Y");
      if ( tmp != "y" && tmp != "Y") break;
      cout << "Enter location item id ";
      int tmp_int;
      if (!( istr >> tmp_int)) return 0;
      location_pattern.is_any= 0;
      location_pattern.item_id_pattern.is_any= 0;
      location_pattern.item_id_pattern.value= tmp_int;
      location_pattern.loc_descr_pattern.is_any= 1;
      try {
	ABng_Core::Locations_var find_ret=
	  view_ref->find_location( location_pattern);
	if ( find_ret->length() != 1) {
	  cerr << "Could not determine requested location" << endl;
	  continue;
	}
	location_refs.length( location_refs.length()+1);
	location_refs[ location_refs.length()-1]= 
	  ABng_Core::Location::_duplicate( find_ret[ 0]);
      }
      catch (CORBA::Exception &ex) {
	cout << "Error contacting view " << ex << endl;
	return 0;
      }
    } while (1);
    break;    
  case LOCATION_COMMAND:
    if (!get_view_ref()) return 0;
    try {
      cout << "Enter item id of a location ";
      istr >> item_id;
      location_pattern.is_any= 0;
      location_pattern.item_id_pattern.is_any= 0;
      location_pattern.item_id_pattern.value= item_id;
      location_pattern.loc_descr_pattern.is_any= 1;

      ABng_Core::Locations_var find_ret=
	view_ref->find_location( location_pattern);
      if ( find_ret->length() != 1) {
	cerr << "Could not determine requested location object" << endl;
	return 0;
      }
      location_ref= ABng_Core::Location::_duplicate( find_ret[ 0]);
    }
    catch ( CORBA::Exception &ex) {
      cerr << "Error contacting view " << ex << endl;
      return 0;
    }
    break;    
  case SCHEDULER_COMMAND:
    if (!read_sensor_seq()) return 0;
    break;
  }
  return 1;
}

int Commander::read_period( Domain_Repository::Time &time) {
  cout << "Seconds ";
  int tmp;
  if (!read_int( tmp, 0)) return 0;
  time.seconds= tmp;
  cout << "Microseconds ";
  if (!read_int( tmp, 0)) return 0;
  time.microseconds= tmp;
  if (!istr) return 0;
  return 1;
}

int Commander::read_time( Domain_Repository::Time &time) {
  RWCString tz;
  const RWZone *rwzone;

  cout << "Command executed [i]mmediately/[l]ater ";
  read_string( tz, "I");
  if ( tz == "i" || tz == "I") {
    time.seconds= time.microseconds= 0;
    return 1;
  }
  else if ( tz == "l" || tz == "L") {
    ;
  }
  else {
    cerr << "Invalid response " << tz << "; should be \"I\" or \"L\"" << endl;
    return 0;
  }

  cout << "Time zone ([L]ocal/[U]TC) ";
  read_string( tz, "L");
  if ( tz == "L" || tz == "l") rwzone= &(RWZone::local());
  else if ( tz == "U" || tz == "u") rwzone= &(RWZone::utc());
  else {
    cerr << "Invalid time zone" << endl;
    return 0;
  }
  RWTime current_time;
  RWDate current_date;
  cout << "Current date/time is " << current_time << endl;
  cout << "Year ";

  int t_year, t_month, t_day, t_hour, t_minute, t_second, t_microsecond;
  if (!read_int( t_year, current_date.year())) return 0;
  cout << "Month (1-based) ";
  if (!read_int( t_month, current_date.month())) return 0;
  cout << "Day (1-based) ";
  if (!read_int( t_day, current_date.dayOfMonth())) return 0;
  cout << "Hour (0-23) ";
  if (!read_int( t_hour, current_time.hour( *rwzone))) return 0;
  cout << "Minute ";
  if (!read_int( t_minute, current_time.minute( *rwzone))) return 0;
  cout << "Second ";
  if (!read_int( t_second, current_time.second())) return 0;
  cout << "Microsecond ";
  if (!read_int( t_microsecond, 0)) return 0;

  RWTime new_time( RWDate( t_day, t_month, t_year),
		   t_hour, t_minute, t_second, *rwzone);

  cout << new_time.asString( '\0', *rwzone) << endl;
  cerr << new_time.seconds() << endl;
  cerr << offset_time.seconds() << endl;
  time.seconds= new_time.seconds() - offset_time.seconds();
  time.microseconds= t_microsecond;
}

int Commander::read_data( ABng_Core_System::Octets &data) { 

  cout << "Enter sequence of octets ";
    
  if ( ! (istr >> data)) return 0;
  //
  cout << data;
  //
  return 1;
}

void Commander::show_requests( ABng_Core::Request_Queue::Requests *reqs) {
  for (int i=0; i<reqs->length(); i++) {
    cout << "Request #" << i << endl;
    cout << "\tuid\t\t\t" << (*reqs)[i].uid << endl;
    cout << "\trequest_id\t\t" << (*reqs)[i].request_id << endl;
    cout << "\tlocation_list (item_ids)";
    for (int j=0; j<(*reqs)[i].location_list.length(); j++) 
      if (CORBA::is_nil( (*reqs)[i].location_list[j])) cout << " nil";
      else {
	try {
	  cout << " " << (*reqs)[i].location_list[j]->item_id();
	}
	catch (CORBA::Exception &ex) {
	  cout << "unreachable";
	}
      }
    cout << endl;
    cout << "\tlocatable_list (item_ids)";
    for (int k=0; k<(*reqs)[i].locatable_list.length(); k++) 
      if (CORBA::is_nil( (*reqs)[i].locatable_list[k])) cout << " nil";
      else {
	try {
	  cout << " " << (*reqs)[i].locatable_list[k]->item_id();
	}
	catch (CORBA::Exception &ex) {
	  cout << "unreachable";
	}
      }
    cout << endl;
    cout << "\targuments\t\t" << (*reqs)[i].arguments << endl;
    cout << "\tcommand_name\t\t" << (*reqs)[i].command_name << endl;
    cout << "\tcommand_context" << endl << (*reqs)[i].command_ctx << endl;
    cout << "\trequest_time " << (*reqs)[i].request_time;
  }
}


void Commander::show_requests( 
       ABng_Core_System::Scheduler_Request_Queue::Scheduler_Requests *reqs) {

  for (int i=0; i<reqs->length(); i++) {
    cout << "Request #" << i << endl;
    cout << (*reqs)[i];
  }
}

void Commander::list_all_requests() {
  ABng_Core::Request_Queue::Requests_var reqs;
  ABng_Core_System::Scheduler_Request_Queue::Scheduler_Requests_var sreqs;

  try {
    switch (ct) {
    case SCHEDULER_COMMAND:
      if (!get_scheduler_ref()) return;
      sreqs= scheduler_ref->list_all_requests();
      cerr << "Got requests" << endl;
      show_requests(
       &((ABng_Core_System::Scheduler_Request_Queue::Scheduler_Requests &) 
       sreqs));
      break;
    case SENSOR_COMMAND:
      if (!read_sensor()) return;
      sreqs= sensor_ref->list_all_requests();
      show_requests(
       &((ABng_Core_System::Scheduler_Request_Queue::Scheduler_Requests &) 
       sreqs));
      break;
    case BADGE_COMMAND:
      if (!read_badge()) return;
      sreqs= badge_ref->list_all_requests();
      show_requests(
       &((ABng_Core_System::Scheduler_Request_Queue::Scheduler_Requests &) 
       sreqs));
      break;
    case LOCATION_COMMAND:
      if (!read_sensor()) return;
      reqs= location_ref->list_all_requests();
      show_requests( &((ABng_Core::Request_Queue::Requests &) reqs));
      break;
    case LOCATABLE_COMMAND:
      if (!read_badge()) return;
      reqs= locatable_ref->list_all_requests();
      show_requests( &((ABng_Core::Request_Queue::Requests &) reqs));
      break;
    case VIEW_COMMAND:
      if (!get_view_ref()) return;
      reqs= view_ref->list_all_requests();
      break;
    }
  }
  catch (CORBA::Exception &ex) {
    cerr << "Caught exception getting list of requests " << ex << endl;
  }
  cerr << "Done" << endl;
}


void Commander::list_user_requests( const char *user_name) {
  ABng_Core::Request_Queue::Requests_var reqs;
  ABng_Core_System::Scheduler_Request_Queue::Scheduler_Requests_var sreqs;

  try {
    switch (ct) {
    case SCHEDULER_COMMAND:
      if (!get_scheduler_ref()) return;
      sreqs= scheduler_ref->list_user_requests( user_name);
      show_requests( sreqs.operator->());
      break;
    case SENSOR_COMMAND:
      if (!read_sensor()) return;
      sreqs= sensor_ref->list_user_requests( user_name);
      show_requests( sreqs.operator->());
      break;
    case BADGE_COMMAND:
      if (!read_badge()) return;
      sreqs= badge_ref->list_user_requests( user_name);
      show_requests( sreqs.operator->());
      break;
    case LOCATION_COMMAND:
      if (!read_sensor()) return;
      reqs= location_ref->list_user_requests( user_name);
      show_requests( reqs.operator->());
      break;
    case LOCATABLE_COMMAND:
      if (!read_badge()) return;
      reqs= locatable_ref->list_user_requests( user_name);
      show_requests( reqs.operator->());
      break;
    case VIEW_COMMAND:
      if (!get_view_ref()) return;
      reqs= view_ref->list_user_requests( user_name);
      show_requests( reqs.operator->());
      break;
    }
  }
  catch (CORBA::Exception &ex) {
    cerr << "Caught exception " << ex << endl;
  }
}

void Commander::remove_request( CORBA::Long request_id) {
  try {
    switch (ct) {
    case SCHEDULER_COMMAND:
      if (!get_scheduler_ref()) return;
      scheduler_ref->remove_request( request_id);
      break;
    case SENSOR_COMMAND:
      if (!read_sensor()) return;
      sensor_ref->remove_request( request_id);
      break;
    case BADGE_COMMAND:
      if (!read_badge()) return;
      badge_ref->remove_request( request_id);
      break;
    case LOCATION_COMMAND:
      if (!read_sensor()) return;
      location_ref->remove_request( request_id);
      break;
    case LOCATABLE_COMMAND:
      if (!read_badge()) return;
      locatable_ref->remove_request( request_id);
      break;
    case VIEW_COMMAND:
      if (!get_view_ref()) return;
      view_ref->remove_request( request_id);
      break;
    }
    cout << "Request removed" << endl;
  }
  catch (CORBA::Exception &ex) {
    cerr << "Caught exception " << ex << endl;
  }
}

int Commander::process_command() {
  RWCString command;

  istr.clear( iostream::goodbit);

  istr >> command;
  if ( command == "?" ||
       command == "help") {

    cout << "?\n"
         "help\n"
         "quit\n"
         "set_command_type\n"
         "show_comand_type\n"
         "set_context\n"
         "show_context\n"
         "issue_locatable_command issue_badge_command\n"
         "issue_location_command issue_sensor_command\n"
         "challenge\n"
         "sound\n"
         "get_state\n"
         "set_state\n"
         "get_home\n"
         "set_home\n"
         "get_station_state\n"
         "reset_buffer\n"
         "reset_fifos\n"
         "set_output\n"
         "set_persistence\n"
         "list_all_requests\n"
         "list_user_requests\n"
         "remove_request\n";
  }
  else if ( command == "quit") {
    quit_flag= 1;
  }
  if ( command == "set_command_type") {
    read_command_type();
  }
  else if ( command == "show_command_type") {
    switch (ct) {
    case SCHEDULER_COMMAND:      
      cout << "Scheduler" << endl;
      break;
    case SENSOR_COMMAND:
      cout << "Sensor" << endl;
      break;
    case BADGE_COMMAND:
      cout << "Badge" << endl;
      break;
    case LOCATION_COMMAND:
      cout << "Location ( view_name = " << view_name << ")" << endl;
      break;
    case LOCATABLE_COMMAND:
      cout << "Locatable ( view_name = " << view_name << ")" << endl;
      break;
    case VIEW_COMMAND:
      cout << "View ( view_name = " << view_name << ")" << endl;
    }
  }
  else if ( command == "set_context") {
    cout << "[at] [waiting_for_sighting_timeout] [waiting_for_reply_timeout]\n"
         << "[retries] [interval] [repeat] [interest]" << endl;

    istr >> command;
    if ( command == "at") {
      if (!read_time( ctx.at)) return 0;
    }
    else if ( command == "waiting_for_sighting_timeout") {
      if (!read_period( ctx.waiting_for_sighting_timeout)) return 0;
    }
    else if ( command == "waiting_for_reply_timeout") {
      if (!read_period( ctx.waiting_for_reply_timeout)) return 0;
    }
    else if ( command == "retries") {
      istr >> ctx.retries;
    }
    else if ( command == "interval") {
      if (!read_period( ctx.interval)) return 0;
    }
    else if ( command == "repeat") {
      istr >> ctx.repeat;
    }
    else if ( command == "interest") {
      RWCString str;
   
      cout << "[Error] [Reply] [Request_Invoked] [Error_And_Reply]\n\t[Error_And_Request_Invoked] [None]       " << endl;

      read_string( str, "Error_And_Reply");

      if (str == "Error") 
	ctx.interest= ABng_Core::Error;
      else if (str == "Reply") 
	ctx.interest= ABng_Core::Reply;
      else if (str == "Request_Invoked") 
	ctx.interest= ABng_Core::Request_Invoked;
      else if (str == "Error_And_Reply") 
	ctx.interest= ABng_Core::Error_And_Reply;
      else if (str == "Error_And_Request_Invoked") 
	ctx.interest= ABng_Core::Error_And_Request_Invoked;
      else if (str == "None") 
	ctx.interest= ABng_Core::None;
      else {
	cerr << "Invalid response";
	return 0;
      }
    }
    else {
      cerr << "Invalid response";
      return 0;
    }
  }
  else if ( command == "show_context") {
    cout << ctx << endl;
  }
  else if ( command == "issue_badge_command" ||
            command == "issue_locatable_command") {
    ABng_Core::Octets command_data;

    if (!read_sensor()) return 0;
    if (!read_badge()) return 0;
    cout << "Command: ";
    if (!read_data( command_data)) return 0;
    int has_reply;
    RWCString tmp;
    cout << "Has reply ([y]/[n]]";
    if (!read_string( tmp, "Y")) return 0;
    has_reply= (tmp == "Y" || tmp == "y");
    int reply_code= 0;
    if ( has_reply) {
      cout << "Reply code (hex): ";
      if (!read_hex_int( reply_code, 0)) return 0;
    }
    try {
      CORBA::Long id;
	
      switch (ct) {
      case SCHEDULER_COMMAND:
	if (!get_scheduler_ref()) return 0;
        id= scheduler_ref->issue_badge_command( sensor_ids, badge_ids,
						command_data, has_reply, 
						(CORBA::Octet) reply_code,
						ctx, &my_caller);
	break;
      case SENSOR_COMMAND:
	id= sensor_ref->issue_badge_command( badge_refs,
					     command_data, has_reply,
					     (CORBA::Octet) reply_code,
					     ctx, &my_caller);
	break;
      case BADGE_COMMAND:
	id= badge_ref->issue_command( sensor_refs,
				      command_data, has_reply,
				      (CORBA::Octet) reply_code,
				      ctx, &my_caller);
	break;
      case LOCATION_COMMAND:
	id= location_ref->issue_locatable_command( locatable_refs,
						   command_data, has_reply,
						   (CORBA::Octet) reply_code,
						   ctx, &core_caller);
	break;
      case LOCATABLE_COMMAND:
	id= locatable_ref->issue_command( location_refs,
					  command_data, has_reply,
					  (CORBA::Octet) reply_code,
					  ctx, &core_caller);
	break;
      case VIEW_COMMAND:
	id= view_ref->issue_locatable_command( location_refs,
					       locatable_refs,
					       command_data, has_reply,
					       (CORBA::Octet) reply_code,
					       ctx, &core_caller);
	break;
      }
      cout << "Request ID " << id << endl;
    }
    catch (CORBA::Exception &ex) {
      cout << "Caught exception " << ex << endl;
    }
  }
  else if ( command == "issue_sensor_command" ||
	    command == "issue_location_command") {
    ABng_Core::Octets command_data;

    if (!read_sensor()) return 0;
    cout << "Command: ";
    if (!read_data( command_data)) return 0;
    int has_reply;
    RWCString tmp;
    cout << "Has reply ([y]/[n]]";
    if (!read_string( tmp, "Y")) return 0;
    has_reply= (tmp == "Y" || tmp == "y");
    int reply_code= 0;
    if ( has_reply) {
      cout << "Reply code (hex): ";
      if (!read_hex_int( reply_code, 0)) return 0;
    }
    try {
      CORBA::Long id;
	
      switch (ct) {
      case SCHEDULER_COMMAND:
	if (!get_scheduler_ref()) return 0;
        id= scheduler_ref->issue_sensor_command( sensor_ids,
						 command_data, has_reply, 
						 (CORBA::Octet) reply_code,
						 ctx, &my_caller);
	break;
      case SENSOR_COMMAND:
	id= sensor_ref->issue_sensor_command( command_data, has_reply,
					      (CORBA::Octet) reply_code,
					      ctx, &my_caller);
	break;
      case BADGE_COMMAND:
	cout << "Cannot issue sensor command through badge commander interface" << endl;
	break;
      case LOCATABLE_COMMAND:
	cout << "Cannot issue location command through locatable commander interface" << endl;
	break;
      case LOCATION_COMMAND:
	id= location_ref->issue_location_command( command_data, has_reply,
						  (CORBA::Octet) reply_code,
						  ctx, &core_caller);
	break;
      case VIEW_COMMAND:
	id= view_ref->issue_location_command( location_refs,
					      command_data, has_reply,
					      (CORBA::Octet) reply_code,
					      ctx, &core_caller );
	break;			      
      }
      cout << "Request ID " << id << endl;
    }
    catch (CORBA::Exception &ex) {
      cout << "Caught exception " << ex << endl;
    }
  }
  else if ( command == "challenge") {
    ABng_Core::Octets random;
    if (!read_sensor()) return 0;
    if (!read_badge()) return 0;
    cout << "Random: ";
    if (!read_data( random)) return 0;
    try {
      CORBA::Long id;
	
      switch (ct) {
      case SCHEDULER_COMMAND:
	if (!get_scheduler_ref()) return 0;
        id= scheduler_ref->challenge( sensor_ids,
				      badge_ids,
				      random,
				      ctx, &my_caller);
	break;
      case SENSOR_COMMAND:
	id= sensor_ref->challenge( badge_refs,
				   random,
				   ctx, &my_caller);
	break;
      case BADGE_COMMAND:
	id= badge_ref->challenge( sensor_refs,
				  random,
				  ctx, &my_caller);
	break;
      case LOCATABLE_COMMAND:
	id= locatable_ref->challenge( location_refs,
				      random,
				      ctx, &core_caller);
	break;
      case LOCATION_COMMAND:
	id= location_ref->challenge( locatable_refs,
				     random,
				     ctx, &core_caller);
	break;
      case VIEW_COMMAND:
	id= view_ref->challenge( location_refs,
				 locatable_refs,
				 random,
				 ctx, &core_caller);
	break;			      
      }
      cout << "Request ID " << id << endl;
    }
    catch (CORBA::Exception &ex) {
      cout << "Caught exception " << ex << endl;
    }
  }
  else if ( command == "sound") {
    ABng_Core::Octets random;
    if (!read_sensor()) return 0;
    if (!read_badge()) return 0;
    cout << "Sound: ";
    if (!read_data( random)) return 0;
    try {
      CORBA::Long id;
	
      switch (ct) {
      case SCHEDULER_COMMAND:
	if (!get_scheduler_ref()) return 0;
        id= scheduler_ref->sound( sensor_ids,
				  badge_ids,
				  random,
				  ctx, &my_caller);
	break;
      case SENSOR_COMMAND:
	id= sensor_ref->sound( badge_refs,
			       random,
			       ctx, &my_caller);
	break;
      case BADGE_COMMAND:
	id= badge_ref->sound( sensor_refs,
			      random,
			      ctx, &my_caller);
	break;
      case LOCATABLE_COMMAND:
	id= locatable_ref->sound( location_refs,
				  random,
				  ctx, &core_caller);
	break;
      case LOCATION_COMMAND:
	id= location_ref->sound( locatable_refs,
				 random,
				 ctx, &core_caller);
	break;
      case VIEW_COMMAND:
	id= view_ref->sound( location_refs,
			     locatable_refs,
			     random,
			     ctx, &core_caller);
	break;			      
      }
      cout << "Request ID " << id << endl;
    }
    catch (CORBA::Exception &ex) {
      cout << "Caught exception " << ex << endl;
    }
  }
  else if ( command == "set_state") {
    ABng_Core::Octets random;
    int status;
    if (!read_sensor()) return 0;
    if (!read_badge()) return 0;
    cout << "State (dec) ";
    if (!read_int( status, 0)) return 0;
    cout << "Sound: ";
    if (!read_data( random)) return 0;
    try {
      CORBA::Long id;
	
      switch (ct) {
      case SCHEDULER_COMMAND:
	if (!get_scheduler_ref()) return 0;
        id= scheduler_ref->set_state( sensor_ids,
				      badge_ids,
				      (CORBA::Octet) status,
				      random,
				      ctx, &my_caller);
	break;
      case SENSOR_COMMAND:
	id= sensor_ref->set_state( badge_refs,
				   (CORBA::Octet) status,
				   random,
				   ctx, &my_caller);
	break;
      case BADGE_COMMAND:
	id= badge_ref->set_state( sensor_refs,
				  (CORBA::Octet) status,
				  random,
				  ctx, &my_caller);
	break;
      case LOCATABLE_COMMAND:
	id= locatable_ref->set_state( location_refs,
				      (CORBA::Octet) status,
				      random,
				      ctx, &core_caller);
	break;
      case LOCATION_COMMAND:
	id= location_ref->set_state( locatable_refs,
				     (CORBA::Octet) status,
				     random,
				     ctx, &core_caller);
	break;
      case VIEW_COMMAND:
	id= view_ref->set_state( location_refs,
				 locatable_refs,
				 (CORBA::Octet) status,
				 random,
				 ctx, &core_caller);
	break;			      
      }
      cout << "Request ID " << id << endl;
    }
    catch (CORBA::Exception &ex) {
      cout << "Caught exception " << ex << endl;
    }
  }
  else if ( command == "get_state") {
    if (!read_sensor()) return 0;
    if (!read_badge()) return 0;
    try {
      CORBA::Long id;
	
      switch (ct) {
      case SCHEDULER_COMMAND:
	if (!get_scheduler_ref()) return 0;
        id= scheduler_ref->get_state( sensor_ids,
				      badge_ids,
				      ctx, &my_caller);
	break;
      case SENSOR_COMMAND:
	id= sensor_ref->get_state( badge_refs,
				   ctx, &my_caller);
	break;
      case BADGE_COMMAND:
	id= badge_ref->get_state( sensor_refs,
				  ctx, &my_caller);
	break;
      case LOCATABLE_COMMAND:
	id= locatable_ref->get_state( location_refs,
				      ctx, &core_caller);
	break;
      case LOCATION_COMMAND:
	id= location_ref->get_state( locatable_refs,
				     ctx, &core_caller);
	break;
      case VIEW_COMMAND:
	id= view_ref->get_state( location_refs,
				 locatable_refs,
				 ctx, &core_caller);
	break;			      
      }
      cout << "Request ID " << id << endl;
    }
    catch (CORBA::Exception &ex) {
      cout << "Caught exception " << ex << endl;
    }
  }
  else if ( command == "set_home") {
    ABng_Core::Octets random;
    if (!read_sensor()) return 0;
    if (!read_badge()) return 0;
    cout << "Address: ";
    if (!read_data( random)) return 0;
    try {
      CORBA::Long id;
	
      switch (ct) {
      case SCHEDULER_COMMAND:
	if (!get_scheduler_ref()) return 0;
	cout << random;
        id= scheduler_ref->set_home( sensor_ids,
				     badge_ids,
				     random,
				     ctx, &my_caller);
	break;
      case SENSOR_COMMAND:
	id= sensor_ref->set_home( badge_refs,
				  random,
				  ctx, &my_caller);
	break;
      case BADGE_COMMAND:
	id= badge_ref->set_home( sensor_refs,
				 random,
				 ctx, &my_caller);
	break;
      case LOCATABLE_COMMAND:
	id= locatable_ref->set_home( location_refs,
				     random,
				     ctx, &core_caller);
	break;
      case LOCATION_COMMAND:
	id= location_ref->set_home( locatable_refs,
				    random,
				    ctx, &core_caller);
	break;
      case VIEW_COMMAND:
	id= view_ref->set_home( location_refs,
				locatable_refs,
				random,
				ctx, &core_caller);
	break;			      
      }
      cout << "Request ID " << id << endl;
    }
    catch (CORBA::Exception &ex) {
      cout << "Caught exception " << ex << endl;
    }
  }
  else if ( command == "get_home") {
    if (!read_sensor()) return 0;
    if (!read_badge()) return 0;
    try {
      CORBA::Long id;
	
      switch (ct) {
      case SCHEDULER_COMMAND:
	if (!get_scheduler_ref()) return 0;
        id= scheduler_ref->get_home( sensor_ids,
				     badge_ids,
				     ctx, &my_caller);
	break;
      case SENSOR_COMMAND:
	id= sensor_ref->get_home( badge_refs,
				  ctx, &my_caller);
	break;
      case BADGE_COMMAND:
	id= badge_ref->get_home( sensor_refs,
				 ctx, &my_caller);
	break;
      case LOCATABLE_COMMAND:
	id= locatable_ref->get_home( location_refs,
				     ctx, &core_caller);
	break;
      case LOCATION_COMMAND:
	id= location_ref->get_home( locatable_refs,
				    ctx, &core_caller);
	break;
      case VIEW_COMMAND:
	id= view_ref->get_home( location_refs,
				locatable_refs,
				ctx, &core_caller);
	break;			      
      }
      cout << "Request ID " << id << endl;
    }
    catch (CORBA::Exception &ex) {
      cout << "Caught exception " << ex << endl;
    }
  }
  else if ( command == "reset_buffer") {
    if (!read_sensor()) return 0;
    try {
      CORBA::Long id;
	
      switch (ct) {
      case SCHEDULER_COMMAND:
	if (!get_scheduler_ref()) return 0;
        id= scheduler_ref->reset_buffer( sensor_ids,
					 ctx, &my_caller);
	break;
      case SENSOR_COMMAND:
	id= sensor_ref->reset_buffer( ctx, &my_caller);
	break;
      case BADGE_COMMAND:
	cout << "Cannot send reset_buffer command through badge commander interface" << endl;
	break;
      case LOCATABLE_COMMAND:
	cout << "Cannot send reset_buffer command through locatable commander interface" << endl;
	break;
      case LOCATION_COMMAND:
	id= location_ref->reset_buffer( ctx, &core_caller);
	break;
      case VIEW_COMMAND:
	id= view_ref->reset_buffer( location_refs,
				    ctx, &core_caller);
	break;			      
      }
      cout << "Request ID " << id << endl;
    }
    catch (CORBA::Exception &ex) {
      cout << "Caught exception " << ex << endl;
    }
  }
  else if ( command == "reset_fifos") {
    if (!read_sensor()) return 0;
    try {
      CORBA::Long id;
	
      switch (ct) {
      case SCHEDULER_COMMAND:
	if (!get_scheduler_ref()) return 0;
        id= scheduler_ref->reset_fifos( sensor_ids,
					ctx, &my_caller);
	break;
      case SENSOR_COMMAND:
	id= sensor_ref->reset_fifos( ctx, &my_caller);
	break;
      case BADGE_COMMAND:
	cout << "Cannot send reset_fifos command through badge commander interface" << endl;
	break;
      case LOCATABLE_COMMAND:
	cout << "Cannot send reset_fifos command through locatable commander interface" << endl;
	break;
      case LOCATION_COMMAND:
	id= location_ref->reset_fifos( ctx, &core_caller);
	break;
      case VIEW_COMMAND:
	id= view_ref->reset_fifos( location_refs,
				   ctx, &core_caller);
	break;			      
      }
      cout << "Request ID " << id << endl;
    }
    catch (CORBA::Exception &ex) {
      cout << "Caught exception " << ex << endl;
    }
  }
  else if ( command == "get_station_state") {
    if (!read_sensor()) return 0;
    try {
      CORBA::Long id;
	
      switch (ct) {
      case SCHEDULER_COMMAND:
	if (!get_scheduler_ref()) return 0;
        id= scheduler_ref->get_station_state( sensor_ids,
					      ctx, &my_caller);
	break;
      case SENSOR_COMMAND:
	id= sensor_ref->get_station_state( ctx, &my_caller);
	break;
      case BADGE_COMMAND:
	cout << "Cannot send get_station_state command through badge commander interface" << endl;
	break;
      case LOCATABLE_COMMAND:
	cout << "Cannot send get_station_state command through locatable commander interface" << endl;
	break;
      case LOCATION_COMMAND:
	id= location_ref->get_station_state( ctx, &core_caller);
	break;
      case VIEW_COMMAND:
	id= view_ref->get_station_state( location_refs,
					 ctx, &core_caller);
	break;			      
      }
      cout << "Request ID " << id << endl;
    }
    catch (CORBA::Exception &ex) {
      cout << "Caught exception " << ex << endl;
    }
  }
  else if ( command == "set_output") {
    int output_value;

    if (!read_sensor()) return 0;
    cout << "Output_value ";
    if (!read_int( output_value, 0)) return 0;

    try {
      CORBA::Long id;
	
      switch (ct) {
      case SCHEDULER_COMMAND:
	if (!get_scheduler_ref()) return 0;
        id= scheduler_ref->set_output( sensor_ids,
				       (CORBA::Octet) output_value,
				       ctx, &my_caller);
	break;
      case SENSOR_COMMAND:
	id= sensor_ref->set_output( (CORBA::Octet) output_value,
				    ctx, &my_caller);
	break;
      case BADGE_COMMAND:
	cout << "Cannot send set_output command through badge commander interface" << endl;
	break;
      case LOCATABLE_COMMAND:
	cout << "Cannot send set_output command through locatable commander interface" << endl;
	break;
      case LOCATION_COMMAND:
	id= location_ref->set_output( (CORBA::Octet) output_value,
				      ctx, &core_caller);
	break;
      case VIEW_COMMAND:
	id= view_ref->set_output( location_refs,
				  (CORBA::Octet) output_value,
				  ctx, &core_caller);
	break;			      
      }
      cout << "Request ID " << id << endl;
    }
    catch (CORBA::Exception &ex) {
      cout << "Caught exception " << ex << endl;
    }
  }
  else if ( command == "set_persistence") {
    RWCString tmp;
    CORBA::Boolean mode= 0;

    if (!read_sensor()) return 0;
    cout << "Persistent mode (y/n) ";
    read_string( tmp, "Y");
    if ( tmp != "y" && tmp != "Y") mode= (CORBA::Boolean) 1;
    try {
      CORBA::Long id;
	
      switch (ct) {
      case SCHEDULER_COMMAND:
	if (!get_scheduler_ref()) return 0;
        id= scheduler_ref->set_persistence( sensor_ids,
					    mode,
					    ctx, &my_caller);
	break;
      case SENSOR_COMMAND:
	id= sensor_ref->set_persistence( mode, 
					 ctx, &my_caller);
	break;
      case BADGE_COMMAND:
	cout << "Cannot send set_persistence command through badge commander interface" << endl;
	break;
      case LOCATABLE_COMMAND:
	cout << "Cannot send set_persistence command through locatable commander interface" << endl;
	break;
      case LOCATION_COMMAND:
	id= location_ref->set_persistence( mode,
					   ctx, &core_caller);
	break;
      case VIEW_COMMAND:
	id= view_ref->set_persistence( location_refs,
				       mode,
				       ctx, &core_caller);
	break;			      
      }
      cout << "Request ID " << id << endl;
    }
    catch (CORBA::Exception &ex) {
      cout << "Caught exception " << ex << endl;
    }
  }
  else if ( command == "list_all_requests") {
    list_all_requests();
  }
  else if ( command == "list_user_requests") {
    cout << "Enter user name ";
    RWCString user_name;
    if (!read_string( user_name, "")) return 0;
    list_user_requests( user_name);
  }
  else if ( command == "remove_request") {
    cout << "Enter request id ";
    int req_id;
    if (!read_int( req_id, 0)) return 0;
    remove_request( req_id);
  }
}

int main( int argc, char **argv) {

  CORBA::ORB_ptr orb_ptr= CORBA::ORB_init( argc, argv, ORB_IDENTIFIER);
  CORBA::BOA_ptr boa_ptr= orb_ptr->BOA_init( argc, argv, BOA_IDENTIFIER);

  //  cerr << orb_ptr->object_to_string( &my_caller) << endl;
  omni_thread *reg_thread= new omni_thread( register_impl, boa_ptr);
  reg_thread->start();
  //  cout << "reg_thread started" << endl;

  try {
    Bootstrap::init( orb_ptr);
  }
  catch ( CORBA::Exception &ex) {
    cerr << "Error initializing bootstrap module " << ex;
    return 1;
  } 

  Commander commander( cin);

  do {
    cout << "? ";
    commander.process_command();
  } while ( commander.more_commands());
  
  return 0;
}


