#ifndef __ER_CLIENT_H__
#define __ER_CLIENT_H__ 1

#include <stream.h>

#include "domain_rep_management.hh"
#include "domain_rep_types_mgr.h"
#include "bootstrap_n.hh"

#include "rep_client.h"

ostream& 
 operator << (ostream&, Domain_Repository::Equipment::Value_Description&);



class Equipment_Client : public Rep_Client<Equipment_Types_Mgr> {

public:

  Equipment_Client(resolve_fun _srv_rep, resolve_fun _srv_rep_mgr)
    : Rep_Client<Equipment_Types_Mgr>(_srv_rep, _srv_rep_mgr) {
    meta_equipment_rep = new Basic_Client<Meta_Equipment_Types>(
      Bootstrap::SRV_Meta_Equipment_Repository);
  }

  virtual ~Equipment_Client() {}

  virtual Domain_Repository::Equipment::Description init_data(char* data);

  protected:
    Basic_Client<Meta_Equipment_Types>* meta_equipment_rep;

};

#endif __ER_CLIENT_H__





