//
//  File:         meta_equipment_rep_client.cc
//  Author:       Andrzej Uszok (uszok@ics.agh.edu.pl)
//  Date Created: 27.05.98
//
// General Description:
//   Implementation file for the class of a client of the Meta_Equipment 
//	 Repository interface
//

#include "meta_equipment_rep_client.h"

extern "C"      int isalpha(int c);
extern "C"      int isdigit(int c);


Meta_Equipment_Rep_Client::Operations Rep_Client<Meta_Equipment_Types_Mgr>::operations = 
  {{0, {0}}};

char* Rep_Client<Meta_Equipment_Types_Mgr>::description = 
"\"type(identifier) vendor(identifier) model(identifier) height(long)  width(long) depth(long) number_of_properties(long) property_name(identifier) property_type(type_name) ...\"";

Domain_Repository::Meta_Equipment::Description 
   Meta_Equipment_Rep_Client::init_data (
	char* data
   ) 
{
	Domain_Repository::Meta_Equipment::Description d;

	d.type      = read_id(data);
	d.vendor    = read_id(data);
	d.model     = read_id(data);

	d.my_dimensions.height = read_long(data);
	d.my_dimensions.width  = read_long(data);
	d.my_dimensions.depth  = read_long(data);

	d.specific_property_description_list.length(read_long(data));
	for (int i = 0; i < d.specific_property_description_list.length(); i ++) {
		d.specific_property_description_list[i].name = read_string(data);
		d.specific_property_description_list[i].type = read_TC(data);
	}
	d.my_control_info.default_field(0);

	return d;
}







