//
//  File:         meta_equipment_rep_client.h
//  Author:       Andrzej Uszok (uszok@ics.agh.edu.pl)
//  Date Created: 27.05.98
//
// General Description:
//   Header file for the implementation class of a client of 
//	the Meta_Equipment Repository interface
//

#ifndef __META_EQUIPMENT_REP_CLIENT_H__
#define __META_EQUIPMENT_REP_CLIENT_H__ 1

#include <stream.h>

#include "domain_rep_management.hh"
#include "domain_rep_types_mgr.h"
#include "bootstrap_n.hh"
#include "rep_client.h"

class Meta_Equipment_Rep_Client : public Rep_Client<Meta_Equipment_Types_Mgr> 
{
public:

   // ctor
   Meta_Equipment_Rep_Client() : Rep_Client<Meta_Equipment_Types_Mgr> (
	Bootstrap::SRV_Meta_Equipment_Repository,
	Bootstrap::SRV_Meta_Equipment_Repository_Manager
   ) { }

   virtual 
    ~Meta_Equipment_Rep_Client () {}

   virtual Domain_Repository::Meta_Equipment::Description
    init_data (
	char* data
    );
};

#endif __META_EQUIPMENT_REP_CLIENT_H__





