//
//  File:         location_type_rep_observer_i.h
//  Author:       Andrzej Uszok (uszok@ics.agh.edu.pl)
//  Date Created: 16.12.97
//
// General Description:
//   Header file for the implementation class of the Observer of 
//	the Location_Type Repositoryinterface
//

#ifndef location_type_rep_observer_i_h
#define location_type_rep_observer_i_h

#include <stdio.h>
#include <fstream.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>

#include "domain_rep_management.hh"

class Location_Type_Rep_Observer_I
{
 public:
   // ctor
   Location_Type_Rep_Observer_I (
   );

  virtual 
   ~Location_Type_Rep_Observer_I ();

  // reference of CORBA object encapsulated this C++ object
  Domain_Repository::Static_Data_Observer_ptr my_corba_object;

  //
  // IDL operations of the Static_Data_Observer interface
  //                       ___________________________
            
  virtual void 
   notify (
        Domain_Repository::Repository_Item_Id id,
	const Domain_Repository::Static_Data_Observer::Static_Data_Object& sd, 
	Domain_Repository::Change_Type change,
	CORBA::Environment &IT_env=CORBA::default_environment
   )
		throw (CORBA::SystemException);

  virtual void 
   abort (
	CORBA::Environment &IT_env=CORBA::default_environment
   ) 
		throw (CORBA::SystemException);

};   

DEF_TIE_Domain_Repository_Static_Data_Observer(Location_Type_Rep_Observer_I)

#endif /* location_type_rep_observer_i_h */
