//
//  File:         sensor_rep_client.h
//  Author:       Andrzej Uszok (uszok@ics.agh.edu.pl)
//  Date Created: 16.05.98
//
// General Description:
//   Header file for the implementation class of a client of 
//	the Sensor Repositoryinterface
//

#ifndef __SENSOR_REP_CLIENT_H__
#define __SENSOR_REP_CLIENT_H__ 1

#include <stream.h>

#include "abng_core_management.hh"
#include "abng_core_types.h"
#include "bootstrap_n.hh"
#include "rep_client.h"

class Sensor_Rep_Client : public Rep_Client<Sensor_Types> 
{
public:

   // ctor
   Sensor_Rep_Client() : Rep_Client<Sensor_Types> (
	Bootstrap::SRV_Sensor_Repository,
	Bootstrap::SRV_Sensor_Repository
   ) { }

   virtual 
    ~Sensor_Rep_Client () {}

   virtual ABng_Core_System::Sensor::Description
    init_data (
	char* data
    );
};

#endif __SENSOR_REP_CLIENT_H__





