#include <sys/time.h>
#include <sys/resource.h>
#include "abng_server_manager.hh"


void start_timer( struct rusage *ru, struct timeval *td);
void stop_timer( struct rusage *ru, struct timeval *td);
void show_timer( struct rusage *ru, struct timeval *td);
void add_timer( struct rusage *ru, struct timeval *rd);
void synch_time( long eps_microseconds);
void my_synch_time( long eps_microseconds);
ABng_Server_Manager::Time currtime();


inline void normalize_time( ABng_Server_Manager::Time &t) {
  while (t.microseconds>1000000) {
    t.microseconds-=1000000;
    t.seconds++;
  }
  while (t.microseconds<0) {
    t.microseconds+= 1000000;
    t.seconds--;
  }
  if (t.seconds<0) {
    if (t.microseconds>0) {
      t.seconds++;
      t.microseconds-= 1000000;
    }
  }
}

int operator > ( const ABng_Server_Manager::Time &t1, 
		 const ABng_Server_Manager::Time &t2);

ABng_Server_Manager::Time operator +( const ABng_Server_Manager::Time &t1, 
				      const ABng_Server_Manager::Time &t2);

ABng_Server_Manager::Time operator -( const ABng_Server_Manager::Time &t1, 
				      const ABng_Server_Manager::Time &t2);

ABng_Server_Manager::Time operator /( const ABng_Server_Manager::Time &t, int dv);






