//
//  File:         user_rep_observer_i.h
//  Author:       Andrzej Uszok (uszok@ics.agh.edu.pl)
//  Date Created: 29.01.98
//
// General Description:
//   Header file for the implementation class of the Observer of 
//	the User Repository interface
//

#ifndef user_rep_observer_i_h
#define user_rep_observer_i_h

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <fstream.h>

#include "CORBA.h"

#include "domain_rep_management.hh"

class User_Rep_Observer_I
{
 public:
   // ctor
   User_Rep_Observer_I (
   );

  virtual 
   ~User_Rep_Observer_I ();

  // reference of CORBA object encapsulated this C++ object
  Domain_Repository::Static_Data_Observer_ptr my_corba_object;

  //
  // IDL operations of the Static_Data_Observer interface
  //                       ____________________
            
  virtual void 
   notify (
	Domain_Repository::Repository_Item_Id id,
	const Domain_Repository::Static_Data_Observer::Static_Data_Object& sd, 
	Domain_Repository::Change_Type change,
	CORBA::Environment &IT_env=CORBA::default_environment
   )
		throw (CORBA::SystemException);

  virtual void 
   abort (
	CORBA::Environment &IT_env=CORBA::default_environment
   ) 
		throw (CORBA::SystemException);

};   

DEF_TIE_Domain_Repository_Static_Data_Observer(User_Rep_Observer_I)

#endif /* user_rep_observer_i_h */
