
#include "tevent.hh"


#ifndef _IDL_SEQUENCE_TEvent_Ops
#define _IDL_SEQUENCE_TEvent_Ops

_IDL_SEQUENCE_TEvent:: ~_IDL_SEQUENCE_TEvent() {
    if (_buffer && _release) {
        {
            for (CORBA::ULong IT_i = 0; IT_i < _length; IT_i++) {
                TEvent_release (_buffer[IT_i]);
            }
        }
        freebuf (_buffer);
    }
}

_IDL_SEQUENCE_TEvent:: _IDL_SEQUENCE_TEvent () {
    _release = 1;
    _length = 0;
    _maximum = 0;
    _buffer = NULL;
}


_IDL_SEQUENCE_TEvent:: _IDL_SEQUENCE_TEvent (CORBA::ULong max, CORBA::ULong length, TEvent_ptr* data, CORBA::Boolean release) {
    _release = release;
    _length = length;
    _maximum = max;
    _buffer = data;
}

_IDL_SEQUENCE_TEvent:: _IDL_SEQUENCE_TEvent (const _IDL_SEQUENCE_TEvent &IT_s) {
    _length = IT_s._length;
    _release = 1;
    CORBA::ULong IT_maximum = _maximum = IT_s._maximum;
    if (IT_maximum) {
        _buffer = allocbuf (IT_maximum);
        for (CORBA::ULong IT_i = 0; IT_i < _length; IT_i++) {
            _buffer[IT_i] = TEvent_duplicate (IT_s._buffer[IT_i]);
        }
    } else
        _buffer = NULL;
}

_IDL_SEQUENCE_TEvent:: _IDL_SEQUENCE_TEvent (CORBA::ULong IT_size) {
    if (IT_size) {
        _buffer = allocbuf (IT_size);
    } else
        _buffer = NULL;
    _length = 0;
    _release = 1;
    _maximum = IT_size;
}

_IDL_SEQUENCE_TEvent& _IDL_SEQUENCE_TEvent:: operator= (const _IDL_SEQUENCE_TEvent &IT_s){
    if (this == &IT_s) return *this;
    if (_buffer && _release) {
        for (CORBA::ULong IT_i = 0; IT_i < _length; IT_i++) {
            TEvent_release (_buffer[IT_i]);
        }
        for (CORBA::ULong IT_j = 0; IT_j < _length; IT_j++) {
            _buffer[IT_j] = TEvent_nil();
        }
    }
    if (!_release || (IT_s._maximum > _maximum)) {
        if (_buffer && _release) {
            freebuf (_buffer);
        }
        _buffer = allocbuf (IT_s._maximum);
        _maximum = IT_s._maximum;
        _release = 1;
    }
    _length = IT_s._length;
    for (CORBA::ULong IT_j = 0; IT_j < _length; IT_j++) {
        _buffer[IT_j] = TEvent_duplicate (IT_s._buffer[IT_j]);
    }
    return *this;
}

CORBA::ULong _IDL_SEQUENCE_TEvent:: maximum () const
{
    return _maximum;
}

CORBA::ULong _IDL_SEQUENCE_TEvent:: length () const
{
    return _length;
}

void _IDL_SEQUENCE_TEvent:: length (CORBA::ULong len) {
    if (len > _maximum) {
        _IDL_SEQUENCE_TEvent tempSeq (*this);
        if (_buffer && _release) {
            {
                for (CORBA::ULong IT_i = 0; IT_i < _length; IT_i++) {
                    TEvent_release (_buffer[IT_i]);
                }
            }
            freebuf (_buffer);
        }
        _release = 1;
        _length = len;
        _maximum = len;
        _buffer = allocbuf(len);
        for (CORBA::ULong IT_i = 0; IT_i < tempSeq._length; IT_i++) {
            _buffer[IT_i] = TEvent_duplicate (tempSeq._buffer[IT_i]);
        }
    } else if (len < _length) {
        if (_release) {
            for (CORBA::ULong IT_i = len; IT_i < _length; IT_i++) {
                TEvent_release (_buffer[IT_i]);
            }
        }
        for (CORBA::ULong IT_j = len; IT_j < _length; IT_j++) {
            _buffer[IT_j] = TEvent_nil();
        }
        _length = len;
    } else {
        _length = len;
    }
}

TEvent_SeqElem _IDL_SEQUENCE_TEvent:: operator [] (CORBA::ULong IT_i)  {
    if (IT_i >= _length)
        ;
    TEvent_SeqElem IT_seqElem (_buffer + IT_i, _release);
    return IT_seqElem;
}

const TEvent_SeqElem _IDL_SEQUENCE_TEvent:: operator [] (CORBA::ULong IT_i) const  {
    if (IT_i >= _length)
        ;
    TEvent_SeqElem IT_seqElem (_buffer + IT_i, _release);
    return IT_seqElem;
}

TEvent_ptr* CALL_SPEC _IDL_SEQUENCE_TEvent:: allocbuf (CORBA::ULong _nelems)
{
    TEvent_ptr *IT_Seq = new TEvent_ptr[_nelems];
    for (CORBA::ULong IT_i = 0; IT_i < _nelems; IT_i++) {
        IT_Seq[IT_i] = TEvent_nil();
    }
    return IT_Seq;
}

void CALL_SPEC _IDL_SEQUENCE_TEvent:: freebuf (TEvent_ptr* _data)
{
    if (_data) delete [] _data;
}

void _IDL_SEQUENCE_TEvent:: assignbuf (CORBA::ULong max, CORBA::ULong length, TEvent_ptr* data, CORBA::Boolean release) {
    if (_buffer && _release) {
        {
            for (CORBA::ULong IT_i = 0; IT_i < _length; IT_i++) {
                TEvent_release (_buffer[IT_i]);
            }
        }
        freebuf (_buffer);
    }
    _release = release;
    _length = length;
    _maximum = max;
    _buffer = data;
}

void _IDL_SEQUENCE_TEvent:: decodeInOutOp (CORBA::Request &IT_r) {
    switch (IT_r.targetProtocol()) {
        case CORBA::IT_INTEROPERABLE_OR_KIND:
        {
            CORBA::ULong IT_max;
            CORBA::ULong IT_length;
            IT_r >> IT_length;
            IT_max = IT_length;
            if (!_release || (IT_max > _maximum)) {
                if (_buffer && _release) {
                    {
                        for (CORBA::ULong IT_i = 0; IT_i < _length; IT_i++) {
                            TEvent_release (_buffer[IT_i]);
                        }
                    }
                    freebuf (_buffer);
                }
                _buffer = allocbuf (IT_max);
                _maximum = IT_max;
                _release = 1;
            }
            if (IT_length > IT_max)
                IT_r.makeRuntimeException4 ();
            else {
                if (IT_length == _length) {
                    for (CORBA::ULong IT_i = 0; IT_i < _length; IT_i++) {
                        if (_release) {
                            TEvent_release (_buffer[IT_i]);
                        }
                        _buffer[IT_i] = (TEvent*) IT_r.decodeObjRef (TEvent_IR);
                    }
                } else if (IT_length < _length) {
                    for (CORBA::ULong IT_i = 0; IT_i < IT_length; IT_i++) {
                        if (_release) {
                            TEvent_release (_buffer[IT_i]);
                        }
                        _buffer[IT_i] = (TEvent*) IT_r.decodeObjRef (TEvent_IR);
                    }
                    for (CORBA::ULong IT_j = IT_length; IT_j < _length; IT_j++) {
                        TEvent_release (_buffer[IT_j]);
                    }
                    for (CORBA::ULong IT_k = IT_length; IT_k < _length; IT_k++) {
                        _buffer[IT_k] = TEvent_nil();
                    }
                } else {
                    for (CORBA::ULong IT_i = 0; IT_i < IT_length; IT_i++) {
                        if (_release) {
                            TEvent_release (_buffer[IT_i]);
                        }
                        _buffer[IT_i] = (TEvent*) IT_r.decodeObjRef (TEvent_IR);
                    }
                    for (CORBA::ULong IT_j = IT_length; IT_j < _length; IT_j++) {
                        _buffer[IT_j] = (TEvent*) IT_r.decodeObjRef (TEvent_IR);
                    }
                }
            }
            _length = IT_length;
            break;
        }
        case CORBA::IT_ORBIX_OR_KIND:
        default:
        {
            CORBA::ULong IT_max;
            CORBA::ULong IT_length;
            IT_r >> IT_max;
            IT_r >> IT_length;
            unsigned char IT_codeSeqElems = IT_max ? 1 : 0;
            if (!_release || (IT_max > _maximum)) {
                if (_buffer && _release) {
                    {
                        for (CORBA::ULong IT_i = 0; IT_i < _length; IT_i++) {
                            TEvent_release (_buffer[IT_i]);
                        }
                    }
                    freebuf (_buffer);
                }
                _buffer = allocbuf (IT_max);
                _maximum = IT_max;
                _release = 1;
            }
            if (IT_length > IT_max)
                IT_r.makeRuntimeException4 ();
            else {
                if (IT_length == _length) {
                    for (CORBA::ULong IT_i = 0; IT_i < _length; IT_i++) {
                        if (_release) {
                            TEvent_release (_buffer[IT_i]);
                        }
                        _buffer[IT_i] = (TEvent*) IT_r.decodeObjRef (TEvent_IR);
                    }
                } else if (IT_length < _length) {
                    for (CORBA::ULong IT_i = 0; IT_i < IT_length; IT_i++) {
                        if (_release) {
                            TEvent_release (_buffer[IT_i]);
                        }
                        _buffer[IT_i] = (TEvent*) IT_r.decodeObjRef (TEvent_IR);
                    }
                    for (CORBA::ULong IT_j = IT_length; IT_j < _length; IT_j++) {
                        TEvent_release (_buffer[IT_j]);
                    }
                    for (CORBA::ULong IT_k = IT_length; IT_k < _length; IT_k++) {
                        _buffer[IT_k] = TEvent_nil();
                    }
                } else {
                    for (CORBA::ULong IT_i = 0; IT_i < IT_length; IT_i++) {
                        if (_release) {
                            TEvent_release (_buffer[IT_i]);
                        }
                        _buffer[IT_i] = (TEvent*) IT_r.decodeObjRef (TEvent_IR);
                    }
                    for (CORBA::ULong IT_j = IT_length; IT_j < _length; IT_j++) {
                        _buffer[IT_j] = (TEvent*) IT_r.decodeObjRef (TEvent_IR);
                    }
                }
            }
            _length = IT_length;
            break;
        }
    }
}

void _IDL_SEQUENCE_TEvent:: encodeOp (CORBA::Request &IT_r) const {
    switch (IT_r.targetProtocol()) {
        case CORBA::IT_INTEROPERABLE_OR_KIND:
        {
            IT_r << _length;
            for (CORBA::ULong IT_i = 0; IT_i < _length; IT_i++) {
                {
                    CORBA::Object* IT_l0 = (CORBA::Object*) _buffer[IT_i];
                    IT_r << IT_l0;
                }
            }
            break;
        }
        case CORBA::IT_ORBIX_OR_KIND:
        default:
        {
            IT_r << _maximum;
            IT_r << _length;
            unsigned char IT_codeSeqElems = _maximum ? 1 : 0;
            for (CORBA::ULong IT_i = 0; IT_i < _length; IT_i++) {
                {
                    CORBA::Object* IT_l1 = (CORBA::Object*) _buffer[IT_i];
                    IT_r << IT_l1;
                }
            }
            break;
        }
    }
}

void _IDL_SEQUENCE_TEvent:: decodeOp (CORBA::Request &IT_r) {
    switch (IT_r.targetProtocol()) {
        case CORBA::IT_INTEROPERABLE_OR_KIND:
        {
            IT_r >> _length;
            _maximum = _length;
            if (_maximum)
                _buffer = allocbuf (_maximum);
            else _buffer = 0;
            for (CORBA::ULong IT_j = 0; IT_j < _maximum; IT_j++) {
                _buffer[IT_j] = TEvent_nil();
            }
            for (CORBA::ULong IT_i = 0; IT_i < _length; IT_i++) {
                _buffer[IT_i] = (TEvent*) IT_r.decodeObjRef (TEvent_IR);
            }
            break;
        }
        case CORBA::IT_ORBIX_OR_KIND:
        default:
        {
            IT_r >> _maximum;
            IT_r >> _length;
            unsigned char IT_codeSeqElems = _maximum ? 1 : 0;
            if (IT_codeSeqElems) {
                _buffer = allocbuf (_maximum);
                for (CORBA::ULong IT_j = 0; IT_j < _maximum; IT_j++) {
                    _buffer[IT_j] = TEvent_nil();
                }
                for (CORBA::ULong IT_i = 0; IT_i < _length; IT_i++) {
                    _buffer[IT_i] = (TEvent*) IT_r.decodeObjRef (TEvent_IR);
                }
            }
            else
              _buffer = NULL;
            break;
        }
    }
}


unsigned char _IDL_SEQUENCE_TEvent_var ::copyHelper (const _IDL_SEQUENCE_TEvent_var &IT_s) {
    if (!IT_s._ptr) {
        _ptr = IT_s._ptr;
    } else
    {
        _ptr = new _IDL_SEQUENCE_TEvent;
        *(_ptr) =  *(IT_s._ptr);
    }
    return 1;
}

_IDL_SEQUENCE_TEvent_ptr* _IDL_SEQUENCE_TEvent_var ::_newPtr () {
    return new _IDL_SEQUENCE_TEvent_ptr;
}

_IDL_SEQUENCE_TEvent_var ::_IDL_SEQUENCE_TEvent_var (const _IDL_SEQUENCE_TEvent_var &IT_s) 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    (void) copyHelper (IT_s);
}

_IDL_SEQUENCE_TEvent_var ::_IDL_SEQUENCE_TEvent_var () 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    _ptr = NULL;
}

_IDL_SEQUENCE_TEvent_var ::_IDL_SEQUENCE_TEvent_var (_IDL_SEQUENCE_TEvent_ptr IT_p) 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    _ptr = IT_p;
}

_IDL_SEQUENCE_TEvent_var &_IDL_SEQUENCE_TEvent_var :: operator= (_IDL_SEQUENCE_TEvent_ptr IT_p) {
    if (_ptr != IT_p) {
        if (_ptr) {
                delete _ptr;
                _ptr = 0;
        }
    }
    _ptr = IT_p;
    return (*this);
}

_IDL_SEQUENCE_TEvent_var &_IDL_SEQUENCE_TEvent_var :: operator= (const _IDL_SEQUENCE_TEvent_var &IT_s) {
    if (_ptr != IT_s._ptr) {
        if (_ptr) {
                delete _ptr;
                _ptr = 0;
        }
    }
    _ptr = new _IDL_SEQUENCE_TEvent;
    *(_ptr) =  *(IT_s._ptr);
    return (*this);
}

_IDL_SEQUENCE_TEvent_var ::~_IDL_SEQUENCE_TEvent_var () {
    if (_ptr) {
        delete _ptr;
        _ptr = 0;
    }
    if ( _indPtr ) {
        delete _indPtr;
        _indPtr = 0;
    }
}

_IDL_SEQUENCE_TEvent_ptr _IDL_SEQUENCE_TEvent_var :: operator-> () const {
    return _ptr;
}

_IDL_SEQUENCE_TEvent_var::operator ! () const {
    return (_ptr ? 0 : 1);
}

_IDL_SEQUENCE_TEvent_var::operator _IDL_SEQUENCE_TEvent_ptr& () { return (_IDL_SEQUENCE_TEvent_ptr &) (_ptr);}
_IDL_SEQUENCE_TEvent_var::operator const _IDL_SEQUENCE_TEvent_cptr& () const { return (_IDL_SEQUENCE_TEvent_cptr &) (_ptr);}
_IDL_SEQUENCE_TEvent_var:: operator _IDL_SEQUENCE_TEvent& () const { return (_IDL_SEQUENCE_TEvent&) (* _ptr);}

const _IDL_SEQUENCE_TEvent _IDL_SEQUENCE_TEvent_var :: in () const {
    return *_ptr;
}

_IDL_SEQUENCE_TEvent& _IDL_SEQUENCE_TEvent_var :: inOut () {
    return *_ptr;
}

_IDL_SEQUENCE_TEvent*& _IDL_SEQUENCE_TEvent_var :: out () {
    return _ptr;
}

_IDL_SEQUENCE_TEvent* _IDL_SEQUENCE_TEvent_var :: ret () const {
    return _ptr;
}

TEvent_SeqElem _IDL_SEQUENCE_TEvent_var:: operator[] (CORBA::ULong index) {
    return (*_ptr) [index];
}

const TEvent_SeqElem _IDL_SEQUENCE_TEvent_var:: operator[] (CORBA::ULong index) const {
    return (*_ptr) [index];
}


#endif

TEvent_mgr::TEvent_mgr () 
{
    _ptr = TEvent:: _nil ();
}

TEvent_mgr::TEvent_mgr (const TEvent_mgr &IT_s) 
{
    _ptr = TEvent:: _duplicate (IT_s._ptr);
}

TEvent_mgr::TEvent_mgr (TEvent_var IT_s) 
{
    _ptr = TEvent:: _duplicate (IT_s);
}

TEvent_mgr::TEvent_mgr (const TEvent_SeqElem &IT_s) 
{
    _ptr = TEvent:: _duplicate (IT_s);
}

TEvent_mgr &TEvent_mgr::operator= (TEvent_ptr IT_p) {
    CORBA::release (_ptr);
    _ptr = IT_p;
    return (*this);
}

TEvent_mgr &TEvent_mgr::operator= (const TEvent_mgr &IT_s) {
    CORBA::release (_ptr);
    _ptr = TEvent:: _duplicate(IT_s._ptr);
    return (*this);
}

TEvent_mgr &TEvent_mgr::operator= (TEvent_var IT_s) {
    CORBA::release (_ptr);
    _ptr = TEvent:: _duplicate(IT_s);
    return (*this);
}

TEvent_mgr &TEvent_mgr::operator= (const TEvent_SeqElem &IT_s) {
    CORBA::release (_ptr);
    _ptr = TEvent:: _duplicate(IT_s);
    return (*this);
}

TEvent_mgr::~TEvent_mgr () {
    CORBA::release (_ptr);
}

TEvent_ptr TEvent_mgr:: operator-> () const {
    return _ptr;
}

TEvent_mgr::operator ! () const {
    return ((CORBA::is_nil (_ptr)));
}

TEvent_mgr::operator TEvent_ptr& () { return (TEvent_ptr &) (_ptr);}
TEvent_mgr::operator const TEvent_ptr& () const { return (TEvent_ptr &) (_ptr);}

TEvent_mgr::operator CORBA::Object_ptr () const {
    return _ptr;
}

TEvent_ptr TEvent_mgr:: in () const {
    return _ptr;
}

TEvent_ptr& TEvent_mgr:: inOut () {
    return _ptr;
}

TEvent_ptr& TEvent_mgr:: out () {
    return _ptr;
}

TEvent_ptr TEvent_mgr:: ret () const {
    return _ptr;
}

TEvent_SeqElem::TEvent_SeqElem (TEvent_ptr* IT_p, unsigned char rel) {
    _ptr = IT_p;
    _release = rel;
}

TEvent_SeqElem &TEvent_SeqElem::operator= (TEvent_ptr IT_p) {
    if (_ptr) {
        if (_release)
            CORBA::release (*(_ptr));
        *(_ptr) = IT_p;
    }
    return (*this);
}

TEvent_SeqElem &TEvent_SeqElem::operator= (const TEvent_SeqElem &IT_s) {
    if (_ptr && IT_s._ptr) {
        if (_release)
            CORBA::release (*(_ptr));
        *(_ptr) = TEvent:: _duplicate(*(IT_s._ptr));
    }
    return (*this);
}

TEvent_SeqElem &TEvent_SeqElem::operator= (const TEvent_mgr &IT_s) {
    if (_ptr ) {
        if (_release)
            CORBA::release (*(_ptr));
        *(_ptr) = TEvent:: _duplicate(IT_s._ptr);
    }
    return (*this);
}

TEvent_SeqElem &TEvent_SeqElem::operator= (TEvent_var IT_s) {
    if (_ptr ) {
        if (_release)
            CORBA::release (*(_ptr));
        *(_ptr) = TEvent:: _duplicate (IT_s);
    }
    return (*this);
}

TEvent_SeqElem::operator ! () const {
    return ((CORBA::is_nil (*_ptr)));
}

TEvent_SeqElem::operator const TEvent_ptr& () const { return (TEvent_ptr &) (*_ptr);}

TEvent_SeqElem::operator CORBA::Object_ptr () const {
    return *_ptr;
}

TEvent_ptr TEvent_SeqElem:: in () const {
    return *_ptr;
}

TEvent_ptr& TEvent_SeqElem:: inOut () {
    return *_ptr;
}

TEvent_ptr& TEvent_SeqElem:: out () {
    return *_ptr;
}

TEvent_ptr TEvent_SeqElem:: ret () const {
    return *_ptr;
}

TEvent_ptr TEvent_SeqElem::operator->() const { return *_ptr;}

TEvent::TEvent (char *IT_OR) {
      m_pptr = new TEvent_dispatch (IT_OR, this,(CORBA::Object*)this);
} 
TEvent::TEvent (ObjectReferenceImpl *IT_OR) {
      m_pptr = new TEvent_dispatch (IT_OR, this,(CORBA::Object*)this);
} 

#ifndef TEventForwC
#define TEventForwC
CORBA::ObjectRef CALL_SPEC TEvent_getBase(void *IT_p){
    return (TEvent*) IT_p;}

void CALL_SPEC TEvent_release (TEvent_ptr IT_p, CORBA::Environment &IT_env) {
    CORBA::release(IT_p, IT_env);}

void CALL_SPEC TEvent_release (TEvent_ptr IT_p) {
    TEvent_release (IT_p, CORBA::IT_chooseDefaultEnv ()); }

TEvent_ptr CALL_SPEC TEvent_nil (CORBA::Environment &) {
    return TEvent:: _nil ();}

TEvent_ptr CALL_SPEC TEvent_nil () {
    return TEvent_nil (CORBA::IT_chooseDefaultEnv ());}

TEvent_ptr CALL_SPEC TEvent_duplicate (TEvent_ptr IT_p, CORBA::Environment &IT_env) {
    return (TEvent::_duplicate(IT_p, IT_env)); }
TEvent_ptr CALL_SPEC TEvent_duplicate (TEvent_ptr IT_p) {
    return TEvent_duplicate (IT_p, CORBA::IT_chooseDefaultEnv ()); }
#endif

TEvent_ptr CALL_SPEC TEvent::_duplicate(TEvent_ptr obj, CORBA::Environment& IT_pEnv) {
        CORBA::EnvExcRaiser IT_raise;
        CORBA::Environment &IT_env = IT_raise.registerEnv (&IT_pEnv);
       if (!obj) {
          return (obj);
       }
       TEvent_ptr IT_obj = obj->__duplicate (IT_env);
       return IT_obj;
}



TEvent* CALL_SPEC TEvent:: _bind (const char* IT_markerServer, const char* host,
		const CORBA::Context &IT_c, 
		CORBA::Environment &IT_env) {
       return (TEvent*)CORBA::Factory.New (IT_markerServer, IT_env, IT_c, host, 
		TEvent_IMPL, TEvent_IR);
}



TEvent* CALL_SPEC TEvent:: _bind (CORBA::Environment &IT_env) {
       return _bind (NULL,NULL,CORBA::Context(), IT_env); }


TEvent* CALL_SPEC TEvent:: _bind (const char* IT_markerServer, const char* host,
                CORBA::Environment &IT_env) {
       return _bind (IT_markerServer, host, CORBA::Context (), IT_env); }
TEvent* CALL_SPEC TEvent::_narrow (CORBA::Object* IT_obj, CORBA::Environment &IT_pEnv) {
        CORBA::EnvExcRaiser IT_raise;
        CORBA::Environment &IT_env = IT_raise.registerEnv (&IT_pEnv);
        if (CORBA::is_nil (IT_obj)) {
                return TEvent:: _nil();
        }

       TEvent* IT_p = (TEvent*)CORBA::Object::_castDown (IT_obj, TEvent_IR, IT_env);
        IT_p = IT_p ? IT_p->__duplicate(IT_env) : NULL;
        if ((IT_env) &&(!strcmp(IT_env.exception()->id(), "CORBA::StExcep::BAD_PARAM")) && (((CORBA::BAD_PARAM*)IT_env.exception())-> minor() == NARROW_FAILED)) {
                IT_env.exception_free();
        }
        return IT_p;
   }

const void* TEvent:: IT_impl = CORBA::IT_implTable.record (TEvent_IMPL, "IDL:TEvent:1.0");


#ifndef TEvent_Description_Ops
#define TEvent_Description_Ops

void TEvent::Description:: encodeOp (CORBA::Request &IT_r) const {

    IT_r << item_id;

    IT_r.encodeStringOp (formula);

    IT_r << state;
}

void TEvent::Description:: decodeOp (CORBA::Request &IT_r) {

    IT_r >> item_id;

    {
        char *IT_0 = 0;
        IT_r.decodeStringOp(IT_0);
        formula = IT_0;
    }

    IT_r >> state;
}

void TEvent::Description:: decodeInOutOp (CORBA::Request &IT_r) {

    IT_r >> item_id;

    {
        char* IT_1;
        IT_1 = (formula)._ptr;
        (formula)._ptr = 0;
        IT_r.decodeInOutStrOp(IT_1, 0);
        formula = IT_1;
    }

    IT_r >> state;
}

TEvent::Description ::~Description () {
}

TEvent::Description:: Description (const TEvent::Description &IT_s) 
	 {
    item_id = IT_s.item_id;
    formula = IT_s.formula;
    state = IT_s.state;
}

TEvent::Description:: Description () {
}

TEvent::Description &TEvent::Description:: operator= (const TEvent::Description& IT_s) {
    if (this == &IT_s) return *this;
    item_id = IT_s.item_id;
    formula = IT_s.formula;
    state = IT_s.state;
    return *this;
}

unsigned char TEvent::Description_var ::copyHelper (const Description_var &IT_s) {
    if (!IT_s._ptr) {
        _ptr = IT_s._ptr;
    } else
    {
        _ptr = new Description;
        *(_ptr) =  *(IT_s._ptr);
    }
    return 1;
}

TEvent::Description_ptr* TEvent::Description_var ::_newPtr () {
    return new TEvent::Description_ptr;
}

TEvent::Description_var ::Description_var (const Description_var &IT_s) 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    (void) copyHelper (IT_s);
}

TEvent::Description_var ::Description_var () 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    _ptr = NULL;
}

TEvent::Description_var ::Description_var (Description_ptr IT_p) 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    _ptr = IT_p;
}

TEvent::Description_var &TEvent::Description_var :: operator= (Description_ptr IT_p) {
    if (_ptr != IT_p) {
        if (_ptr) {
                delete _ptr;
                _ptr = 0;
        }
    }
    _ptr = IT_p;
    return (*this);
}

TEvent::Description_var &TEvent::Description_var :: operator= (const Description_var &IT_s) {
    if (_ptr != IT_s._ptr) {
        if (_ptr) {
                delete _ptr;
                _ptr = 0;
        }
    }
    _ptr = new Description;
    *(_ptr) =  *(IT_s._ptr);
    return (*this);
}

TEvent::Description_var ::~Description_var () {
    if (_ptr) {
        delete _ptr;
        _ptr = 0;
    }
    if ( _indPtr ) {
        delete _indPtr;
        _indPtr = 0;
    }
}

TEvent::Description_ptr TEvent::Description_var :: operator-> () const {
    return _ptr;
}

TEvent::Description_var::operator ! () const {
    return (_ptr ? 0 : 1);
}

TEvent::Description_var::operator TEvent::Description_ptr& () { return (TEvent::Description_ptr &) (_ptr);}
TEvent::Description_var::operator const TEvent::Description_cptr& () const { return (TEvent::Description_cptr &) (_ptr);}
TEvent::Description_var:: operator TEvent::Description& () const { return (TEvent::Description&) (* _ptr);}

const TEvent::Description TEvent::Description_var :: in () const {
    return *_ptr;
}

TEvent::Description& TEvent::Description_var :: inOut () {
    return *_ptr;
}

TEvent::Description*& TEvent::Description_var :: out () {
    return _ptr;
}

TEvent::Description* TEvent::Description_var :: ret () const {
    return _ptr;
}


#endif


#ifndef TEvent__IDL_SEQUENCE_TEvent_Description_Ops
#define TEvent__IDL_SEQUENCE_TEvent_Description_Ops

TEvent::_IDL_SEQUENCE_TEvent_Description:: ~_IDL_SEQUENCE_TEvent_Description() {
    if (_buffer && _release) {
        {
        }
        freebuf (_buffer);
    }
}

TEvent::_IDL_SEQUENCE_TEvent_Description:: _IDL_SEQUENCE_TEvent_Description () {
    _release = 1;
    _length = 0;
    _maximum = 0;
    _buffer = NULL;
}


TEvent::_IDL_SEQUENCE_TEvent_Description:: _IDL_SEQUENCE_TEvent_Description (CORBA::ULong max, CORBA::ULong length, TEvent::Description* data, CORBA::Boolean release) {
    _release = release;
    _length = length;
    _maximum = max;
    _buffer = data;
}

TEvent::_IDL_SEQUENCE_TEvent_Description:: _IDL_SEQUENCE_TEvent_Description (const TEvent::_IDL_SEQUENCE_TEvent_Description &IT_s) {
    _length = IT_s._length;
    _release = 1;
    CORBA::ULong IT_maximum = _maximum = IT_s._maximum;
    if (IT_maximum) {
        _buffer = allocbuf (IT_maximum);
        for (CORBA::ULong IT_i = 0; IT_i < _length; IT_i++) {
            _buffer[IT_i] = IT_s._buffer[IT_i];
        }
    } else
        _buffer = NULL;
}

TEvent::_IDL_SEQUENCE_TEvent_Description:: _IDL_SEQUENCE_TEvent_Description (CORBA::ULong IT_size) {
    if (IT_size) {
        _buffer = allocbuf (IT_size);
    } else
        _buffer = NULL;
    _length = 0;
    _release = 1;
    _maximum = IT_size;
}

TEvent::_IDL_SEQUENCE_TEvent_Description& TEvent::_IDL_SEQUENCE_TEvent_Description:: operator= (const TEvent::_IDL_SEQUENCE_TEvent_Description &IT_s){
    if (this == &IT_s) return *this;
    if (_buffer && _release) {
    }
    if (!_release || (IT_s._maximum > _maximum)) {
        if (_buffer && _release) {
            freebuf (_buffer);
        }
        _buffer = allocbuf (IT_s._maximum);
        _maximum = IT_s._maximum;
        _release = 1;
    }
    _length = IT_s._length;
    for (CORBA::ULong IT_j = 0; IT_j < _length; IT_j++) {
        _buffer[IT_j] = IT_s._buffer[IT_j];
    }
    return *this;
}

CORBA::ULong TEvent::_IDL_SEQUENCE_TEvent_Description:: maximum () const
{
    return _maximum;
}

CORBA::ULong TEvent::_IDL_SEQUENCE_TEvent_Description:: length () const
{
    return _length;
}

void TEvent::_IDL_SEQUENCE_TEvent_Description:: length (CORBA::ULong len) {
    if (len > _maximum) {
        TEvent::_IDL_SEQUENCE_TEvent_Description tempSeq (*this);
        if (_buffer && _release) {
            {
            }
            freebuf (_buffer);
        }
        _release = 1;
        _length = len;
        _maximum = len;
        _buffer = allocbuf(len);
        for (CORBA::ULong IT_i = 0; IT_i < tempSeq._length; IT_i++) {
            _buffer[IT_i] = tempSeq._buffer[IT_i];
        }
    } else if (len < _length) {
        if (_release) {
        }
        _length = len;
    } else {
        _length = len;
    }
}

TEvent::Description& TEvent::_IDL_SEQUENCE_TEvent_Description:: operator [] (CORBA::ULong IT_i)  {
    if (IT_i >= _length)
        ;
    return _buffer [IT_i];
}

const TEvent::Description& TEvent::_IDL_SEQUENCE_TEvent_Description:: operator [] (CORBA::ULong IT_i) const  {
    if (IT_i >= _length)
        ;
    return _buffer [IT_i];
}

TEvent::Description* CALL_SPEC TEvent::_IDL_SEQUENCE_TEvent_Description:: allocbuf (CORBA::ULong _nelems)
{
    struct TEvent::Description* _pSequence = (struct TEvent::Description*)CORBA::_IT_vecAlloc ( sizeof ( struct TEvent::Description ), _nelems );
    for ( CORBA::ULong _index = 0; _index < _nelems; _index++ ) {
        (void)new ((void*)( _pSequence + _index )) struct TEvent::Description;
    }
    return _pSequence;
}

void CALL_SPEC TEvent::_IDL_SEQUENCE_TEvent_Description:: freebuf (TEvent::Description* _data)
{
    if ( _data ) {
        for ( CORBA::ULong _index = CORBA::_IT_vecNElems ( _data ); _index; _index-- ) {
            _data[ _index - 1 ].TEvent::Description::~Description ();
        }
        CORBA::_IT_vecFree ( _data );
    }
}

void TEvent::_IDL_SEQUENCE_TEvent_Description:: assignbuf (CORBA::ULong max, CORBA::ULong length, TEvent::Description* data, CORBA::Boolean release) {
    if (_buffer && _release) {
        {
        }
        freebuf (_buffer);
    }
    _release = release;
    _length = length;
    _maximum = max;
    _buffer = data;
}

void TEvent::_IDL_SEQUENCE_TEvent_Description:: decodeInOutOp (CORBA::Request &IT_r) {
    switch (IT_r.targetProtocol()) {
        case CORBA::IT_INTEROPERABLE_OR_KIND:
        {
            CORBA::ULong IT_max;
            CORBA::ULong IT_length;
            IT_r >> IT_length;
            IT_max = IT_length;
            if (!_release || (IT_max > _maximum)) {
                if (_buffer && _release) {
                    {
                    }
                    freebuf (_buffer);
                }
                _buffer = allocbuf (IT_max);
                _maximum = IT_max;
                _release = 1;
            }
            if (IT_length > IT_max)
                IT_r.makeRuntimeException4 ();
            else {
                for (CORBA::ULong IT_i = 0; IT_i < IT_length; IT_i++) {
                    _buffer[IT_i].decodeInOutOp (IT_r);
                }
            }
            _length = IT_length;
            break;
        }
        case CORBA::IT_ORBIX_OR_KIND:
        default:
        {
            CORBA::ULong IT_max;
            CORBA::ULong IT_length;
            IT_r >> IT_max;
            IT_r >> IT_length;
            unsigned char IT_codeSeqElems = IT_max ? 1 : 0;
            if (!_release || (IT_max > _maximum)) {
                if (_buffer && _release) {
                    {
                    }
                    freebuf (_buffer);
                }
                _buffer = allocbuf (IT_max);
                _maximum = IT_max;
                _release = 1;
            }
            if (IT_length > IT_max)
                IT_r.makeRuntimeException4 ();
            else {
                for (CORBA::ULong IT_i = 0; IT_i < IT_length; IT_i++) {
                    _buffer[IT_i].decodeInOutOp (IT_r);
                }
            }
            _length = IT_length;
            break;
        }
    }
}

void TEvent::_IDL_SEQUENCE_TEvent_Description:: encodeOp (CORBA::Request &IT_r) const {
    switch (IT_r.targetProtocol()) {
        case CORBA::IT_INTEROPERABLE_OR_KIND:
        {
            IT_r << _length;
            for (CORBA::ULong IT_i = 0; IT_i < _length; IT_i++) {
                _buffer[IT_i].encodeOp (IT_r);
            }
            break;
        }
        case CORBA::IT_ORBIX_OR_KIND:
        default:
        {
            IT_r << _maximum;
            IT_r << _length;
            unsigned char IT_codeSeqElems = _maximum ? 1 : 0;
            for (CORBA::ULong IT_i = 0; IT_i < _length; IT_i++) {
                _buffer[IT_i].encodeOp (IT_r);
            }
            break;
        }
    }
}

void TEvent::_IDL_SEQUENCE_TEvent_Description:: decodeOp (CORBA::Request &IT_r) {
    switch (IT_r.targetProtocol()) {
        case CORBA::IT_INTEROPERABLE_OR_KIND:
        {
            IT_r >> _length;
            _maximum = _length;
            if (_maximum)
                _buffer = allocbuf (_maximum);
            else _buffer = 0;
            for (CORBA::ULong IT_i = 0; IT_i < _length; IT_i++) {
                _buffer[IT_i].decodeOp (IT_r);
            }
            break;
        }
        case CORBA::IT_ORBIX_OR_KIND:
        default:
        {
            IT_r >> _maximum;
            IT_r >> _length;
            unsigned char IT_codeSeqElems = _maximum ? 1 : 0;
            if (IT_codeSeqElems) {
                _buffer = allocbuf (_maximum);
                for (CORBA::ULong IT_i = 0; IT_i < _length; IT_i++) {
                    _buffer[IT_i].decodeOp (IT_r);
                }
            }
            else
              _buffer = NULL;
            break;
        }
    }
}


unsigned char TEvent::_IDL_SEQUENCE_TEvent_Description_var ::copyHelper (const _IDL_SEQUENCE_TEvent_Description_var &IT_s) {
    if (!IT_s._ptr) {
        _ptr = IT_s._ptr;
    } else
    {
        _ptr = new _IDL_SEQUENCE_TEvent_Description;
        *(_ptr) =  *(IT_s._ptr);
    }
    return 1;
}

TEvent::_IDL_SEQUENCE_TEvent_Description_ptr* TEvent::_IDL_SEQUENCE_TEvent_Description_var ::_newPtr () {
    return new TEvent::_IDL_SEQUENCE_TEvent_Description_ptr;
}

TEvent::_IDL_SEQUENCE_TEvent_Description_var ::_IDL_SEQUENCE_TEvent_Description_var (const _IDL_SEQUENCE_TEvent_Description_var &IT_s) 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    (void) copyHelper (IT_s);
}

TEvent::_IDL_SEQUENCE_TEvent_Description_var ::_IDL_SEQUENCE_TEvent_Description_var () 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    _ptr = NULL;
}

TEvent::_IDL_SEQUENCE_TEvent_Description_var ::_IDL_SEQUENCE_TEvent_Description_var (_IDL_SEQUENCE_TEvent_Description_ptr IT_p) 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    _ptr = IT_p;
}

TEvent::_IDL_SEQUENCE_TEvent_Description_var &TEvent::_IDL_SEQUENCE_TEvent_Description_var :: operator= (_IDL_SEQUENCE_TEvent_Description_ptr IT_p) {
    if (_ptr != IT_p) {
        if (_ptr) {
                delete _ptr;
                _ptr = 0;
        }
    }
    _ptr = IT_p;
    return (*this);
}

TEvent::_IDL_SEQUENCE_TEvent_Description_var &TEvent::_IDL_SEQUENCE_TEvent_Description_var :: operator= (const _IDL_SEQUENCE_TEvent_Description_var &IT_s) {
    if (_ptr != IT_s._ptr) {
        if (_ptr) {
                delete _ptr;
                _ptr = 0;
        }
    }
    _ptr = new _IDL_SEQUENCE_TEvent_Description;
    *(_ptr) =  *(IT_s._ptr);
    return (*this);
}

TEvent::_IDL_SEQUENCE_TEvent_Description_var ::~_IDL_SEQUENCE_TEvent_Description_var () {
    if (_ptr) {
        delete _ptr;
        _ptr = 0;
    }
    if ( _indPtr ) {
        delete _indPtr;
        _indPtr = 0;
    }
}

TEvent::_IDL_SEQUENCE_TEvent_Description_ptr TEvent::_IDL_SEQUENCE_TEvent_Description_var :: operator-> () const {
    return _ptr;
}

TEvent::_IDL_SEQUENCE_TEvent_Description_var::operator ! () const {
    return (_ptr ? 0 : 1);
}

TEvent::_IDL_SEQUENCE_TEvent_Description_var::operator TEvent::_IDL_SEQUENCE_TEvent_Description_ptr& () { return (TEvent::_IDL_SEQUENCE_TEvent_Description_ptr &) (_ptr);}
TEvent::_IDL_SEQUENCE_TEvent_Description_var::operator const TEvent::_IDL_SEQUENCE_TEvent_Description_cptr& () const { return (TEvent::_IDL_SEQUENCE_TEvent_Description_cptr &) (_ptr);}
TEvent::_IDL_SEQUENCE_TEvent_Description_var:: operator TEvent::_IDL_SEQUENCE_TEvent_Description& () const { return (TEvent::_IDL_SEQUENCE_TEvent_Description&) (* _ptr);}

const TEvent::_IDL_SEQUENCE_TEvent_Description TEvent::_IDL_SEQUENCE_TEvent_Description_var :: in () const {
    return *_ptr;
}

TEvent::_IDL_SEQUENCE_TEvent_Description& TEvent::_IDL_SEQUENCE_TEvent_Description_var :: inOut () {
    return *_ptr;
}

TEvent::_IDL_SEQUENCE_TEvent_Description*& TEvent::_IDL_SEQUENCE_TEvent_Description_var :: out () {
    return _ptr;
}

TEvent::_IDL_SEQUENCE_TEvent_Description* TEvent::_IDL_SEQUENCE_TEvent_Description_var :: ret () const {
    return _ptr;
}

TEvent::Description& TEvent::_IDL_SEQUENCE_TEvent_Description_var:: operator[] (CORBA::ULong index) {
    return (*_ptr) [index];
}

const TEvent::Description& TEvent::_IDL_SEQUENCE_TEvent_Description_var:: operator[] (CORBA::ULong index) const {
    return (*_ptr) [index];
}


#endif


#ifndef TEvent_Value_Description_Ops
#define TEvent_Value_Description_Ops

void TEvent::Value_Description:: encodeOp (CORBA::Request &IT_r) const {

    IT_r << item_id;

    IT_r.encodeStringOp (formula);

    IT_r << state;
}

void TEvent::Value_Description:: decodeOp (CORBA::Request &IT_r) {

    IT_r >> item_id;

    {
        char *IT_0 = 0;
        IT_r.decodeStringOp(IT_0);
        formula = IT_0;
    }

    IT_r >> state;
}

void TEvent::Value_Description:: decodeInOutOp (CORBA::Request &IT_r) {

    IT_r >> item_id;

    {
        char* IT_1;
        IT_1 = (formula)._ptr;
        (formula)._ptr = 0;
        IT_r.decodeInOutStrOp(IT_1, 0);
        formula = IT_1;
    }

    IT_r >> state;
}

TEvent::Value_Description ::~Value_Description () {
}

TEvent::Value_Description:: Value_Description (const TEvent::Value_Description &IT_s) 
	 {
    item_id = IT_s.item_id;
    formula = IT_s.formula;
    state = IT_s.state;
}

TEvent::Value_Description:: Value_Description () {
}

TEvent::Value_Description &TEvent::Value_Description:: operator= (const TEvent::Value_Description& IT_s) {
    if (this == &IT_s) return *this;
    item_id = IT_s.item_id;
    formula = IT_s.formula;
    state = IT_s.state;
    return *this;
}

unsigned char TEvent::Value_Description_var ::copyHelper (const Value_Description_var &IT_s) {
    if (!IT_s._ptr) {
        _ptr = IT_s._ptr;
    } else
    {
        _ptr = new Value_Description;
        *(_ptr) =  *(IT_s._ptr);
    }
    return 1;
}

TEvent::Value_Description_ptr* TEvent::Value_Description_var ::_newPtr () {
    return new TEvent::Value_Description_ptr;
}

TEvent::Value_Description_var ::Value_Description_var (const Value_Description_var &IT_s) 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    (void) copyHelper (IT_s);
}

TEvent::Value_Description_var ::Value_Description_var () 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    _ptr = NULL;
}

TEvent::Value_Description_var ::Value_Description_var (Value_Description_ptr IT_p) 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    _ptr = IT_p;
}

TEvent::Value_Description_var &TEvent::Value_Description_var :: operator= (Value_Description_ptr IT_p) {
    if (_ptr != IT_p) {
        if (_ptr) {
                delete _ptr;
                _ptr = 0;
        }
    }
    _ptr = IT_p;
    return (*this);
}

TEvent::Value_Description_var &TEvent::Value_Description_var :: operator= (const Value_Description_var &IT_s) {
    if (_ptr != IT_s._ptr) {
        if (_ptr) {
                delete _ptr;
                _ptr = 0;
        }
    }
    _ptr = new Value_Description;
    *(_ptr) =  *(IT_s._ptr);
    return (*this);
}

TEvent::Value_Description_var ::~Value_Description_var () {
    if (_ptr) {
        delete _ptr;
        _ptr = 0;
    }
    if ( _indPtr ) {
        delete _indPtr;
        _indPtr = 0;
    }
}

TEvent::Value_Description_ptr TEvent::Value_Description_var :: operator-> () const {
    return _ptr;
}

TEvent::Value_Description_var::operator ! () const {
    return (_ptr ? 0 : 1);
}

TEvent::Value_Description_var::operator TEvent::Value_Description_ptr& () { return (TEvent::Value_Description_ptr &) (_ptr);}
TEvent::Value_Description_var::operator const TEvent::Value_Description_cptr& () const { return (TEvent::Value_Description_cptr &) (_ptr);}
TEvent::Value_Description_var:: operator TEvent::Value_Description& () const { return (TEvent::Value_Description&) (* _ptr);}

const TEvent::Value_Description TEvent::Value_Description_var :: in () const {
    return *_ptr;
}

TEvent::Value_Description& TEvent::Value_Description_var :: inOut () {
    return *_ptr;
}

TEvent::Value_Description*& TEvent::Value_Description_var :: out () {
    return _ptr;
}

TEvent::Value_Description* TEvent::Value_Description_var :: ret () const {
    return _ptr;
}


#endif


#ifndef TEvent__IDL_SEQUENCE_TEvent_Value_Description_Ops
#define TEvent__IDL_SEQUENCE_TEvent_Value_Description_Ops

TEvent::_IDL_SEQUENCE_TEvent_Value_Description:: ~_IDL_SEQUENCE_TEvent_Value_Description() {
    if (_buffer && _release) {
        {
        }
        freebuf (_buffer);
    }
}

TEvent::_IDL_SEQUENCE_TEvent_Value_Description:: _IDL_SEQUENCE_TEvent_Value_Description () {
    _release = 1;
    _length = 0;
    _maximum = 0;
    _buffer = NULL;
}


TEvent::_IDL_SEQUENCE_TEvent_Value_Description:: _IDL_SEQUENCE_TEvent_Value_Description (CORBA::ULong max, CORBA::ULong length, TEvent::Value_Description* data, CORBA::Boolean release) {
    _release = release;
    _length = length;
    _maximum = max;
    _buffer = data;
}

TEvent::_IDL_SEQUENCE_TEvent_Value_Description:: _IDL_SEQUENCE_TEvent_Value_Description (const TEvent::_IDL_SEQUENCE_TEvent_Value_Description &IT_s) {
    _length = IT_s._length;
    _release = 1;
    CORBA::ULong IT_maximum = _maximum = IT_s._maximum;
    if (IT_maximum) {
        _buffer = allocbuf (IT_maximum);
        for (CORBA::ULong IT_i = 0; IT_i < _length; IT_i++) {
            _buffer[IT_i] = IT_s._buffer[IT_i];
        }
    } else
        _buffer = NULL;
}

TEvent::_IDL_SEQUENCE_TEvent_Value_Description:: _IDL_SEQUENCE_TEvent_Value_Description (CORBA::ULong IT_size) {
    if (IT_size) {
        _buffer = allocbuf (IT_size);
    } else
        _buffer = NULL;
    _length = 0;
    _release = 1;
    _maximum = IT_size;
}

TEvent::_IDL_SEQUENCE_TEvent_Value_Description& TEvent::_IDL_SEQUENCE_TEvent_Value_Description:: operator= (const TEvent::_IDL_SEQUENCE_TEvent_Value_Description &IT_s){
    if (this == &IT_s) return *this;
    if (_buffer && _release) {
    }
    if (!_release || (IT_s._maximum > _maximum)) {
        if (_buffer && _release) {
            freebuf (_buffer);
        }
        _buffer = allocbuf (IT_s._maximum);
        _maximum = IT_s._maximum;
        _release = 1;
    }
    _length = IT_s._length;
    for (CORBA::ULong IT_j = 0; IT_j < _length; IT_j++) {
        _buffer[IT_j] = IT_s._buffer[IT_j];
    }
    return *this;
}

CORBA::ULong TEvent::_IDL_SEQUENCE_TEvent_Value_Description:: maximum () const
{
    return _maximum;
}

CORBA::ULong TEvent::_IDL_SEQUENCE_TEvent_Value_Description:: length () const
{
    return _length;
}

void TEvent::_IDL_SEQUENCE_TEvent_Value_Description:: length (CORBA::ULong len) {
    if (len > _maximum) {
        TEvent::_IDL_SEQUENCE_TEvent_Value_Description tempSeq (*this);
        if (_buffer && _release) {
            {
            }
            freebuf (_buffer);
        }
        _release = 1;
        _length = len;
        _maximum = len;
        _buffer = allocbuf(len);
        for (CORBA::ULong IT_i = 0; IT_i < tempSeq._length; IT_i++) {
            _buffer[IT_i] = tempSeq._buffer[IT_i];
        }
    } else if (len < _length) {
        if (_release) {
        }
        _length = len;
    } else {
        _length = len;
    }
}

TEvent::Value_Description& TEvent::_IDL_SEQUENCE_TEvent_Value_Description:: operator [] (CORBA::ULong IT_i)  {
    if (IT_i >= _length)
        ;
    return _buffer [IT_i];
}

const TEvent::Value_Description& TEvent::_IDL_SEQUENCE_TEvent_Value_Description:: operator [] (CORBA::ULong IT_i) const  {
    if (IT_i >= _length)
        ;
    return _buffer [IT_i];
}

TEvent::Value_Description* CALL_SPEC TEvent::_IDL_SEQUENCE_TEvent_Value_Description:: allocbuf (CORBA::ULong _nelems)
{
    struct TEvent::Value_Description* _pSequence = (struct TEvent::Value_Description*)CORBA::_IT_vecAlloc ( sizeof ( struct TEvent::Value_Description ), _nelems );
    for ( CORBA::ULong _index = 0; _index < _nelems; _index++ ) {
        (void)new ((void*)( _pSequence + _index )) struct TEvent::Value_Description;
    }
    return _pSequence;
}

void CALL_SPEC TEvent::_IDL_SEQUENCE_TEvent_Value_Description:: freebuf (TEvent::Value_Description* _data)
{
    if ( _data ) {
        for ( CORBA::ULong _index = CORBA::_IT_vecNElems ( _data ); _index; _index-- ) {
            _data[ _index - 1 ].TEvent::Value_Description::~Value_Description ();
        }
        CORBA::_IT_vecFree ( _data );
    }
}

void TEvent::_IDL_SEQUENCE_TEvent_Value_Description:: assignbuf (CORBA::ULong max, CORBA::ULong length, TEvent::Value_Description* data, CORBA::Boolean release) {
    if (_buffer && _release) {
        {
        }
        freebuf (_buffer);
    }
    _release = release;
    _length = length;
    _maximum = max;
    _buffer = data;
}

void TEvent::_IDL_SEQUENCE_TEvent_Value_Description:: decodeInOutOp (CORBA::Request &IT_r) {
    switch (IT_r.targetProtocol()) {
        case CORBA::IT_INTEROPERABLE_OR_KIND:
        {
            CORBA::ULong IT_max;
            CORBA::ULong IT_length;
            IT_r >> IT_length;
            IT_max = IT_length;
            if (!_release || (IT_max > _maximum)) {
                if (_buffer && _release) {
                    {
                    }
                    freebuf (_buffer);
                }
                _buffer = allocbuf (IT_max);
                _maximum = IT_max;
                _release = 1;
            }
            if (IT_length > IT_max)
                IT_r.makeRuntimeException4 ();
            else {
                for (CORBA::ULong IT_i = 0; IT_i < IT_length; IT_i++) {
                    _buffer[IT_i].decodeInOutOp (IT_r);
                }
            }
            _length = IT_length;
            break;
        }
        case CORBA::IT_ORBIX_OR_KIND:
        default:
        {
            CORBA::ULong IT_max;
            CORBA::ULong IT_length;
            IT_r >> IT_max;
            IT_r >> IT_length;
            unsigned char IT_codeSeqElems = IT_max ? 1 : 0;
            if (!_release || (IT_max > _maximum)) {
                if (_buffer && _release) {
                    {
                    }
                    freebuf (_buffer);
                }
                _buffer = allocbuf (IT_max);
                _maximum = IT_max;
                _release = 1;
            }
            if (IT_length > IT_max)
                IT_r.makeRuntimeException4 ();
            else {
                for (CORBA::ULong IT_i = 0; IT_i < IT_length; IT_i++) {
                    _buffer[IT_i].decodeInOutOp (IT_r);
                }
            }
            _length = IT_length;
            break;
        }
    }
}

void TEvent::_IDL_SEQUENCE_TEvent_Value_Description:: encodeOp (CORBA::Request &IT_r) const {
    switch (IT_r.targetProtocol()) {
        case CORBA::IT_INTEROPERABLE_OR_KIND:
        {
            IT_r << _length;
            for (CORBA::ULong IT_i = 0; IT_i < _length; IT_i++) {
                _buffer[IT_i].encodeOp (IT_r);
            }
            break;
        }
        case CORBA::IT_ORBIX_OR_KIND:
        default:
        {
            IT_r << _maximum;
            IT_r << _length;
            unsigned char IT_codeSeqElems = _maximum ? 1 : 0;
            for (CORBA::ULong IT_i = 0; IT_i < _length; IT_i++) {
                _buffer[IT_i].encodeOp (IT_r);
            }
            break;
        }
    }
}

void TEvent::_IDL_SEQUENCE_TEvent_Value_Description:: decodeOp (CORBA::Request &IT_r) {
    switch (IT_r.targetProtocol()) {
        case CORBA::IT_INTEROPERABLE_OR_KIND:
        {
            IT_r >> _length;
            _maximum = _length;
            if (_maximum)
                _buffer = allocbuf (_maximum);
            else _buffer = 0;
            for (CORBA::ULong IT_i = 0; IT_i < _length; IT_i++) {
                _buffer[IT_i].decodeOp (IT_r);
            }
            break;
        }
        case CORBA::IT_ORBIX_OR_KIND:
        default:
        {
            IT_r >> _maximum;
            IT_r >> _length;
            unsigned char IT_codeSeqElems = _maximum ? 1 : 0;
            if (IT_codeSeqElems) {
                _buffer = allocbuf (_maximum);
                for (CORBA::ULong IT_i = 0; IT_i < _length; IT_i++) {
                    _buffer[IT_i].decodeOp (IT_r);
                }
            }
            else
              _buffer = NULL;
            break;
        }
    }
}


unsigned char TEvent::_IDL_SEQUENCE_TEvent_Value_Description_var ::copyHelper (const _IDL_SEQUENCE_TEvent_Value_Description_var &IT_s) {
    if (!IT_s._ptr) {
        _ptr = IT_s._ptr;
    } else
    {
        _ptr = new _IDL_SEQUENCE_TEvent_Value_Description;
        *(_ptr) =  *(IT_s._ptr);
    }
    return 1;
}

TEvent::_IDL_SEQUENCE_TEvent_Value_Description_ptr* TEvent::_IDL_SEQUENCE_TEvent_Value_Description_var ::_newPtr () {
    return new TEvent::_IDL_SEQUENCE_TEvent_Value_Description_ptr;
}

TEvent::_IDL_SEQUENCE_TEvent_Value_Description_var ::_IDL_SEQUENCE_TEvent_Value_Description_var (const _IDL_SEQUENCE_TEvent_Value_Description_var &IT_s) 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    (void) copyHelper (IT_s);
}

TEvent::_IDL_SEQUENCE_TEvent_Value_Description_var ::_IDL_SEQUENCE_TEvent_Value_Description_var () 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    _ptr = NULL;
}

TEvent::_IDL_SEQUENCE_TEvent_Value_Description_var ::_IDL_SEQUENCE_TEvent_Value_Description_var (_IDL_SEQUENCE_TEvent_Value_Description_ptr IT_p) 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    _ptr = IT_p;
}

TEvent::_IDL_SEQUENCE_TEvent_Value_Description_var &TEvent::_IDL_SEQUENCE_TEvent_Value_Description_var :: operator= (_IDL_SEQUENCE_TEvent_Value_Description_ptr IT_p) {
    if (_ptr != IT_p) {
        if (_ptr) {
                delete _ptr;
                _ptr = 0;
        }
    }
    _ptr = IT_p;
    return (*this);
}

TEvent::_IDL_SEQUENCE_TEvent_Value_Description_var &TEvent::_IDL_SEQUENCE_TEvent_Value_Description_var :: operator= (const _IDL_SEQUENCE_TEvent_Value_Description_var &IT_s) {
    if (_ptr != IT_s._ptr) {
        if (_ptr) {
                delete _ptr;
                _ptr = 0;
        }
    }
    _ptr = new _IDL_SEQUENCE_TEvent_Value_Description;
    *(_ptr) =  *(IT_s._ptr);
    return (*this);
}

TEvent::_IDL_SEQUENCE_TEvent_Value_Description_var ::~_IDL_SEQUENCE_TEvent_Value_Description_var () {
    if (_ptr) {
        delete _ptr;
        _ptr = 0;
    }
    if ( _indPtr ) {
        delete _indPtr;
        _indPtr = 0;
    }
}

TEvent::_IDL_SEQUENCE_TEvent_Value_Description_ptr TEvent::_IDL_SEQUENCE_TEvent_Value_Description_var :: operator-> () const {
    return _ptr;
}

TEvent::_IDL_SEQUENCE_TEvent_Value_Description_var::operator ! () const {
    return (_ptr ? 0 : 1);
}

TEvent::_IDL_SEQUENCE_TEvent_Value_Description_var::operator TEvent::_IDL_SEQUENCE_TEvent_Value_Description_ptr& () { return (TEvent::_IDL_SEQUENCE_TEvent_Value_Description_ptr &) (_ptr);}
TEvent::_IDL_SEQUENCE_TEvent_Value_Description_var::operator const TEvent::_IDL_SEQUENCE_TEvent_Value_Description_cptr& () const { return (TEvent::_IDL_SEQUENCE_TEvent_Value_Description_cptr &) (_ptr);}
TEvent::_IDL_SEQUENCE_TEvent_Value_Description_var:: operator TEvent::_IDL_SEQUENCE_TEvent_Value_Description& () const { return (TEvent::_IDL_SEQUENCE_TEvent_Value_Description&) (* _ptr);}

const TEvent::_IDL_SEQUENCE_TEvent_Value_Description TEvent::_IDL_SEQUENCE_TEvent_Value_Description_var :: in () const {
    return *_ptr;
}

TEvent::_IDL_SEQUENCE_TEvent_Value_Description& TEvent::_IDL_SEQUENCE_TEvent_Value_Description_var :: inOut () {
    return *_ptr;
}

TEvent::_IDL_SEQUENCE_TEvent_Value_Description*& TEvent::_IDL_SEQUENCE_TEvent_Value_Description_var :: out () {
    return _ptr;
}

TEvent::_IDL_SEQUENCE_TEvent_Value_Description* TEvent::_IDL_SEQUENCE_TEvent_Value_Description_var :: ret () const {
    return _ptr;
}

TEvent::Value_Description& TEvent::_IDL_SEQUENCE_TEvent_Value_Description_var:: operator[] (CORBA::ULong index) {
    return (*_ptr) [index];
}

const TEvent::Value_Description& TEvent::_IDL_SEQUENCE_TEvent_Value_Description_var:: operator[] (CORBA::ULong index) const {
    return (*_ptr) [index];
}


#endif


#ifndef TEvent_Pattern_Ops
#define TEvent_Pattern_Ops

void TEvent::Pattern:: encodeOp (CORBA::Request &IT_r) const {

    IT_r << is_any;

    item_id_pattern.encodeOp (IT_r);

    formula.encodeOp (IT_r);

    state.encodeOp (IT_r);
}

void TEvent::Pattern:: decodeOp (CORBA::Request &IT_r) {

    IT_r >> is_any;

    item_id_pattern.decodeOp (IT_r);

    formula.decodeOp (IT_r);

    state.decodeOp (IT_r);
}

void TEvent::Pattern:: decodeInOutOp (CORBA::Request &IT_r) {

    IT_r >> is_any;

    item_id_pattern.decodeInOutOp (IT_r);

    formula.decodeInOutOp (IT_r);

    state.decodeInOutOp (IT_r);
}

TEvent::Pattern ::~Pattern () {
}

TEvent::Pattern:: Pattern (const TEvent::Pattern &IT_s) 
	 : item_id_pattern(IT_s.item_id_pattern) ,formula(IT_s.formula) ,state(IT_s.state) {
    is_any = IT_s.is_any;
}

TEvent::Pattern:: Pattern () {
}

TEvent::Pattern &TEvent::Pattern:: operator= (const TEvent::Pattern& IT_s) {
    if (this == &IT_s) return *this;
    is_any = IT_s.is_any;
    item_id_pattern = IT_s.item_id_pattern;
    formula = IT_s.formula;
    state = IT_s.state;
    return *this;
}

unsigned char TEvent::Pattern_var ::copyHelper (const Pattern_var &IT_s) {
    if (!IT_s._ptr) {
        _ptr = IT_s._ptr;
    } else
    {
        _ptr = new Pattern;
        *(_ptr) =  *(IT_s._ptr);
    }
    return 1;
}

TEvent::Pattern_ptr* TEvent::Pattern_var ::_newPtr () {
    return new TEvent::Pattern_ptr;
}

TEvent::Pattern_var ::Pattern_var (const Pattern_var &IT_s) 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    (void) copyHelper (IT_s);
}

TEvent::Pattern_var ::Pattern_var () 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    _ptr = NULL;
}

TEvent::Pattern_var ::Pattern_var (Pattern_ptr IT_p) 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    _ptr = IT_p;
}

TEvent::Pattern_var &TEvent::Pattern_var :: operator= (Pattern_ptr IT_p) {
    if (_ptr != IT_p) {
        if (_ptr) {
                delete _ptr;
                _ptr = 0;
        }
    }
    _ptr = IT_p;
    return (*this);
}

TEvent::Pattern_var &TEvent::Pattern_var :: operator= (const Pattern_var &IT_s) {
    if (_ptr != IT_s._ptr) {
        if (_ptr) {
                delete _ptr;
                _ptr = 0;
        }
    }
    _ptr = new Pattern;
    *(_ptr) =  *(IT_s._ptr);
    return (*this);
}

TEvent::Pattern_var ::~Pattern_var () {
    if (_ptr) {
        delete _ptr;
        _ptr = 0;
    }
    if ( _indPtr ) {
        delete _indPtr;
        _indPtr = 0;
    }
}

TEvent::Pattern_ptr TEvent::Pattern_var :: operator-> () const {
    return _ptr;
}

TEvent::Pattern_var::operator ! () const {
    return (_ptr ? 0 : 1);
}

TEvent::Pattern_var::operator TEvent::Pattern_ptr& () { return (TEvent::Pattern_ptr &) (_ptr);}
TEvent::Pattern_var::operator const TEvent::Pattern_cptr& () const { return (TEvent::Pattern_cptr &) (_ptr);}
TEvent::Pattern_var:: operator TEvent::Pattern& () const { return (TEvent::Pattern&) (* _ptr);}

const TEvent::Pattern TEvent::Pattern_var :: in () const {
    return *_ptr;
}

TEvent::Pattern& TEvent::Pattern_var :: inOut () {
    return *_ptr;
}

TEvent::Pattern*& TEvent::Pattern_var :: out () {
    return _ptr;
}

TEvent::Pattern* TEvent::Pattern_var :: ret () const {
    return _ptr;
}


#endif


#ifndef TEvent_Entity_Set_Ops
#define TEvent_Entity_Set_Ops
void TEvent::Entity_Set:: encodeOp (CORBA::Request &IT_r) const {
    if (!isSet) return;
    {
    CORBA::ULong IT_0 = (CORBA::ULong) __d;
    IT_r << IT_0;
    }
    switch (__d) {
        case Domain_Repository::ESC_Pattern: 
        (*_s_pattern_).encodeOp (IT_r);
        break;
        case Domain_Repository::ESC_Ids: 
        (*_s_ids_).encodeOp (IT_r);
        break;
        case Domain_Repository::ESC_Refs: 
        (*_s_refs_).encodeOp (IT_r);
        break;
    }

}

void TEvent::Entity_Set:: decodeOp (CORBA::Request &IT_r) {
    isSet = 0;
    {
    CORBA::ULong IT_1;
    IT_r >> IT_1;
    __d = Domain_Repository::Entity_Set_Criteria(IT_1);
    }
    switch (__d) {
        case Domain_Repository::ESC_Pattern: 
        if (!isSet) {
            _s_pattern_ = new TEvent::Pattern;
            isSet = 1;
        }
        (*_s_pattern_).decodeOp (IT_r);
        break;
        case Domain_Repository::ESC_Ids: 
        if (!isSet) {
            _s_ids_ = new Domain_Repository::Repository_Item_Ids;
            isSet = 1;
        }
        (*_s_ids_).decodeOp (IT_r);
        break;
        case Domain_Repository::ESC_Refs: 
        if (!isSet) {
            _s_refs_ = new TEvents;
            isSet = 1;
        }
        (*_s_refs_).decodeOp (IT_r);
        break;
    }

}
void TEvent::Entity_Set:: decodeInOutOp (CORBA::Request &IT_r) {
    Domain_Repository::Entity_Set_Criteria IT_d;
    {
    CORBA::ULong IT_2;
    IT_r >> IT_2;
    IT_d = Domain_Repository::Entity_Set_Criteria(IT_2);
    }
    if (IT_d == __d)
        switch (__d) {
            case Domain_Repository::ESC_Pattern: 
            if (!isSet) {
                _s_pattern_ = new TEvent::Pattern;
                isSet = 1;
            }
            (*_s_pattern_).decodeInOutOp (IT_r);
            break;
            case Domain_Repository::ESC_Ids: 
            if (!isSet) {
                _s_ids_ = new Domain_Repository::Repository_Item_Ids;
                isSet = 1;
            }
            (*_s_ids_).decodeInOutOp (IT_r);
            break;
            case Domain_Repository::ESC_Refs: 
            if (!isSet) {
                _s_refs_ = new TEvents;
                isSet = 1;
            }
            (*_s_refs_).decodeInOutOp (IT_r);
            break;
        }

    else {
        this->Entity_Set:: ~Entity_Set();
        memset(this, 0, sizeof(*this));
        __d = IT_d;
        switch (__d) {
            case Domain_Repository::ESC_Pattern: 
            if (!isSet) {
                _s_pattern_ = new TEvent::Pattern;
                isSet = 1;
            }
            (*_s_pattern_).decodeOp (IT_r);
            break;
            case Domain_Repository::ESC_Ids: 
            if (!isSet) {
                _s_ids_ = new Domain_Repository::Repository_Item_Ids;
                isSet = 1;
            }
            (*_s_ids_).decodeOp (IT_r);
            break;
            case Domain_Repository::ESC_Refs: 
            if (!isSet) {
                _s_refs_ = new TEvents;
                isSet = 1;
            }
            (*_s_refs_).decodeOp (IT_r);
            break;
        }
        isSet = 1;
    }

}

TEvent::Entity_Set:: Entity_Set(const Domain_Repository::Entity_Set_Criteria d) {
    memset(this, 0, sizeof(*this));
    __d = d;
    isSet = 1;
    switch (__d) {
        case Domain_Repository::ESC_Pattern:         _s_pattern_ = new TEvent::Pattern;
        break;
        case Domain_Repository::ESC_Ids:         _s_ids_ = new Domain_Repository::Repository_Item_Ids;
        break;
        case Domain_Repository::ESC_Refs:         _s_refs_ = new TEvents;
        break;
    }
}

TEvent::Entity_Set:: Entity_Set() { 
    memset(this, 0, sizeof(*this));
    isSet = 0;
}

TEvent::Entity_Set ::~Entity_Set() {
    if (!isSet) return;
    switch (__d) { 
        case Domain_Repository::ESC_Pattern:         if (_s_pattern_) delete _s_pattern_;
        break;
        case Domain_Repository::ESC_Ids:         if (_s_ids_) delete _s_ids_;
        break;
        case Domain_Repository::ESC_Refs:         if (_s_refs_) delete _s_refs_;
        break;
    }

    isSet = 0;
}

TEvent::Entity_Set:: Entity_Set (const TEvent::Entity_Set &IT_s) {
    isSet = 0;
    memset(this, 0, sizeof(*this));
    __d = IT_s.__d;
    switch (__d) {
        case Domain_Repository::ESC_Pattern: 
        if (!isSet) {
            _s_pattern_ = new TEvent::Pattern;
            isSet = 1;
        }
        *(_s_pattern_) = *(IT_s._s_pattern_);
        break;
        case Domain_Repository::ESC_Ids: 
        if (!isSet) {
            _s_ids_ = new Domain_Repository::Repository_Item_Ids;
            isSet = 1;
        }
        *(_s_ids_) = *(IT_s._s_ids_);
        break;
        case Domain_Repository::ESC_Refs: 
        if (!isSet) {
            _s_refs_ = new TEvents;
            isSet = 1;
        }
        *(_s_refs_) = *(IT_s._s_refs_);
        break;
    }
    isSet = 1;
}

TEvent::Entity_Set& TEvent::Entity_Set:: operator= (const TEvent::Entity_Set & IT_s) {
    if (this == &IT_s) return *this;
    if (isSet && (__d != IT_s.__d))
    {
        this-> Entity_Set::~Entity_Set();
        memset(this, 0, sizeof(*this));
    }

    __d = IT_s.__d;
    switch (__d) {
        case Domain_Repository::ESC_Pattern: 
        if (!isSet) {
            _s_pattern_ = new TEvent::Pattern;
            isSet = 1;
        }
        *(_s_pattern_) = *(IT_s._s_pattern_);
        break;
        case Domain_Repository::ESC_Ids: 
        if (!isSet) {
            _s_ids_ = new Domain_Repository::Repository_Item_Ids;
            isSet = 1;
        }
        *(_s_ids_) = *(IT_s._s_ids_);
        break;
        case Domain_Repository::ESC_Refs: 
        if (!isSet) {
            _s_refs_ = new TEvents;
            isSet = 1;
        }
        *(_s_refs_) = *(IT_s._s_refs_);
        break;
    }
    isSet = 1;
    return *this;
}

unsigned char TEvent::Entity_Set_var ::copyHelper (const Entity_Set_var &IT_s) {
    if (!IT_s._ptr) {
        _ptr = IT_s._ptr;
    } else
    {
        _ptr = new Entity_Set;
        *(_ptr) =  *(IT_s._ptr);
    }
    return 1;
}

TEvent::Entity_Set_ptr* TEvent::Entity_Set_var ::_newPtr () {
    return new TEvent::Entity_Set_ptr;
}

TEvent::Entity_Set_var ::Entity_Set_var (const Entity_Set_var &IT_s) 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    (void) copyHelper (IT_s);
}

TEvent::Entity_Set_var ::Entity_Set_var () 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    _ptr = NULL;
}

TEvent::Entity_Set_var ::Entity_Set_var (Entity_Set_ptr IT_p) 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    _ptr = IT_p;
}

TEvent::Entity_Set_var &TEvent::Entity_Set_var :: operator= (Entity_Set_ptr IT_p) {
    if (_ptr != IT_p) {
        if (_ptr) {
                delete _ptr;
                _ptr = 0;
        }
    }
    _ptr = IT_p;
    return (*this);
}

TEvent::Entity_Set_var &TEvent::Entity_Set_var :: operator= (const Entity_Set_var &IT_s) {
    if (_ptr != IT_s._ptr) {
        if (_ptr) {
                delete _ptr;
                _ptr = 0;
        }
    }
    _ptr = new Entity_Set;
    *(_ptr) =  *(IT_s._ptr);
    return (*this);
}

TEvent::Entity_Set_var ::~Entity_Set_var () {
    if (_ptr) {
        delete _ptr;
        _ptr = 0;
    }
    if ( _indPtr ) {
        delete _indPtr;
        _indPtr = 0;
    }
}

TEvent::Entity_Set_ptr TEvent::Entity_Set_var :: operator-> () const {
    return _ptr;
}

TEvent::Entity_Set_var::operator ! () const {
    return (_ptr ? 0 : 1);
}

TEvent::Entity_Set_var::operator TEvent::Entity_Set_ptr& () { return (TEvent::Entity_Set_ptr &) (_ptr);}
TEvent::Entity_Set_var::operator const TEvent::Entity_Set_cptr& () const { return (TEvent::Entity_Set_cptr &) (_ptr);}
TEvent::Entity_Set_var:: operator TEvent::Entity_Set& () const { return (TEvent::Entity_Set&) (* _ptr);}

const TEvent::Entity_Set TEvent::Entity_Set_var :: in () const {
    return *_ptr;
}

TEvent::Entity_Set& TEvent::Entity_Set_var :: inOut () {
    return *_ptr;
}

TEvent::Entity_Set*& TEvent::Entity_Set_var :: out () {
    return _ptr;
}

TEvent::Entity_Set* TEvent::Entity_Set_var :: ret () const {
    return _ptr;
}


#endif


#ifndef TEvent_Query_Results_Ops
#define TEvent_Query_Results_Ops

void TEvent::Query_Results:: encodeOp (CORBA::Request &IT_r) const {

    r_references.encodeOp (IT_r);

    r_descriptions.encodeOp (IT_r);

    r_value_descriptions.encodeOp (IT_r);

    r_attach_results.encodeOp (IT_r);

    r_detach_results.encodeOp (IT_r);

    r_valid_descriptions.encodeOp (IT_r);

    r_valid_value_descriptions.encodeOp (IT_r);
}

void TEvent::Query_Results:: decodeOp (CORBA::Request &IT_r) {

    r_references.decodeOp (IT_r);

    r_descriptions.decodeOp (IT_r);

    r_value_descriptions.decodeOp (IT_r);

    r_attach_results.decodeOp (IT_r);

    r_detach_results.decodeOp (IT_r);

    r_valid_descriptions.decodeOp (IT_r);

    r_valid_value_descriptions.decodeOp (IT_r);
}

void TEvent::Query_Results:: decodeInOutOp (CORBA::Request &IT_r) {

    r_references.decodeInOutOp (IT_r);

    r_descriptions.decodeInOutOp (IT_r);

    r_value_descriptions.decodeInOutOp (IT_r);

    r_attach_results.decodeInOutOp (IT_r);

    r_detach_results.decodeInOutOp (IT_r);

    r_valid_descriptions.decodeInOutOp (IT_r);

    r_valid_value_descriptions.decodeInOutOp (IT_r);
}

TEvent::Query_Results ::~Query_Results () {
}

TEvent::Query_Results:: Query_Results (const TEvent::Query_Results &IT_s) 
	 : r_references(IT_s.r_references) ,r_descriptions(IT_s.r_descriptions) ,r_value_descriptions(IT_s.r_value_descriptions) ,r_attach_results(IT_s.r_attach_results) ,r_detach_results(IT_s.r_detach_results) ,r_valid_descriptions(IT_s.r_valid_descriptions) ,r_valid_value_descriptions(IT_s.r_valid_value_descriptions) {
}

TEvent::Query_Results:: Query_Results () {
}

TEvent::Query_Results &TEvent::Query_Results:: operator= (const TEvent::Query_Results& IT_s) {
    if (this == &IT_s) return *this;
    r_references = IT_s.r_references;
    r_descriptions = IT_s.r_descriptions;
    r_value_descriptions = IT_s.r_value_descriptions;
    r_attach_results = IT_s.r_attach_results;
    r_detach_results = IT_s.r_detach_results;
    r_valid_descriptions = IT_s.r_valid_descriptions;
    r_valid_value_descriptions = IT_s.r_valid_value_descriptions;
    return *this;
}

unsigned char TEvent::Query_Results_var ::copyHelper (const Query_Results_var &IT_s) {
    if (!IT_s._ptr) {
        _ptr = IT_s._ptr;
    } else
    {
        _ptr = new Query_Results;
        *(_ptr) =  *(IT_s._ptr);
    }
    return 1;
}

TEvent::Query_Results_ptr* TEvent::Query_Results_var ::_newPtr () {
    return new TEvent::Query_Results_ptr;
}

TEvent::Query_Results_var ::Query_Results_var (const Query_Results_var &IT_s) 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    (void) copyHelper (IT_s);
}

TEvent::Query_Results_var ::Query_Results_var () 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    _ptr = NULL;
}

TEvent::Query_Results_var ::Query_Results_var (Query_Results_ptr IT_p) 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    _ptr = IT_p;
}

TEvent::Query_Results_var &TEvent::Query_Results_var :: operator= (Query_Results_ptr IT_p) {
    if (_ptr != IT_p) {
        if (_ptr) {
                delete _ptr;
                _ptr = 0;
        }
    }
    _ptr = IT_p;
    return (*this);
}

TEvent::Query_Results_var &TEvent::Query_Results_var :: operator= (const Query_Results_var &IT_s) {
    if (_ptr != IT_s._ptr) {
        if (_ptr) {
                delete _ptr;
                _ptr = 0;
        }
    }
    _ptr = new Query_Results;
    *(_ptr) =  *(IT_s._ptr);
    return (*this);
}

TEvent::Query_Results_var ::~Query_Results_var () {
    if (_ptr) {
        delete _ptr;
        _ptr = 0;
    }
    if ( _indPtr ) {
        delete _indPtr;
        _indPtr = 0;
    }
}

TEvent::Query_Results_ptr TEvent::Query_Results_var :: operator-> () const {
    return _ptr;
}

TEvent::Query_Results_var::operator ! () const {
    return (_ptr ? 0 : 1);
}

TEvent::Query_Results_var::operator TEvent::Query_Results_ptr& () { return (TEvent::Query_Results_ptr &) (_ptr);}
TEvent::Query_Results_var::operator const TEvent::Query_Results_cptr& () const { return (TEvent::Query_Results_cptr &) (_ptr);}
TEvent::Query_Results_var:: operator TEvent::Query_Results& () const { return (TEvent::Query_Results&) (* _ptr);}

const TEvent::Query_Results TEvent::Query_Results_var :: in () const {
    return *_ptr;
}

TEvent::Query_Results& TEvent::Query_Results_var :: inOut () {
    return *_ptr;
}

TEvent::Query_Results*& TEvent::Query_Results_var :: out () {
    return _ptr;
}

TEvent::Query_Results* TEvent::Query_Results_var :: ret () const {
    return _ptr;
}


#endif

unsigned char TEvent_var ::copyHelper (const TEvent_var &IT_s) {
    {
        _ptr = TEvent:: _duplicate (IT_s._ptr);
    }
    return 1;
}

unsigned char TEvent_var ::copyHelper (const TEvent_mgr &IT_s) {
    _ptr = TEvent:: _duplicate (IT_s._ptr);
return 1;
}

unsigned char TEvent_var ::copyHelper (const TEvent_SeqElem &IT_s) {
    _ptr = TEvent:: _duplicate (IT_s);
return 1;
}

TEvent_ptr* TEvent_var ::_newPtr () {
    return new TEvent_ptr;
}

TEvent_var ::TEvent_var (const TEvent_var &IT_s) 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    (void) copyHelper (IT_s);
}

TEvent_var ::TEvent_var (const TEvent_mgr &IT_s) 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    (void) copyHelper (IT_s);
}

TEvent_var ::TEvent_var (const TEvent_SeqElem &IT_s) 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    (void) copyHelper (IT_s);
}

TEvent_var ::TEvent_var () 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    _ptr = TEvent:: _nil ();
}

TEvent_var ::TEvent_var (TEvent_ptr IT_p) 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    _ptr = IT_p;
}

TEvent_var &TEvent_var :: operator= (TEvent_ptr IT_p) {
    CORBA::release (_ptr);
    _ptr = IT_p;
    return (*this);
}

TEvent_var &TEvent_var :: operator= (const TEvent_var &IT_s) {
    CORBA::release (_ptr);
    _ptr = TEvent:: _duplicate (IT_s._ptr);
    return (*this);
}

TEvent_var &TEvent_var :: operator= (const TEvent_mgr &IT_s) {
    CORBA::release (_ptr);
    _ptr = TEvent:: _duplicate (IT_s._ptr);
    return (*this);
}

TEvent_var &TEvent_var :: operator= (const TEvent_SeqElem &IT_s) {
    CORBA::release (_ptr);
    _ptr = TEvent:: _duplicate (IT_s);
    return (*this);
}

TEvent_var ::~TEvent_var () {
    CORBA::release (_ptr);
    if ( _indPtr ) {
        delete _indPtr;
        _indPtr = 0;
    }
}

TEvent_ptr TEvent_var :: operator-> () const {
    return _ptr;
}

TEvent_var::operator ! () const {
    return ((CORBA::is_nil (_ptr)));
}

TEvent_var::operator TEvent_ptr& () { return (TEvent_ptr &) (_ptr);}
TEvent_var::operator const TEvent_cptr& () const { return (TEvent_cptr &) (_ptr);}

TEvent_var ::operator CORBA::Object_ptr () const {
    return _ptr;
}

TEvent_ptr TEvent_var :: in () const {
    return _ptr;
}

TEvent_ptr& TEvent_var :: inOut () {
    return _ptr;
}

TEvent_ptr& TEvent_var :: out () {
    return _ptr;
}

TEvent_ptr TEvent_var :: ret () const {
    return _ptr;
}

void* TEventProxyFactoryClass::New (char *IT_OR, CORBA::Environment&) {
        return  new class TEvent(IT_OR);}

void* TEventProxyFactoryClass::New (ObjectReferenceImpl *IT_OR, CORBA::Environment&) {
        return  new class TEvent(IT_OR);}

void* TEventProxyFactoryClass::New2 () {
        return  new class TEvent((char*)0);}

CORBA::Object* TEventProxyFactoryClass::NewObject (char *IT_OR, CORBA::Environment& IT_env) {
        return (CORBA::Object*)((TEvent*)New (IT_OR, IT_env));}

CORBA::Object* TEventProxyFactoryClass::NewObject (ObjectReferenceImpl *IT_OR, CORBA::Environment& IT_env) {
        return (CORBA::Object*)((TEvent*)New (IT_OR, IT_env));}

CORBA::Object* TEventProxyFactoryClass::New2Object () {
        return (CORBA::Object*)((TEvent*)New2 ());}

void* TEventProxyFactoryClass::IT_castUp (void *IT_p, char* IT_s, CORBA::Environment &IT_env) {
      void *IT_l;
      if (!CORBA::_interfaceCmp (IT_s,TEvent_IR, IT_env))
         return IT_p;
      else if (IT_l=TEvent_Data_Observed_EProxyFactoryClass::IT_castUp((class TEvent_Data_Observed_E*)((class TEvent*)IT_p),IT_s, IT_env))
          return IT_l;
      else return NULL;
    }


CORBA::PPTR* TEventProxyFactoryClass::pptr (void *IT_p) {
       return ((class TEvent*)IT_p)->_pptr ();}

void TEventProxyFactoryClass::baseInterfaces (_IDL_SEQUENCE_string& seq) {
      add (seq, TEvent_IR);
TEvent_Data_Observed_EProxyFactoryClass::baseInterfaces (seq);
}

TEventProxyFactoryClass TEventProxyFactory(1);

TEvent::Description* TEvent::descr (CORBA::Environment &IT_pEnv) throw (CORBA::SystemException) {

    CORBA::EnvExcRaiser IT_raise;
    CORBA::Environment &IT_env = IT_raise.registerEnv (&IT_pEnv);
    if (IT_env || m_isNull) {
    return NULL;
    }

    CORBA::Request IT_r (this, "_get_descr",IT_env,1,0);
    for (int IT_i1=0; IT_i1 < 2; IT_i1++) {
        IT_r.invoke(CORBA::Flags(0), IT_env);
        CORBA::SystemException *IT_sy = CORBA::SystemException::_narrow(IT_env.exception()) ;
        if (IT_sy && IT_sy->minor() == 10601)
                IT_r.reset(IT_r.target(),  IT_r.operation(), IT_env);
        else
                break;
    }
    if (!IT_r.isException (IT_env)) {
        TEvent::Description* descr;
        descr = new TEvent::Description;

        (*descr).decodeOp (IT_r);
        IT_r.checkEnv (IT_env);
        return descr;
    }
    if (IT_r.exceptionKind () == CORBA::SYSTEM_EXCEPTION) {
        IT_r.checkEnv (IT_env);
    }
    return NULL;
}

TEvent::Value_Description* TEvent:: value_descr (CORBA::Environment &IT_pEnv) throw (CORBA::SystemException, Domain_Repository::Destination_Unreachable) {

    CORBA::EnvExcRaiser IT_raise;
    CORBA::Environment &IT_env = IT_raise.registerEnv (&IT_pEnv);
    if (IT_env || m_isNull) {
        return NULL;
    }
    CORBA::Request IT_r (this, "value_descr",IT_env,1,0);
    for (int IT_i1=0; IT_i1 < 2; IT_i1++) {

        IT_r.invoke (CORBA::Flags(0),IT_env);
        CORBA::SystemException *IT_sy = CORBA::SystemException::_narrow(IT_env.exception()) ;
        if (IT_sy && IT_sy->minor() == 10601)
                IT_r.reset(IT_r.target(),  IT_r.operation(), IT_env);
        else
                break;
    }
    if (!IT_r.isException (IT_env)) {
        switch (IT_r.targetProtocol()) {
            case CORBA::IT_INTEROPERABLE_OR_KIND:
            {
                TEvent::Value_Description* IT_result = new TEvent::Value_Description;
                (*(IT_result)).decodeOp (IT_r);
                IT_r.checkEnv (IT_env);
                return IT_result;
            }
            case CORBA::IT_ORBIX_OR_KIND:
            default:
            {
                TEvent::Value_Description* IT_result = new TEvent::Value_Description;
                (*(IT_result)).decodeOp (IT_r);
                IT_r.checkEnv (IT_env);
                return IT_result;
            }
        }
    }
    else if (CORBA::UserException:: _narrow (IT_env.exception ())) { 
        const char* IT_str = IT_env.exception_id (); 
        if ((!strcmp (IT_str, Domain_Repository::ex_Destination_Unreachable        )||!strcmp (IT_str, "Domain_Repository::Destination_Unreachable"))) {
            CORBA::Exception *IT_ex =  new Domain_Repository::Destination_Unreachable;
            ((Domain_Repository::Destination_Unreachable*)IT_ex) -> decodeOp (IT_r);
            IT_env = IT_ex;
        }
    } else if (CORBA::SystemException:: _narrow (IT_env.exception ())) {
    }
    if (IT_r.exceptionKind () == CORBA::SYSTEM_EXCEPTION) {
        IT_r.checkEnv (IT_env);
    }
    return NULL;
}

Domain_Repository::Repository_Item_Id TEvent::item_id (CORBA::Environment &IT_pEnv) throw (CORBA::SystemException) {

    CORBA::EnvExcRaiser IT_raise;
    CORBA::Environment &IT_env = IT_raise.registerEnv (&IT_pEnv);
    if (IT_env || m_isNull) {
    return 0;
    }

    CORBA::Request IT_r (this, "_get_item_id",IT_env,1,0);
    for (int IT_i1=0; IT_i1 < 2; IT_i1++) {
        IT_r.invoke(CORBA::Flags(0), IT_env);
        CORBA::SystemException *IT_sy = CORBA::SystemException::_narrow(IT_env.exception()) ;
        if (IT_sy && IT_sy->minor() == 10601)
                IT_r.reset(IT_r.target(),  IT_r.operation(), IT_env);
        else
                break;
    }
    if (!IT_r.isException (IT_env)) {
        Domain_Repository::Repository_Item_Id item_id;

        IT_r >> item_id;
        IT_r.checkEnv (IT_env);
        return item_id;
    }
    if (IT_r.exceptionKind () == CORBA::SYSTEM_EXCEPTION) {
        IT_r.checkEnv (IT_env);
    }
    return 0;
}

TEvent::TEventContext TEvent::formula (CORBA::Environment &IT_pEnv) throw (CORBA::SystemException) {

    CORBA::EnvExcRaiser IT_raise;
    CORBA::Environment &IT_env = IT_raise.registerEnv (&IT_pEnv);
    if (IT_env || m_isNull) {
    return ((char *) NULL);
    }

    CORBA::Request IT_r (this, "_get_formula",IT_env,1,0);
    for (int IT_i1=0; IT_i1 < 2; IT_i1++) {
        IT_r.invoke(CORBA::Flags(0), IT_env);
        CORBA::SystemException *IT_sy = CORBA::SystemException::_narrow(IT_env.exception()) ;
        if (IT_sy && IT_sy->minor() == 10601)
                IT_r.reset(IT_r.target(),  IT_r.operation(), IT_env);
        else
                break;
    }
    if (!IT_r.isException (IT_env)) {
        TEvent::TEventContext formula;

        IT_r.decodeStringOp(formula);
        IT_r.checkEnv (IT_env);
        return formula;
    }
    if (IT_r.exceptionKind () == CORBA::SYSTEM_EXCEPTION) {
        IT_r.checkEnv (IT_env);
    }
    return ((char *) NULL);
}

CORBA::Boolean TEvent::state (CORBA::Environment &IT_pEnv) throw (CORBA::SystemException) {

    CORBA::EnvExcRaiser IT_raise;
    CORBA::Environment &IT_env = IT_raise.registerEnv (&IT_pEnv);
    if (IT_env || m_isNull) {
    return 0;
    }

    CORBA::Request IT_r (this, "_get_state",IT_env,1,0);
    for (int IT_i1=0; IT_i1 < 2; IT_i1++) {
        IT_r.invoke(CORBA::Flags(0), IT_env);
        CORBA::SystemException *IT_sy = CORBA::SystemException::_narrow(IT_env.exception()) ;
        if (IT_sy && IT_sy->minor() == 10601)
                IT_r.reset(IT_r.target(),  IT_r.operation(), IT_env);
        else
                break;
    }
    if (!IT_r.isException (IT_env)) {
        CORBA::Boolean state;

        IT_r >> state;
        IT_r.checkEnv (IT_env);
        return state;
    }
    if (IT_r.exceptionKind () == CORBA::SYSTEM_EXCEPTION) {
        IT_r.checkEnv (IT_env);
    }
    return 0;
}





#ifndef TEvent_dispatch_impl

unsigned char TEvent_dispatch::dispatch (CORBA::Request &IT_r, 
    unsigned char, void *) {
      IT_r.makeRuntimeException1 ("TEvent");
      return 0;
}
 
#endif

