

#include "tevent.hh"


#define TEvent_dispatch_impl

unsigned char TEvent_dispatch::dispatch (CORBA::Request &IT_r, 
 unsigned char IT_isTarget, void *IT_pp) {
    if (!IT_pp)
       IT_pp = m_obj;
    const char *IT_s = IT_r.getOperation ();
    if (!strcmp (IT_s,"_get_descr")) {
        TEvent::Description* descr;
        CORBA::Environment IT_env (IT_r);
        CORBA::Filter* IT_f = CORBA::Orbix.getFilter ();
        if (!IT_r.tcAssert ("\
Ro~_get_descr~>{R~TEvent::Description~item_id{ul},formula{0},state{b}},N{}\
"))
            return 1;
        if (IT_f)
        	IT_f->inRequestPostM (IT_r, IT_env);
        if (!IT_r.isException (IT_env)) {
            try {
                descr = ((TEvent*)IT_pp)->descr(IT_env);
            } catch (CORBA::SystemException &IT_exSys) {
            IT_env.propagate (&IT_exSys);
            } catch (CORBA::UserException &IT_exUsr) {
            IT_env.propagate (&IT_exUsr);
            }
        }

        if (!IT_r.isException (IT_env)) {
            if (!IT_r.convertToReply ("\
R~TEvent::Description~item_id{ul},formula{0},state{b}\
", IT_env)) return 1;
            if (!descr) {
                IT_r.makeRuntimeException6 ();
                return 1;
            }
            else

            (*descr).encodeOp (IT_r);
            delete descr;
        }
        else IT_r.makeSystemException (IT_env);

        return 1;
    }

    if (!strcmp(IT_s,"value_descr")) {
        TEvent::Value_Description* IT_result;
        CORBA::Environment IT_env (IT_r);
        CORBA::Filter* IT_f = CORBA::Orbix.getFilter ();
        if (!IT_r.tcAssert ("\
Ro~value_descr~>{R~TEvent::Value_Description~item_id{ul},formula{0},state{b}},N{}\
"))
            return 1;

        if (IT_f && !IT_r.isException (IT_env))
        	IT_f->inRequestPostM (IT_r, IT_env);
        if (!IT_r.isException (IT_env)) {
            try {
                	IT_result = ((TEvent*)IT_pp)->value_descr (IT_env);

            } catch (CORBA::SystemException &IT_exSys) {
            IT_env.propagate (&IT_exSys);
            } catch (CORBA::UserException &IT_exUsr) {
            IT_env.propagate (&IT_exUsr);
            }
        }

        if (!IT_r.isException (IT_env)) {
            if (!IT_r.convertToReply ("\
R~TEvent::Value_Description~item_id{ul},formula{0},state{b}\
", IT_env)) return 1;
            switch (IT_r.targetProtocol()) {
                case CORBA::IT_INTEROPERABLE_OR_KIND:
                {
                    (*(IT_result)).encodeOp (IT_r);
                    delete IT_result;
                    break;
                }
                case CORBA::IT_ORBIX_OR_KIND:
                default:
                {
                    (*(IT_result)).encodeOp (IT_r);
                    delete IT_result;
                    break;
                }
            }
            }
        else {
            IT_r.convertToException (IT_env);
            if (!strcmp (IT_env.exception_id(), Domain_Repository::ex_Destination_Unreachable)) {
                ((Domain_Repository::Destination_Unreachable*)IT_env.exception_value()) -> encodeOp (IT_r);
            }

            else IT_r.makeSystemException (IT_env);
        }
        return 1;
    }

    if (!strcmp (IT_s,"_get_item_id")) {
        Domain_Repository::Repository_Item_Id item_id;
        CORBA::Environment IT_env (IT_r);
        CORBA::Filter* IT_f = CORBA::Orbix.getFilter ();
        if (!IT_r.tcAssert ("\
Ro~_get_item_id~>{ul},N{}\
"))
            return 1;
        if (IT_f)
        	IT_f->inRequestPostM (IT_r, IT_env);
        if (!IT_r.isException (IT_env)) {
            try {
                item_id = ((TEvent*)IT_pp)->item_id(IT_env);
            } catch (CORBA::SystemException &IT_exSys) {
            IT_env.propagate (&IT_exSys);
            } catch (CORBA::UserException &IT_exUsr) {
            IT_env.propagate (&IT_exUsr);
            }
        }

        if (!IT_r.isException (IT_env)) {
            if (!IT_r.convertToReply ("\
ul\
", IT_env)) return 1;

            IT_r << item_id;
        }
        else IT_r.makeSystemException (IT_env);

        return 1;
    }

    if (!strcmp (IT_s,"_get_formula")) {
        TEvent::TEventContext formula;
        CORBA::Environment IT_env (IT_r);
        CORBA::Filter* IT_f = CORBA::Orbix.getFilter ();
        if (!IT_r.tcAssert ("\
Ro~_get_formula~>{0},N{}\
"))
            return 1;
        if (IT_f)
        	IT_f->inRequestPostM (IT_r, IT_env);
        if (!IT_r.isException (IT_env)) {
            try {
                formula = ((TEvent*)IT_pp)->formula(IT_env);
            } catch (CORBA::SystemException &IT_exSys) {
            IT_env.propagate (&IT_exSys);
            } catch (CORBA::UserException &IT_exUsr) {
            IT_env.propagate (&IT_exUsr);
            }
        }

        if (!IT_r.isException (IT_env)) {
            if (!IT_r.convertToReply ("\
0\
", IT_env)) return 1;

            IT_r.encodeStringOp (formula);
            CORBA::string_free (formula);
        }
        else IT_r.makeSystemException (IT_env);

        return 1;
    }

    if (!strcmp (IT_s,"_get_state")) {
        CORBA::Boolean state;
        CORBA::Environment IT_env (IT_r);
        CORBA::Filter* IT_f = CORBA::Orbix.getFilter ();
        if (!IT_r.tcAssert ("\
Ro~_get_state~>{b},N{}\
"))
            return 1;
        if (IT_f)
        	IT_f->inRequestPostM (IT_r, IT_env);
        if (!IT_r.isException (IT_env)) {
            try {
                state = ((TEvent*)IT_pp)->state(IT_env);
            } catch (CORBA::SystemException &IT_exSys) {
            IT_env.propagate (&IT_exSys);
            } catch (CORBA::UserException &IT_exUsr) {
            IT_env.propagate (&IT_exUsr);
            }
        }

        if (!IT_r.isException (IT_env)) {
            if (!IT_r.convertToReply ("\
b\
", IT_env)) return 1;

            IT_r << state;
        }
        else IT_r.makeSystemException (IT_env);

        return 1;
    }

    if  (
        TEvent_Data_Observed_E_dispatch::dispatch
                (
                IT_r,
                0,
                (TEvent_Data_Observed_E*)((TEvent*)IT_pp)
                )
        )
    {
        return 1;
    }

    if (IT_isTarget)
        IT_r.makeRuntimeException2 ();

    return 0;
}

#include "teventC.cc"

