

#include "tevent_rep_manager.hh"


#define TEvent_Rep_Manager_dispatch_impl

unsigned char TEvent_Rep_Manager_dispatch::dispatch (CORBA::Request &IT_r, 
 unsigned char IT_isTarget, void *IT_pp) {
    if (!IT_pp)
       IT_pp = m_obj;
    const char *IT_s = IT_r.getOperation ();
    if (!strcmp (IT_s,"_get_rep")) {
        TEvent_Rep_ptr rep;
        CORBA::Environment IT_env (IT_r);
        CORBA::Filter* IT_f = CORBA::Orbix.getFilter ();
        if (!IT_r.tcAssert ("\
Ro~_get_rep~>{O~TEvent_Rep},N{}\
"))
            return 1;
        if (IT_f)
        	IT_f->inRequestPostM (IT_r, IT_env);
        if (!IT_r.isException (IT_env)) {
            try {
                rep = ((TEvent_Rep_Manager*)IT_pp)->rep(IT_env);
            } catch (CORBA::SystemException &IT_exSys) {
            IT_env.propagate (&IT_exSys);
            } catch (CORBA::UserException &IT_exUsr) {
            IT_env.propagate (&IT_exUsr);
            }
        }

        if (!IT_r.isException (IT_env)) {
            if (!IT_r.convertToReply ("\
O~TEvent_Rep\
", IT_env)) return 1;

            {
                CORBA::Object* IT_l1 = (CORBA::Object*) rep;
                IT_r << IT_l1;
            }
            if (rep) TEvent_Rep_release (rep);
        }
        else IT_r.makeSystemException (IT_env);

        return 1;
    }

    if (!strcmp (IT_s,"_get_tevent_list")) {
        TEvents* tevent_list;
        CORBA::Environment IT_env (IT_r);
        CORBA::Filter* IT_f = CORBA::Orbix.getFilter ();
        if (!IT_r.tcAssert ("\
Ro~_get_tevent_list~>{S{O~TEvent},0},N{}\
"))
            return 1;
        if (IT_f)
        	IT_f->inRequestPostM (IT_r, IT_env);
        if (!IT_r.isException (IT_env)) {
            try {
                tevent_list = ((TEvent_Rep_Manager*)IT_pp)->tevent_list(IT_env);
            } catch (CORBA::SystemException &IT_exSys) {
            IT_env.propagate (&IT_exSys);
            } catch (CORBA::UserException &IT_exUsr) {
            IT_env.propagate (&IT_exUsr);
            }
        }

        if (!IT_r.isException (IT_env)) {
            if (!IT_r.convertToReply ("\
S{O~TEvent},0\
", IT_env)) return 1;
            if (!tevent_list) {
                IT_r.makeRuntimeException6 ();
                return 1;
            }
            else

            (*tevent_list).encodeOp (IT_r);
            delete tevent_list;
        }
        else IT_r.makeSystemException (IT_env);

        return 1;
    }

    if (!strcmp(IT_s,"add")) {
        TEvent_ptr IT_result;
        CORBA::Environment IT_env (IT_r);
        CORBA::Filter* IT_f = CORBA::Orbix.getFilter ();
        if (!IT_r.tcAssert ("\
Ro~add~>{O~TEvent},N{}\
"))
            return 1;
        TEvent::Description data_record;

        data_record.decodeOp (IT_r);

        if (IT_f && !IT_r.isException (IT_env))
        	IT_f->inRequestPostM (IT_r, IT_env);
        if (!IT_r.isException (IT_env)) {
            try {
                	IT_result = ((TEvent_Rep_Manager*)IT_pp)->add (  data_record, IT_env);

            } catch (CORBA::SystemException &IT_exSys) {
            IT_env.propagate (&IT_exSys);
            } catch (CORBA::UserException &IT_exUsr) {
            IT_env.propagate (&IT_exUsr);
            }
        }

        if (!IT_r.isException (IT_env)) {
            if (!IT_r.convertToReply ("\
O~TEvent\
", IT_env)) return 1;
            switch (IT_r.targetProtocol()) {
                case CORBA::IT_INTEROPERABLE_OR_KIND:
                {
                    {
                        CORBA::Object* IT_l0 = (CORBA::Object*) IT_result;
                        IT_r << IT_l0;
                    }
                    if (IT_result) TEvent_release (IT_result);
                    break;
                }
                case CORBA::IT_ORBIX_OR_KIND:
                default:
                {
                    {
                        CORBA::Object* IT_l1 = (CORBA::Object*) IT_result;
                        IT_r << IT_l1;
                    }
                    if (IT_result) TEvent_release (IT_result);
                    break;
                }
            }
            }
        else {
            IT_r.convertToException (IT_env);
            if (!strcmp (IT_env.exception_id(), Domain_Repository::ex_Duplicate_Data_Record)) {
                ((Domain_Repository::Duplicate_Data_Record*)IT_env.exception_value()) -> encodeOp (IT_r);
            }
    else
            if (!strcmp (IT_env.exception_id(), Domain_Repository::ex_Invalid_Description)) {
                ((Domain_Repository::Invalid_Description*)IT_env.exception_value()) -> encodeOp (IT_r);
            }
    else
            if (!strcmp (IT_env.exception_id(), Domain_Repository::ex_Destination_Unreachable)) {
                ((Domain_Repository::Destination_Unreachable*)IT_env.exception_value()) -> encodeOp (IT_r);
            }

            else IT_r.makeSystemException (IT_env);
        }
        return 1;
    }

    if (!strcmp(IT_s,"remove")) {
        CORBA::Environment IT_env (IT_r);
        CORBA::Filter* IT_f = CORBA::Orbix.getFilter ();
        if (!IT_r.tcAssert ("\
Ro~remove~>{v},N{}\
"))
            return 1;
        TEvent_ptr object_to_remove;

        object_to_remove = (TEvent*) IT_r.decodeObjRef (TEvent_IR);

        if (IT_f && !IT_r.isException (IT_env))
        	IT_f->inRequestPostM (IT_r, IT_env);
        if (!IT_r.isException (IT_env)) {
            try {
                ((TEvent_Rep_Manager*)IT_pp)->remove (  object_to_remove, IT_env);

            } catch (CORBA::SystemException &IT_exSys) {
            IT_env.propagate (&IT_exSys);
            } catch (CORBA::UserException &IT_exUsr) {
            IT_env.propagate (&IT_exUsr);
            }
        }
        if (object_to_remove) TEvent_release (object_to_remove);

        if (!IT_r.isException (IT_env)) {
            switch (IT_r.targetProtocol()) {
                case CORBA::IT_INTEROPERABLE_OR_KIND:
                {
                    break;
                }
                case CORBA::IT_ORBIX_OR_KIND:
                default:
                {
                    break;
                }
            }
            if (!IT_r.convertToReply ("\
v\
", IT_env)) return 1;
            }
        else {
            IT_r.convertToException (IT_env);
            if (!strcmp (IT_env.exception_id(), Domain_Repository::ex_Unknown_Object_Ref)) {
                ((Domain_Repository::Unknown_Object_Ref*)IT_env.exception_value()) -> encodeOp (IT_r);
            }

            else IT_r.makeSystemException (IT_env);
        }
        return 1;
    }

    if (!strcmp(IT_s,"update")) {
        CORBA::Environment IT_env (IT_r);
        CORBA::Filter* IT_f = CORBA::Orbix.getFilter ();
        if (!IT_r.tcAssert ("\
Ro~update~>{v},N{}\
"))
            return 1;
        TEvent_ptr object_to_update;

        object_to_update = (TEvent*) IT_r.decodeObjRef (TEvent_IR);

        TEvent::Description data_record_pattern;

        data_record_pattern.decodeOp (IT_r);

        if (IT_f && !IT_r.isException (IT_env))
        	IT_f->inRequestPostM (IT_r, IT_env);
        if (!IT_r.isException (IT_env)) {
            try {
                ((TEvent_Rep_Manager*)IT_pp)->update (  object_to_update,   data_record_pattern, IT_env);

            } catch (CORBA::SystemException &IT_exSys) {
            IT_env.propagate (&IT_exSys);
            } catch (CORBA::UserException &IT_exUsr) {
            IT_env.propagate (&IT_exUsr);
            }
        }
        if (object_to_update) TEvent_release (object_to_update);


        if (!IT_r.isException (IT_env)) {
            switch (IT_r.targetProtocol()) {
                case CORBA::IT_INTEROPERABLE_OR_KIND:
                {

                    break;
                }
                case CORBA::IT_ORBIX_OR_KIND:
                default:
                {

                    break;
                }
            }
            if (!IT_r.convertToReply ("\
v\
", IT_env)) return 1;
            }
        else {
            IT_r.convertToException (IT_env);
            if (!strcmp (IT_env.exception_id(), Domain_Repository::ex_Unknown_Object_Ref)) {
                ((Domain_Repository::Unknown_Object_Ref*)IT_env.exception_value()) -> encodeOp (IT_r);
            }
    else
            if (!strcmp (IT_env.exception_id(), Domain_Repository::ex_Duplicate_Data_Record)) {
                ((Domain_Repository::Duplicate_Data_Record*)IT_env.exception_value()) -> encodeOp (IT_r);
            }
    else
            if (!strcmp (IT_env.exception_id(), Domain_Repository::ex_Invalid_Description)) {
                ((Domain_Repository::Invalid_Description*)IT_env.exception_value()) -> encodeOp (IT_r);
            }
    else
            if (!strcmp (IT_env.exception_id(), Domain_Repository::ex_Destination_Unreachable)) {
                ((Domain_Repository::Destination_Unreachable*)IT_env.exception_value()) -> encodeOp (IT_r);
            }

            else IT_r.makeSystemException (IT_env);
        }
        return 1;
    }

    if (IT_isTarget)
        IT_r.makeRuntimeException2 ();

    return 0;
}

#include "tevent_rep_managerC.cc"

